' CASSE : Rcriture des mots-cls Panoramic en majuscules ou en minuscules. Version 3
' Marc - novembre 2021

dim motsCles$, source2$, mot$, nomFichier$, nouveauMotCle$, repertoire$
dim index%, modif$, annonce$, reponseUtilisateur%, nomLogiciel$, versionLogiciel$

label ajouterMotCle, supprimerMotCle, ouvrir, minuscules, majuscules
label redim0, afficherFenetreAPropos, redimFenetreAPropos, fermerFenetreAPropos
label enregistrer, quitter 

nomLogiciel$ = "CASSE"
versionLogiciel$ = "version 1.03 du 19/11/2021"

repertoire$ = dir_current$ + "\"
interfaceUtilisateur()
creerStringMotsCles()
end
' ------------------------------------------------------------------------------

sub interfaceUtilisateur()
    creerFenetrePricipale()
    creerBarreMenu()
    creerEditeur()
    creerBarreEtat()
    creerFenetreApropos()
end_sub
' ------------------------------------------------------------------------------

sub creerFenetrePricipale()
    width 0,width(0) - width_client(0) + 900
    height 0,height(0) - height(0) + 700
    top 0,(screen_y - height(0)) / 2
    left 0,(screen_x - width(0)) / 2 
    color 0,240,240,240
    caption 0,nomLogiciel$
    on_resize 0,redim0
    on_close 0,quitter
end_sub
' ------------------------------------------------------------------------------

sub creerBarreMenu()
    creerIconeOuvrirProjet(8,8)
    creerIconeMajuscules(48,8)
    creerIconeMinuscules(88,8)
    creerIconeSauvegarderProjet(128,8)
    creerComboMotsCles(168,8)
    creerIconeAjouterMotCle(514,8)
    creerIconeSupprimerMotCle(554,8)
    creerIconeAPropos(594,8)
end_sub
' ------------------------------------------------------------------------------

sub creerIconeOuvrirProjet(x%,y%)
    dim_local i%

    picture 3
    height 3,28
    width 3,28
    top 3,y%
    left 3,x%
    color 3,240,240,240
    hint 3,"Ouvrir Projet"
    cursor_point 3
    on_click 3,ouvrir

    2d_target_is 3
    2d_pen_color 0,0,0
    2d_line 16,4,20,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,23,7
    2d_line 22,5,22,8
    2d_line 5,9,11,9
    2d_line 10,11,21,11
    2d_line 11,16,25,16
    2d_line 5,22,19,22
    2d_line 5,9,5,23
    2d_line 10,9,10,12
    2d_line 20,11,20,17
    2d_line 5,22,12,15
    2d_line 18,22,25,15
    for i% = 10 to 20
        2d_flood 6,i%,255,255,255
    next i%
    for i% = 17 to 21
        2d_flood 11,i%,250,250,0
    next i%
end_sub
' ------------------------------------------------------------------------------

sub creerIconeMajuscules(x%,y%)
    dim_local i%

    picture 4
    height 4,28
    width 4,28
    top 4,y%
    left 4,x%
    color 4,240,240,240
    cursor_point 4
    hint 4,"Mots-cls en MAJUSCULES"
    on_click 4,majuscules

    2d_target_is 4
    2d_pen_color 0,0,175
    2d_fill_color 0,0,175
    2d_rectangle 5,7,9,22
    2d_line 9,7,9,11
    2d_line 10,9,10,13
    2d_line 11,10,11,15
    2d_line 12,12,12,17
    2d_rectangle 13,14,15,18
    2d_line 15,12,15,17
    2d_line 16,10,16,15
    2d_line 17,9,17,13
    2d_line 18,7,18,11
    2d_rectangle 19,7,23,22
end_sub
' ------------------------------------------------------------------------------

sub creerIconeMinuscules(x%,y%)
    dim_local i%

    picture 5
    height 5,28
    width 5,28
    top 5,y%
    left 5,x%
    color 5,240,240,240
    cursor_point 5
    hint 5,"Mots-cls en minuscules"
    on_click 5,minuscules

    2d_target_is 5
    2d_pen_color 0,0,200
    2d_fill_color 0,0,200
    2d_line 6,12,6,22
    2d_rectangle 7,11,9,22
    2d_line 11,11,13,11
    2d_line 17,11,19,11
    2d_line 10,12,14,12
    2d_line 16,12,20,12
    2d_line 9,13,21,13
    2d_point 9,14
    2d_line 12,14,16,14
    2d_point 18,14
    2d_rectangle 12,14,15,22
    2d_rectangle 18,13,21,22
end_sub
' ------------------------------------------------------------------------------

sub creerIconeSauvegarderProjet(x%,y%)
    dim_local i%

    picture 6
    height 6,28
    width 6,28
    top 6,y%
    left 6,x%
    color 6,240,240,240
    cursor_point 6
    hint 6,"Enregistrer Projet"
    on_click 6,enregistrer

    2d_target_is 6
    2d_pen_color 0,0,0
    2d_line 7,5,20,5
    2d_line 19,6,21,6
    2d_line 20,7,22,7
    2d_line 7,22,21,22
    2d_line 6,6,6,22
    2d_line 21,7,21,22
    
    for i% = 6 to 21
         2d_flood 8,i%,0,255,0
    next i%
    
    2d_rectangle 8,14,20,21
    2d_line 10,16,18,16
    2d_line 10,18,18,18
    2d_rectangle 9,5,18,10
    2d_line 9,6,15,6
    2d_line 9,7,15,7
    2d_line 9,8,15,8
end_sub
' ------------------------------------------------------------------------------

sub creerComboMotsCles(x%,y%)
    combo 7
    left 7,x%
    top 7,y%
    width 7,330
    sort_on 7
    font_name 7,"Consolas"
    font_size 7,12
end_sub
' ------------------------------------------------------------------------------

sub creerIconeAjouterMotCle(x%,y%)
    dim_local i%

    picture 8
    height 8,28
    width 8,28
    top 8,y%
    left 8,x%
    color 8,240,240,240
    cursor_point 8
    hint 8,"Ajouter Mot-Cl"
    on_click 8,ajouterMotCle

    2d_target_is 8
    2d_pen_color 0,140,0
    2d_fill_off
    2d_circle 14,14,12
    2d_flood 14,14,0,170,0
    2d_fill_color 255,255,255
    2d_pen_color 255,255,255
    2d_rectangle 7,12,21,16
    2d_rectangle 12,7,16,21

end_sub
' ------------------------------------------------------------------------------

sub creerIconeSupprimerMotCle(x%,y%)
    dim_local i%

    picture 9
    height 9,28
    width 9,28
    top 9,y%
    left 9,x%
    color 9,240,240,240
    cursor_point 9
    hint 9,"Supprimer Mot-Cl"
    on_click 9,supprimerMotCle

    2d_target_is 9
    2d_pen_color 170,0,0
    2d_fill_off
    2d_circle 14,14,12
    2d_flood 14,14,255,0,0
    2d_pen_color 255,255,255
    2d_line 10,8,20,18
    2d_line 9,8,20,19
    2d_line 9,9,19,19
    2d_line 8,9,19,20
    2d_line 8,10,18,20 

    2d_line 17,8,7,18
    2d_line 18,8,7,19
    2d_line 18,9,8,19
    2d_line 19,9,8,20
    2d_line 19,10,9,20
end_sub
' ------------------------------------------------------------------------------

sub creerIconeAPropos(x%,y%)
    picture 10
    height 10,28
    width 10,28
    color 10,240,240,240
    top 10,y%
    left 10,x%
    cursor_point 10
    Hint 10,"A Propos"
    on_click 10,afficherFenetreAPropos

    2d_target_is 10
    2d_pen_color 0,0,255
    2d_line 10,3,17,3
    2d_line 9,4,19,4
    2d_line 8,5,20,5
    2d_line 7,6,21,6
    2d_line 6,7,11,7
    2d_line 15,7,22,7
    2d_line 6,8,10,8
    2d_line 16,8,22,8
    2d_line 6,9,9,9
    2d_line 17,9,22,9
    2d_line 17,10,22,10
    2d_line 17,11,22,11
    2d_line 16,12,21,12
    2d_line 15,13,20,13
    2d_line 14,14,19,14
    2d_line 13,15,18,15
    2d_line 12,16,17,16
    2d_line 12,17,16,17
    2d_line 12,18,16,18
    2d_line 12,21,16,21
    2d_line 12,22,16,22
    2d_line 12,23,16,23
    2d_line 12,24,16,24
end_sub
' ------------------------------------------------------------------------------

sub creerEditeur()
    synedit 1
    width 1,width_client(0)
    height 1,height_client(0)-70
    color 1,255,255,255         :' Couleur de fond de l'diteur
    font_name 1,"Courier New"
    font_size 1,12              :' Taille des caractres dans l'diteur
    font_color 1,0,0,0 :' Couleur d'criture dans l'diteur
    synedit_target_is_gutter
    color 1,255,255,255         :' Couleur de fond de la marge
    font_name 1,"Courier New"
    font_size 1,12              :' Taille d'criture dans la marge
    synedit_target_is_comment
    font_color 1,255,0,0        :' Couleur des commentaires
    left 1,0
    top 1,44
end_sub
' ------------------------------------------------------------------------------

sub creerBarreEtat()
    alpha 15
    font_size 15,10
    font_color 15,0,0,0
    top 15,height_client(0)-20
    left 15,3        
    caption 15," Ralis en langage PANORAMIC par Marc - https://panoramic.1fr1.net/"

    picture 16
    width 16,12
    height 16,12
    top 16,height_client(0)-12
    left 16,width_client(0)-12
    color 16,240,240,240
    2d_target_is 16
    2d_pen_color 0,0,0
    2d_rectangle 6,0,8,2 
    2d_rectangle 3,3,5,5 
    2d_rectangle 6,3,8,5 
    2d_rectangle 0,6,2,8 
    2d_rectangle 3,6,5,8 
    2d_rectangle 6,6,8,8 
end_sub
' ------------------------------------------------------------------------------

sub creerFenetreAPropos()
    dim_local n%
    form 25
    border_small 25
    width 25,width(25) - width_client(25) + 640
    height 25,height(25) - height_client(25) + 360 
    left 25,(screen_x - width(25))/2
    top 25,(screen_y - height(25))/2
    hide 25
    caption 25,"A Propos"
    on_resize 25,redimFenetreAPropos
    on_close 25,fermerFenetreAPropos

    command_target_is 25
    picture 26
    width 26,640
    height 26,360
    color 26,255,255,255
    2d_target_is 26
    2d_pen_width 2
    2d_fill_off

    ' Dcor dgrad vert    
    for n% = 210 to 0 step -1
        2d_pen_color n%/2,147+n%/2,0+n%/2
        2d_ellipse -43-n%,20-n%,1530+n%,700+n%
    next n%

    ' lgende
    alpha 27
    font_name 27,"Arial"
    font_size 27,26
    color 27,255,255,255
    font_color 27,0,0,0
    top 27,125
    left 27,268
    caption 27,nomLogiciel$
    
    ' lgende
    alpha 28
    font_name 28,"Arial"
    font_size 28,13
    color 28,255,255,255
    font_color 28,0,0,0
    top 28,142
    left 28,391
    caption 28,versionLogiciel$
    
    ' lgende
    alpha 29
    font_name 29,"Arial"
    font_size 29,13
    color 29,255,255,255
    font_color 29,0,0,0
    top 29,206
    left 29,233
    caption 29,"La rcriture des mots-cls Panoramic contenus"
    
    ' lgende
    alpha 30
    font_name 30,"Arial"
    font_size 30,13
    color 30,255,255,255
    font_color 30,0,0,0
    top 30,226
    left 30,159
    caption 30,"dans un code-source, en lettres majuscules ou minuscules."
    
    ' avertissement, dcharge de responsabilit
    alpha 31
    font_name 31,"Arial"
    font_size 31,10
    color 31,255,255,255
    font_color 31,0,0,0
    top 31,290
    left 31,55
    annonce$ = "Dvelopp sous Panoramic 0.9.29i9 par Marc, ce logiciel et son code-source sont distribus" + chr$(13)
    annonce$ = annonce$ + "gratuitement sans aucune garantie.  En aucun cas, l'auteur ne saurait tre tenu responsable" + chr$(13)
    annonce$ = annonce$ + "des dommages rsultant de son utilisation."
    caption 31,annonce$
    
    creerLogoPanoramic(30,30)
    
end_sub
' ------------------------------------------------------------------------------

sub creerLogoPanoramic(x%,y%)
    picture 35
    width 35,76
    height 35,76
    color 35,255,255,255
    left 35,x%
    top 35,y%
    cursor_point 35
    hint 35,"https://panoramic.1fr1.net/"
    2d_target_is 35

    ' cercles rouges
    2d_fill_color 255,255,255
    2d_pen_width 3
    2d_pen_color 255,0,0
    2d_circle 38,38,33
    2d_circle 38,38,24

    ' dessin de la lettre "P"
    2d_pen_width 1
    2d_fill_color 50,50,150
    2d_pen_color 50,50,150
    2d_line 28,27,47,27
    2d_line 29,28,49,28
    2d_point 31,29
    2d_rectangle 32,29,38,50
    2d_line 31,48,39,48
    2d_line 30,49,40,49
    2d_rectangle 28,50,43,52
    2d_line 44,29,50,29
    2d_rectangle 45,30,51,32
    2d_rectangle 46,32,52,36
    2d_rectangle 45,36,51,38
    2d_line 44,38,50,38
    2d_line 36,39,49,39
    2d_line 36,40,47,40 

end_sub
' ------------------------------------------------------------------------------

sub creerStringMotsCles()
    dim_local ligne%
    if file_exists(repertoire$ + "motsCles.txt") = 0
        annonce$ = "Le fichier ''motsCles.txt'' contenant la liste des mots-cls est manquant !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Merci de rinstaller le programme !"
        if message_error_ok(annonce$) < 2
            terminate
        end_if
    end_if    
    file_load 7,repertoire$ + "motsCles.txt"

    motsCles$ = " "

    for ligne% = 1 to count(7)
        motsCles$ = motsCles$ + item_read$(7,ligne%) + " " 
    next ligne%
    
    motsCles$ = upper$(motsCles$)
end_sub 
' ------------------------------------------------------------------------------

ouvrir:
    ouvrirFichier()
return
' ------------------------------------------------------------------------------

sub ouvrirFichier()
    if modif$ = "*"
        reponseUtilisateur% = message_information_yes_no("Souhaitez-vous enregistrer votre projet en cours, avant d'en ouvrir un autre ?")
        if reponseUtilisateur% = 0
            exit_sub
        end_if
        if reponseUtilisateur% = 1
            subEnregistrer()
        end_if
    end_if

    if object_exists(20) = 0
        open_dialog 20
    end_if    

    filter 20,"Basic Files|*.bas"
    file_dialog 20,""
    nomFichier$ = file_name$(20)

    if nomFichier$ = "_"
        return
    end_if
        
    file_load 1,nomFichier$
    modif$ = ""
    caption 15,nomFichier$ + modif$
end_sub
' ------------------------------------------------------------------------------

majuscules:
    if text$(1) = ""
        return 
    end_if

    inactive 0
    modif$ = "*"
    caption 15,nomFichier$ + modif$
    convertir(2)
    active 0
return
' ------------------------------------------------------------------------------

minuscules:
    if text$(1) = ""
        return 
    end_if

    inactive 0
    modif$ = "*"
    caption 15,nomFichier$ + modif$
    convertir(1)
    active 0
return
' ------------------------------------------------------------------------------

ajouterMotCle:
    nouveauMotCle$ = upper$(trim$(text$(7)))

    if nouveauMotCle$ = ""
        text 7,""
        return
    end_if    

    if instr(nouveauMotCle$," ") > 0
        annonce$ = "Mot-cl non valide !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'ajout n'est pas autoris."
        reponseUtilisateur% = message_warning_ok(annonce$)
        return
    end_if

    if instr(nouveauMotCle$,"(") > 0 or instr(nouveauMotCle$,")") > 0
        annonce$ = "Tapez votre mot-cl sans les parenthses !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le mot-cl n'a pas t ajout."
        reponseUtilisateur% = message_warning_ok(annonce$)
        return
    end_if

    if instr(motsCles$," " + nouveauMotCle$ + " ") > 0 :' vrification si doublon
        annonce$ = "Le mot-cl " + text$(7) + " existe dj dans la liste !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'ajout n'est pas autoris."
        reponseUtilisateur% = message_warning_ok(annonce$) 
        text 7,""
        return
    end_if

    item_add 7,nouveauMotCle$
    annonce$ = "Le mot-cl " + nouveauMotCle$ + " a t ajout  la liste."
    reponseUtilisateur% = message_information_ok(annonce$)
    text 7,""
return
' ------------------------------------------------------------------------------

supprimerMotcle:
     if item_index$(7) = ""
         return
     end_if
     annonce$ = "Supprimer le mot-cl : " + item_index$(7) + " ?"
     reponseUtilisateur% = message_confirmation_yes_no(annonce$)
     if reponseUtilisateur% = 1
         item_delete 7,item_index(7)
     end_if
return
' ------------------------------------------------------------------------------

sub convertir(choix%)
    dim_local mot1$
    inactive 0
    source2$ = upper$(text$(1))
    source2$ = source2$ + chr$(13)+chr$(10) 
    index% = 1

    while index% <= len(source2$)
        lectureMot()
        mot1$ = " " + mot$ + " "
        if instr(motsCles$,mot1$) > 0 :' test si le mot trouv est un mot-cl
            select_text 1,index%-len(mot$)-1,len(mot$)
            select_delete 1
            if choix% = 1
                text_insert 1,index%-len(mot$)-2,lower$(mot$)
            else
                text_insert 1,index%-len(mot$)-2,upper$(mot$)
            end_if
        end_if
    end_while
    active 0
    annonce$ = "Les mots-cls ont t rcrits en lettres "

    if choix% = 1
        annonce$ = annonce$ + "minuscules."
    else
        annonce$ = annonce$ + "majuscules." 
    end_if 
    reponseUtilisateur% = message_information_ok(annonce$)      
end_sub
' ------------------------------------------------------------------------------

sub lectureMot()
    dim_local a$, r%

    ' recherche dbut d'un mot
    while index% < len(source2$)
        a$=MID$(Source2$,index%,1)
        r%=INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ23",a$)
        index% = index% + 1
        if r% > 0
            mot$ = a$
            exit_while
        end_if
    end_while

    ' recherche fin du mot
    while index% <= len(source2$)
        a$=MID$(Source2$,index%,1)
        r%=INSTR(chr$(13)+" ,()+-*/:="+chr$(34),a$)
        index% = index% + 1
        if r% = 0
            mot$ = mot$ + a$
        else
            exit_while
        end_if
    end_while
end_sub
' ------------------------------------------------------------------------------

enregistrer:
    subEnregistrer()
return
' ------------------------------------------------------------------------------

sub subEnregistrer()
    dim_local nomDuProjet$, b$, longueurNomProjet%, pos%, n%

    if text$(1) = ""
        exit_sub
    end_if
    
    if object_exists(21) = 0
        save_dialog 21
    end_if
        
    filter 21,"Basic Files|*.bas"
    file_dialog 21,nomFichier$
    nomDuProjet$ = file_name$(21)

    if nomDuProjet$ = "_" or nomDuProjet$ = ""
        exit_sub
    end_if
        
    if file_exists(nomDuProjet$) = 1
         if message_confirmation_yes_no("Ce nom de fichier existe dj. Le remplacer ?") <> 1
             exit_sub
         end_if    
    end_if

    b$=UPPER$(nomDuProjet$)
    
    if file_extract_extension$(b$) <> ".BAS"
        if file_extract_extension$(b$) <> ""
            longueurNomProjet% = len(nomNouveauProjet$)
            pos% = instr_right(nomDuProjet$,".")
            n% = longueurNomProjet% - pos%
            nomDuProjet$ = left$(nomDuProjet$,n%)
        end_if
        nomDuProjet$ = nomDuProjet$ + ".bas"
    end_if
    
    file_save 1,nomDuProjet$
    nomFichier$ = nomDuProjet$
    modif$ = ""
    caption 15,nomFichier$ + modif$
end_sub
' ------------------------------------------------------------------------------

afficherFenetreAPropos:
    show 25
    to_foreground 25
    inactive 0
return
' ------------------------------------------------------------------------------

fermerFenetreAPropos:
    active 0
    hide 25
return
' ------------------------------------------------------------------------------

redimFenetreAPropos:
    off_resize 25
    width 25,width(25) - width_client(25) + 640
    height 25,height(25) - height_client(25) + 360
    on_resize 25,redimFenetreAPropos 
return
' ------------------------------------------------------------------------------

redim0:
    width 1,width_client(0)
    height 1,height_client(0)-70
    top 15,height_client(0)-20
    top 16,height_client(0)-12
    left 16,width_client(0)-12
return
' ------------------------------------------------------------------------------

quitter:
    if modif$ = "*"
        close_inactive
            reponseUtilisateur% = message_information_yes_no("Souhaitez-vous enregistrer votre projet en cours avant de quitter ?")
            if reponseUtilisateur% = 0
                return
            end_if
            if reponseUtilisateur% = 1
                subEnregistrer()
            end_if
        close_active
    end_if    

    file_save 7,repertoire$ + "motsCles.txt" 
    terminate    
return   