' Panoramic => Arduino UNO
' Logiciel de dmonstration
' Commande en tout ou rien des GPIO 2  13
' Marc - juillet 2021

dim portCom%, i%

label onOffSerial, choixPortCom, action, redim0

dessinerInterfaceUtilisateur()

end

action:
    select number_click
        case 12
            if checked(12) = 0
                serial_write 60,chr$(2)+chr$(1)+chr$(255)
                color 42,0,255,0
            else
                serial_write 60,chr$(2)+chr$(0)+chr$(255)
                color 42,127,127,127
            end_if

        case 13
            if checked(13) = 0
                serial_write 60,chr$(3)+chr$(1)+chr$(255)
                color 43,0,255,0
            else
                serial_write 60,chr$(3)+chr$(0)+chr$(255)
                color 43,127,127,127
            end_if
            
        case 14
            if checked(14) = 0
                serial_write 60,chr$(4)+chr$(1)+chr$(255)
                color 44,0,255,0
            else
                serial_write 60,chr$(4)+chr$(0)+chr$(255)
                color 44,127,127,127
            end_if

        case 15
            if checked(15) = 0
                serial_write 60,chr$(5)+chr$(1)+chr$(255)
                color 45,0,255,0
            else
                serial_write 60,chr$(5)+chr$(0)+chr$(255)
                color 45,127,127,127
            end_if
        
        case 16
            if checked(16) = 0
                serial_write 60,chr$(6)+chr$(1)+chr$(255)
                color 46,0,255,0
            else
                serial_write 60,chr$(6)+chr$(0)+chr$(255)
                color 46,127,127,127
            end_if
        
        case 17
            if checked(17) = 0
                serial_write 60,chr$(7)+chr$(1)+chr$(255)
                color 47,0,255,0
            else
                serial_write 60,chr$(7)+chr$(0)+chr$(255)
                color 47,127,127,127
            end_if
        
        case 18
            if checked(18) = 0
                serial_write 60,chr$(8)+chr$(1)+chr$(255)
                color 48,0,255,0
            else
                serial_write 60,chr$(8)+chr$(0)+chr$(255)
                color 48,127,127,127
            end_if
        
        case 19
            if checked(19) = 0
                serial_write 60,chr$(9)+chr$(1)+chr$(255)
                color 49,0,255,0
            else
                serial_write 60,chr$(9)+chr$(0)+chr$(255)
                color 49,127,127,127
            end_if

        case 20
            if checked(20) = 0
                serial_write 60,chr$(10)+chr$(1)+chr$(255)
                color 50,0,255,0
            else
                serial_write 60,chr$(10)+chr$(0)+chr$(255)
                color 50,127,127,127
            end_if

        case 21
            if checked(21) = 0
                serial_write 60,chr$(11)+chr$(1)+chr$(255)
                color 51,0,255,0
            else
                serial_write 60,chr$(11)+chr$(0)+chr$(255)
                color 51,127,127,127
            end_if

        case 22
            if checked(22) = 0
                serial_write 60,chr$(12)+chr$(1)+chr$(255)
                color 52,0,255,0
            else
                serial_write 60,chr$(12)+chr$(0)+chr$(255)
                color 52,127,127,127
            end_if
        
        case 23
            if checked(23) = 0
                serial_write 60,chr$(13)+chr$(1)+chr$(255)
                color 53,0,255,0
            else
                serial_write 60,chr$(13)+chr$(0)+chr$(255)
                color 53,127,127,127
            end_if

    end_select
return


choixPortCom:
    portCom% = item_index(2)
    if serial_port_exists(portCom%) = 0
        if message_warning_ok("COM"+str$(portCom%) + " : Liaison srie inexistante !") < 2
            inactive 3 :' interrupteur on/off Serial
            return
        end_if    
    end_if
    active 3 :' interrupteur on/off Serial
return


onOffSerial:
    if checked(3) = 0
        inactive 2
        initialisationLiaisonSerie()
        serial_open 60
        for i% = 12 to 23
            active i%
        next i%
    else
        serial_close 60
        active 2
        for i% = 12 to 23
            inactive i%
        next i%
    end_if        
return


sub initialisationLiaisonSerie()
    if object_exists(60) = 0
        serial 60
    end_if
    serial_port 60,portCom%
    serial_baudrate 60,9600
    serial_databits 60,8
    serial_parity 60,0
    serial_stopbits 60,1
end_sub


sub dessinerInterfaceUtilisateur()
    width 0,width(0) - width_client(0) + 1010
    height 0,height(0) - height_client(0) + 180
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    on_resize 0,redim0
    caption 0,"PANORAMIC --> Arduino UNO       Commande des GPIO"
    creerModuleSerial()
    creerModuleInterrupteursGpio()
end_sub


sub creerModuleSerial()
    dim_local n%

    command_target_is 0

    container 1
    width 1,100
    height 1,150
    left 1,15
    top 1,15
    caption 1,"Serial"
  
    command_target_is 1
    
    combo 2
    parent 2,1
    width 2,70
    top 2,30
    left 2,15
    for n% = 1 to 255
        item_add 2,"COM" + str$(n%)
    next n%
    on_change 2,choixPortCom

    switch1 3
    parent 3,1
    width 3,50
    top 3,70
    left 3,25
    caption 3,"Off|On"
    on_click 3,onOffSerial
    inactive 3
end_sub


sub creerModuleInterrupteursGpio()
    dim_local n%,e%,numeroGpio%
    command_target_is 0
    
    container 10
    width 10,865
    height 10,150
    top 10,15
    left 10,130
    caption 10,"GPIO"
    
    ' dessiner les interrupteurs de commande des GPIO
    numeroGpio% = 2
    e% = 23
    
    for n% = 12 to 23
        switch1 n%
        parent n%,10
        width n%,50
        top n%,70
        left n%,e%
        caption n%,str$(numeroGpio%)+": Off|"+str$(numeroGpio%)+": On"
        on_click n%, action
        inactive n%
        e% = e% + 70
        numeroGpio% = numeroGpio% + 1
    next n%
    
    ' dessiner LEDs au dessus des interrupteurs de commande GPIO
    e% = 36
    for n% = 42 to 53
        led1 n%
        parent n%,10
        top n%,28
        left n%,e%
        color n%,127,127,127
        e% = e% + 70
    next n%
end_sub


redim0:
   width 0,width(0) - width_client(0) + 1010
   height 0,height(0) - height_client(0) + 180
return