' Scan COM1  255
' Marc - mai 2021

dim n%, comN%(255), quitter%
dim trameRTF$

interfaceUtilisateur()

initPortComPresent()

rechercheModifPortCom()

end

sub initPortComPresent()
    hide 2
    for n% = 1 to 255
        if inkey$ = chr$(27)
            quitter% = 1
            exit_for
        end_if
        if serial_port_exists(n%) = 1
            comN%(n%) = 1
        end_if
    next n%
    if quitter% = 1
        terminate
    end_if
    show 2    
end_sub

sub rechercheModifPortCom()
    dim_local key%
    while scancode <> 27
        for n% = 1 to 255
            if serial_port_exists(n%) = 1
                if comN%(n%) = 0
                    comN%(n%) = 1
                    item_add 2,time$ + "  COM" + str$(n%) + " has been added"
                end_if
            else
                if comN%(n%) = 1
                    comN%(n%) = 0
                    item_add 2,time$ + "  COM" + str$(n%) + " has been deleted"
                end_if    
            end_if
        if count(2) > 0
            item_select 2,count(2)
        end_if
        next n%
        pause 20
        key% = scancode
        if key% = 82
            hide 2
            clear 2
            initPortComPresent()            
        end_if
        if key% = 27
            exit_while
        end_if    
    end_while
    terminate
end_sub

sub interfaceUtilisateur()
    border_hide 0
    width 0,300
    height 0,200
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    color 0,240,240,240

    alpha 1
    left 1,65
    top 1,12
    caption 1,"Scan COM1 to 255"

    list 2
    height 2,130
    width 2,270
    left 2,15
    top 2,38
    color 2,255,255,255
    hide 2

    alpha 3
    left 3,30
    top 3,175
    caption 3,"R: reset"

    alpha 4
    left 4,224
    top 4,175
    caption 4,"ESC: Quit"

    alpha 5
    top 5,95
    left 5,35
    font_size 5,10
    caption 5,"Initialization in progress ... Please wait!"

    picture 6
    width 6,44
    height 6,18
    top 6,10
    left 6,16
    color 6,255,255,255
    2d_target_is 6
    2d_pen_color 0,0,0
    2d_fill_color 0,0,0
    2d_line 2,0,42,0
    2d_point 42,1
    2d_line 43,2,43,16
    2d_point 42,16
    2d_line 2,17,42,17
    2d_point 1,16
    2d_line 0,2,0,16
    2d_point 1,1
    2d_line 4,7,7,7
    2d_rectangle 3,8,8,11
    2d_line 4,11,7,11
    2d_line 10,4,34,4
    2d_line 9,5,9,7
    2d_line 10,7,10,9
    2d_line 11,9,11,11
    2d_line 12,11,12,13
    2d_line 13,13,31,13
    2d_line 34,5,34,7
    2d_line 33,7,33,9
    2d_line 32,9,32,11
    2d_line 31,11,31,13
    2d_rectangle 13,6,15,8
    2d_rectangle 17,6,19,8
    2d_rectangle 21,6,23,8
    2d_rectangle 25,6,27,8
    2d_rectangle 29,6,31,8
    2d_rectangle 15,10,17,12
    2d_rectangle 19,10,21,12
    2d_rectangle 23,10,25,12
    2d_rectangle 27,10,29,12
    2d_line 37,7,40,7
    2d_rectangle 36,8,41,11
    2d_line 37,11,40,11
    2d_flood 0,0,240,240,240
    2d_flood 43,0,240,240,240
    2d_flood 0,17,240,240,240
    2d_flood 43,17,240,240,240
    2d_flood 10,5,240,240,240
end_sub