rem ============================================================================
rem       Calcul du lever et du coucher du Soleil pour une date donne
rem                Par JL35 et Papydall
rem ============================================================================
LABEL Lcs,Mois
DIM lat,long,b$,i,j,m,a,lm(12),n$(12),bi
lm(1)=31: lm(2)=28: lm(3)=31: lm(4)=30: lm(5)=31: lm(6)=30
lm(7)=31: lm(8)=31: lm(9)=30: lm(10)=31: lm(11)=30: lm(12)=31
n$(1)="Janvier": n$(2)="Fvrier": n$(3)="Mars": n$(4)="Avril": n$(5)="Mai"
n$(6)="Juin": n$(7)="Juillet": n$(8)="Aot": n$(9)="Septembre": n$(10)="Octobre"
n$(11)="Novembre": n$(12)="Dcembre"
lat = 48.8534: long = 2.3488: ' *** latitude, longitude de Paris ***
BORDER_SMALL 0
i = WIDTH(0)-WIDTH_CLIENT(0): WIDTH 0,190+i
i = HEIGHT(0)-HEIGHT_CLIENT(0): HEIGHT 0,100+i
COLOR 0,220,255,255
LEFT 0,(SCREEN_X-WIDTH(0))/2: TOP 0,50
CAPTION 0,"LEVER / COUCHER  DU  SOLEIL": FONT_SIZE 0,12
ALPHA 1: LEFT 1,5: CAPTION 1," Jour    Mois  Anne"
SPIN 2: TOP 2,TOP(1)+18: LEFT 2,LEFT(1): WIDTH 2,45: MIN 2,1: MAX 2,31
SPIN 3: TOP 3,TOP(2): LEFT 3,LEFT(2)+WIDTH(2)+5: WIDTH 3,45: MIN 3,1: MAX 3,12
SPIN 4: TOP 4,TOP(3): LEFT 4,LEFT(3)+WIDTH(3)+5: WIDTH 4,60: MIN 4,2000
        MAX 4,2050: ' arbitraire
ALPHA 6: TOP 6,TOP(2)+30: LEFT 6,8: CAPTION 6," Lever  Coucher  Dure"
EDIT 7: TOP 7,TOP(6)+18: LEFT 7,LEFT(6): WIDTH 7,50
EDIT 8: TOP 8,TOP(7): LEFT 8,LEFT(7)+WIDTH(7)+10: WIDTH 8,WIDTH(7)
EDIT 9: TOP 9,TOP(8): LEFT 9,LEFT(8)+WIDTH(8)+10: WIDTH 9,WIDTH(8)
FOR i = 7 TO 9: COLOR i,255,255,0: NEXT i
BUTTON 10: TOP 10,0: WIDTH 10,20: LEFT 10,WIDTH_CLIENT(0)-WIDTH(10)
           HEIGHT 10,20: CAPTION 10,"M": FONT_BOLD 10: ON_CLICK 10,Mois

FORM 20: BORDER_SMALL 20: HIDE 20
TOP 20,TOP(0)+HEIGHT(0): LEFT 20,LEFT(0): WIDTH 20,WIDTH(0): HEIGHT 20,650
LIST 21: PARENT 21,20: FULL_SPACE 21: FONT_NAME 21,"Consolas": FONT_SIZE 21,12
         COLOR 21,255,255,200
'
j = DATE_DAY : m = DATE_MONTH : a = DATE_YEAR
POSITION 2,j: POSITION 3,m: POSITION 4,a
FOR i = 2 TO 4: COLOR i,255,255,220: ON_CHANGE i,Lcs: NEXT i
GOSUB Lcs
END
' =============================================================================  
Lcs:
  ' Lever, coucher, dure pour le jour slectionn
  a = POSITION(4): lm(2) = 28
  IF (MOD(a,4) = 0) AND ((MOD(a,100) > 0) OR (MOD(a,400) = 0)) THEN lm(2) = 29  
  j = POSITION(2): m = POSITION(3): a = POSITION(4)
  MAX 2,lm(m)
  b$ = Lever_Coucher$(lat,long,j,m,a)
  TEXT 7,LEFT$(b$,5): TEXT 8,MID$(b$,7,5): TEXT 9,RIGHT$(b$,5)
RETURN
' =============================================================================
Mois:
  CLEAR 21
  CAPTION 20,"            -   "+UPPER$(n$(m))+" "+STR$(a)+"   -"
  ITEM_ADD 21,"   Lever Couch Dure"
  FOR i = 1 TO lm(m)
      b$ = Lever_Coucher$(lat,long,i,m,a)
      ITEM_ADD 21,""+RIGHT$(" "+STR$(i),2)+" "+b$
  NEXT i
  SHOW 20: TO_FOREGROUND 20
RETURN
' =============================================================================
FNC Lever_Coucher$(Latitude,Longitude,jour,mois,annee)
  ' *************** merci papydall ***************
  ' Heures des lever/coucher de soleil en heures locales pour la France
  ' jour, mois, annee sous forme numrique
  ' Pour Paris: latitude = 48.8534, longitude = 2.3488  
  ' Rendues en chane sous la forme h1:m1 h2:m2 h3:m3
  ' respectivement lever, coucher et dure
    IF LABEL("NeSeLevePas")   = 0 THEN LABEL NeSeLevePas
    IF LABEL("NeSeCouchePas") = 0 THEN LABEL NeSeCouchePas
    IF LABEL("Ete_Hiver") = 0 THEN LABEL Ete_Hiver
    DIM_LOCAL k,jm,jl,e,ob,tex$
    DIM_LOCAL dr,hr,ht,h,j,m,a,L,s,x,y,z,R,rx,ry,ET,DC,cs,ah,pm,hs,fh
    DIM_LOCAL CalculSol$,hs$,pm$,lev$,couch$
    DIM_LOCAL h$,h1,m1,h2,m2,h3,m3,d,qj%,mm,a_h%,b_h%,s_h%
  ' Fuseau horaire et coordonnes gographiques
    k = 0.0172024: jm = 308.67: jl = 21.55: e = 0.0167: ob = 0.4091
  ' Hauteur du soleil au lever et au coucher
    dr = PI/ 180 : hr = PI/ 12 : ht = (-40 / 60) : ht = ht * dr
    Latitude = Latitude * dr : Longitude = 0-Longitude * dr
  ' Date
    IF (mois < 3) then mois = mois + 12
  ' Heure TU du milieu de la journe
    h = 12 + (Longitude / hr)
  ' Nombre de jours couls depuis le 1 Mars O h TU
    J = int(30.61 * (mois + 1)) + jour + (h / 24) - 123
  ' Anomalie et longitude moyenne
    M = k * (J - jm) : L = k * (J - jl)
  ' Longitude vraie
    S = L + 2 * e * Sin(M) + 1.25 * e * e * Sin(2 * M)
  ' Coordonnes rectangulaires du soleil dans le repre quatorial
    X = Cos(S) : Y = Cos(ob) * Sin(S) : Z = Sin(ob) * Sin(S)
  ' Equation du temps et dclinaison
    R = L  : rx = Cos(R) * X + Sin(R) * Y : ry = 0-Sin(R) * X + Cos(R) * Y
    X = rx : Y  = ry : ET = atn(Y / X)    : DC = atn(Z / Sqr(1 - Z * Z))
  ' Angle horaire au lever et au coucher
  cs = (Sin(ht) - Sin(Latitude) * Sin(DC)) / Cos(Latitude) / Cos(DC)
  IF (cs > 1)  then CalculSol$ = "Ne se lve pas"   : goto NeSeLevePas
  IF (cs < -1) then CalculSol$ = "Ne se couche pas" : goto NeSeCouchePas
  IF (cs = 0)  then ah = PI / 2 : ELSE : ah = atn(Sqr(1 - cs * cs) / cs)
  IF (cs < 0)  then ah = ah + PI
  ' Lever du soleil
  pm = h + fh + (ET - ah) / hr
  IF (pm < 0) then pm = pm + 24
  IF (pm > 24) then pm = pm - 24
  hs = int(pm) : pm = int(60 * (pm - hs))
  hs$ = RIGHT$("0"+STR$(hs),2): pm$ = RIGHT$("0"+STR$(pm),2)
NeSeLevePas:
  IF CalculSol$ = "" then lev$ = hs$ + ":" + pm$ : ELSE : lev$ = "-----"
  ' Coucher du soleil
  pm = h + fh + (ET + ah) /hr
  IF pm > 24 then pm = Pm - 24
  IF pm < 0  then pm = pm + 24
  hs = int(pm) : pm = int(60 * (pm - hs))
  hs$ = str$(hs) : pm$ = str$(pm)
  IF len(str$(hs)) < 2 then hs$ = "0" + str$(hs)
  IF len(str$(Pm)) < 2 then pm$ = "0" + str$(pm)
NeSeCouchePas:
  IF CalculSol$ = "" THEN couch$ = hs$ + ":" + pm$ : ELSE : couch$  = "-----"
  h1 = VAL(LEFT$(lev$,2)): m1 = VAL(MID$(lev$,4,2)): ' h:m lever
  h2 = VAL(LEFT$(couch$,2)): m2 = VAL(MID$(couch$,4,2)): ' h:m coucher
  d = h2*60+m2-(h1*60+m1): h3 = INT(d/60): m3 = d-h3*60: ' h:m dure  
  ' Heures locales
  j = jour: m = mois: a = annee
  h1 = h1+1: h2 = h2+1: ' heure d'hiver (GMT+1)
  IF m > 3 AND m < 10 THEN h1 = h1+1: h2 = h2+1: ' heure d't (GMT+2)
  IF m = 3
      GOSUB Ete_Hiver: IF j >= qj% THEN h1 = h1+1: h2 = h2+1
  ELSE
      IF m = 10
          GOSUB Ete_Hiver: IF j < qj% THEN h1 = h1+1: h2 = h2+1
      END_IF
  END_IF
  h$ = RIGHT$("0"+STR$(h1),2)+":"+RIGHT$("0"+STR$(m1),2)
  h$ = h$+" "+RIGHT$("0"+STR$(h2),2)+":"+RIGHT$("0"+STR$(m2),2)
  h$ = h$+" "+RIGHT$("0"+STR$(h3),2)+":"+RIGHT$("0"+STR$(m3),2)
  RESULT h$: EXIT_FNC
Ete_Hiver:
  mm = m-2
  s_h% = INT(a/100): a_h% = a - s_h%*100
  b_h% = INT(2.6*mm - .19) + 31 + a_h%+INT(a_h%/4)+INT(s_h%/4)-s_h%*2
  qj% = 31-INT((b_h%/7-INT(b_h%/7))*7+.1)
RETURN  
END_FNC
rem ===========================================================================