' Calendrier des lever/coucher/dures de soleil pour l'anne courante
' Rsultat: image A4 paysage dans fs$ (bmp) et dans le presse-papier
DIM fs$,wm,hm,wj,hj,x,y,i,mg,mh,lm(12),n$(12),j,m,a,b$,l$,c$,d$
fs$ = "C:\TEMP\Calsol.bmp": ' Image rsultat,  ajuster
lm(1)=31: lm(2)=28: lm(3)=31: lm(4)=30: lm(5)=31: lm(6)=30: lm(7)=31
lm(8)=31: lm(9)=30: lm(10)=31: lm(11)=30: lm(12)=31
n$(1)="JANVIER": n$(2)="FVRIER": n$(3)="MARS": n$(4)="AVRIL": n$(5)="MAI"
n$(6)="JUIN": n$(7)="JUILLET": n$(8)="AOT": n$(9)="SEPTEMBRE": n$(10)="OCTOBRE"
n$(11)="NOVEMBRE": n$(12)="DCEMBRE"
WIDTH 0,1120: HEIGHT 0,850
PICTURE 1: WIDTH 1,1100: HEIGHT 1,779
  2D_TARGET_IS 1: PRINT_TARGET_IS 1: 2D_FILL_OFF
  FONT_NAME 1,"Consolas": FONT_SIZE 1,10
mg = 5: mh = 16: hm = 18: wm = 91: wj = 19: hj = 24
' Valeurs pour l'anne, jour aprs jour
a = DATE_YEAR: lm(2) = 28
IF (MOD(a,4) = 0) AND ((MOD(a,100) > 0) OR (MOD(a,400) = 0)) THEN lm(2) = 29
FOR m = 1 TO 12
    x = mg+(m-1)*wm
    FOR j = 1 TO lm(m)
        b$ = Lever_Coucher$(48.8534,2.3488,j,m,a)
        l$ = LEFT$(b$,5): c$ = MID$(b$,7,5): d$ = RIGHT$(b$,5)
        y = mh+hm+(j-1)*hj
        FONT_SIZE 1,10: FONT_BOLD 1
        PRINT_LOCATE x+2,y+4: PRINT RIGHT$(" "+STR$(j),2): ' jour
        FONT_BOLD_OFF 1
        PRINT_LOCATE x+wj+2,y-1: PRINT l$: ' lever
        PRINT_LOCATE x+wj+2,y+11: PRINT c$: ' coucher
        FONT_SIZE 1,8
        PRINT_LOCATE x+wj+39,y+5: PRINT d$: ' dure
    NEXT j
NEXT m

y = mh
FOR i = 0 TO 12: ' lignes verticales
    x = mg+i*wm: 2D_LINE x,y,x,778: 2D_LINE x+wj,mh+hm,x+wj,778
NEXT i
FOR i = 1 TO 31: ' lignes horizontales
    y = mh+hm+(i-1)*hj: x = mg
    2D_LINE x,y,x+12*wm,y
NEXT i

FONT_SIZE 1,12: FONT_COLOR 1,0,0,255: FONT_BOLD 1
x = mg
FOR i = 1 TO 12
    b$ = n$(i): j = TEXT_WIDTH(b$,1)
    PRINT_LOCATE x+(wm-j)/2,16: PRINT n$(i): ' nom du mois
    x = x+wm
NEXT i
2D_LINE mg,mh+hm,mg+12*wm,mh+hm

b$ = "Levers, couchers de soleil et dure du jour (Paris) pour "+STR$(a)
FONT_COLOR 1,200,0,0
j = TEXT_WIDTH(b$,1): x = (WIDTH(1)-j)/2
PRINT_LOCATE x,-2: PRINT b$
2D_PEN_WIDTH 2: 2D_RECTANGLE mg,mh,mg+wm*12,mh+hm+31*hj+2
2D_LINE mg,mh+hm,mg+12*wm,mh+hm
FOR m = 1 TO 11: 2D_LINE mg+wm*m,mh,mg+wm*m,mh+hm+32*hj: NEXT m
IF DIR_EXISTS(FILE_EXTRACT_PATH$(fs$)) = 1 THEN FILE_SAVE 1,fs$
CLIPBOARD_COPY 1
END
' =============================================================================
FNC Lever_Coucher$(Latitude,Longitude,jour,mois,annee)
  ' *************** merci papydall ***************
  ' Heures des lever/coucher de soleil en heures locales pour la France
  ' jour, mois, annee sous forme numrique
  ' Pour Paris: latitude = 48.8534, longitude = 2.3488 
  ' Rendues en chane sous la forme h1:m1 h2:m2 h3:m3
  ' respectivement lever, coucher et dure
    IF LABEL("NeSeLevePas")  = 0 THEN LABEL NeSeLevePas
    IF LABEL("NeSeCouchePas") = 0 THEN LABEL NeSeCouchePas
    IF LABEL("Ete_Hiver") = 0 THEN LABEL Ete_Hiver
    DIM_LOCAL k,jm,jl,e,ob,tex$
    DIM_LOCAL dr,hr,ht,h,j,m,a,L,s,x,y,z,R,rx,ry,ET,DC,cs,ah,pm,hs,fh
    DIM_LOCAL CalculSol$,hs$,pm$,lev$,couch$
    DIM_LOCAL h$,h1,m1,h2,m2,h3,m3,d,qj%,mm,a_h%,b_h%,s_h%
  ' Fuseau horaire et coordonnes gographiques
    k = 0.0172024: jm = 308.67: jl = 21.55: e = 0.0167: ob = 0.4091
  ' Hauteur du soleil au lever et au coucher
    dr = PI/ 180 : hr = PI/ 12 : ht = (-40 / 60) : ht = ht * dr
    Latitude = Latitude * dr : Longitude = 0-Longitude * dr
  ' Date
    IF (mois < 3) then mois = mois + 12
  ' Heure TU du milieu de la journe
    h = 12 + (Longitude / hr)
  ' Nombre de jours couls depuis le 1 Mars O h TU
    J = int(30.61 * (mois + 1)) + jour + (h / 24) - 123
  ' Anomalie et longitude moyenne
    M = k * (J - jm) : L = k * (J - jl)
  ' Longitude vraie
    S = L + 2 * e * Sin(M) + 1.25 * e * e * Sin(2 * M)
  ' Coordonnes rectangulaires du soleil dans le repre quatorial
    X = Cos(S) : Y = Cos(ob) * Sin(S) : Z = Sin(ob) * Sin(S)
  ' Equation du temps et dclinaison
    R = L  : rx = Cos(R) * X + Sin(R) * Y : ry = 0-Sin(R) * X + Cos(R) * Y
    X = rx : Y  = ry : ET = atn(Y / X)    : DC = atn(Z / Sqr(1 - Z * Z))
  ' Angle horaire au lever et au coucher
  cs = (Sin(ht) - Sin(Latitude) * Sin(DC)) / Cos(Latitude) / Cos(DC)
  IF (cs > 1)  then CalculSol$ = "Ne se lve pas"  : goto NeSeLevePas
  IF (cs < -1) then CalculSol$ = "Ne se couche pas" : goto NeSeCouchePas
  IF (cs = 0)  then ah = PI / 2 : ELSE : ah = atn(Sqr(1 - cs * cs) / cs)
  IF (cs < 0)  then ah = ah + PI
  ' Lever du soleil
  pm = h + fh + (ET - ah) / hr
  IF (pm < 0) then pm = pm + 24
  IF (pm > 24) then pm = pm - 24
  hs = int(pm) : pm = int(60 * (pm - hs))
  hs$ = RIGHT$("0"+STR$(hs),2): pm$ = RIGHT$("0"+STR$(pm),2)
NeSeLevePas:
  IF CalculSol$ = "" then lev$ = hs$ + ":" + pm$ : ELSE : lev$ = "-----"
  ' Coucher du soleil
  pm = h + fh + (ET + ah) /hr
  IF pm > 24 then pm = Pm - 24
  IF pm < 0  then pm = pm + 24
  hs = int(pm) : pm = int(60 * (pm - hs))
  hs$ = str$(hs) : pm$ = str$(pm)
  IF len(str$(hs)) < 2 then hs$ = "0" + str$(hs)
  IF len(str$(Pm)) < 2 then pm$ = "0" + str$(pm)
NeSeCouchePas:
  IF CalculSol$ = "" THEN couch$ = hs$ + ":" + pm$ : ELSE : couch$  = "-----"
  h1 = VAL(LEFT$(lev$,2)): m1 = VAL(MID$(lev$,4,2)): ' h:m lever
  h2 = VAL(LEFT$(couch$,2)): m2 = VAL(MID$(couch$,4,2)): ' h:m coucher
  d = h2*60+m2-(h1*60+m1): h3 = INT(d/60): m3 = d-h3*60: ' h:m dure 
  ' Heures locales
  j = jour: m = mois: a = annee
  h1 = h1+1: h2 = h2+1: ' heure d'hiver (GMT+1)
  IF m > 3 AND m < 10 THEN h1 = h1+1: h2 = h2+1: ' heure d't (GMT+2)
  IF m = 3
      GOSUB Ete_Hiver: IF j >= qj% THEN h1 = h1+1: h2 = h2+1
  ELSE
      IF m = 10
          GOSUB Ete_Hiver: IF j < qj% THEN h1 = h1+1: h2 = h2+1
      END_IF
  END_IF
  h$ = RIGHT$("0"+STR$(h1),2)+":"+RIGHT$("0"+STR$(m1),2)
  h$ = h$+" "+RIGHT$("0"+STR$(h2),2)+":"+RIGHT$("0"+STR$(m2),2)
  h$ = h$+" "+RIGHT$("0"+STR$(h3),2)+":"+RIGHT$("0"+STR$(m3),2)
  RESULT h$: EXIT_FNC
Ete_Hiver:
  mm = m-2
  s_h% = INT(a/100): a_h% = a - s_h%*100
  b_h% = INT(2.6*mm - .19) + 31 + a_h%+INT(a_h%/4)+INT(s_h%/4)-s_h%*2
  qj% = 31-INT((b_h%/7-INT(b_h%/7))*7+.1)
RETURN 
END_FNC
rem ===========================================================================