
rem ============================================================================
rem              Cadre pour vos textes
rem ============================================================================
dim x,y,w
WIDTH 0,600: HEIGHT 0,600
PICTURE 10: FULL_SPACE 10 : 2D_TARGET_IS 10 : 2D_FILL_COLOR 255,255,0
PRINT_TARGET_IS 10 :  font_bold 10 : font_size 10,12
x = 100 : y = 50 : w = 400
2D_PEN_COLOR 255,0,0 : 2D_PEN_WIDTH 2

Cadretoile(10,x,y,w,5)
2d_flood 300,300,200,100,200
caption 0,"<ESC> pour terminer ..."
2d_fill_on : 2d_fill_color 255,255,255
repeat
    font_color 10,255,0,0
    print_locate 270,200 : print "Coucou !"
    print_locate 220,230 : print "Cadre pour vos textes"
    print_locate 230,300 : print "C'est original, non !"
    print_locate 230,350 : print "<ESC> pour sortir ..."
    pause 1000
    font_color 10,0,0,255
    print_locate 270,200 : print "Coucou !"
    print_locate 220,230 : print "Cadre pour vos textes"
    print_locate 230,300 : print "C'est original, non !"
    print_locate 230,350 : print "<ESC> pour sortir ..."
    pause 1000
until scancode = 27
terminate    

END
rem ============================================================================
SUB Cadretoile(p,x0,y0,w,gen)
  ' Cadre fantaisie dans picture p, forme gen = 1 (triangle)  5 (toil)
  ' Trac en x0,y0, w = largeur de la figure (enveloppe ~ carre)
  ' Paramtres actuels : couleur et paisseur de trait.
  DIM_LOCAL L,lg,sin60,cos60,x(4*65536),y(4*65536)
  DIM_LOCAL p4,i,j,k,dx,dy
  IF gen > 5 THEN gen = 5
  i = 2*gen-2: p4 = POWER(2,i)
  ' Init
  L  = w : ' longueur en pixels du ct du triangle initial
  lg = 3 : ' primtre du triangle de dpart de ct 1
  sin60 = sqr(3)/2 : ' sin(60) pour les dplacements
  cos60 = 0.5 : ' cos(60)
  x(0) = x0 : y(0) = y0+2+L*Sin60 : ' 1er point
  x(1) = x(0)+L*Cos60 : y(1) = y(0)-L*Sin60 : ' 2me point
  x(2) = x(0)+L : y(2) = y(0) : ' 3me point
  x(3) = x(0) : y(3) = y(0)
  IF gen > 1
    ' Gnrer
    FOR k = 2 TO gen
      for j = p4 * 3 to 1 step -1 : ' Intercaler les 3 nouveaux points  
        x(j*4) = x(j) : y(j*4) = y(j)
      next j
      for j = 0 to p4 * 3 - 1     : ' On intercale les 3 nouveaux points
        i = 4*j
        dx = (x(i+4)-x(i))/3 : dy = (y(i+4)-y(i))/3 : ' Coupe en 3
        x(i+1) = x(i)+dx : y(i+1) = y(i)+dy         : ' Du 1/3 aux 2/3
        x(i+2) = x(i+1)+cos60*dx+sin60*dy           : ' nouveau point,
        y(i+2) = y(i+1)-sin60*dx+cos60*dy           : ' sommet triangle quilatral
        x(i+3) = x(i)+2*dx : y(i+3) = y(i)+2*dy    
      next j  
    NEXT k
  END_IF  
  ' Dessiner  
  for i = 1 to 3*p4
      2d_circle x(i),y(i),4 : display
  next i
END_SUB
rem ============================================================================