
rem ============================================================================
rem                   Les Chiffres arabes
rem                 Papydall 17 / 05 / 2020
rem ============================================================================  
rem   Le code suivant illustre la calligraphie des chiffres arabes
rem ============================================================================      
picture 10 : full_space 10 : 2d_target_is 10 : print_target_is 10 : color 10,20,100,50
font_bold 10 : font_color 10,255,255,0 : font_size 10,12 : 2d_fill_off
caption 0,"Calligraphie des chiffres arabes"
degrees
Un(40,30)
Deux(120,30)
Trois(240,30)
Quatre(430,30)
Cinq(570,30)
Six(90,250)
Sept(120,250)
Huit(240,250)
Neuf(440,310)
Zero(490,250)
end
rem ============================================================================
SUB Un(x,y)
    if x < 34 then x = 34
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x-30,y+30
    2d_poly_to x,y : 2d_poly_to x,y+120
    2d_pen_width 1 : 2d_pen_color 255,255,0 : 2d_arc x,y,25,270,180+45
    print_locate x-30,y+130 : print " 1 angle "
END_SUB
rem ============================================================================
SUB Deux(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x+80,y : 2d_poly_to x,y+120 : 2d_poly_to x+80,y+120
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_arc x+80,y,25,270-40,180 : 2d_arc x,y+120,25,45,0
    print_locate x,y+130 : print " 2 angles "
END_SUB
rem ============================================================================
SUB Trois(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x+80,y : 2d_poly_to x+20,y+60 : 2d_poly_to x+80,y+120 : 2d_poly_to x,y+120
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_arc x+80,y,25,270-45,180 : 2d_arc x+20,y+60,25,40,360-40 : 2d_arc x+80,y+120,25,180,180-40
    print_locate x,y+130 : print " 3 angles "
END_SUB
rem ============================================================================
SUB Quatre(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y+120 : 2d_poly_to x,y
    2d_poly_to x-80,y+80 : 2d_poly_to x,y+80
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_arc x,y,25,270,180+45 : 2d_arc x-80,y+80,25,45,0
    2d_arc x,y+80,15,270,90
    print_locate x-80,y+130 : print " 4 angles "
END_SUB
rem ============================================================================
SUB Cinq(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x-80,y : 2d_poly_to x-80,y+60 : 2d_poly_to x,y+60
    2d_poly_to x,y+120 : 2d_poly_to x-80,y+120 : 2d_poly_to x-80,y+100
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_poly_from x-70,y : 2d_poly_to x-70,y+10 : 2d_poly_to x-80,y+10
    2d_poly_from x-80,y+50 : 2d_poly_to x-70,y+50 : 2d_poly_to x-70,y+60
    2d_poly_from x-10,y+60 : 2d_poly_to x-10,y+70 : 2d_poly_to x,y+70
    2d_poly_from x,y+110 : 2d_poly_to x-10,y+110  : 2d_poly_to x-10,y+120
    2d_poly_from x-80,y+110 : 2d_poly_to x-70,y+110 : 2d_poly_to x-70,y+120
    print_locate x-80,y+130 : print " 5 angles "
END_SUB
rem ============================================================================
SUB Six(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x-80,y : 2d_poly_to x-80,y+120 : 2d_poly_to x,y+120
    2d_poly_to x,y+60 : 2d_poly_to x-80,y+60
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_poly_from x-70,y : 2d_poly_to x-70,y+10 : 2d_poly_to x-80,y+10
    2d_poly_from x-80,y+50 : 2d_poly_to x-70,y+50
    2d_poly_to x-70,y+70 : 2d_poly_to x-80,y+70
    2d_poly_from x-10,y+60 : 2d_poly_to x-10,y+70 : 2d_poly_to x,y+70
    2d_poly_from x-80,y+110 : 2d_poly_to x-70,y+110 : 2d_poly_to x-70,y+120
    2d_poly_from x,y+110 : 2d_poly_to x-10,y+110 : 2d_poly_to x-10,y+120
    print_locate x-80,y+130 : print " 6 angles "
END_SUB
rem ============================================================================
SUB Sept(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x+80,y : 2d_poly_to x+30,y+120 : 2d_poly_to x+10,y+120
    2d_poly_to x+50,y+120
    2d_line x+20,y+60,x+80,y+60
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_arc x+80,y,25,270-30,180
    2d_circle x+55,y+60,15
    2d_arc x+33,y+120,15,180,0
    print_locate x,y+130 : print " 7 angles "
END_SUB
rem ============================================================================
SUB Huit(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x+80,y : 2d_poly_to x,y+120 : 2d_poly_to x+80,y+120
    2d_poly_to x,y
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_arc x,y,25,0,360-45 : 2d_arc x,y+120,25,45,360
    2d_arc x+80,y,25,180+45,180 : 2d_arc x+80,y+120,25,180,180-45
    2d_fill_off : 2d_circle x+40,y+60,15
    print_locate x,y+130 : print " 8 angles "
END_SUB
rem ============================================================================
SUB Neuf(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255 : 2d_poly_from x,y
    2d_poly_to x-80,y : 2d_poly_to x-80,y-60 : 2d_poly_to x,y-60
    2d_poly_to x,y+60 :  2d_poly_to x-80,y+60
    2d_poly_to x-80,y+30 : 2d_poly_to x-55,y+30 : 2d_poly_to x-55,y+45
    2d_pen_width 1 : 2d_pen_color 255,255,0
    2d_poly_from x,y+10 : 2d_poly_to x-10,y+10 : 2d_poly_to x-10,y-10
    2d_poly_to x,y-10
    2d_poly_from x-70,y-60 : 2d_poly_to x-70,y-50 : 2d_poly_to x-80, y-50
    2d_poly_from x,y-50 : 2d_poly_to x-10,y-50 : 2d_poly_to x-10,y-60
    2d_poly_from x,y+50 : 2d_poly_to x-10,y+50 : 2d_poly_to x-10,y+60
    2d_poly_from x-70,y+60 : 2d_poly_to x-70,y+50 : 2d_poly_to x-80,y+50
    2d_poly_from x-55,y+40 : 2d_poly_to x-65,y+40 : 2d_poly_to x-65,y+30
    2d_poly_from x-80,y+40 : 2d_poly_to x-70,y+40 : 2d_poly_to x-70,y+30
    2d_poly_from x-70,y : 2d_poly_to x-70,y-10 : 2d_poly_to x-80,y-10
    print_locate x-70,y+70 : print " 9 angles "
END_SUB
rem ============================================================================
SUB Zero(x,y)
    2d_pen_width 4 : 2d_pen_color 255,255,255
    2d_ellipse x,y,x+80,y+120
    print_locate x,y+130 : print " 0 angle "
END_SUB
rem ============================================================================