
rem ' Othello - par jjn4 - rnov le le 13-03-2020 ============================
   dim V1M% , V2M% , V3M% , V1D$ : rem Variables  utilisation Multiple
   dim EI% : rem Emplacement Indiqu pour dessiner les pions
   dim CC%(9,9) : rem Pions contenus dans les cases de la grille
   dim CF% : rem Tour de jouer (noir=0 - blanc=1)
   dim CJ% : rem Couleur que joue le joueur seul contre l`ordi (1=Blancs 0=Noirs)
   dim GA%(8,8) : rem Grille d`Analyse de la situation
   dim GR%(8,8) : rem GRille dcorative
   dim IFA% : rem Indicateur de Flches Affiches
   dim IFJ% : rem Indice de Fin de Jeu
   dim MS% : rem Mode Silencieux (1) ou bruyant (0)
   dim NB$(9) : rem Nom des Boutons
   dim NC% : rem Nombre de cases o jouer
   dim NJB% : rem Nombre de Joueurs Biologiques
   dim NQ% : rem Numero de la cellule cliQue
   dim IO% : rem Indicateur du bouton O
   dim JP% : rem Indicateur de Juste Place d`un pion
   dim TB% , TN% : rem Total de points des blancs et des noirs
   dim VL%(8) : rem Valeur des Lignes autour du pion jou
   dim TP$ : rem Titre du Programme
   label clac : rem Redirection de tous les on-click hors grille
   label clic : rem Clic sur une cellule de la grille
   label cloc : rem Gestion du mode silencieux
   label close : rem Gestion de l`on-close
   CC%(5,4)=1 : CC%(5,5)=2 : CC%(4,4)=2 : CC%(4,5)=1 : NJB%=1
   TP$=" Othello - par jjn4 - Ver-130514.3.0"
     
rem form0 et autres prparations ==============================================
   width 0,1365
   height 0,720
   caption 0,TP$
   on_close 0,close
   for V1M% = 1 to 9
      read NB$(V1M%)
   next V1M%
   read V1D$
   for V1M% = 1 to 2
      V1D$=reverse$(V1D$)
      for V3M% = 1+(V1M%-1)*4 to 4+(V1M%-1)*4
         for V2M% = 1 to 8
            GR%(V3M%,V2M%)=asc(mid$(V1D$,((V3M%-1)-(V1M%-1)*4)*8+V2M%,1))-65
         next V2M%
      next V3M%
   next V1M%

rem Cache de prparation de jeu ===============================================
   form 5
      width 5,1365
      height 5,720
      caption 5,"   Othello - Prparation du jeu"
   picture 7
      parent 7,5
      width 7,1349
      height 7,681
      file_load 7,"Oth-Attente.jpg"
   
rem Affichage des lments de commande ========================================
   panel 10
      left 10,679
      width 10,669
      height 10,680
      color 10,0,0,100
   for V1M% = 50 to 54 step 2 : rem Boutons Rejouer(52) Aide(50) et Quitter (54)
      scene2d V1M% : rem N 50, 52 et 54 ---------------
         parent V1M%,10
         left V1M%,((V1M%/2)-25)*220+5
         top V1M%,540
         width V1M%,220
         height V1M%,137
         font_bold V1M%
         font_size V1M%,24
         font_name V1M%,"Arial"
         font_color V1M%,255,255,255
         file_load V1M%,"Oth-Bouton.bmp"
         on_click V1M%,clac
         sprite_target_is V1M%
      sprite V1M%+1 : rem N 51, 53 et 55 --------------
         sprite_text V1M%+1,NB$((V1M%/2)-24)
         sprite_position V1M%+1,160-(text_width(NB$((V1M%/2)-24),0)*3),48
      scene2d V1M%+6 : rem Boutons 1 joueur(56) 2 joueurs(58) et Couleur(60) --
         parent V1M%+6,10 : rem N 56, 58 et 60 -------------
         left V1M%+6,((V1M%/2)-25)*220+5
         top V1M%+6,400
         width V1M%+6,220
         height V1M%+6,137
         font_bold V1M%+6
         font_size V1M%+6,24
         font_name V1M%+6,"Arial"
         font_color V1M%+6,255,255,255
         file_load V1M%+6,"Oth-Bouton.bmp"
         on_click V1M%+6,clac
         sprite_target_is V1M%+6
      sprite V1M%+7 : rem N 57, 59 et 61 --------------
         sprite_text V1M%+7,NB$((V1M%/2)-21)
         sprite_position V1M%+7,160-(text_width(NB$((V1M%/2)-21),0)*3),48
   next V1M%
   left 50,225
   left 52,5
   V3M%=4
   for V1M% = 18 to 58 step 20 : rem Boutons Conseils(18) Inverser(38) et Go(62)
      if V1M%=58
         V2M%=V1M%+V3M%
      else
         V2M%=V1M%
      end_if
      scene2d V2M% : rem N 18, 38 et 62 ----------------
         parent V2M%,10
         left V2M%,(((V1M%+2)/20)-1)*220+5
         top V2M%,260
         width V2M%,220
         height V2M%,137
         font_bold V2M%
         font_size V2M%,24
         font_name V2M%,"Arial"
         font_color V2M%,255,255,255
         file_load V2M%,"Oth-Bouton.bmp"
         on_click V2M%,clac
         sprite_target_is V2M%
      sprite V2M%+1 : rem N 19, 39 et 63 ------------------
         sprite_text V2M%+1,NB$(((V1M%+2)/20)+6)
         sprite_position V2M%+1,160-(text_width(NB$(((V1M%+2)/20)+6),0)*3),48
   next V1M%
   griser(0,38)
   griser(0,52)
   griser(2,56)
   griser(0,62)
   scene2d 70 : rem Indication du tour de jeu ---------------------------------
      parent 70,10
      left 70,545
      top 70,5
      width 70,120
      height 70,120
      font_bold 70
      font_size 70,20
      font_name 70,"Arial"
      font_color 70,255,60,255
      file_load 70,"Oth-Cadre.bmp"
      sprite_target_is 70
   sprite 71
      sprite_text 71,"Vous"
      sprite_position 71,26,13
   sprite 72
      sprite_text 72,"jouez"
      sprite_position 72,25,42
   sprite 73
      sprite_text 73,"Noir"
      sprite_position 73,22,74
      sprite_position 73,30,74
   picture 75 : rem Cadre de dco marqu Othello 2 joueurs --------------------
      parent 75,10
      left 75,545
      top 75,5
      width 75,120
      height 75,120
      file_load 75,"Oth-Note.jpg"
      hide 75
   for V1M% = 40 to 42 step 2 : rem Indication Noir-Blanc pour les points -----
      alpha V1M% : rem N 40 et 42 -----------------
         parent V1M%,10
         left V1M%,((V1M%/2)-20)*74+400
         top V1M%,5
         font_bold V1M%
         font_size V1M%,14
         font_color V1M%,255,60,255
   next V1M%
   caption 40,"Noir"
   caption 42,"Blanc"
   scene2d 43 : rem Cadre pour l`indication des points ------------------------
      parent 43,10
      left 43,373
      top 43,30
      width 43,169
      height 43,93
      font_bold 43
      font_size 43,30
      font_name 43,"Arial"
      font_color 43,255,60,255
      file_load 43,"Oth-Compteur.bmp"
      sprite_target_is 43
   sprite 44
   sprite 45
   scene2d 35 : rem Flche d`indication  qui c`est de jouer ------------------
      parent 35,10
      left 35,1
      top 35,5
      width 35,375
      height 35,120
      font_bold 35
      font_size 35,24
      font_name 35,"Arial"
      font_color 35,255,60,255
      file_load 35,"Oth-Fleche-3.bmp"
      sprite_target_is 35
   sprite 36
      sprite_text 36,"Noir joue"
      sprite_position 36,120,40
   scene2d 180 : rem Bouton Silence -------------------------------------------
      parent 180,10
      left 180,425
      top 180,520
      width 180,40
      height 180,40
      stretch_on 180
      font_size 180,18
      font_name 180,"Webdings"
      font_color 180,255,255,255
      file_load 180,"Oth-Bouton.bmp"
      on_click 180,cloc
      sprite_target_is 180
   sprite 185
      sprite_text 185,chr$(175)
      sprite_position 185,8,8      
   picture 195 : rem Coupe du gagnant -----------------------------------------
      parent 195,10
      left 195,545
      top 195,5
      width 195,120
      height 195,255
      file_load 195,"Oth-Coupe.jpg"
      hide 195
   memo 80 : rem Texte d`accompagnement du jeu --------------------------------
      parent 80,10
      left 80,5
      top 80,127
      width 80,655
      height 80,130
      color 80,0,0,100
      font_bold 80
      font_size 80,20
      font_name 80,"Arial"
      font_color 80,0,255,255
      aff()       
   
rem Affichage de la grille ====================================================
   panel 100
      width 100,680
      height 100,680
      color 100,0,0,0
   for V1M% = 1 to 8 : rem    ( 101-108 + 111-118 + 121-128 + 131-138)   
      for V2M% = 1 to 8 : rem ( 141-148 + 151-158 + 161-168 + 171-178)
         picture 100+(V1M%-1)*10+V2M%
            parent 100+(V1M%-1)*10+V2M%,100
            left 100+(V1M%-1)*10+V2M%,(V2M%-1)*84+5
            top 100+(V1M%-1)*10+V2M%,(8-V1M%)*84+5
            width 100+(V1M%-1)*10+V2M%,83
            height 100+(V1M%-1)*10+V2M%,83
            file_load 100+(V1M%-1)*10+V2M%,"Oth-Feutrine.jpg"
            on_click 100+(V1M%-1)*10+V2M%,clic
         movie 200+(V1M%-1)*10+V2M%
            parent 200+(V1M%-1)*10+V2M%,100
            left 200+(V1M%-1)*10+V2M%,(V2M%-1)*84+5
            top 200+(V1M%-1)*10+V2M%,(8-V1M%)*84+5
            width 200+(V1M%-1)*10+V2M%,83
            height 200+(V1M%-1)*10+V2M%,83
            hide 200+(V1M%-1)*10+V2M%   
      next V2M%
   next V1M%   

rem Tableau d`aide ============================================================
   panel 1000
      hide 1000
      width 1000,1349
      height 1000,681
   memo_rich 1010
      parent 1010,1000
      width 1010,900
      height 1010,680
      color 1010,120,200,80
      file_load 1010,"Oth-Aide.rtf"
      on_click 1010,clac
   picture 1020
      parent 1020,1000
      left 1020,900
      width 1020,449
      height 1020,680
      stretch_on 1020
      file_load 1020,"Oth-Aide.jpg"
      on_click 1020,clac

rem Derniers prparatifs avant le jeu =========================================
   for V1M% = 0 to 1
      for V2M% = 0 to 1
         EI%=134+V1M%*10+V2M%
         dessin(V1M%,V2M%)
      next V2M%
   next V1M%
   sound 1500
   dlist 2000 : dlist 2010 : rem Listes de travail de l`ordinateur
   calcul()
   midi_on
   midi_volume 127
   hide 5

end : ' Dbut des routines ====================================================

sub aff() : rem Affichages du dbut ===========================================
   clear 80
   if NJB%=1
      item_add 80,"Choisissez le nombre de joueur et la couleur"
      if CJ%=0
         item_add 80,"Vous pouvez commencer  jouer maintenant"
      else
         item_add 80,"Cliquez sur  Go  pour commencer  jouer"
      end_if
   else
      item_add 80,"Choisissez le nombre de joueur"
      item_add 80,"Vous pouvez commencer  jouer maintenant"
   end_if
end_sub

sub aide() : rem Afficher le tableau d`aide ===================================
   close_inactive
   caption 0,"   Explication du fonctionnement d'Othello - Cliquez n'importe o pour sortir"
   show 1000
end_sub

sub auto() : rem Jeu de l`ordinateur ==========================================
   dim_local v1au% , v2au% , v3au% , v4au%
   if NJB%=1
      clear 80
      item_add 80,"L'ORDINATEUR RFLCHIT..."
      if MS%=0
         midi_instrument 115
         midi_play 43,10
      end_if
      pause 500
      if CF%<>CJ%
         v4au%=CJ%
         if CJ%=0
            v4au%=2
         end_if
         ou2(2)
         if count(2000)>0
            v1au%=(int(rnd(count(2000)/2))+1)*2-1
         end_if
         if v1au%>0
            v2au%=val(item_read$(2000,v1au%))
            v3au%=val(item_read$(2000,v1au%+1))
            EI%=v2au%*10+v3au%+90
               NQ%=EI%
            CC%(v2au%,v3au%)=v4au%
            quel(v2au%,v3au%)
            if MS%=0
               midi_instrument 113
               midi_play 80,10
            end_if
            for v1au%=1 to 3
               file_load EI%,"Oth-Fleche-1.jpg"
               pause 200
               if MS%=0
                  midi_play 80,10
               end_if
               file_load EI%,"Oth-Feutrine.jpg"
               pause 200
            next v1au%
            dessin(1,v4au%)
            CC%(v2au%,v3au%)=3-v4au%
            pivot()
            suivant(1)
            calcul()
            if MS%=0
               midi_instrument 113
               midi_play 40,10
            end_if
         else
            clear 80
            item_add 80,"Impossible de jouer"
            item_add 80,"L'ordinateur passe son tour"
            if MS%=0
               midi_instrument 114
               midi_play 64,10
            end_if
            pause 1000
            suivant(1)
         end_if
         teste()
         if IFJ%=0
            for v1au%=1 to 8
               for v2au%=1 to 8
                  on_click 100+(v1au%-1)*10+v2au%,clic
               next v2au%
            next v1au%
         end_if
      end_if
   end_if
end_sub

sub calcul() : rem Calcul du nombre de pions de chacun ========================
   dim_local v1ca% , v2ca%
   TB%=0 : TN%=0
   for v1ca%=1 to 8
      for v2ca%=1 to 8
         if CC%(v1ca%,v2ca%)=1
            TB%=TB%+1
         end_if
         if CC%(v1ca%,v2ca%)=2
            TN%=TN%+1
         end_if
      next v2ca%
   next v1ca%
   sprite_text 44,TN%
   if TN%<10
      sprite_position 44,35,23
   else
      sprite_position 44,22,23
   end_if
   sprite_text 45,TB%
   if TB%<10
      sprite_position 45,113,23
   else
      sprite_position 45,103,23
   end_if
end_sub

sub choix1() : rem Choix d`un seul joueur biologique ==========================
   griser(2,56)
   griser(1,58)
   griser(1,60)
   NJB%=1
   aff()
   hide 75
   show 70
end_sub

sub choix2() : rem Choix de deux joueurs biologiques ==========================
   griser(1,18)
   griser(1,56)
   griser(2,58)
   griser(0,60)
   griser(0,62)
   NJB%=2
   CJ%=0
   aff()
   hide 70
   show 75
end_sub

clac: : rem Redirection de tous les on-click  part ceux de la grille =========
   if MS%=0
      midi_instrument 120
      midi_play 105,10
   end_if
   select number_click
      case 18 : ou()
      case 38 : suivant(1)
      case 50 : aide()
      case 52 : new()
      case 54 : quitter()
      case 56 : choix1()
      case 58 : choix2()
      case 60 : couleur()
      case 62 : go()
      case 1010 : fermer()
      case 1020 : fermer()
   end_select
return

clic: : rem Clic sur une cellule de la grille =================================
   inactive 10
   inactive 100
   NQ%=number_click
   if TN%+TB%=4
      demar()
   end_if
   if IFA%=1
      efface()
      IFA%=0
   end_if
   clear 80
   if CC%(int((NQ%-100)/10)+1,NQ%-(int(NQ%/10)*10))=0
      V1M%=int((NQ%-100)/10)+1
      V2M%=NQ%-(int(NQ%/10)*10)
      quel(V1M%,V2M%)
      if JP%=1
         midi_instrument 120
         if CF%=1
            file_load NQ%,"Oth-Pion-Blanc.jpg"
            CC%(int((NQ%-100)/10)+1,NQ%-(int(NQ%/10)*10))=1
            if MS%=0
               midi_play 70,10
            end_if
         else
            file_load NQ%,"Oth-Pion-Noir.jpg"
            CC%(int((NQ%-100)/10)+1,NQ%-(int(NQ%/10)*10))=2
            if MS%=0
               midi_play 60,10
            end_if
         end_if
         pivot()
         ou2(2)
         suivant(1)
         calcul()
         if NJB%=1
            for V1M%=1 to 8
               for V2M%=1 to 8
                  off_click 100+(V1M%-1)*10+V2M%
               next V2M%
            next V1M%
         end_if
         teste()
         pause 400
         if show(195)=0
            auto()
         end_if
      else
         beep
         item_add 80,"Non, vous ne pouvez pas jouer  cet endroit"
         item_add 80,"N'hsitez pas  utiliser les  Conseils "
      end_if
   else
      beep
      item_add 80,"Non, vous ne pouvez pas jouer  cet endroit"
      item_add 80,"N'hsitez pas  utiliser les  Conseils "
   end_if
   active 10
   active 100
return

cloc: : rem Gestion du mode silencieux ========================================
   sons()
return

close: : rem Gestion de l`on-close ============================================
   caption 0,""
   pause 80
   if show(1000)=1
      beep
   end_if
   caption 0,"   Cliquer n'importe o dans ce tableau pour revenir au jeu"
return 

sub couleur() : rem Le joueur seul joue les Noirs ou les Blancs ===============
   if CJ%=0
      sprite_text 61,"Blanc"
      sprite_position 61,160-(text_width("Blanc",0)*3),48
      griser(1,62)
      griser(0,18)
      sprite_text 73,"Blanc"
      sprite_position 73,22,74
      CJ%=1
      aff()      
      active 62
      inactive 100
   else
      griser(1,60)
      griser(0,62)
      griser(1,18)
      sprite_text 73,"Noir"
      sprite_position 73,30,74
      CJ%=0
      aff()
      active 18
      active 100
   end_if
end_sub

rem Datas =====================================================================
   data "Aide  " , " Rejouer" , "Quitter" , "1 Joueur" , "2 joueurs" , "Noir  "
   data "Conseils" , "Inverser" , "GO   "
   data "DBDAADBDECEDDECEBACBBCABFBEDDEBF" : rem Hexadcimal
rem Fin des datas

sub demar() : rem Dmarrage du jeu ============================================
   inactive 60
   griser(1,52)
   font_color 60,255,60,255
   if NJB%=1
      if CJ%=0
         griser(2,60)
      else
         font_color 60,255,60,255
         sprite_text 61,"Blanc"
         sprite_position 61,160-(text_width("Blanc",0)*3),48
      end_if
   else
      griser(0,60)
   end_if
   if NJB%=1
      griser(0,58)
   else
      griser(0,56)
   end_if
end_sub

sub dessin(c1%,c2%) : rem Dessine un pion  l`endroit indiqu =================
   rem c1% = Couleur 1 et c2% = Couleur 2
   if c1%=c2%
      file_load EI%,"Oth-Pion-Noir.jpg"
   else
      file_load EI%,"Oth-Pion-Blanc.jpg"
   end_if
end_sub

sub efface() : rem Efface les flches de conseil ==============================
   dim_local v1ef% , v2ef%
   if count(2010)>0
      for v1ef% = 1 to count(2010)
         file_load val(item_read$(2010,v1ef%)),"Oth-Feutrine.jpg"
      next v1ef%
   end_if
   IO%=0
end_sub

sub fermer() : rem Fermeture du tableau d`aide ================================
   caption 0,TP$
   hide 1000
   close_active
end_sub

sub fin(cc%) : rem Dclaration de fin de jeu ==================================
   dim_local v1fi% , v2fi% , v3fi%
   rem cc% = Combien de Cases sont remplies de jetons
   clear 80
   inactive 38
   griser(0,18)
   v1fi%=TN%
   v2fi%=TB%
   if cc%<64
      v3fi%=64-cc%
   end_if
   if v1fi%>v2fi%
      item_add 80,"Les Noirs ont gagn"
      item_add 80,"par "+str$(v1fi%+v3fi%)+"  "+str$(v2fi%)
      hide 70
      hide 75
      width 80,535
      show 195
      if MS%=0
         file_load 1500,"Oth-Applau.mp3"
         play 1500
      end_if
   end_if
   if v2fi%>v1fi%
      item_add 80,"Les Blancs ont gagn"
      item_add 80,"par "+str$(v2fi%+v3fi%)+"  "+str$(v1fi%)
      hide 70
      hide 75
      width 80,535
      show 195
      if MS%=0
         file_load 1500,"Oth-Applau.mp3"
         play 1500
      end_if
   end_if
   if v2fi%=v1fi%
      item_add 80,"galit = Personne n'a gagn"
      item_add 80,"( "+str$(v1fi%)+"  "+str$(v2fi%)+" )"
   end_if
   for v1fi%=1 to 8
      for v2fi%=1 to 8
         off_click 100+(v1fi%-1)*10+v2fi%
      next v2fi%
   next v1fi%
   griser(0,38)
   IFJ%=1
end_sub

sub fini(qa%) : rem Dtection si le jeu est fini ==============================
   dim_local v1fn% , v2fn%
   dim_local ncfn% : rem Nombre de Cases remplies
   rem qa% = Quel Appel
   for v1fn%=1 to 8
      for v2fn%=1 to 8
         if CC%(v1fn%,v2fn%)>0
            ncfn%=ncfn%+1
         end_if
      next v2fn%
   next v1fn%
   if ncfn%=64 or qa%=2
      fin(ncfn%)
   end_if
end_sub

sub go() : rem L`ordinateur commence le jeu ===================================
   inactive 10
   inactive 100
   griser(0,62)
   griser(1,18)
   demar()
   auto()
   active 10
   active 100
end_sub

sub griser(qc%,qb%) : rem Griser ou non les boutons de commande ===============
   dim_local v1gr%
   rem qc% = Quelle Couleur (0=gris) (1=blanc) (2=rose) - qb% = Quel Bouton
   select qc%
      case 0 : font_color qb%,75,75,75 : inactive qb%
      case 1 : font_color qb%,255,255,255 : active qb%
      case 2 : font_color qb%,255,60,255 : inactive qb%
   end_select
   if qb%>49 and qb%<61
      v1gr%=(qb%/2)-24
   else
      select qb%
         case 18 : v1gr%=7
         case 38 : v1gr%=8
         case 62 : v1gr%=9
      end_select
   end_if
   sprite_text qb%+1,NB$(v1gr%)
   sprite_position qb%+1,160-(text_width(NB$(v1gr%),0)*3),48
end_sub

sub new() : rem Recommencer un nouveau jeu ====================================
   dim_local v1ne% , v2ne% , v3ne%
   v1ne%=message_confirmation_yes_no("Recommencer un nouveau jeu ?")
   if v1ne%=1
      for v2ne%=1 to 8
         for v3ne%=1 to 8
            file_load 100+(v2ne%-1)*10+v3ne%,"Oth-Feutrine.jpg"
            CC%(v2ne%,v3ne%)=0
         next v3ne%
      next v2ne%
      for v2ne%=0 to 1
         for v3ne%=0 to 1
            EI%=134+v2ne%*10+v3ne%
            dessin(v2ne%,v3ne%)
         next v3ne%
      next v2ne%
      CC%(5,4)=1 : CC%(5,5)=2 : CC%(4,4)=2 : CC%(4,5)=1
      calcul()
      CF%=1
      suivant(0)
      griser(0,38)
      if NJB%=2
         griser(0,60)
         griser(0,62)
      else
         if CJ%=0
            griser(1,60)
         else
            font_color 60,255,255,255
            sprite_text 61,"Blanc"
            sprite_position 61,160-(text_width("Blanc",0)*3),48
            griser(1,62)
         end_if
      end_if
      if active(62)=0
         griser(1,18)
      end_if
      if NJB%=1
         griser(1,58)
         show 70
      end_if
      if NJB%=2
         griser(1,56)
         show 75   
      end_if
      hide 195
      width 80,655
      aff()
      for v1ne%=1 to 8
         for v2ne%=1 to 8
            on_click 100+(v1ne%-1)*10+v2ne%,clic
         next v2ne%
      next v1ne%
      IFJ%=0
   end_if
end_sub

sub ou() : rem O placer les pions ============================================
   dim_local v1ou% , v2ou%
   IO%=1-IO%
   if IO%=1
      ou2(1)
      for v1ou%=1 to 8
         for v2ou%=1 to 8
            on_click 100+(v1ou%-1)*10+v2ou%,clic
         next v2ou%
      next v1ou%
      if count(2000)=0
         if show(195)=0
            clear 80
            item_add 80,"Jeu impossible - Cliquer sur  Inverser "
            item_add 80,"pour passer au joueur suivant"
            griser(1,38)
         end_if
      end_if
   else
      efface()
      for v1ou%=1 to 8
         for v2ou%=1 to 8
            on_click 100+(v1ou%-1)*10+v2ou%,clic
         next v2ou%
      next v1ou%
      clear 80
      if TN%+TB%=4
         aff()
      else
         if CF%=0
            item_add 80,"C'est au tour de Noir de jouer"
         else
            item_add 80,"C'est au tour de Blanc de jouer"
         end_if
         item_add 80,"Demandez conseil si ncessaire"
      end_if
      v1ou%=TN%
      v2ou%=TB%
      if count(2000)=0
         if show(195)=0 
            if CJ%=0 or NJB%=2
               griser(1,38)
            end_if
         end_if
      end_if
   end_if
end_sub

sub ou2(qo%) : rem Suite de chercher o mettre les pions ======================
   dim_local v1o2% , v2o2% , v3o2% , v4o2%
   rem qo% = Quelle Origine (1=on affiche le rsultat - 2=on ne l`affiche pas)
   for v3o2%=1 to 8
      for v4o2%=1 to 8
         if NJB%=1
            off_click 100+(v3o2%-1)*10+v4o2%
         end_if
         GA%(v3o2%,v4o2%)=0
      next v4o2%
   next v3o2%
   NC%=0 : clear 2010 : IFA%=0
   for v3o2%=1 to 8
      for v4o2%=1 to 8
         if CC%(v3o2%,v4o2%)=0
            quel(v3o2%,v4o2%)
            if JP%=1
               GA%(v3o2%,v4o2%)=1
               NC%=NC%+1
               if qo%=1
                  file_load 100+(v3o2%-1)*10+v4o2%,"Oth-Fleche-1.jpg"
                  IFA%=1
                  item_add 2010,100+(v3o2%-1)*10+v4o2%
               end_if
            end_if
         end_if
      next v4o2%
   next v3o2%
   v1o2%=0
   clear 2000
   for v2o2%=5 to 0 step -1
      for v3o2%=1 to 8
         for v4o2%=1 to 8
            if (GA%(v3o2%,v4o2%)=1) and (GR%(v3o2%,v4o2%)=v2o2%)
               if qo%=1
                  file_load 100+(v3o2%-1)*10+v4o2%,"Oth-Fleche-2.jpg"
               end_if
               item_add 2000,v3o2%
               item_add 2000,v4o2%
               v1o2%=1
            end_if
         next v4o2%
      next v3o2%
      if v1o2%=1
         exit_for
      end_if
   next v2o2%
   if qo%=1
      clear 80
      if count(2000)>0
         item_add 80,"Cases conseilles et cases recommandes"
         if MS%=0
            midi_instrument 112
            midi_play 60,10
         end_if
      else
         item_add 80,"Pas de possibilit de placer un pion"
         item_add 80,"Cliquez sur  Inverser "
         griser(1,38)
         if MS%=0
            midi_instrument 114
            midi_play 64,10
         end_if
         pause 1000
      end_if
   end_if
end_sub

sub pivot() : rem Faire pivoter les pions =====================================
   dim_local v1pi% , v2pi% , v3pi% , v4pi%
   v3pi%=int((NQ%-100)/10)+1
   v4pi%=NQ%-(int(NQ%/10)*10)
   v1pi%=CC%(v3pi%,v4pi%)
   clear 80
   item_add 80,"Retournement des pions"
   if VL%(1)>0 : rem Horizontale Est
      for v2pi% = v4pi%+1 to v4pi%+VL%(1)
         pivot2(2-v1pi%,100+(v3pi%-1)*10+v2pi%)
         CC%(v3pi%,v2pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(2)>0 : rem Oblique Nord-Est
      for v2pi%=v3pi%+1 to v3pi%+VL%(2)
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%+v2pi%-v3pi%)
         CC%(v2pi%,v4pi%+v2pi%-v3pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(3)>0 : rem Verticale Nord
      for v2pi%=v3pi%+1 to v3pi%+VL%(3)
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%)
         CC%(v2pi%,v4pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(4)>0 : rem Oblique Nord-Ouest
      for v2pi%=v3pi%+1 to v3pi%+VL%(4)
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%-v2pi%+v3pi%)
         CC%(v2pi%,v4pi%-v2pi%+v3pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(5)>0 : rem Horizontale Ouest
      for v2pi%=v4pi%-1 to v4pi%-VL%(5) step -1
         pivot2(2-v1pi%,100+(v3pi%-1)*10+v2pi%)
         CC%(v3pi%,v2pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(6)>0 : rem Oblique Sud-Ouest
      for v2pi%=v3pi%-1 to v3pi%-VL%(6) step -1
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%+v2pi%-v3pi%)
         CC%(v2pi%,v4pi%+v2pi%-v3pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(7)>0 : rem Verticale Sud
      for v2pi%=v3pi%-1 to v3pi%-VL%(7) step -1
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%)
         CC%(v2pi%,v4pi%)=v1pi%
      next v2pi%
   end_if
   if VL%(8)>0 : rem Oblique Sud-Est
      for v2pi%=v3pi%-1 to v3pi%-VL%(8) step -1
         pivot2(2-v1pi%,100+(v2pi%-1)*10+v4pi%-v2pi%+v3pi%)
         CC%(v2pi%,v4pi%-v2pi%+v3pi%)=v1pi%
      next v2pi%
   end_if
end_sub

sub pivot2(qc%,qe%) : rem Suite de la rotation des pions ==========================
   rem qc% = Quelle couleur d`arrive - qe% = A Quelle Endroit tourner
   if qc%=0
      file_load qe%+100,"Oth-B-N.avi"
   else
      file_load qe%+100,"Oth-N-B.avi"
   end_if
   show qe%+100
   display
   hide qe%
   display
   if MS%=0
      midi_instrument 88
      play qe%+100
   end_if
   pause 510
   display
   if qc%=0
      file_load qe%,"Oth-Pion-Noir.jpg"
   else
      file_load qe%,"Oth-Pion-Blanc.jpg"
   end_if
   display
   show qe%
   display
   hide qe%+100
   display
   if MS%=0
      midi_play 30,10
   end_if
end_sub

sub quel(qa%,qo%) : rem Quelle rponse donner au clic =========================
   rem qa% = Quelle Abscisse
   rem qo% = Quelle Ordonne
   dim_local v1ql% , v2ql%
   v1ql%=2-CF%
   for v2ql%=1 to 8
      VL%(v2ql%)=0
   next v2ql%
   for v2ql%=qo%+1 to qo%+8 : rem Horizontale Est
      if v2ql%<10
         if CC%(qa%,v2ql%)=3-v1ql%
            VL%(1)=VL%(1)+1
         else
            if CC%(qa%,v2ql%)=0
               VL%(1)=VL%(1)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%+1 to qa%+8 : rem Oblique Nord-Est
      if (v2ql%<10) and ((qo%+v2ql%-qa%)<10)
         if CC%(v2ql%,qo%+v2ql%-qa%)=3-v1ql%
            VL%(2)=VL%(2)+1
         else
            if CC%(v2ql%,qo%+v2ql%-qa%)=0
               VL%(2)=VL%(2)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%+1 to qa%+8 : rem Verticale Nord
      if v2ql%<10
         if CC%(v2ql%,qo%)=3-v1ql%
            VL%(3)=VL%(3)+1
         else
            if CC%(v2ql%,qo%)=0
               VL%(3)=VL%(3)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%+1 to qa%+8 : rem Oblique Nord-Ouest
      if (v2ql%<10) and ((qo%-v2ql%+qa%)>-1)
         if CC%(v2ql%,qo%-v2ql%+qa%)=3-v1ql%
            VL%(4)=VL%(4)+1
         else
            if CC%(v2ql%,qo%-v2ql%+qa%)=0
               VL%(4)=VL%(4)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qo%-1 to qo%-8 step -1 : rem Horizontale Ouest
      if v2ql%>-1
         if CC%(qa%,v2ql%)=3-v1ql%
            VL%(5)=VL%(5)+1
         else
            if CC%(qa%,v2ql%)=0
               VL%(5)=VL%(5)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%-1 to qa%-8 step -1 : rem Oblique Sud-Ouest
      if (v2ql%>-1) and ((qo%+v2ql%-qa%)>-1)
         if CC%(v2ql%,qo%+v2ql%-qa%)=3-v1ql%
            VL%(6)=VL%(6)+1
         else
            if CC%(v2ql%,qo%+v2ql%-qa%)=0
               VL%(6)=VL%(6)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%-1 to qa%-8 step -1 : rem Verticale Sud
      if v2ql%>-1
         if CC%(v2ql%,qo%)=3-v1ql%
            VL%(7)=VL%(7)+1
         else
            if CC%(v2ql%,qo%)=0
               VL%(7)=VL%(7)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   for v2ql%=qa%-1 to qa%-8 step -1 : rem Oblique Sud-Est
      if (v2ql%>-1) and ((qo%-v2ql%+qa%)<10)
         if CC%(v2ql%,qo%-v2ql%+qa%)=3-v1ql%
            VL%(8)=VL%(8)+1
         else
            if CC%(v2ql%,qo%-v2ql%+qa%)=0
               VL%(8)=VL%(8)*0
            end_if
            exit_for
         end_if
      end_if
   next v2ql%
   JP%=0
   for v2ql%=1 to 8
      if VL%(v2ql%)>0
         JP%=1
      end_if
   next v2ql%
end_sub

sub quitter() : rem Sortir du programme =======================================
   dim_local v1qu%
   v1qu%=message_confirmation_yes_no("Quoi, vous voulez rellement quitter ce superbe jeu ?")
   if v1qu%=1
      midi_off
      terminate
   end_if
end_sub

sub sons() : rem Gestion du mode silencieux ===================================
   if MS%=0
      MS%=1
      sprite_hide 185
   else
      MS%=0
      sprite_show 185
      midi_instrument 120
      midi_play 105,10
   end_if
end_sub

sub suivant(qp%) : rem Passage au joueur suivant ==============================
   rem qp% = Quel Paramtre (0=on n`affiche pas 1=on affiche dans le mmo)
   CF%=1-CF%
   if CF%=1
      sprite_text 36,"Blanc joue"
      sprite_position 36,120,40
      if qp%=1
         clear 80
         item_add 80,"C'est au tour de Blanc de jouer"
         if NJB%=2
            item_add 80,"Demandez conseil si ncessaire"
         end_if
      end_if
      if NJB%=1
         if number_click=38
            auto()
         end_if
      end_if
   else
      sprite_text 36,"Noir joue"
      sprite_position 36,120,40
      if qp%=1
         clear 80
         item_add 80,"C'est au tour de Noir de jouer"
         item_add 80,"Demandez conseil si ncessaire"
      end_if
   end_if
   IO%=0
   griser(0,38)
end_sub

sub teste() : rem L`ordinateur teste le jeu du joueur bio =====================
   dim_local v1te% , v2te% , v3te%
   v1te%=CF%
   CF%=0 : ou2(2) : v2te%=count(2000)
   CF%=1 : ou2(2) : v3te%=count(2000)
   CF%=v1te%
   if v2te%=0 and v3te%=0 and ((TB%+TN%)>5)
      fini(2)
   end_if
   if (count(2000)=0) and ((TN%+TB%)=64)
      fini(2)
   end_if
   if TN%=0 or TB%=0
      fini(2)
   end_if
end_sub
