
rem ' Mah-Jong-7-familles - par jjn4 - le 26/11/2017 ==========================
   dim ADS% : rem Activation ou Dsactivation du Son
   dim IDJ% : rem Indice de Dbut de Jeu
   dim IFC% : rem Numro de l`Image de Fond Choisie
   dim IJT% : rem Indicateur de Jeu Termin
   dim IRA% : rem Indicateur de Recul et d`Avance
   dim NB$(10) : rem Noms des Boutons
   dim NCF%(14) : rem Nombre de Contenus de chaque Famille
   dim NFA% : rem Nombre de Flches Affiches
   dim NJ% : rem Niveau de Jeu
   dim NPA% : rem Nombre de Points Acquis
   dim TC%(2) , FT$(2) : rem Tuiles Choisies et Famille de la Tuile
   dim TDN%(4) , TFN%(4) : rem Tuiles de Dbut et de Fin par Niveau
   dim TP$ : rem Titre du Programme
   dim TPM% : rem Total des Points en Moins
   dim TSU% : rem Total des Suggestions Utilises
   dim VP$ : rem Version du Programme
   dim V1M% , V2M% , V3M% : rem Variables globales  utilation Multiple
   dim V1V$ , V2V$ : rem Variables globales  utilisation Varie
   TP$="Le Mah-Jong des sept familles   -   par jjn4"
   VP$="Ver-261117.1.1" : NJ%=2
   label clic : rem Redirection de tous les on-click
   label close : rem Gestion de l`on-close

rem Form0 et prparation ======================================================
   width 0,1365
   height 0,720
   color 0,200,120,255
   caption 0,"   "+TP$+"   -   "+VP$
   on_close 0,close
   for V1M% = 1 to 10 : rem Lecture des datas ---------------------------------
      read NB$(V1M%)
   next V1M%
   for V1M% = 1 to 4
      read TDN%(V1M%)
      read TFN%(V1M%)
   next V1M%
   rem Calcul du nombre de contenus par famille -------------------------------
   for V1M% = 1 to 14
      V3M%=0
      V1V$=str$(V1M%)
      if len(V1V$)<2
         V1V$="0"+V1V$
      end_if
      file_open_read 1,"MJ7F-t-"+V1V$+".txt"
         while file_eof(1)<>1
            file_readln 1,V2V$
            if V2V$=""
               V3M%=V3M%+1
            end_if
         end_while
      file_close 1
      NCF%(V1M%)=V3M%-1
   next V1M%
   dlist 10 : dlist 20 : rem Listes pour le contenu des tuiles ----------------
   dlist 30 : dlist 40 : rem Listes de travail de l`ordinateur ----------------
   dlist 50 : dlist 60 : rem Listes pour reculer et avancer -------------------

rem Panneau de prsentation ===================================================
   form 70
      width 70,1365
      height 70,720
      color 70,200,120,255
   panel 75
      parent 75,70
      left 75,10
      top 75,200
      width 75,428
      height 75,450
   picture 76
      parent 76,75
      full_space 76
      file_load 76,"MJ7F-d-01.jpg"
   panel 80
      parent 80,70
      left 80,840
      top 80,255
      width 80,493
      height 80,348
   picture 81
      parent 81,80
      full_space 81
      file_load 81,"MJ7F-d-02.jpg"
   panel 85
      parent 85,70
      left 85,100
      top 85,50
      width 85,1200
      height 85,90
      font_bold 85
      font_size 85,40
      font_color 85,0,0,255
      color 85,255,200,255
      caption 85,"LE   MAH - JONG   DES   SEPT   FAMILLES"
   alpha 90
      parent 90,70
      left 90,630
      top 90,350
      font_size 90,18
      font_color 90,0,100,0
      caption 90,"ou"
   picture 91
      parent 91,70
      left 91,490
      top 91,220
      width 91,306
      height 91,406
      font_size 91,18
      font_color 91,0,0,255
      font_name 91,"Arial"
      file_load 91,"MJ7F-Cadre intro.jpg"
      2d_target_is 91
      2d_fill_color 255,200,255
      print_target_is 91
      print_locate 85,50
      print "AVEZ-VOUS"
      print_locate 55,85
      print "REMARQU QUE"
      print_locate 70,120
      print "CLASSER LES"
      print_locate 80,155
      print "CHOSES DE"
      print_locate 63,190
      print "FAON CLAIRE"
      print_locate 90,225
      print "ET NETTE"
      print_locate 85,260
      print "N'EST PAS"
      print_locate 80,295
      print "TOUJOURS"
      print_locate 94,330
      print "FACILE ?"
      display

rem Affichage des tuiles et des images ========================================
   panel 100 : rem Support des tuiles - Rang de 16 tuiles = Obj n 110  260
      width 100,1345           : rem    Rang de 14 tuiles = Obj n 270  400
      height 100,145           : rem    Rang de 12 tuiles = Obj n 410  520
   picture 105                 : rem    Rang de 10 tuiles = Obj n 530  620
      parent 105,100           : rem    Rang de 08 tuiles = Obj n 630  700
      full_space 105           : rem    Rang de 06 tuiles = Obj n 710  760
      color 105,240,240,240    : rem    Rang de 04 tuiles = Obj n 770  800
      font_color 105,255,0,0   : rem    Rang de 02 tuiles = Obj n 810  820
      font_size 105,20         : rem Les pictures font 5 de plus
      font_name 105,"Webdings"
      tri()
      image()
      2d_target_is 105
      2d_fill_color 255,0,0
      points()
      V3M%=100 : rem Tuiles ---------------------------------------------------
   for V2M% = 16 to 2 step -2
      for V1M% = 1 to V2M%
         V3M%=V3M%+10
         panel V3M%
            parent V3M%,100
            hide V3M%
            left V3M%,((V1M%+((14-V2M%)/2))*84)+(16-V2M%)
            top V3M%,21-V2M%
            width V3M%,84
            height V3M%,120
            inactive V3M%
         picture V3M%+5 : rem Obj n = (les mmes avec +5) : rem Images -------
            parent V3M%+5,V3M%
            full_space V3M%+5
            stretch_on V3M%+5
            on_click V3M%+5,clic
      next V1M%
   next V2M% : rem Dernier Obj-Syst utilis = 825
   alpha 830 : rem Pas utilis mais ncessaire pour le fonctionnement ---------
      hide 830
      
rem Zoom de la tuile et explications diverses =================================
   panel 900 : rem Support du zoom et des explications
      top 900,160
      width 900,940
      height 900,500
      color 900,255,200,255
   panel 910 : rem Support de la photo ---------------
      parent 910,900
      left 910,10
      top 910,10
      width 910,335
      height 910,480
   picture 920
      parent 920,910
      full_space 920
      stretch_on 920
   panel 930 : rem Support des explications ----------
      parent 930,900
      left 930,355
      top 930,10
      width 930,575
      height 930,440
      color 930,255,200,255
   shape 935
      parent 935,930
      left 935,3
      top 935,2
      width 935,568
      height 935,60
      shape_rectangle_rounded 935
   alpha 940 : rem Prcision de la famille -----------
      parent 940,930
      left 940,10
      top 940,6
      font_bold 940
      font_size 940,14
      font_color 940,0,175,0
      color 940,255,255,255
      font_name 940,"Arial"
   alpha 950 : rem Prcision du nom ------------------
      parent 950,930
      left 950,10
      top 950,30
      font_bold 950
      font_size 950,18
      font_color 950,255,0,0
      color 950,255,255,255
      font_name 950,"Arial"
   memo 960 : rem Explications complmentaires -------
      parent 960,930
      left 960,5
      top 960,65
      width 960,565
      height 960,370
      font_size 960,16
      font_name 960,"Arial"
      inactive 960
   shape 965
      parent 965,900
      left 965,350
      top 965,452
      width 965,584
      height 965,45
      shape_rectangle_rounded 965
   alpha 970 : rem Zone de dialogue 1 ----------------
      parent 970,900
      left 970,355
      top 970,454
      font_size 970,12
      font_name 970,"Arial"
      font_color 970,0,0,255
      color 970,255,255,255
      caption 970,"Choisissez votre niveau d'empilement (Pile N) avant de commencer"
   alpha 980 : rem Zone de dialogue 2 ----------------
      parent 980,900
      left 980,355
      top 980,474
      font_size 980,12
      font_name 980,"Arial"
      font_color 980,0,0,255
      color 980,255,255,255
      caption 980,"Cliquez sur  Jouer  pour commencer le jeu"
   panel 985 : rem Support de l`image d`attente de droite -----------
      parent 985,930
      width 985,575
      height 985,440
      hide 985
   picture 990 : rem Image d`attente de droite
      parent 990,985
      full_space 990
      
rem Affichage des boutons de commande =========================================
   panel 1000 : rem Support des boutons : Obj n 1010  1100  pas de 10
      left 1000,950
      top 1000,160
      width 1000,390
      height 1000,500
      color 1000,255,200,255
   for V1M% = 1 to 2
      for V2M% = 1 to 5
         scene2d ((V1M%-1)*5+V2M%)*10+1000
            parent ((V1M%-1)*5+V2M%)*10+1000,1000
            left ((V1M%-1)*5+V2M%)*10+1000,(V1M%-1)*190+10
            top ((V1M%-1)*5+V2M%)*10+1000,(V2M%-1)*96+10
            width ((V1M%-1)*5+V2M%)*10+1000,180
            height ((V1M%-1)*5+V2M%)*10+1000,91
            font_bold ((V1M%-1)*5+V2M%)*10+1000
            font_size ((V1M%-1)*5+V2M%)*10+1000,18
            font_name ((V1M%-1)*5+V2M%)*10+1000,"Arial"
            font_color ((V1M%-1)*5+V2M%)*10+1000,0,0,255
            file_load ((V1M%-1)*5+V2M%)*10+1000,"MJ7F-Bouton violet.bmp"
            sprite_target_is ((V1M%-1)*5+V2M%)*10+1000
            on_click ((V1M%-1)*5+V2M%)*10+1000,clic
         sprite (((V1M%-1)*5+V2M%)*10+1000)/10
            sprite_text (((V1M%-1)*5+V2M%)*10+1000)/10,NB$((V1M%-1)*5+V2M%)
            sprite_x_position (((V1M%-1)*5+V2M%)*10+1000)/10,(width(((V1M%-1)*5+V2M%)*10+1000)/2)-((len(NB$((V1M%-1)*5+V2M%))/2)*(18/1.5))
            sprite_y_position (((V1M%-1)*5+V2M%)*10+1000)/10,(height(((V1M%-1)*5+V2M%)*10+1000)/2)-(18/1.4)
      next V2M%
   next V1M%
   for V1M% = 1010 to 1060 step 10
      inactive V1M%
      activ(V1M%,0)
   next V1M%
   scene2d 1110 : rem Bouton rond musical ---------------
      parent 1110,1000
      left 1110,181
      top 1110,377
      width 1110,28
      height 1110,28
      font_size 1110,16
      font_name 1110,"Webdings"
      font_color 1110,0,0,255
      file_load 1110,"MJ7F-Bouton rond violet.bmp"
      sprite_target_is 1110
      on_click 1110,clic
   sprite 111
      sprite_text 111,chr$(175)
      sprite_x_position 111,(width(1110)/2)-((1/2)*(16/1.5))-5
      sprite_y_position 111,(height(1110)/2)-(16/1.4)-2
rem 1200  1250 = Affichage des points et applaudissements --------------------
   sound 1260
   file_load 1260,"MJ7F-Applau.mp3"

rem Affichage du tableau d`Aide ===============================================
   panel 1300
      hide 1300
      width 1300,1349
      height 1300,662
   memo_rich 1310
      parent 1310,1300
      full_space 1310
      file_load 1310,"MJ7F-Aide.rtf"
      on_click 1310,clic
   panel 1320 : rem Support de l`image 
      parent 1320,1300
      left 1320,960
      top 1320,162
      width 1320,199
      height 1320,160
   picture 1330
      parent 1330,1320
      full_space 1330
      file_load 1330,"MJ7F-Explic.jpg"
      on_click 1330,clic
      
rem Derniers prparatifs du jeu ===============================================
   for V1M% = 410 to 820 step 10
      show V1M%
   next V1M%
   choix()
   bravo()
   midi_on
   midi_volume 127
   hide 70
   
end : rem ' Dbut des routines ================================================

sub activ(qb%,qa%) : rem Ractivation d`un bouton joli ========================
   rem qb%=Quel Bouton , qa%=Quelle Action (1=activation 0=inactivation)
   dim_local v1av$ 
   select qb%
      case 1010 : v1av$="Annuler"
      case 1020 : v1av$="Suggestion"    
      case 1030 : v1av$="Reculer" 
      case 1040 : v1av$="Avanver" 
      case 1050 : v1av$="Restructurer"
      case 1060 : v1av$="Retirer"
      case 1070 : v1av$="Pile "+str$(NJ%) 
      case 1080 : v1av$="Rejouer"
      case 1090 : v1av$="Aide"
      case 1100 : v1av$="Quitter"
   end_select
   if qa%=1  
      font_color qb%,0,0,255
   else
      font_color qb%,180,180,180
   end_if
   sprite_target_is qb%
   sprite_text qb%/10,v1av$
   sprite_x_position qb%/10,(width(qb%)/2)-((len(v1av$)/2)*(18/1.5))
   sprite_y_position qb%/10,(height(qb%)/2)-(18/1.4) 
end_sub

sub afficher() : rem Afficher la photo et le texte de la tuile ================
   dim_local v1af% , v2af$ , v3af$ , v4af% , v5af$
   clear 960
   hide 985
   for v1af% = 1 to count(20)
      if item_read$(10,v1af%)=str$(number_click-5)
         v2af$=mid$(item_read$(20,v1af%),4,2)
         v3af$=left$(item_read$(20,v1af%),2)
         file_load 920,"MJ7F-p-"+v2af$+"-"+v3af$+".jpg"
         file_open_read 1,"MJ7F-t-"+v2af$+".txt"
            file_readln 1,v5af$
            caption 940,"Famille : "+v5af$
            while v4af%<val(v3af$)
               file_readln 1,v5af$
               if v5af$=""
                  v4af%=v4af%+1
               end_if
            end_while
            if file_eof(1)<>1
               file_readln 1,v5af$
               caption 950,v5af$
            end_if
            while file_eof(1)<>1
               file_readln 1,v5af$
               if v5af$<>""
                  item_add 960,v5af$
               else
                  exit_while
               end_if
            end_while
         file_close 1
         exit_for
      end_if
   next v1af%
end_sub

sub aide() : rem Explications sur le jeu ======================================
   show 1300
   close_inactive
   caption 0,"   Explications sur le fonctionnement du jeu - Cliquez n'importe o pour passer  la suite"
end_sub

sub annuler() : rem Annuler l`affichage des flches rouges ====================
   image()
   NFA%=0
   TC%(1)=0
   TC%(2)=0
   caption 970,"Annulation effectue"
   caption 980,""
end_sub

sub avancer() : rem Repartir vers l`avant =====================================
   dim_local v1av%
   for v1av% = 1 to 2
      hide val(item_read$(60,count(60)))
      item_add 50,item_read$(60,count(60))
      item_delete 60,count(60)
   next v1av%
   active 1030
   activ(1030,1)
   if count(60)=0
      inactive 1040
      activ(1040,0)
   end_if
   IRA%=1
   NPA%=NPA%+2
   caption 1250,NPA%
end_sub

sub bravo() : rem Affichage des images de bravo ===============================
   dim_local v1br% , v2br%
   v1br%=int(rnd(2))+1
   v2br%=int(rnd(2))+1
   file_load 920,"MJ7F-BravoG"+str$(v1br%)+".jpg"
   file_load 990,"MJ7F-BravoD"+str$(v2br%)+".jpg"
   show 985   
end_sub

sub choix() : rem Choix des familles et des sujets ============================
   dim_local v1ch% , v2ch% , v3ch% , v4ch$
   dim_local qnch% , ctch% : rem Quel Niveau de jeu et Combien de Tuiles
   qnch%=NJ%
   ctch%=qnch%*2+2
   clear 10
   clear 20
   clear 30
   clear 40
   for v1ch% = 1 to 14
      v4ch$=str$(v1ch%)
      if len(v4ch$)<2
         v4ch$="0"+v4ch$
      end_if
      item_add 40,v4ch$
   next v1ch%
   for v1ch% = 1 to 7
      v2ch%=int(rnd(count(40)))+1
      item_add 30,item_read$(40,v2ch%)
      item_delete 40,v2ch%
   next v1ch%
   for v1ch% = 1 to 7
      clear 40
      for v2ch% = 1 to NCF%(val(item_read$(30,v1ch%)))
         v4ch$=str$(v2ch%)
         if len(v4ch$)<2
            v4ch$="0"+v4ch$
         end_if
         item_add 40,v4ch$
      next v2ch%
      for v2ch% = 1 to ctch%
         v3ch%=int(rnd(count(40)))+1
         item_add 20,item_read$(40,v3ch%)+"-"+item_read$(30,v1ch%)
         item_add 10,str$(TDN%(qnch%)-10+((v1ch%-1)*ctch%+v2ch%)*10)
         item_delete 40,v3ch%
      next v2ch%
   next v1ch%
   meler()
   for v1ch% = 1 to ctch%*7
      file_load val(item_read$(10,v1ch%))+5,"MJ7F-p-"+mid$(item_read$(20,v1ch%),4,2)+"-"+left$(item_read$(20,v1ch%),2)+".jpg"
   next v1ch%
end_sub

clic: : rem Redirection de tous les on-click ==================================
   if number_click>103 and number_click<827
      V1M%=mouse_x_position(number_click)
      V2M%=mouse_y_position(number_click)
      if V1M%>3 and V2M%>3
         afficher()
         fleche()
      end_if
   end_if
   if number_click>1000 and number_click<1300
      left number_click,left(number_click)-1
      top number_click,top(number_click)+1
      if ADS%=0
         midi_instrument 120
         midi_play 105,10
      end_if
      pause 100
      left number_click,left(number_click)+1
      top number_click,top(number_click)-1
   end_if
   select number_click
      case 1010 : annuler()
      case 1020 : suggest()
      case 1030 : reculer()
      case 1040 : avancer()
      case 1050 : restruct()
      case 1060 : retirer()
      case 1070 : niveau()
      case 1080 : jouer()
      case 1090 : aide()
      case 1100 : quitter()
      case 1110 : son()
      case 1310 : fermer()
      case 1330 : fermer()
   end_select
return

close: : rem Gestion de l`on-close ============================================
   caption 0,""
   pause 80
   if show(1300)=1
      if ADS%=0
         beep
      end_if
      caption 0,"   Cliquer n'importe o dans ce tableau pour revenir au jeu"
   end_if
return

rem Datas =====================================================================
   data "Annuler" , "Suggestion" , "Reculer" , "Avancer" , "Restructurer"
   data "Retirer" , "Pile 2" , "Jouer" , "Aide" , "Quitter"
   data 530 , 800 , 410 , 820 , 270 , 820 , 110 , 800
rem Fin des datas

sub fermer() : rem Fermer la fentre d`aide ===================================
   hide 1300
   close_active
   caption 0,"   "+TP$+"   -   "+VP$
end_sub

sub fin() : rem Vrification de fin de jeu ====================================
   dim_local v1fi% , v2fi% , v3fi%
   for v1fi% = 1 to count(10)
      if show(val(item_read$(10,v1fi%)))=1
         v2fi%=1
      end_if
   next v1fi%
   v1fi%=20-TPM%
   if v1fi%<0
      v1fi%=0
   end_if
   if v2fi%=0
      caption 980,"Bravo, vous avez termin la partie avec succs !"
      for v3fi% = 1020 to 1060 step 10
         inactive v3fi%
         activ(v3fi%,0)
      next v3fi%
      IJT%=1
      if ADS%=0
         play 1260
      end_if
      lot(v1fi%)
   end_if
end_sub

sub fleche() : rem Affichage d`une flche sous la tuile clique ===============
   if NFA%>1
      image()
      NFA%=0
      TC%(1)=0
      TC%(2)=0
   end_if
   V3M%=left(number_click-5)+25
   2d_fill_color 255,0,0
   2d_ellipse V3M%+7,127,V3M%+22,175
   NFA%=NFA%+1
   TC%(NFA%)=number_click
   FT$(NFA%)=caption$(940)
   caption 970,""
   caption 980,""
   inactive 1070
   activ(1070,0)
end_sub

sub image() : rem Affichage de l`image de fond ================================
   dim_local v1im$
   v1im$=str$(IFC%)
   if len(v1im$)<2
      v1im$="0"+v1im$
   end_if
   file_load 105,"MJ7F-Bande-"+v1im$+".jpg"
end_sub

sub jouer() : rem Commencer ou rejouer une nouvelle partie ====================
   dim_local v1jo% , v2jo%   
   if IDJ%=1
      for v1jo% = 1 to count(10)
         if show(val(item_read$(10,v1jo%)))=1
            v2jo%=1
         end_if
      next v1jo%
      inactive 1030
      activ(1030,0)
      inactive 1040
      activ(1040,0)
      tri()
      image()
      TC%(1)=0
      TC%(2)=0
      NJ%=NJ%-1
      niveau()
      color 920,255,255,255
      caption 940,""
      caption 950,""
      clear 960
      bravo()
      if v2jo%=1
         lot(0)
      end_if
   end_if
   sprite_target_is 1080
   sprite_text 108,"Rejouer"
   sprite_x_position 108,(width(1080)/2)-((7/2)*(18/1.5))
   sprite_y_position 108,(height(1080)/2)-(18/1.4)
   IDJ%=1
   caption 970,"Cliquez une par une sur les deux tuiles  retirer"
   caption 980,""
   TPM%=0
   TSU%=0
   for v1jo% = 1010 to 1020 step 10
      active v1jo%
      active v1jo%+40
      activ(v1jo%,1)
      activ(v1jo%+40,1)
   next v1jo%
   for v1jo% = 110 to 820 step 10
      active v1jo%
   next v1jo%
   active 1070
   activ(1070,1)
   clear 50
   clear 60
   NPA%=0
   caption 1250,"00"
   IJT%=0
end_sub

sub lot(qn%) : rem Quel lot affecter en fin de partie =========================
   dim_local v1lo%
   if qn%<10
      v1lo%=3
   else
      v1lo%=2
   end_if
   if qn%=20
      v1lo%=1
   end_if
   file_load 920,"MJ7F-f-0"+str$(v1lo%)+".jpg"
   hide 985
   select v1lo%
      case 1
         item_add 960,"Bravo !   Vous avez gagn le gros lot !   Maintenant, le coffre-fort d'oncle Picsou vous appartient personnellement."
      case 2
         item_add 960,"Bravo !   En rcompense, oncle Picsou vous invite  prendre un bain de pices d'or avec lui dans son coffre-fort personnel."
      case 3
         item_add 960,"Comme lot de consolation, vous avez le droit de regarder un gteau."
   end_select
end_sub

sub meler() : rem Mlanger les tuiles =========================================
   dim_local v1me% , v2me%
   clear 40
   for v1me% = 1 to count(10)
      item_add 40,item_read$(10,v1me%)
   next v1me%
   clear 10
   repeat
      v2me%=int(rnd(count(40)))+1
      item_add 10,item_read$(40,v2me%)
      item_delete 40,v2me%
   until count(40)=0
end_sub

sub niveau() : rem Rglage du niveau de jeu ===================================
   dim_local v1ni%
   NJ%=NJ%+1
   if NJ%>4
      NJ%=1
   end_if
   sprite_target_is 1070
   sprite_text 107,"Pile "+str$(NJ%)
   sprite_x_position 107,(width(1070)/2)-((6/2)*(18/1.5))
   sprite_y_position 107,(height(1070)/2)-(18/1.4)
   for v1ni% = 110 to 820 step 10
      show v1ni%
   next v1ni%
   select NJ%
      case 1
         for v1ni% = 110 to 520 step 10
            hide v1ni%
         next v1ni%
         hide 810 : hide 820
         caption 1230,"28"
      case 2
         for v1ni% = 110 to 400 step 10
            hide v1ni%
         next v1ni%
         caption 1230,"42"
      case 3
         for v1ni% = 110 to 260 step 10
            hide v1ni%
         next v1ni%
         caption 1230,"56"
      case 4
         hide 810
         hide 820
         caption 1230,"70"
   end_select
   choix()
end_sub

sub note(qc%) : rem Commentaires et Note affichs en bas ======================
   rem qc% = Quel Commentaire
   select qc%
      case 1 : caption 970,"Erreur : une des tuiles au moins est inaccessible"
      case 2 : caption 970,"Erreur : ce n'est pas la mme famille"
      case 3 : caption 970,"Erreur : il faut choisir deux tuiles  retirer"
   end_select
   caption 980,"(vous marquez un point de moins)"
   TPM%=TPM%+1
   NPA%=NPA%-1
   caption 1250,NPA%
   if ADS%=0
      midi_instrument 83
      midi_play 60,10
   end_if
end_sub

sub points() : rem Affichage du dcompte des points et des scores =============
   dim_local v1po%
   shape 1200
      parent 1200,100
      left 1200,1215
      top 1200,10
      width 1200,120
      height 1200,60
      shape_rectangle_rounded 1200
   shape 1210
      parent 1210,100
      left 1210,1215
      top 1210,75
      width 1210,120
      height 1210,60
      shape_rectangle_rounded 1210
   alpha 1220
      parent 1220,100
      left 1220,1230
      top 1220,17
      font_bold 1220
      font_size 1220,16
      font_name 1220,"Arial"
      font_color 1220,0,0,255
      color 1220,255,255,255
      caption 1220,"RECORD"
   alpha 1230
      parent 1230,100
      left 1230,1262
      top 1230,42
      font_bold 1230
      font_size 1230,16
      font_name 1230,"Arial"
      font_color 1230,255,0,0
      color 1230,255,255,255
      caption 1230,"42"
   alpha 1240
      parent 1240,100
      left 1240,1237
      top 1240,82
      font_bold 1240
      font_size 1240,16
      font_name 1240,"Arial"
      font_color 1240,0,0,255
      color 1240,255,255,255
      caption 1240,"SCORE"
   alpha 1250
      parent 1250,100
      left 1250,1262
      top 1250,107
      font_bold 1250
      font_size 1250,16
      font_name 1250,"Arial"
      font_color 1250,255,0,0
      color 1250,255,255,255
      caption 1250,"00"
end_sub

sub quitter() : rem Quitter le jeu ============================================
   dim_local v1qu%
   v1qu%=message_confirmation_yes_no("Vous voulez dj nous quitter ?")
   if v1qu%=1
      midi_off
      terminate
   end_if
end_sub

sub reculer() : rem Revenir en arrire ========================================
   dim_local v1rc%
   for v1rc% = 1 to 2
      show val(item_read$(50,count(50)))
      item_add 60,item_read$(50,count(50))
      item_delete 50,count(50)
   next v1rc%
   active 1040
   activ(1040,1)
   if count(50)=0
      inactive 1030
      activ(1030,0)
   end_if
   IRA%=1
   NPA%=NPA%-2
   caption 1250,NPA%
end_sub

sub restruct() : rem Restructurer le final incomplet du jeu ===================
   dim_local v1rs% , v2rs%
   clear 30
   clear 40
   for v1rs% = 1 to count(10)
      if show(val(item_read$(10,v1rs%)))=1
         item_add 30,item_read$(10,v1rs%)
      end_if
   next v1rs%
   for v1rs% = 1 to count(30)
      v2rs%=int(rnd(count(30)))+1
      item_add 40,item_read$(30,v2rs%)
      item_delete 30,v2rs%
   next v1rs%
   clear 30
   for v1rs% = 1 to count(10)
      item_add 30,item_read$(10,v1rs%)
   next v1rs%
   clear 10
   v2rs%=0
   for v1rs% = 1 to count(30)
      if show(val(item_read$(30,v1rs%)))=1
         v2rs%=v2rs%+1
         item_add 10,item_read$(40,v2rs%)
      else
         item_add 10,item_read$(30,v1rs%)
      end_if
   next v1rs%
   for v1rs% = 1 to count(10)
      if show(val(item_read$(10,v1rs%)))=1
         file_load val(item_read$(10,v1rs%))+5,"MJ7F-p-"+mid$(item_read$(20,v1rs%),4,2)+"-"+left$(item_read$(20,v1rs%),2)+".jpg"
      end_if
   next v1rs%
   image()
   TC%(1)=0
   TC%(2)=0
   caption 970,"Restructuration termine"
   caption 980,""
   clear 50
   clear 60
   inactive 1030
   activ(1030,0)
   inactive 1040
   activ(1040,0)
end_sub

sub retirer() : rem Retirer les deux tuiles flches ==========================
   dim_local v1re%
   for v1re% = 110 to 820 step 10
      inactive v1re%
   next v1re%
   for v1re% = 1010 to 1020 step 10
      inactive v1re%
      inactive v1re%+40
      activ(v1re%,0)
      activ(v1re%+40,0)
      if active(v1re%+20)=1
         width v1re%+20,179
      end_if
      inactive v1re%+20
      activ(v1re%+20,0)
   next v1re%
   if TC%(1)>0 and TC%(2)>0
      if FT$(1)=FT$(2)
         if (((hide(TC%(1)-15)=1) or (hide(TC%(1)+5)=1)) or (top(TC%(1)-15)<>top(TC%(1)+5)))
            if (((hide(TC%(2)-15)=1) or (hide(TC%(2)+5)=1)) or (top(TC%(2)-15)<>top(TC%(2)+5)))
               if IRA%=1
                  clear 60
                  inactive 1040
                  activ(1040,0)
                  width 1040,180
                  IRA%=0
               end_if
               for v1re% = 1 to 4
                  hide TC%(1)
                  pause 100
                  show TC%(1)
                  pause 100
               next v1re%
               hide TC%(1)-5
               for v1re% = 1 to 3
                  hide TC%(2)
                  pause 100
                  show TC%(2)
                  pause 100
               next v1re%
               hide TC%(2)-5
               image()
               color 920,255,255,255
               item_add 50,TC%(1)-5
               item_add 50,TC%(2)-5
               active 1030
               activ(1030,1)
               caption 940,""
               caption 950,""
               clear 960
               bravo()
               TC%(1)=0
               TC%(2)=0
               caption 970,"Bien jou !"
               if ADS%=0
                  midi_instrument 55
                  midi_play 80,10
               end_if
               NPA%=NPA%+2
               caption 1250,NPA%
               fin()
            else
               note(1)
            end_if
         else
            note(1)
         end_if
      else
         note(2)
      end_if
   else
      note(3)
   end_if
   if IJT%=0
      for v1re% = 1010 to 1020 step 10
         active v1re%
         active v1re%+40
         activ(v1re%,1)
         activ(v1re%+40,1)
         if width(v1re%+20)=179
            width v1re%+20,180
            active v1re%+20
            activ(v1re%+20,1)
         end_if
      next v1re%
   end_if
   for v1re% = 110 to 820 step 10
      active v1re%
   next v1re%
end_sub

sub son() : rem Activation ou dsactivation du son ============================
   if ADS%=0
      sprite_hide 111
      ADS%=1
   else
      sprite_show 111
      ADS%=0
   end_if
end_sub

sub suggest() : rem Donner une suggestion de jeu ==============================
   dim_local v1su% , v2su% , v3su% , v4su% , v5su% , v6su% , v7su% , v8su%
   caption 970,"ATTENDEZ, recherche en cours..."
   caption 980,""
   display
   for v1su% = 1 to count(10)
      for v2su% = 1 to count(10)
         if v1su%<>v2su%
            v4su%=val(item_read$(10,v1su%))
            v5su%=val(item_read$(10,v2su%))
            if show(v4su%)=1 and show(v5su%)=1
               if right$(item_read$(20,v1su%),2)=right$(item_read$(20,v2su%),2)
                  if (((hide(v4su%-10)=1) or (hide(v4su%+10)=1)) or (top(v4su%-10)<>top(v4su%+10)))
                     if (((hide(v5su%-10)=1) or (hide(v5su%+10)=1)) or (top(v5su%-10)<>top(v5su%+10)))
                        v7su%=0 : v8su%=0
                        for v6su% = 1 to count(10)
                           if show(val(item_read$(10,v6su%)))=1
                              if left(val(item_read$(10,v6su%)))=left(v4su%)+2
                                 v7su%=1
                              end_if
                              if left(val(item_read$(10,v6su%)))=left(v5su%)+2
                                 v8su%=1
                              end_if
                           end_if
                        next v6su%
                        if v7su%=0 and v8su%=0
                           2d_fill_color 0,255,0
                           V3M%=left(v4su%)+25
                           2d_ellipse V3M%+7,127,V3M%+22,175
                           V3M%=left(v5su%)+25
                           2d_ellipse V3M%+7,127,V3M%+22,175
                           pause 1400
                           image()
                           TC%(1)=0
                           TC%(2)=0
                           font_color 105,255,0,0
                           v3su%=1
                           TSU%=TSU%+1
                           if TSU%>(NJ%+1)*3
                              TPM%=TPM%+1
                           end_if
                           caption 980,"Rsultat trouv (brefs indicateurs verts)"
                        end_if
                     end_if
                  end_if
               end_if
            end_if
         end_if
         if v3su%=1
            exit_for
         end_if
      next v2su%
      if v3su%=1
         exit_for
      end_if
   next v1su%
   if v3su%=0
      caption 980,"Aucune combinaison possible  >>>>>>>  Restructurez ou Reculez"
      if ADS%=0
         midi_instrument 111
         midi_play 50,10
      end_if
   end_if
   caption 970,""
end_sub

sub tri() : rem Tri d`une image parmi la liste ================================
   IFC%=int(rnd(15))+1
end_sub




