
rem ============================================================================
rem             Des belles mathmatiques pour des beaux yeux        
rem ============================================================================
rem
rem              Paramtrisation cartsienne de la courbe
rem               ______________________________________
rem              |                                      |
rem              |  x = a * cos(t)                      |
rem              |  y = a * sin(t) * sin(t) * sin(t)    |
rem              |______________________________________|
rem
rem On appelle cette courbe : "Courbe de la bouche" ou "Kiss curve"
rem Personnellement, je voie quelle ressemble plutt  un oeil.
rem Mais, bon, une bouche, un oeil, ou autre chose, cest mathmatiquement beau !
rem ============================================================================
dim xc,yc,n
width 0,1000 : caption 0,"Courbe des yeux"
picture 10 : full_space 10 : 2d_target_is 10 : color 10,150,100,50 : 2d_pen_color 255,255,0
xc = 240 : yc = height_client(10)/2
alpha 20 : top 20,20 : left 20,100 : font_bold 20 : font_name 20,forte
font_size 20,25 : font_color 20,255,255,0 : color 20,150,100,50
for n = 60 to 200 step 5 : Oeil(n) : next n

2d_pen_width 1 : 2d_circle xc,yc,25
2d_flood xc,yc,0,255,255  : 2d_flood xc-27,yc,255,255,255

2d_circle 3*xc,yc,25
2d_flood 3*xc,yc,0,255,255  : 2d_flood 3*xc-27,yc,255,255,255
repeat
    font_color 20,255,255,0 : caption 20,"Des belles mathmatiques pour des beaux yeux !": pause 1000
    font_color 20,0,255,255 : caption 20,"Des belles mathmatiques pour des beaux yeux !": pause 1000
until scancode <> 0
end
rem ============================================================================
SUB Oeil(a)
    dim_local t,x,y
    degrees : 2d_pen_width 4
    2d_pen_color mod(rnd(a),255),mod(rnd(a),255),abs(mod(rnd(360),255))
    2d_poly_from a+xc , yc
    for t = 0 to 360        
        x = a * cos(t)
        y = 0.5*a * sin(t) * sin(t) * sin(t)        
        2d_poly_to xc+x,yc+y  
    next t    
    
    2d_poly_from x +3*xc, yc
    for t = 0 to 360
        x = a * cos(t)
        y = 0.5 * a * sin(t) * sin(t) * sin(t)
        2d_poly_to x + 3*xc,yc+y
    next t  
    display    
END_SUB
rem ============================================================================