
rem ============================================================================
rem                   Nombres narcissiques
rem ============================================================================
rem Un nombre narcissique (ou nombre dArmstrong) de premire espce, est
rem un entier naturel n non nul qui est gal  la somme des puissances
rem p-imes de ses chiffres en base dix, o p dsigne le nombre de chiffres de n
rem Exemples:
rem Tous les entiers de 1  9 sont narcissiques.
rem 153   = 1^3 + 5^3 + 3^3 = 1 + 125 + 27 = 153  est un nombre narcissique dordre 3
rem 93084 = 9^5 + 3^5 + 0^5 + 8^5 + 4^5 = 93084   est un nombre narcissique dordre 5
rem ============================================================================
rem Le programme calcul et affiche la liste de tous les nombres narcissiques
rem dordre 1  5 (c--d les nombres de 1  99999); au-del a devient chronophage
rem ============================================================================
rem  Note : il ny a ancun nombre narcissique dordre 2
rem ============================================================================
dim n,ordre
caption 0,"Nombres narcissiques par Papydall"
list 10 : top 10,20 : left 10,20 : width 10,200 : height 10,400
for n = 1 to 999 : ' jusqu' l'ordre 3 (nombre de 3 chiffres), les rsultats sont
                   ' instantans; au-del, a commence  ramer sur ma bcane !
                   ' Pour le compilateur, on peut aller facilement jusqu ordre 6 ou 7
                   ' soit jusqu' n = 9999999 et mme plus si vous disposez d'un bolide
    if EstNarcissique(n) = 1
       item_add 10,str$(n) + " est narcissique d'ordre " + str$(ordre)
    end_if
next n
message "ok!"
end
rem ============================================================================
' Renvoie 1 si l'argument n est un nombre narcissique, sinon 0
FNC EstNarcissique(n)  
    dim_local total,i,nb$ ,c(10)    
    nb$ = str$(n)
    ordre = len(nb$) : ' ordre est gal au nombres de chiffres de n  
    for i = 1 to ordre
        c(i) = val(mid$(nb$,i,1)) : ' Le tableau C() contiendra les chiffres de n
        total = total + power(c(i),ordre) : ' sommation des chiffres de n ports  la puissance ordre
    next i    
    if total = n then result 1 : else : result 0
END_FNC
rem ============================================================================

rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
rem Voici une liste pour n = 3 jusqu n = 23

rem Pour n = 3, il y a 4 nombres qui sont :
rem    153; 370; 371; 407

rem Pour n = 4, il y a 3 nombres qui sont :
rem    1634 = 1^4 + 6^4 + 3^4 + 4^4 = 1634
rem    8208 = 8^4 + 2^4 + 0^4 + 8^8 = 8208
rem    9474 = 9^4 + 4^4 + 7^4 + 4^4 = 9474

rem Pour n = 5, il y a aussi 3 nombres qui sont :
rem    54748 ; 92727 ; 93084

rem Pour n = 6, il y a un seul nombre qui est :
rem    548834

rem Pour n = 7, il y a 4 nombres qui sont :
rem    1741725 ; 4210818 ; 9800817 ; 9926315

rem Pour n = 8, il y a 3 nombres qui sont :
       24678050 ; 24678051 ; 88593477

rem Pour n = 9, il y a 4 nombres qui sont :
rem    146511208 ; 472335975 ; 534494836 ; 912985153

rem Pour n = 10, il y a un seul nombre qui est :
rem    4679307774

rem Pour n = 11, il y a 8 nombres qui sont :
rem    321640499650 ; 32164049651 ; 40028394225 ; 42678290603 ;
rem    44708635679 ; 49388550606 ; 82693916578 ; 94204591914

rem Pour n = 12 et n = 13, il ny a pas de solution

rem Pour n = 14, il y a un seul nombre qui est :
rem    28116440335967

rem Pour n = 15, pas de solution

rem Pour = 16, il y a 2 nombres qui sont :
rem    4338281769391370 ; 4338281769391371

rem Pour n = 17, il y a 3 nombres qui sont :
rem    21897142587612075, 35641594208964132, 35875699062250035

rem Pour n = 18, pas de solution

rem Pour n = 19, il y a 4 nombres qui sont :
rem    1517841543307505039, 3289582984443187032, 4498128791164624869,4929273885928088826

rem Pour n = 20, il y a un seul nombre qui est : 63105425988599693916

rem Pour n = 21, il y a 2 nombres qui sont :
rem    128468643043731391252, 449177399146038697307

rem Pour n = 22, pas de solution

rem Pour n = 23, il y a 5 nombres qui sont :
rem    21887696841122916288858, 27879694893054074471405, 27907865009977052567814,
rem    28361281321319229463398, 35452590104031691935943

rem Bon divertissement avec ces nombres !
rem ============================================================================