
rem ============================================================================
rem                 Traitement dimages
rem                    Par Papydall
rem ============================================================================
dim Largeur, Hauteur
dim image$
dim i
label clic
image$ = "c:\users\microtek\desktop\Traitement_Images\lena.bmp" : '  adapter
Dimensions(image$)
width 0, 2*Largeur + 400
if Hauteur < 500
   height 0, 600
else
   height 0,Hauteur + 100
end_if

picture 10 : width 10,Largeur : height 10,Hauteur
top 10,40 : left 10,365 : 2d_target_is 10 : file_load 10,image$
picture 20 : width 20,Largeur : height 20,Hauteur
top 20,40 : left 20,350+Largeur + 20
alpha 23 : top 23,10 : left 23,300+largeur/2 : caption 23,"Image originale"
font_bold 23 : font_color 23,0,0,255 : font_size 23,12
alpha 24 : top 24,10 : left 24,280+3*largeur/2 : caption 24,"Image traite"
font_bold 24 : font_color 24,0,0,255 : font_size 24,12 : hide 24
container_option 25 : top 25,20 : left 25,10 : font_bold 25 : font_color 25,255,0,0
width 25,350 : height 25,400 : font_size 25,14 : caption 25,"Faites votre choix"
for i = 30 to 41
    option i : parent i,25
    top i,50+(i-30)*30 : left i,20 : width i,320 : font_bold i
    font_color i,0,0,255 :  font_size i,10
     on_click i,clic
next i
caption 30," Eclaircir l'image "
caption 31," Eliminer les couleurs,except le rouge"
caption 32," Eliminer les couleurs,except le vert "
caption 33," Eliminer les couleurs,except le bleu "
caption 34," Crer le ngatif de l'image "
caption 35," Convertir l'image couleur en noir et blanc "
caption 36," Convertir l'image couleur en nuances de spia "
caption 37," Modifier le contrast "
caption 38," Symtrie axiale d'axe horizontal "
caption 39," Symtrie axiale d'axe vertical "
caption 40," Afficher l'image dans une ellipse ou un cercle "
caption 41," QUITTER LE PROGRAMME "

font_bold 0 : font_color 0,255,0,0 : font_size 0,10
print_locate 20,top(25)+height(25)+20
print "Dimensions de l'image originale : " + str$(largeur) + " x " + str$(hauteur) + " pixels"

end
rem ============================================================================
Clic:
    for i = 30 to 40 : inactive i : next i
    show 24
    select number_click
        case 30 : Lumineuse()
        case 31 : Rouge()
        case 32 : Vert()
        case 33 : Bleu()
        case 34 : Negatif()
        case 35 : Gris()
        case 36 : Sepia()
        case 37 : Modifier_Contrast()
        case 38 : Symetrie_Horizontale()
        case 39 : Symetrie_Verticale()
        case 40 : Ellipse()
        case 41 : terminate
    end_select
    for i = 30 to 40 : active i : next i
return
rem ============================================================================
' Rendre l'image plus lumineuse
SUB Lumineuse()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Rendre l'image plus lumineuse"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)   : r = min(r+30,255)
            g = color_pixel_green(10,x,y) : g = min(g+30,255)
            b = color_pixel_blue(10,x,y)  : b = min(b+30,255)
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Eliminer toutes les couleurs, except le rouge
SUB Rouge()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Eliminer toutes les couleurs, except le rouge"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y) : g = 0 : b = 0  
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Eliminer toutes les couleurs, except le vert
SUB Vert()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Eliminer toutes les couleurs, except le vert"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            g = color_pixel_red(10,x,y) : r = 0 : b = 0  
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Eliminer toutes les couleurs, except le bleu
SUB Bleu()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Eliminer totes les couleurs, except le bleu"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            b = color_pixel_red(10,x,y) : r = 0 : g = 0  
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Crer le ngatif de l'image
SUB Negatif()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Crer le ngatif de l'image"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)   : r = 255-r
            g = color_pixel_green(10,x,y) : g = 255-g
            b = color_pixel_blue(10,x,y)  : b = 255-b
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Convertir l'image couleur en noir et blanc
SUB Gris()
    dim_local x,y,r,g,b,c
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Convertir l'image couleur en noir et blanc"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)
            ' formule standard donnant le niveau de gris en fonction
            ' des 3 composantes RGB  
            c = 0.299*r + 0.587*g + 0.114*b
            2d_pen_color c,c,c : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Convertir l'image couleur en nuances de spia
SUB Sepia()
    dim_local x,y,r,g,b,r1,g1,b1
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Convertir l'image couleur en nuances de spia"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)
          
            r1 = 0.393*r + 0.769*g + 0.189*b : if r1 > 255 then r1 = 255
            g1 = 0.349*r + 0.686*g + 0.168*b : if g1 > 255 then g1 = 255
            b1 = 0.272*r + 0.534*g + 0.131*b : if b1 > 255 then b1 = 255
            2d_pen_color r1,g1,b1 : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Modifier le contrast de l'image
SUB Modifier_Contrast()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Modifier le contrast de l'image"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)
            if r < 30 then r = 0
            if g < 30 then g = 0
            if b < 30 then b = 0
            if (r >= 30) and (r < 225) then r = int(255/195*(r-30)+0.5)
            if (g >= 30) and (g < 225) then g = int(255/195*(g-30)+0.5)
            if (b >= 30) and (b < 225) then b = int(255/195*(b-30)+0.5)            
            2d_pen_color r,g,b : 2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Produire une symtrie axiale d'axe horizontal
SUB Symetrie_Horizontale()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Crer une symtrie horizontale"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)  
            2d_pen_color r,g,b : 2d_point x,hauteur-y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Produire une symtrie axiale d'axe vertical
SUB Symetrie_Verticale()
    dim_local x,y,r,g,b
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Crer une symtrie verticale"
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)  
            2d_pen_color r,g,b : 2d_point largeur-x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Afficher l'image dans un cercle si l'image est carre, dans une ellipse si
' l'image est rectangulaire
SUB Ellipse()
    dim_local x,y,r,g,b,r1,r2,xc,yc ,p
    2d_target_is 20 :cls
    caption 0,"Traitement en cours ... Affichage dans une ellipse"
    r1 = largeur/2 : r2 = hauteur/2
    xc = r1 : yc = r2
    r1 = r1-1 : r2 = r2-1
    for y = 0 to hauteur-1
        for x = 0 to largeur-1
            r = color_pixel_red(10,x,y)  
            g = color_pixel_green(10,x,y)
            b = color_pixel_blue(10,x,y)
            ' Determiner si le point (x,y) est  l'interieur de l'ellipse
            p = (power((x-xc),2) / power(r1,2)) + (power((y-yc),2) / power(r2,2))
            if p < 1                    : ' Le point (x,y) est  l'intrieur
               2d_pen_color r,g,b       : ' on le trace en couleur RGB
            else                        : ' Le point (x,y) est  l'extrieur
               2d_pen_color 255,255,255 : ' on le trace en blanc
            end_if
            2d_point x,y
        next x
        display
    next y
    caption 0,"Traitement termin"
END_SUB
rem ============================================================================
' Recuprer les dimensions (Largeur_Image et Hauteur_Image) de l'image image$
SUB Dimensions(image$)
    filebin_open_read 999,image$
    filebin_position 999,18
    Largeur = filebin_read(999) + 256 * filebin_read(999)
    filebin_position 999,22
    Hauteur = filebin_read(999) + 256 * filebin_read(999)
    filebin_close 999

END_SUB
rem ============================================================================