
rem ============================================================================
rem   Pour la nouvelle version V 0.9.27i1
rem ============================================================================
rem On lance obliquement, sous un angle A, un projectile avec une vitesse initiale V0.
rem L abscisse X et l ordonne Y du projectile sont relies entre elles par l quation :
rem          ___________________________________________________
rem         |                                                   |
rem         |  y = (0-g*x*x)/(2*v0*v0*cos(a)*cos(a)) + x*tan(a) |
rem         |___________________________________________________|
rem
rem Le programme  calcule  et trace les valeurs successives de X et de Y
rem Le calcul s arrte ds que Y < 0.
rem Ce calcul servira galement  trouver, parmi les valeurs calcules,
rem les valeurs approches de la hauteur maximale H atteinte par le projectile
rem et de la port D (valeur maximale de X).
rem ============================================================================


Calcul_Trajectoire_Projectile(60,100)
Calcul_Trajectoire_Projectile(45,090)
Calcul_Trajectoire_Projectile(30,100)
Calcul_Trajectoire_Projectile(80,120)
Calcul_Trajectoire_Projectile(10,180)
end

rem ============================================================================
' calculs et affichage des coordonnes
SUB Calcul_Trajectoire_Projectile(angle,v0)
    dim_local x0,y0,x,y,h,d,g,t$
    degrees  : ' On travaille avec les degrs comme unit d'angle
    g = 9.81 : ' constante de la pesanteur terrestre
    full_space 0 : x0 = 100: y0 = height(0)-100 : color 0,0,0,0
    2d_pen_color 255,0,0 : 2d_line x0,50,x0,y0 : 2d_poly_to width(0)-100,y0
    2d_pen_color 255,255,0 : 2d_poly_from x0,y0
    while y >= 0 : ' tant que l'ordonne est positive
          y = (0-g*x*x)/(2*v0*v0*cos(angle)*cos(angle)) + x*tan(angle)
          if y > h then h = y :' hauteur "h" maximale du projectile
          2d_poly_to x0+x,y0-y
          x = x + 1
    end_while
    d = x  : ' porte du projectile
' affichage des donnes et rsultats
    t$ = "La vitesse initiale 'V0' : " + str$(v0) + " m/s." +chr$(13)
    t$ = t$ + "L'angle de tir : " + str$(angle) + " degrs" + chr$(13)
    t$ = t$ + "La hauteur maximale 'h' est de : " + str$(h) + " m." + chr$(13)
    t$ = t$ + "Et la porte 'd' du projectile vaut : " + str$(d) + " m."
    message t$
END_SUB
rem ============================================================================