
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
rem        Dmonstration de Draw_polygone
rem               Par Papydall
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================

Init()
Decors()
Fermer_La_Boutique()
terminate
end
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Initialisation et dclarations des variables globales
SUB Init()
    dim result%, n_poly%, pnt(1), deg2rad ,newx,newy
    dim poly(200,1)
    dim plane$,barrel$,obus$
    
    full_space 0  : caption 0,"<CLICK> pour terminer .............."
    picture 10 : full_space 10 : 2d_target_is 10 : print_target_is 10
    font_name 10 ,"tahoma" : font_color 10,255,0,0 : font_size 10,16 : hide 10
    image 20
    deg2rad = pi/180

' String contenant les coordonnes des sommets du polygone reprsentant l'avion
    plane$ = plane$ + "000,056, 010,046, 157,046, 197,002, 222,002, 222,027, 177,067,"
    plane$ = plane$ + "177,214, 165,223, 128,116, 092,148, 090,191, 076,207, 069,177,"
    plane$ = plane$ + "062,173, 054,178, 045,178, 046,168, 053,157, 024,149, 021,143,"
    plane$ = plane$ + "032,133, 076,133, 108,097, 002,062, 000,056"
' String contenant les coordonnes des sommets du polygone reprsentant le canon du char
    barrel$ = "0,-1, 0,1, 20,1, 20,-1, 0,-1"
' String contenant les coordonnes des sommets du polygone reprsentant un obus
    obus$ = "10,10,30,10,35,15,30,20,10,20,10,10"

END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Mise en place et mouvements des types d'objets (avion et char)
SUB Decors()
    dim_local i,x,y,a

    while 1 = 1
       for x = .1 to 8*pi step 0.2
           color 10,80,100,150
           print_locate 20,20 : print "Demonstration de Draw_polygone"
           print_locate width(0)/2-100,20 : print "<CLICK> pour mettre fin  l'ennui !!!"
           y =  sin(x) : a = (cos(x)+ pi/4)/deg2rad
' Les avions voluent en suivant la pente de la tangente d'une courbe sinusodale
           Draw_Polygone(plane$,26,60*x,200+150*y,1/4,a,255,0,255)
           Draw_Polygone(plane$,26,500+80*x,200+100*y,1/5,a,255,255,255)
           Draw_Polygone(plane$,26,800+100*x,200+150*y,1/6,a,10,10,10)
           Draw_Polygone(plane$,26,150+120*x,200+50*y,1/7,a,100,200,0)
          
           Draw_Polygone(plane$,26,250+120*x,200+50*y,1/7,a,10,50,100)
           Draw_Polygone(plane$,26,120*x,200+50*y,1/4,a,10,50,100)

' Mettre en place les chars
           for i = 0 to width(10) step 200
            Char(i,0,45+a)

             next i
           copy_image() : ' Pour liminer le clignotement
           if scancode <> 0 then exit_while
       next x
    end_while

END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
SUB Fermer_La_Boutique()
    dim_local i
     color 10,80,100,150
     print_locate 500,100 : print "Au revoir et   la prochaine !!!"
     Draw_Polygone(plane$,26,10,300,2,0,255,0,255)
     Draw_Polygone(plane$,26,400,600,2,-45,255,255,255)
     Draw_Polygone(plane$,26,900,700,2,-90,255,255,0)
      copy_image() : pause 2000
    for i = height(0) to 0 step -2 : height 0,i : next i
END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Tracer le polygone dont les sommets sont donns par des coordonnes x,y stocks
'  la suite les unes des autres dans la chane P$.
' Le coin suprieur gauche sera positionn aux coordonnes xo,yo.

' Paramtres:
' P$      : chaine contenant les diffrentes coordonnes des sommets du polygone
' n       : nombre de sommets du polygone
' xo,yo   : coordonnes du coin suprieur gauche du trac (origine)
' echelle : facteur d'agrandissement / rapetissement du polygone
'           Si echelle > 1 alors c'est un agrandissement
'           Si echelle < 1 alors c'est un rapetissement
'           Si echelle = 1 alors on conserve la taille
' angle   : valeur en degr de rotation du polygone  partir de l'origine dans
'           le sens des aiguilles d'une montre si angle est positif, et dans
'           le sens trigonomtrique si angle est ngatif
' r,g,b   : couleur du remplissage du polygone
rem ============================================================================
SUB Draw_Polygone(p$,n,xo,yo,echelle,angle,r,g,b)
    dim_local a$,l,virgule,p,i,x,y
    a$ = p$ + "," : l = len(a$) : virgule = instr(a$,",")
    x = val(left$(a$,virgule - 1)) : ' abscisse de l'origine du polygone
    a$ = right$(a$,l-virgule) : l = len(a$) : virgule = instr(a$,",")
    y = val(left$(a$,virgule - 1)) : ' ordonne de l'origine du polygone
    poly(0,0) = x : poly(0,1) = y
' On calcule les nouvelles coordonnes de l'origine du trac pour la rotation
    Rotation_Point(x,y,angle) : 2d_poly_from xo + newx*echelle,yo + newy*echelle
' Poly to
    a$ = right$(a$,l-virgule) : l = len(a$) : virgule = instr(a$,",")
    p = 1
' On dtermine les coordonnes des differents sommets du polygones
    while  l > 0
        p = p + 1
        x = val(left$(a$,virgule - 1))
        a$ = right$(a$,l-virgule) : l = len(a$) : virgule = instr(a$,",")
        y = val(left$(a$,virgule - 1))
        poly(p,0) = x : poly(p,1) = y : ' coordonnes du sommet numro P
' On calcule de mme les nouvelles coordonnes de tous les sommets pour la rotation
        Rotation_Point(x,y,angle) : 2d_poly_to xo + newx*echelle,yo + newy*echelle
        a$ = right$(a$,l-virgule) : l = len(a$) : virgule = instr(a$,",")
    end_while
' On remplit la surface du polygone avec la couleur R,G,B
    flooder(n,xo,yo,echelle,angle,r,g,b)

END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Calculer les nouvelles coordonnes dans la rotation tetha
' Le paramtre tetha est transmis en degrs.
' Rappel :
' La matrice de rotion d'angle tetha est :
' (  cos(tetha)   -sin(tetha) )
' |                           |
' (  sin(tetha)    cos(tetha) )
SUB Rotation_Point(x,y,tetha)
    dim_local t
    t = deg2rad * tetha : ' conversion de degrs en radians
    newx =  x * cos(t) - y * sin(t) : newy =  x * sin(t) + y * cos(t)
END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Remplissage du polygone par la couleur R,G,B
SUB flooder(n,xo,yo,echelle,angle,r,g,b)
    dim_local x,y,coin%
    for coin% = 0 to n - 1
        pnt(0) = poly(coin%,0) + 2/echelle : pnt(1) = poly(coin%,1) + 2/echelle
        PointInPolygon(n) : ' Dterminer un point  l'intrieur du polygone
        if result%=1
           x = pnt(0) : y = pnt(1) : Rotation_Point(x,y,angle)
' Faire le remplissage de la figure
           2d_flood xo + newx*echelle,yo + newy*echelle ,r,g,b
           exit_sub
        end_if
    next coin%

END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Merci  Klaus pour cette SUB
' Dterminer les coordonnes d'un point  l'intrieur du polygone pour servir
'  la commande 2D_FLOOD
SUB  PointInPolygon(n_poly%)
     dim_local aDroite%, aGauche%, np%, XIntersection, lg1%, lg2%
     result% = 0 : aDroite% = 0 : aGauche% = 0
     if n_poly% < 3 then exit_sub
     for np% = 1 to n_poly% - 1
         lg1% = 0 : lg2% = 0
         if (Poly(np%-1,1) <= pnt(1)) and (Poly(np%,1) >  pnt(1)) then lg1% = 1
         if (Poly(np%-1,1) >  pnt(1)) and (Poly(np%,1) <= pnt(1)) then lg2% = 1
         if (lg1% = 1) or (lg2% = 1)
' calculer les coordonnes x de l'intersection
            XIntersection = Poly(np%-1,0) + ((Poly(np%,0)-Poly(np%-1,0)) / (Poly(np%,1)-Poly(np%-1,1))) * (pnt(1)-Poly(np%-1,1))
' adapter l'indicateur appropri
            if XIntersection < pnt(0) then aGauche% = 1 - aGauche%
            if XIntersection > pnt(0) then aDroite% = 1 - aDroite%
        end_if
   next np%
   if (aDroite% = 1) and (aGauche% = 1) then Result% = 1
END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Dessiner un tank
SUB Char(x0,x,a)
    dim_local i
    2d_fill_color 0,0,0 : 2d_pen_color 0,0,0
    2d_circle x0+100+10*x,700,10 : 2d_circle x0+160+10*x,700,10 :2d_circle x0+130+10*x,690,10
    2d_rectangle x0+100+10*x,690,x0+160+10*x,710
    if a > 0 then a = 0-a
    if a < -180 then a = -180
    Draw_Polygone(barrel$,5,x0+130+10*x,678,2,a,0,0,0): ' dessiner le canon selon l'angle a
    2d_fill_color 255,255,0 : 2d_circle x0+130+10*x,678-10*x,10
END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
' Pour viter le clignotement dans le PICTURE du travail
' Merci  Silverman pour cette astuce
SUB Copy_Image()
    2d_image_copy 20,left(10),top(10),width(10),height(10)
    2d_target_is 0: 2d_image_paste 20,left(10),top(10) : 2d_target_is 10
END_SUB
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================