
rem ============================================================================
rem                Les Courbes paramtres
rem                  QUARTIQUE PIRIFORME
rem               Courbe sous forme de Poire
rem
rem        __________________________________
rem       |                                  |
rem       |  x = a*a/b * (1 + sin(t))*cos(t) |
rem       |  y = a*(1 + sin(t))              |
rem       |__________________________________|

rem ============================================================================

Picture 10 : full_space 10 : 2d_target_is 10


Quartique_Piriforme(100,420,1/2)
Quartique_Piriforme(200,420,1)
Quartique_Piriforme(400,420,2)

end
rem ============================================================================
SUB Quartique_Piriforme(xc,yc,echelle)
    dim_local a,b,x,y,t
    a = 100 : b = 2*a : ' Essayer avec b = 3*a ; b = 4*a , etc.
    degrees    
    2d_poly_from xc+(a*a/b)*echelle,yc - a*echelle
    for t = 0 to 360      
        x = a*a/b * (1 + sin(t))*cos(t)
        y = a*(1 + sin(t))
        2d_poly_to xc+x*echelle, yc-y*echelle
    next t
    2d_flood xc-2+(a*a/b)*echelle,yc- a*echelle,255,0,0
END_SUB
rem ============================================================================