
rem ============================================================================
rem      Faire rebondir une balle
rem ============================================================================
Init()
Demo()
Fin()
terminate
end

rem ============================================================================
SUB Init()
    dim xPos,yPos,xVit,yVit,r
    xPos = 100 : yPos = 100 : ' Position initiale
    xVit = 2   : yVit = 4   : ' Vitesse initiale  modifier si ncessaire
    r    = 20               : ' rayon de la balle
    picture 10 : full_space 10 : 2d_target_is 10 : 2d_fill_on : print_target_is 10
    font_color 10,255,255,255 : font_size 10,14  : font_bold 10
    caption 0,"Rebondissement de la balle sur les bords du PICTURE"
END_SUB
rem ============================================================================
SUB Demo()
    repeat
    ' Effacer la balle
        2d_fill_color 255,255,255 : 2d_pen_color 255,255,255 : 2d_circle xPos-r,yPos-r,r
    ' Calculer la nouvelle position
        xPos = xPos + xVit : yPos = yPos + yVit
    ' Rebondi sur les murs ?
        If (xPos < r) Or (xPos > Width(10))  then xVit = 0-xVit
        If (yPos < r) Or (yPos > Height(10)) Then yVit = 0-yVit
   ' Actualiser la position
        2d_fill_color 0,0,0 : 2d_pen_color 0,0,0 : 2d_circle xPos-r,yPos-r,r
        Decors() : ' Redessiner le dcors
    until scancode = 32
END_SUB
rem ============================================================================
SUB Decors()
    2d_fill_color 255,0,0
    print_locate 20,20 : print " Rebondissement de la balle sans destruction du dcors "
    print_locate 150,50 : print " <ESPACE> pour continuer ... "
    2d_fill_color 255,255,000 : 2d_rectangle 200,100,400,300
    2d_fill_color 255,000,000 : 2d_circle  300,200,50
    2d_fill_color 000,000,255 : 2d_circle  300,200,25
    2d_fill_color 255,255,255 : 2d_circle  300,200,10
END_SUB
rem ============================================================================
SUB Fin()
    dim_local i,w,h
    w = width(0) : h = height(0)
    hide 10 : 2d_target_is 0 : print_target_is 0
    color 0,0,0,0 : font_size 0,24 : font_color 0,255,0,0
    repeat
            2d_pen_color rnd(255),rnd(255),rnd(255) : 2d_point rnd(w),rnd(h)
           print_locate 20,200 : print " Demo termine ! <ESC> pour quitter "
    until scancode = 27
    for i = h to 10 step -10 : height 0,i : pause 50 : next i
END_SUB
rem ============================================================================