
rem ' Chants-d'oiseaux - par jjn4 - le 29/04/2022 =============================
   dim CRC$ : rem Chemin du Rpertoire Courant
   dim DCO% : rem Dure du Chant de l`Oiseau choisi
   dim NOC% , NOC$ : rem Numro et Nom de l`Oiseau Choisi
   dim V1M% : rem Variable  utilisation Multiple
   CRC$=dir_current$+"\"
   label clic : rem Gestion de tous les on-click
   label time : rem Mise en action du timer

rem Form0 et autres prparatifs ===============================================
   width 0,1365
   height 0,720
   font_bold 0
   font_size 0,18
   font_name 0,"Arial"
   font_color 0,0,0,255
   color 0,175,230,255
   caption 0,"   Chants d'oiseaux"
   dlist 10 : rem Liste de travail de l`ordinateur
   dlist 20 : rem Adresses des renseignements annexes
   dlist 30 : rem Ordre alphabtique des oiseaux
      if file_exists(CRC$+"Wiki.txt")=1
         file_load 20,CRC$+"Wiki.txt"
      end_if
      if file_exists(CRC$+"Ordre-Oiseaux.txt")=1
         file_load 30,CRC$+"Ordre-Oiseaux.txt"
      end_if
   
rem Affichage de la faade ====================================================
   list 100
      left 100,10
      top 100,30
      width 100,300
      height 100,640
      sort_on 100
      font_bold 100
      font_size 100,24
      font_name 100,"Arial"
      font_color 100,0,0,255
      color 100,175,230,255
      on_click 100,clic
      if file_exists(CRC$+"Chants-d'oiseaux.txt")=1
         file_load 10,CRC$+"Chants-d'oiseaux.txt"
         for V1M% = 1 to count(10) step 4
            item_add 100,item_read$(10,V1M%)
         next V1M%
      end_if
   progress_bar 110
      left 110,320
      top 110,30
      width 110,120
      height 110,25
      min 110,0
      max 110,100
   alpha 120
      left 120,320
      top 120,60
      caption 120,"Tps :       s"
   alpha 130
      left 130,390
      top 130,60
      font_color 130,255,0,0
   button_picture 140
      left 140,320
      top 140,95
      width 140,120
      height 140,65
      button_picture_target_is_picture
      width 140,116
      height 140,61
      file_load 140,CRC$+"Bouton1.bmp"
      on_click 140,clic
   button_picture 150
      button_picture_target_is_object
      left 150,320
      top 150,170
      width 150,120
      height 150,65
      button_picture_target_is_picture
      width 150,116
      height 150,61
      file_load 150,CRC$+"Bouton2.bmp"
      on_click 150,clic
   picture 160
      left 160,450
      top 160,10
      width 160,890
      height 160,660
      if file_exists("Nid.jpg")=1
         file_load 160,"Nid.jpg"
      end_if
   sound 170
      V1M%=0
   timer 180
      timer_interval 180,1000
      on_timer 180,time
      timer_off 180
   alpha 190
      left 190,320
      top 190,245
      font_size 190,14
      font_color 190,255,0,0
      caption 190,"Nom latin :"
   memo 200
      left 200,311
      top 200,265
      width 200,138
      height 200,60
      bar_vertical 200
      font_size 200,11
      color 200,175,230,255
   alpha 210
      left 210,320
      top 210,335
      font_size 210,14
      font_color 210,255,0,0
      caption 210,"Description :"
   memo 220
      left 220,315
      top 220,358
      width 220,130
      height 220,160
      bar_vertical 220
      font_size 220,9
      color 220,175,230,255
   alpha 230
      left 230,5
      top 230,1
      font_color 230,255,0,0
      caption 230,"Nom de l'oiseau"
   button_picture 240
      button_picture_target_is_object
      left 240,320
      top 240,605
      width 240,120
      height 240,65
      button_picture_target_is_picture
      width 240,116
      height 240,61
      file_load 240,CRC$+"Bouton4.bmp"
      on_click 240,clic
   button_picture 250
      button_picture_target_is_object
      left 250,320
      top 250,530
      width 250,120
      height 250,65
      button_picture_target_is_picture
      width 250,116
      height 250,61
      file_load 250,CRC$+"Bouton3.bmp"
      on_click 250,clic
      
end : ' Dbut des routines ====================================================

sub arret() : rem Arrt du chant de l`oiseau ==================================
   if file_exists(CRC$+"Chant-vide.mp3")=1
      file_load 170,CRC$+"Chant-vide.mp3"
      play 170
      timer_off 180
      position 110,0
   end_if
end_sub

sub chant() : rem Lancement du chant de l`oiseau choisi =======================
   dim_local v1ch$
   if NOC%<>0
      v1ch$=str$(NOC%)
      if len(v1ch$)<2
         v1ch$="0"+v1ch$
      end_if
      if file_exists(CRC$+v1ch$+"_Piste.mp3")=1
         file_load 170,CRC$+v1ch$+"_Piste.mp3"
         play 170
         V1M%=0
         position 110,0
         timer_on 180
      end_if
   end_if
end_sub

sub choix() : rem Choix d`un oiseau ===========================================
   if item_index(100)>0
      if position(110)>0
         trigger_click 150
      end_if
      NOC%=val(item_read$(30,item_index(100)))
      NOC$=item_index$(100)
      DCO%=val(item_read$(10,((NOC%-1)*4)+4))
      if file_exists(CRC$+NOC$+".jpg")=1
         file_load 160,CRC$+NOC$+".jpg"
         caption 130,DCO%
         clear 200
         item_add 200,item_read$(10,((NOC%-1)*4)+2)
         clear 220
         item_add 220,item_read$(10,((NOC%-1)*4)+3)
         caption 230,item_read$(10,((NOC%-1)*4)+1)
      end_if
   end_if
end_sub

clic: : rem Gestion de tous les on-click ======================================
   select number_click
      case 100 : choix()
      case 140 : chant()
      case 150 : arret()
      case 240 : quitter()
      case 250 : wiki()
   end_select
return

sub quitter() : rem Quitter le programme ======================================
   timer_off 180
   terminate
end_sub

time: : rem Mise en action du timer ===========================================
   V1M%=V1M%+1
   position 110,(V1M%/DCO%)*100
   if V1M%=>DCO%
      timer_off 180
      position 110,0
   end_if
return

sub wiki() : rem Consultation des donnes de Wikipedia ========================
   if NOC%>0
      execute_wait item_read$(20,NOC%)
   end_if
end_sub
