' TSL : Barre de couleurs
' Marc - Mai 2022
' Ecrit en langage Panoramic

dim r%,v%,b%,i%
dim teinte,saturation,luminosite

picture 1
width 1,360
height 1,30
top 1,50
left 1,110
2d_target_is 1

teinte = 0 :' [0,359]
saturation = 100 :' [0,100%]
luminosite = 50 :' [0,100%]

for i% = 0 to 359
    tsl2rvb(i%,saturation,luminosite)
    2d_pen_color r%,v%,b%
    2d_line i%,0,i%,30
next i%

end
' ------------------------------------------------------------------------------
sub tsl2rvb(t1,s1,l1)
    dim_local var1,var2

    t1 = t1 / 360
    s1 = s1 / 100
    l1 = l1 / 100
    
    if s1 = 0
        r% = int(l1*255)
        v% = int(l1*255)
        b% = int(l1*255)
    else
        if (l1 < 0.5)
            var2 = l1 * (1 + s1)
        else
            var2 = (l1 + s1) - (s1 * l1)
        end_if
        var1 = 2 * l1 - var2

        r% = 255 * teinteRVB(var1,var2,t1 + (1/3))
        v% = 255 * teinteRVB(var1,var2,t1 )
        b% = 255 * teinteRVB(var1,var2,t1 - (1/3))
   end_If
end_sub
' ------------------------------------------------------------------------------
fnc teinteRVB(v1,v2,vH)
   if vH < 0 then vH = vH + 1
   if vH > 1 then vH = vH - 1
   if 6 * vH < 1 then result (v1 + (v2 - v1) * 6 * vH) : exit_fnc
   if 2 * vH < 1 then result (v2 )  : exit_fnc
   if 3 * vH < 2 then result (v1 + (v2 - v1) * ((2/3) - vH) * 6)  : exit_fnc
   result v1
end_fnc
' ------------------------------------------------------------------------------