' Exemple de 3 potentiomtres horizontaux
' Marc - Mai 2022
' Ecrit en langage Panoramic

dim null%, xSouris%, p1%,p2%,p3%

label reglageP1, reglageP2, reglageP3

interfaceUtilisateur()

end
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    width 0,width(0) - width_client(0) + 540
    height 0,height(0) - height_client(0) + 240
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    color 0,255,255,255
    caption 0,"PANORAMIC Exemple de trois potentiomtres horizontaux"

    ' PICTURE non visible servant de planche  dessins
    create_hide
    picture 1
    create_show
    
    ' zones mmoire pour stocker les dessins
    image 2
    image 3

    dessinerModelePotentiometre()

    ' creerPotentiometre(nummro d'objet,coordonne en x, coordonne en y)
    creerPotentiometre(30,50,50)
    creerPotentiometre(35,50,100)
    creerPotentiometre(40,50,150)
    
    ' creer affichage de la position des curseurs des potentiomtres
    alpha 45
    top 45,55
    left 45,450
    font_size 45,18
    caption 45,"0"
    
    alpha 46
    top 46,105
    left 46,450
    font_size 46,18
    caption 46,"0"
    
    alpha 47
    top 47,155
    left 47,450
    font_size 47,18
    caption 47,"0"

    on_mouse_down 30,reglageP1    
    on_mouse_down 35,reglageP2    
    on_mouse_down 40,reglageP3    
end_sub
' ------------------------------------------------------------------------------
sub dessinerModelePotentiometre()
    2d_target_is 1

    ' dessiner le dcor de fond du potentiomtre
    width 1,368
    height 1,44
    color 1,255,255,255
    2d_pen_color 153,153,153
    2d_rectangle 0,21,368,23
  
    ' copie du dessin effectu (dcor de fond) en mmoire dans l'objet IMAGE 2
    2d_image_copy 2,0,0,368,44

    ' dessiner le bouton du potentiomtre
    color 1,0,0,0 :' effacer planche  dessin (picture 1)
    2d_pen_color 0,120,215
    2d_fill_color 0,120,215
    2d_rectangle 0,21,368,23
    2d_rectangle 361,11,367,33
    2d_line 362,10,366,10
    2d_line 360,12,360,32
    2d_line 367,12,367,32
    2d_line 362,33,366,33

    ' copie du dessin effectu (bouton) en mmoire dans l'objet IMAGE 3
    2d_image_copy 3,0,0,368,44
end_sub
' ------------------------------------------------------------------------------
sub creerPotentiometre(n%,x%,y%)
    ' Corps du potentiomtre
    scene2d n%
    top n%,y%
    left n%,x%
    width n%,368
    height n%,44
    sprite_target_is n%

    sprite_create_hide

    ' creer sprite servant d'image de fond et copier le dessin dessus
    sprite n%
    sprite_image_load n%,2
    sprite_position n%,0,0
 
    ' creer le sprite du bouton et copier le dessin dessus
    sprite n%+1
    sprite_image_load n%+1,3
    sprite_position n%+1,-360,0

    sprite_show n%
    sprite_show n%+1
end_sub
' ------------------------------------------------------------------------------
reglageP1:
    off_mouse_down 30
    ' inhibition bouton droit souris
    if mouse_right_down(30)=1
        on_mouse_down 30,reglageP1    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(30)
    null% = mouse_left_down(30)

    while mouse_left_up(30) = 0 :' Tant que le bouton gauche de la souris est enfonc            
        xSouris% = mouse_x_position(30) - 364
        if xSouris% < -360 :' limite gauche
            sprite_x_position 31,-360
        end_if
        if xSouris% > 0
            sprite_x_position 31,0 :' limite droite
        end_if
        if xSouris% > -360 and xSouris% < 0
            sprite_x_position 31,xSouris%
        end_if
        p1% = sprite_x_position(31) + 360
        caption 45,p1%
    end_while

    on_mouse_down 30,reglageP1    
return
' ------------------------------------------------------------------------------
reglageP2:
    off_mouse_down 35
    ' inhibition bouton droit souris
    if mouse_right_down(35)=1
        on_mouse_down 35,reglageP2    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(35)
    null% = mouse_left_down(35)

    while mouse_left_up(35) = 0 :' Tant que le bouton gauche de la souris est enfonc            
        xSouris% = mouse_x_position(35) - 364
        if xSouris% < -360 :' limite gauche
            sprite_x_position 36,-360
        end_if
        if xSouris% > 0
            sprite_x_position 36,0 :' limite droite
        end_if
        if xSouris% > -360 and xSouris% < 0
            sprite_x_position 36,xSouris%
        end_if
        p2% = sprite_x_position(36) + 360
        caption 46,p2%
    end_while

    on_mouse_down 35,reglageP2    
return
' ------------------------------------------------------------------------------
reglageP3:
    off_mouse_down 40
    ' inhibition bouton droit souris
    if mouse_right_down(40)=1
        on_mouse_down 40,reglageP3    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(40)
    null% = mouse_left_down(40)

    while mouse_left_up(40) = 0 :' Tant que le bouton gauche de la souris est enfonc            
        xSouris% = mouse_x_position(40) - 364
        if xSouris% < -360 :' limite gauche
            sprite_x_position 41,-360
        end_if
        if xSouris% > 0
            sprite_x_position 41,0 :' limite droite
        end_if
        if xSouris% > -360 and xSouris% < 0
            sprite_x_position 41,xSouris%
        end_if
        p3% = sprite_x_position(41) + 360
        caption 47,p3%
    end_while

    on_mouse_down 40,reglageP3    
return
' ------------------------------------------------------------------------------