' RVB vers TSV (RGB to HSV ou HSB)
' Marc - Mai 2022
' Ecrit en langage Panoramic

dim r%,v%,b%
dim teinte,saturation,valeur

caption 0,"RVB vers TSV (RGB to HSV/HSB)"

' ******* SAISIR ICI LES VALEURS RVB  CONVERTIR *******
r% = 82
v% = 157
b% = 87

RVB2TSV(r%,v%,b%)
print " R,V,B = " + str$(r%) + "," + str$(v%) + "," + str$(b%)
print
print " Teinte = " + str$(teinte) + ""
print " Saturation = " + str$(saturation) + "%"
print " Valeur = " + str$(valeur) + "%"

end

sub RVB2TSV(r1,v1,b1)
    dim_local mini, maxi, ecart

    ' conversion rvb dans l'intervalle [0,1]
    r1 = r1 / 255
    v1 = v1 / 255
    b1 = b1 / 255

   ' recherche de la plus grande valeur parmi les composantes r,v,b
    maxi = max(r1,max(v1,b1))

    ' recherche de la plus petite valeur parmi les composantes r,v,b  
    mini = min(r1,min(v1,b1))

    ' calcul du paramtre valeur
    valeur = maxi

    ' calcul de l'cart entre la valeur mini et maxi
    ecart = maxi - mini

    ' calcul de la saturation
    if valeur = 0
        saturation = 0
    else      
        saturation = ecart / valeur
    end_if

    ' calcul de la teinte
    if saturation = 0
        teinte = 0
    else
 if r1 = valeur then teinte = (v1 - b1) / ecart
 if v1 = valeur then teinte = 2 + ((b1 - r1) / ecart)
 if b1 = valeur then teinte = 4 + ((r1 - v1) / ecart)
    end_if

    ' conversion de la teinte en degrs [0,359]
    teinte = int(teinte * 60)
    teinte = wrap_value(teinte)

    ' conversion saturation en pourcentage [0,100]
    saturation = int(saturation * 1000)/10

    ' conversion valeur en pourcentage [0,100]
    valeur = int(valeur * 1000)/10
end_sub