
rem ============================================================================
rem       ROTOR : le jeu qui vous donne du fil  RETORDRE
rem                Papydall le 25 / 05 / 2020
rem ============================================================================
rem Jai essay de coder  ma faon un jeu que jai trouv sur :
rem http://ressources.univ-lemans.fr/AccesLibre/UM/Pedago/physique/02/recre/rotor.html
rem ============================================================================
dim bouton,coup,rotation,i,j,n,m,nm,w,t$
label nouveau,melanger,tourner,retablir,quitter
label bouton20,bouton30,bouton40,bouton50
width 0,1200 : height 0,700 : color 0,0,150,150

Rotor()

end
rem ============================================================================
SUB Rotor()
    Damier()
    Info()
    GUI()
END_SUB
rem ============================================================================
SUB Damier()  
    w = 200
    picture 99 : top 99,20 : left 99,20
    width 99,600 : height 99,600 : color 99,200,180,50
    for i = 1 to 3
        for j = 1 to 3
            n = j + (i-1)*3
            memo n : top n,40+(i-1)* w : left n,40+(j-1)*w
            width n,w/2 : height n,w/2
            font_name n,"arial blak" : font_size n,30 : item_add n,str$(n)
            color n, 0,0,255 : font_color n,255,255,0
        next j
    next i
    button 20 : top 20,60+w/2   : left 20,60+w/2    : width 20,60 : height 20,60    
    button 30 : top 30,60+w/2   : left 30, 60+w+w/2 : width 30,60 : height 30,60    
    button 40 : top 40,60+w+w/2 : left 40,60+w/2    : width 40,60 : height 40,60    
    button 50 : top 50,60+w+w/2 : left 50,60+w+w/2  : width 50,60 : height 50,60
    for i = 20 to 50 step 10
        font_name i,"wingdings 3" : font_size i,12 : caption i, chr$(81)
        font_bold i : on_click i,tourner
    next i
    on_mouse_move 20,bouton20 : on_mouse_move 30,bouton30
    on_mouse_move 40,bouton40 : on_mouse_move 50,bouton50
    on_mouse_move 99,retablir      
END_SUB
rem ============================================================================
SUB Info()
    t$ = "Un damier 3 x 3 contient 9 pions numrots de 1  9." +chr$(13)
    t$ = t$ + "Quatre boutons provoquent quand ils sont presss" + chr$(13)
    t$ = t$ + "une permutation circulaire des quatres pions les plus" + chr$(13)
    t$ = t$ + "proches du bouton press." + chr$(13)
    t$ = t$ + "Lorsque le curseur de la souris se positionne sur l'un"+chr$(13)
    t$ = t$ + "des 4 boutons de rotation, les pions concerns changent"+chr$(13)
    t$ = t$ + "de couleur pour votre confort."+chr$(13)
    t$ = t$ + "Quatre pressions successives redonnent la situation de"+chr$(13)
    t$ = t$ + "dpart." + chr$(13)+chr$(13)
    t$ = t$ + "Le jeu :" + chr$(13) + chr$(13)
    t$ = t$ + "Presser le bouton [ Mlanger ]."+chr$(13)
    t$ = t$ + "Le programme effectue alors un nombre alatoire de"+chr$(13)
    t$ = t$ + "rotations avec un choix galement alatoire des"+chr$(13)
    t$ = t$ + "boutons utiliss." + chr$(13)+chr$(13)
    t$ = t$ + "Le but du jeu consiste  ramener tous les pions dans"+chr$(13)
    t$ = t$ + "la configuration initiale." + chr$(13)+chr$(13)
    t$ = t$ + "a ne vous rappelle pas un autre jeu comme le taquin ?" + chr$(13) +chr$(13)
    t$ = t$ + "BONNE CHANCE !!!"
END_SUB
rem ============================================================================
SUB GUI()
    alpha 100 : top 100,20 : left 100,650 : font_name 100,"arial black" : font_size 100,12
    font_color 100,255,255,0 : caption 100,t$
    t$ = "Le jeu du ROTOR qui vous donne du fil  RETORDRE !!!"
    caption 0,t$ : application_title t$
 
    button 110 : top 110,600 : left 110,650 : font_bold 110 : caption 110,"&Nouveau"
    width 110,100 : font_size 110,12 : on_click 110,nouveau
    button 120 : top 120,600 : left 120,800 : font_bold 120 : caption 120,"&Mlanger"
    width 120,100 : font_size 120,12 : on_click 120,melanger
    button 130 : top 130,600 : left 130,950 : font_bold 130 : caption 130,"&Quitter"
    width 130,100 : font_size 130,12 : on_click 130,quitter
    alpha 140 : top 140,620 : left 140,50 : font_bold 140 : font_size 140,12
    caption 140,"Nombre de coups : 0"
END_SUB
rem ============================================================================
Retablir:
    for i = 1 to 9 : color i,0,0,255 : next i
return
rem ============================================================================
Bouton20:
    bouton = 20 : Montrer(20)
return
rem ============================================================================
Bouton30:
    bouton = 30 : Montrer(30)
return
rem ============================================================================
Bouton40:
    bouton = 40 : Montrer(40)
return
rem ============================================================================
Bouton50:
    bouton = 50 : Montrer(50)
return
rem ============================================================================
SUB Montrer(bouton)
   for i = 1 to 9 : color i,0,0,255 : next i
   select bouton
       case 20 : color 1,0,128,0 : color 2,0,128,0 : color 4,0,128,0 : color 5,0,128,0
       case 30 : color 2,0,128,0 : color 3,0,128,0 : color 5,0,128,0 : color 6,0,128,0
       case 40 : color 4,0,128,0 : color 5,0,128,0 : color 7,0,128,0 : color 8,0,128,0
       case 50 : color 5,0,128,0 : color 6,0,128,0 : color 8,0,128,0 : color 9,0,128,0      
   end_select
END_SUB
rem ============================================================================
Tourner:
    Tourne(number_click) : Verifier()
return
rem ============================================================================
SUB Tourne(n)
    dim_local tmp$
    coup = coup + 1
    select n
        case 20 : tmp$ = item_read$(5,1)
                  clear 5 : item_add 5,item_read$(4,1)
                  clear 4 : item_add 4,item_read$(1,1)
                  clear 1 : item_add 1,item_read$(2,1)
                  clear 2 : item_add 2,tmp$
        case 30 : tmp$ = item_read$(6,1)
                  clear 6 : item_add 6,item_read$(5,1)
                  clear 5 : item_add 5,item_read$(2,1)
                  clear 2 : item_add 2,item_read$(3,1)
                  clear 3 : item_add 3,tmp$
        case 40 : tmp$ = item_read$(8,1)
                  clear 8 : item_add 8,item_read$(7,1)
                  clear 7 : item_add 7,item_read$(4,1)
                  clear 4 : item_add 4,item_read$(5,1)
                  clear 5 : item_add 5,tmp$
        case 50 : tmp$ = item_read$(9,1)
                  clear 9 : item_add 9,item_read$(8,1)
                  clear 8 : item_add 8,item_read$(5,1)
                  clear 5 : item_add 5,item_read$(6,1)
                  clear 6 : item_add 6,tmp$
    end_select
    caption 140,"Nombre de coups : " + str$(coup)
  
END_SUB
rem ============================================================================
Nouveau:
   coup = 0
   caption 140,"Nombre de coups : 0"
   for n = 1 to 9
       clear n : item_add n,str$(n)
   next n
return
rem ============================================================================
Melanger:
   gosub Nouveau
   rotation = 0  
   nm = 5 + int(rnd(20))
   if mod(nm,4) = 0 then nm = nm+1
   for i = 1 to nm
       m = 10*int(2 + rnd(4))
       tourne(m) : pause 100    
   next i
   caption 140,"Nombre de rotations : " + str$(nm)
   coup = 0
return
rem ============================================================================
SUB Verifier()
    for i = 1 to 9
        if item_read$(i,1) <> str$(i) then exit_for
    next i
    if i = 10
       message "!!! BRAVO !!! Tu as russi en " + str$(coup) + " coups !!! Tu es un grand champion !!!"
       coup = 0 : caption 140,"Nombre de coups : 0"  
       for i = 1 to 9 : color i, 0,0,255 : next i
    end_if
END_SUB
rem ============================================================================
Quitter:
   terminate
return
rem ============================================================================