' PANORAMIC - Ralisations et Codes sources
' Marc - Dcembre 2022
' Ecrit en langage Panoramic 0.9.29.i9
dim dossier$, fichier$, codeSource$, nombreAffichettesEcran%, mode%, liste%, bd%, n%, i%, exe%
dim fiche%, nombreEnregistrements%, page%, numeroAffichette%, index%, separateur%(8)
dim image$, largeurImage%, hauteurImage%, h_bordures%, l_bordures%, enregistrement$
dim champNumero$(15), champImage$(15), champNom1$(15), champNom2$(15), champAuteur$(15), champTheme$(15), champLienForum$(15), champCodeSource$(15), champExecutable$(15)

label testExecuterCodeSource, chargerCodeSource, collerCodeSource, effacerCodeSource
label goForum, goToArticleForum, copierCodeSource, executerCodeSource, afficherImage, fermerImage
label modeEdition, fermerEditeurListe, afficherEditeurListe, redim0, quitter
label creerNouvelleFiche, editer, nouveau, supprimer, valider, selection, redim15
label afficherPagePrecedente, afficherPageSuivante, afficherPremierePage, afficherDernierePage
label goToPage, allerPage, annulerGoToPage

label chargerImage, enregistrerFiche, fermerFenetreEdition, triBase, annulTriTheme, annulTriAuteur
label recherche, annulRecherche

dossier$ = dir_current$ + "\"

creerInterfaceUtilisateur()

chargerFichiers()

end
' ------------------------------------------------------------------------------
recherche:
    rechercher()
return    
' ------------------------------------------------------------------------------
sub rechercher()
    dim_local n%, mot$, record$
    clear 79
    item_select 3,1
    item_select 4,1
    mot$ = lower$(text$(5))

    if mot$ = ""
        set_focus 99
        bd% = 80
        nombreEnregistrements% = count(80)
        page% = 1
        afficherPage()
        end_sub
    end_if

    for n% = 1 to count(80)
        record$ = lower$(item_read$(80,n%))
        if instr(record$,mot$) > 0
            item_add 79,record$
        end_if 
    next n%

    bd% = 79
    nombreEnregistrements% = count(79)
    page% = 1
    afficherPage()
end_sub
' ------------------------------------------------------------------------------
annulRecherche:
    text 5,""
    item_select 3,1
    item_select 4,1
    set_focus 99
    bd% = 80
    nombreEnregistrements% = count(80)
    page% = 1
    afficherPage()
return
' ------------------------------------------------------------------------------
triBase:
    inactive 0
    trierBase()
    active 0
return
' ------------------------------------------------------------------------------
sub trierBase()
    dim_local n%, record$, theme$, auteur$
    clear 79

    theme$ = text$(3)
    auteur$ = text$(4)

    ' aucun tri
    if theme$ = "* Tous les thmes *" and auteur$ = "* Tous les auteurs *"
        bd% = 80
        nombreEnregistrements% = count(80)
        page% = 1
        afficherPage()
        exit_sub
    end_if
    
    ' tri sur les deux critres
    if auteur$ <> "* Tous les auteurs *" and theme$ <> "* Tous les thmes *"  
        for n% = 1 to count(80)
            record$ = item_read$(80,n%)
            if instr(record$,auteur$) > 0 and instr(record$,theme$) > 0
                item_add 79,record$
            end_if 
        next n%
        bd% = 79
        nombreEnregistrements% = count(79)
        page% = 1
        afficherPage()
        exit_sub    
    end_if    

    ' tri par auteur
    if auteur$ <> "* Tous les auteurs *"  
        for n% = 1 to count(80)
            record$ = item_read$(80,n%)
            if instr(record$,auteur$) > 0
                item_add 79,record$
            end_if 
        next n%
        bd% = 79
        nombreEnregistrements% = count(79)
        page% = 1
        afficherPage()
        exit_sub    
    end_if    
    
    ' tri par thme
    if theme$ <> "* Tous les thmes *"  
        for n% = 1 to count(80)
            record$ = item_read$(80,n%)
            if instr(record$,theme$) > 0
                item_add 79,record$
            end_if 
        next n%
    end_if    
    
    bd% = 79
    nombreEnregistrements% = count(79)
    page% = 1
    afficherPage()    
end_sub
' ------------------------------------------------------------------------------
annulTriTheme:
    item_select 3,1
    set_focus 99
    trierBase()
return
' ------------------------------------------------------------------------------
annulTriAuteur:
    item_select 4,1
    set_focus 99
    trierBase()
return
' ------------------------------------------------------------------------------
creerNouvelleFiche:
    nouvelleFiche()
return
' ------------------------------------------------------------------------------
sub nouvelleFiche()
    ' suppression de l'icne l'excution instantane si absence Make_exe.exe
    if exe% = 0
        hide 66
    end_if 

    ' numro d'ordre de la nouvelle fiche
    fiche% = count(80) + 1

    ' place de la nouvelle affichette sur l'cran
    numeroAffichette% = mod(fiche%,nombreAffichettesEcran%)
    if numeroAffichette% = 0
        numeroAffichette% = nombreAffichettesEcran%
    end_if

    ' numro de la page o sera dispose la nouvelle fiche
    page% = (fiche% - numeroAffichette%) / nombreAffichettesEcran% + 1
    
    ' effacer tous les champs de saisie
    ' image
    width 53,425
    height 53,425
    color 53,255,255,255
    color 82,255,255,255    
    ' Nom du logiciel
    text 55,""
    text 56,""
    ' Auteur
    text 57,""
    ' Thme
    text 59,""
    ' Lien Internet vers le Forum
    text 61,""
    ' Code source
    clear 54    
    ' case  cocher Executable
    mark_off 67

    ' afficher fentre d'dition
    show 50
    to_foreground 50
    inactive 0

    caption 52,"Cration de la fiche n " + str$(fiche%)
    set_focus 55
end_sub
' ------------------------------------------------------------------------------
editer:
    ' suppression de l'icne de l'excution instantane si absence Make_exe.exe
    if exe% = 0
        hide 66
    end_if 

    ' afficher fentre d'dition
    show 50
    to_foreground 50
    inactive 0

    ' Identifier l'affichette clique
    numeroAffichette% = int(number_click / 10) - 9

    ' Numro de la fiche
    if champNumero$(numeroAffichette%) = ""
        nouvelleFiche()
        return
    else
        fiche% = val(champNumero$(numeroAffichette%))
    end_if    

    ' titre de la fentre
    caption 52,"Edition de la fiche n " + str$(fiche%)

    ' REMPLIR LES CHAMPS
    ' image du logiciel
    width 53,425
    height 53,425
    color 53,255,255,255
    color 82,255,255,255    
    if file_exists(champImage$(numeroAffichette%)) = 1 
        file_load 53,champImage$(numeroAffichette%)
        file_load 82,champImage$(numeroAffichette%)
    end_if

    ' Titre du logiciel
    text 55,champNom1$(numeroAffichette%)
    text 56,champNom2$(numeroAffichette%)

    ' Auteur
    text 57,champAuteur$(numeroAffichette%)

    ' Thme
    text 59,champTheme$(numeroAffichette%)

    ' Lien Internet vers le Forum
    text 61,champLienForum$(numeroAffichette%)

    ' Code source
    if file_exists(champCodeSource$(numeroAffichette%)) = 1 
        file_load 54,champCodeSource$(numeroAffichette%)
    else
        clear 54    
    end_if

    ' case  cocher Executable
    if champExecutable$(numeroAffichette%) = "1"
        mark_on 67
    else
        mark_off 67
    end_if
return
' ------------------------------------------------------------------------------
chargerImage:
    filter 85,"Image (*.jpg *.bmp)|*.jpg;*.bmp"
    image$=FILE_NAME$(85)

    if image$="_"
         return
    end_if
         
    if file_exists(image$) = 0
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(image$) + "'' n'existe pas  cet endroit !")
        set_focus 0
        return
    end_if

    file_load 53,image$
    file_load 82,image$
    dir_change dossier$
return
' ------------------------------------------------------------------------------
chargerCodeSource:
    filter 85,"Fichier PANORAMIC basic (*.bas)|*.bas"
    fichier$=FILE_NAME$(85)

    if fichier$="_"
         return
    end_if
         
    if file_exists(fichier$) = 0
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(fichier$) + "'' n'existe pas  cet endroit !")
        set_focus 0
        return
    end_if

    file_load 54,fichier$
    dir_change dossier$
return
' ------------------------------------------------------------------------------
collerCodeSource:
   text 54,clipboard_string_paste$
return
' ------------------------------------------------------------------------------
TestExecuterCodeSource:
    if text$(54) = ""
        return
    end_if

    dir_change dossier$
    fichier$ = str$(fiche%) + ".bas"

    if file_exists("temp\" + fichier$) = 1
        file_delete "temp\" + fichier$
    end_if

    file_save 54,"temp\"+ fichier$
    item_add 87,"temp\" + fichier$

    if file_exists("temp\" + left$(fichier$,len(fichier$)-4) + ".exe") = 1
        file_delete "temp\" + left$(fichier$,len(fichier$)-4) + ".exe"
    end_if

    if file_exists("temp\" + left$(fichier$,len(fichier$)-4) + ".exe") = 1
        message "Fermez le programme en cours d'excution pour pouvoir le relancer !"
        return
    end_if

    execute_wait dossier$ + "Make_Exe.exe| -e temp\" + fichier$
    fichier$ = left$(fichier$,len(fichier$)-4) + ".exe"
    item_add 87,"temp\" + fichier$
    execute "temp\" + fichier$
return
' ------------------------------------------------------------------------------
effacerCodeSource:
    text 54,""
return
' ------------------------------------------------------------------------------
enregistrerFiche:
    if text$(55)+text$(56) = ""
        if message_error_ok("Le champ Titre n'est pas renseign !")<3
        end_if
        to_foreground 50
        return
    end_if    
    
    if text$(57) = ""
        if message_error_ok("Le champ Auteur n'est pas renseign !")<3
        end_if
        to_foreground 50
        return
    end_if    
    
    if text$(59) = ""
        if message_error_ok("Le champ Thme n'est pas renseign !")<3
        end_if
        to_foreground 50
        return
    end_if    
    
    ' concatner les champs
    ' Numro squentiel de fiche
    enregistrement$ = str$(fiche%) + chr$(164)
    ' Image
    enregistrement$ = enregistrement$ + "data\images\" + str$(fiche%) + ".bmp" + chr$(164)
    ' Nom
    enregistrement$ = enregistrement$ + trim$(text$(55)) + chr$(164) + trim$(text$(56)) + chr$(164)
    ' Auteur
    enregistrement$ = enregistrement$ + text$(57) + chr$(164)
    ' Thme
    enregistrement$ = enregistrement$ + text$(59) + chr$(164)
    ' Lien vers l'article du Forum PANORAMIC
    enregistrement$ = enregistrement$ + trim$(text$(61)) + chr$(164)
    ' Lien vers le code source
    enregistrement$ = enregistrement$ + "data\codes\" + str$(fiche%) + ".bas" + chr$(164)
    ' Case  cocher Excutable
    enregistrement$ = enregistrement$ + str$(checked(67))

    if fiche% > count(80)
        item_add 80,enregistrement$
    else    
        item_delete 80,fiche%
        item_insert 80,fiche%,enregistrement$
    end_if    

    dir_change dossier$
    file_save 80,"data\prc.db"
    file_save 82,"data\images\" + str$(fiche%) + ".bmp"
    file_save 54,"data\codes\" + str$(fiche%) + ".bas"

    nombreEnregistrements% = count(80)

    if bd% = 79
        trierBase()
    end_if

    afficherPage()

    to_foreground 0
    hide 50
    active 0
    set_focus 99
return
' ------------------------------------------------------------------------------
sub chargerFichiers()
    dir_change dossier$

    ' test de prsence du "Make_exe.exe"
    if file_exists("Make_exe.exe") = 1
        exe% = 1
    else
        exe% = 0
        i% = message_information_ok("Le fichier ''Make_exe.exe'' est absent :"+chr$(13)+"L'excution instantane d'un code source ne sera pas disponible.")
    end_if

    if dir_exists("temp")=0
        dir_make "temp"
    end_if

    if dir_exists("data")=0
        dir_make "data"
    end_if

    if dir_exists("data\images")=0
        dir_make "data\images"
    end_if

    if dir_exists("data\codes")=0
        dir_make "data\codes"
    end_if

    if file_exists("data\prc.db")=1
        file_load 80,"data\prc.db"
    end_if

    if file_exists("data\themes.txt")=1
        file_load 3,"data\themes.txt"
        file_load 59,"data\themes.txt"
    end_if

    if file_exists("data\auteurs.txt")=1
        file_load 4,"data\auteurs.txt"
        file_load 57,"data\auteurs.txt"
    end_if

    nombreEnregistrements% = count(80)
    page% = 1
    afficherPage()
end_sub
' ------------------------------------------------------------------------------
sub afficherPage()
    dim_local adresse%, leftVignette%, topVignette%, nbPage%

    afficherNumeroPage()

    for numeroAffichette% = 1 to nombreAffichettesEcran%
        adresse% = (numeroAffichette% + 9)*10
        
        ' effacer numro de fiche
        champNumero$(numeroAffichette%) = ""

        ' effacer la miniature
        height adresse% + 1,120
        width adresse% + 1,213
        color adresse% + 1,255,255,255
        if nombreAffichettesEcran% = 15
            leftVignette% = 60 + 600 * mod(numeroAffichette% - 1,3)
            topVignette% = 168 + 160 * int((numeroAffichette% - 1) / 3)
        else
            leftVignette% = 93 + 600 * mod(numeroAffichette% - 1,2)
            topVignette% = 168 + 160 * int((numeroAffichette% - 1) / 2)
        end_if
        top adresse% + 1,topVignette%
        left adresse% + 1,leftVignette%
        champImage$(numeroAffichette%) = ""
        
        ' effacer champ Nom du programme
        caption adresse% + 2,"" 
        champNom1$(numeroAffichette%) = ""
        champNom2$(numeroAffichette%) = ""

        ' effacer champ Auteur
        caption adresse% + 4,"" 
        champAuteur$(numeroAffichette%) = ""

        ' effacer champ Thme
        champTheme$(numeroAffichette%) = ""

        ' effacer champ Lien Forum
        champLienForum$(numeroAffichette%) = ""

        ' effacer Code source
        champCodeSource$(numeroAffichette%) = ""
        
        ' effacer icne Executer
        hide adresse% + 7
        champExecutable$(numeroAffichette%) = "0"

        fiche% = nombreAffichettesEcran% * (page%-1) + numeroAffichette%
        
        if fiche% <= nombreEnregistrements%
             afficherEnregistrement()
        end_if
        
    next numeroAffichette%
end_sub
' ------------------------------------------------------------------------------
sub afficherEnregistrement()
    dim_local long%, adresseVignette%, ratio, leftVignette%, topVignette%
    
    enregistrement$ = item_read$(bd%,fiche%)

    ' mappage des sparateurs
    for i% = 1 to 8
        separateur%(i%) = instr_pos(enregistrement$,chr$(164),separateur%(i%-1)+1)
    next i%

    ' rpartition des champs
    champNumero$(numeroAffichette%) = left$(enregistrement$,separateur%(1)-1)
    
    long% = separateur%(2)- separateur%(1)-1 
    champImage$(numeroAffichette%) = mid$(enregistrement$,separateur%(1)+1,long%)
    
    long% = separateur%(3)- separateur%(2)-1 
    champNom1$(numeroAffichette%) = mid$(enregistrement$,separateur%(2)+1,long%)
    
    long% = separateur%(4)- separateur%(3)-1 
    champNom2$(numeroAffichette%) = mid$(enregistrement$,separateur%(3)+1,long%)
   
    long% = separateur%(5)- separateur%(4)-1 
    champAuteur$(numeroAffichette%) = mid$(enregistrement$,separateur%(4)+1,long%)

    long% = separateur%(6)- separateur%(5)-1 
    champTheme$(numeroAffichette%) = mid$(enregistrement$,separateur%(5)+1,long%)

    long% = separateur%(7)- separateur%(6)-1 
    champLienForum$(numeroAffichette%) = mid$(enregistrement$,separateur%(6)+1,long%)

    long% = separateur%(8)- separateur%(7)-1 
    champCodeSource$(numeroAffichette%) = mid$(enregistrement$,separateur%(7)+1,long%)

    long% = len(enregistrement$) - separateur%(8)
    champExecutable$(numeroAffichette%) = right$(enregistrement$,long%)
    if champExecutable$(numeroAffichette%) = "0"
        hide numeroAffichette% * 10 + 90 + 7   
    end_if

    ' emplacement affichette  l'cran
    adresseVignette% = (numeroAffichette% + 9) * 10 

    ' chargement image
    if file_exists(champImage$(numeroAffichette%)) = 1
        if nombreAffichettesEcran% = 15
            leftVignette% = 60 + 600 * mod(numeroAffichette% - 1,3)
            topVignette% = 168 + 160 * int((numeroAffichette% - 1) / 3)
        else
            leftVignette% = 93 + 600 * mod(numeroAffichette% - 1,2)
            topVignette% = 168 + 160 * int((numeroAffichette% - 1) / 2)
        end_if

        ' lire les dimensions de l'image
        filebin_open_read 84,champImage$(numeroAffichette%)
        filebin_position 84,18
        largeurImage% = filebin_read(84) + 256 * filebin_read(84)
        filebin_position 84,22
        hauteurImage% = filebin_read(84)+256*filebin_read(84)
        filebin_close 84

        ' calcul du ratio de l'image
        ratio = largeurImage% / hauteurImage%
        if ratio > 1.77
            height adresseVignette% + 1,int(width(adresseVignette% + 1) / ratio)
            top adresseVignette% + 1,int(topVignette% + ((120 - height(adresseVignette% + 1))/2))
        else
            width adresseVignette% + 1,int(height(adresseVignette% + 1) * ratio)
            left adresseVignette% + 1,int(leftVignette% + ((213 - width(adresseVignette% + 1))/2))
        end_if

        file_load adresseVignette% + 1,champImage$(numeroAffichette%)
    end_if

    caption adresseVignette% + 2,champNom1$(numeroAffichette%)+chr$(13)+champNom2$(numeroAffichette%) 
    caption adresseVignette% + 4,champAuteur$(numeroAffichette%)

    if champExecutable$(numeroAffichette%) = "1" and exe% = 1
        show adresseVignette% + 7
    else
        hide adresseVignette% + 7
    end_if
end_sub
' ------------------------------------------------------------------------------
sub afficherNumeroPage()
    dim_local nbPage%
    nbPage% = int((nombreEnregistrements% - 1) / nombreAffichettesEcran%) + 1

    ' une seule et unique page
    if nbPage% < 2
        caption 34,str$(page%) + " / " + str$(nbPage%)
        caption 44,str$(page%) + " / " + str$(nbPage%)

        2d_target_is 46
        2d_flood 4,3,140,140,140
        2d_flood 15,3,140,140,140
        2d_target_is 36
        2d_flood 4,3,140,140,140
        2d_flood 15,3,140,140,140
        2d_target_is 35
        2d_flood 6,3,140,140,140
        2d_target_is 45
        2d_flood 6,3,140,140,140

        2d_target_is 32
        2d_flood 4,2,140,140,140
        2d_flood 16,3,140,140,140
        2d_target_is 42
        2d_flood 4,2,140,140,140
        2d_flood 16,3,140,140,140
        2d_target_is 33
        2d_flood 14,3,140,140,140
        2d_target_is 43
        2d_flood 14,3,140,140,140

        exit_sub
    end_if

    ' dernire page
    if nbPage% = page%
        caption 34,str$(page%) + " / " + str$(nbPage%)
        caption 44,str$(page%) + " / " + str$(nbPage%)

        2d_target_is 32
        2d_flood 4,2,0,0,0
        2d_flood 16,3,0,0,0
        2d_target_is 42
        2d_flood 4,2,0,0,0
        2d_flood 16,3,0,0,0
        2d_target_is 33
        2d_flood 14,3,0,0,0
        2d_target_is 43
        2d_flood 14,3,0,0,0

        2d_target_is 46
        2d_flood 4,3,140,140,140
        2d_flood 15,3,140,140,140
        2d_target_is 36
        2d_flood 4,3,140,140,140
        2d_flood 15,3,140,140,140
        2d_target_is 35
        2d_flood 6,3,140,140,140
        2d_target_is 45
        2d_flood 6,3,140,140,140

        exit_sub
    end_if

    ' premire page
    if page% = 1  
        caption 34,str$(page%) + " / " + str$(nbPage%)
        caption 44,str$(page%) + " / " + str$(nbPage%)

        2d_target_is 32
        2d_flood 4,2,140,140,140
        2d_flood 16,3,140,140,140
        2d_target_is 42
        2d_flood 4,2,140,140,140
        2d_flood 16,3,140,140,140
        2d_target_is 33
        2d_flood 14,3,140,140,140
        2d_target_is 43
        2d_flood 14,3,140,140,140

        2d_target_is 46
        2d_flood 4,3,0,0,0
        2d_flood 15,3,0,0,0
        2d_target_is 36
        2d_flood 4,3,0,0,0
        2d_flood 15,3,0,0,0
        2d_target_is 35
        2d_flood 6,3,0,0,0
        2d_target_is 45
        2d_flood 6,3,0,0,0

        exit_sub
    end_if
    
    ' entre la premire et la dernire page
    caption 34,str$(page%) + " / " + str$(nbPage%)
    caption 44,str$(page%) + " / " + str$(nbPage%)
    2d_target_is 32
    2d_flood 4,2,0,0,0
    2d_flood 16,3,0,0,0
    2d_target_is 42
    2d_flood 4,2,0,0,0
    2d_flood 16,3,0,0,0
    2d_target_is 33
    2d_flood 14,3,0,0,0
    2d_target_is 43
    2d_flood 14,3,0,0,0
        
    2d_target_is 46
    2d_flood 4,3,0,0,0
    2d_flood 15,3,0,0,0
    2d_target_is 36
    2d_flood 4,3,0,0,0
    2d_flood 15,3,0,0,0
    2d_target_is 35
    2d_flood 6,3,0,0,0
    2d_target_is 45
    2d_flood 6,3,0,0,0
end_sub
' ------------------------------------------------------------------------------
modeEdition:
    if mouse_left_up(2) = 1
        return
    end_if
    
    if mode% = 0
        if message_confirmation_yes_no("Voulez-vous entrer en mode Edition ?")<>1
            return
        end_if    
        mode% = 1
        changerBandeau()
        show 12

        for n% = 101 to 248
            if object_exists(n%) = 1
                off_click n%
                cursor_point n%
                on_click n%,editer
            end_if
        next n% 
    else
        if message_confirmation_yes_no("Voulez-vous quitter le mode Edition ?")<>1
            return
        end_if    
        mode% = 0
        changerBandeau()
        hide 12

        for n% = 101 to 248
            if object_exists(n%) = 1
                off_click n%
                cursor_default n%
            end_if
        next n%
         
        for n% = 101 to 241 step 10
            if object_exists(n%) = 1
                on_click n%, afficherImage
                cursor_point n%
            end_if    
        next n% 

        for n% = 105 to 245 step 10
            if object_exists(n%) = 1
                on_click n%, goToArticleForum
                cursor_point n%
            end_if
        next n% 

        for n% = 106 to 246 step 10
            if object_exists(n%) = 1
                on_click n%, copierCodeSource
                cursor_point n%
            end_if
        next n% 

        for n% = 107 to 247 step 10
            if object_exists(n%) = 1
                on_click n%, executerCodeSource
                cursor_point n%
            end_if    
        next n% 
    end_if
return    
' ------------------------------------------------------------------------------
sub changerBandeau()
    ' couleur du bandeau
    2d_target_is 1
    if mode% = 0                                                                              
        2d_pen_color 40,40,140
        2d_fill_color 40,40,140
    else
        2d_pen_color 170,0,0
        2d_fill_color 170,0,0
    end_if
    2d_rectangle 0,0,width(0),95

    ' Titre
    print_target_is 1
    font_color 1,255,255,255
    font_name 1,"Calibri"
    font_size 1,32
    font_italic_off 1
    if mode% = 1
        if nombreAffichettesEcran% = 6
            print_locate 190,20
        else    
            print_locate 468,20
        end_if
        print "PANORAMIC - Ralisations et Codes sources. Mode EDITION"
    else
        if nombreAffichettesEcran% = 6
            print_locate 298,20
        else    
            print_locate 608,20
        end_if
        print "PANORAMIC - Ralisations et Codes sources"
    end_if    
end_sub

' ------------------------------------------------------------------------------
afficherImage:
    dir_change dossier$

    ' Identifier l'affichette clique
    numeroAffichette% = int(number_click / 10) - 9
    
    ' vrifier si le fichier image existe
    if file_exists(champImage$(numeroAffichette%)) = 0
        return
    end_if

    ' lire les dimensions de l'image
    filebin_open_read 84,champImage$(numeroAffichette%)
    filebin_position 84,18
    largeurImage% = filebin_read(84) + 256 * filebin_read(84)
    filebin_position 84,22
    hauteurImage% = filebin_read(84)+256*filebin_read(84)
    filebin_close 84

    if largeurImage% > screen_x - 100
        largeurImage% = screen_x - 60
        stretch_on 27
    end_if

    if hauteurImage% > screen_y - 100
        hauteurImage% = screen_y - 150
        stretch_on 27
    end_if

    width 26,largeurImage% + l_bordures% + 50
    height 26,hauteurImage% + h_bordures% + 50

    width 27,largeurImage%
    height 27,hauteurImage%

    ' charger l'image
    file_load 27,champImage$(numeroAffichette%)

    ' afficher la fentre et la centrer
    show 26
    top 26,(screen_y - height(26))/2
    left 26,(screen_x - width(26))/2
    caption 26,"Aperu : " + champNom1$(numeroAffichette%) + " " + champNom2$(numeroAffichette%) 
    
    inactive 0
    to_foreground 26
return
' ------------------------------------------------------------------------------
fermerImage:
    active 0
    stretch_off 27
return
' ------------------------------------------------------------------------------
sub creerFenetreImage()    
    form 26
    border_small 26
    color 26,100,100,100
    on_close 26,fermerImage

    ' calcul paisseurs des bords de la fentre 26
    l_bordures% = width(26) - width_client(26) 
    h_bordures% = height(26)- height_client(26) 

    picture 27
    parent 27,26
    top 27,25
    left 27,25
    hide 26
end_sub


' //////////////////////////////////////////////////////////////////////////////
' NAVIGATION : GESTION DES PAGES  
' ------------------------------------------------------------------------------
afficherPremierePage:
    page% = 1
    afficherPage()
return
' ------------------------------------------------------------------------------
afficherDernierePage:
    page% = int((nombreEnregistrements% - 1) / nombreAffichettesEcran%) + 1
    afficherPage()
return
' ------------------------------------------------------------------------------
afficherPagePrecedente:
    page% = page% - 1
    if page% < 1
        page% = 1
    end_if
    afficherPage()
return
' ------------------------------------------------------------------------------
afficherPageSuivante:
    if page% >= int((nombreEnregistrements% - 1) / nombreAffichettesEcran%) + 1
        return
    end_if    
    page% = page% + 1
    afficherPage()    
return
' ------------------------------------------------------------------------------
goToPage:
    show 70
    inactive 0
    to_foreground 70
    if number_click = 34
        top 70,top(0) + top(30) + 55
        left 70,left(0) + left(30) + 8
    else
        top 70,top(0) + top(40) - 90
        left 70,left(0) + left(30) + 8
    end_if    
    
    set_focus 73
return
' ------------------------------------------------------------------------------
allerPage:
    ' la saisie doit tre une valeur numrique
    if numeric(text$(73)) = 0
        active 0
        set_focus 99
        hide 70
        text 73,""
        return
    end_if

    ' le nombre saisie doit tre compris entre 1 et le nombre de pages
    if int(val(text$(73))) < 1 or int(val(text$(73))) > int((nombreEnregistrements% - 1) / nombreAffichettesEcran%) + 1
        active 0
        set_focus 99
        hide 70
        text 73,""
        return
    end_if

    ' afficher la page demande
    page% = int(val(text$(73)))
    afficherPage()
    active 0
    set_focus 99
    hide 70
return
' ------------------------------------------------------------------------------
annulerGoToPage:
    active 0
    set_focus 99
    hide 70
return


' //////////////////////////////////////////////////////////////////////////////
' DIVERS 
' ------------------------------------------------------------------------------
redim0:
    off_resize 0

    if screen_x > 1900
        nombreAffichettesEcran% = 15
        width 0,width(0)-width_client(0) + 1900
        height 0,height(0)-height_client(0) + 1000
    else
        nombreAffichettesEcran% = 6
    end_if        

    on_resize 0,redim0
return
' ------------------------------------------------------------------------------
goForum:
    execute "https://panoramic.1fr1.net/"
return
' ------------------------------------------------------------------------------
goToArticleForum:
    numeroAffichette% = int(number_click / 10) - 9
    if champLienForum$(numeroAffichette%) = ""
        return
    end_if
    execute champLienForum$(numeroAffichette%) 
return
' ------------------------------------------------------------------------------
copierCodeSource:
    dir_change dossier$
    numeroAffichette% = int(number_click / 10) - 9
    if champCodeSource$(numeroAffichette%) = ""
        return
    end_if 
    file_load 54,champCodeSource$(numeroAffichette%)
    codeSource$ = text$(54)
    clipboard_string_copy codeSource$
    clear 54
    codeSource$ = ""
    if message_information_ok("Le code source a t copi dans le presse-papiers.")<3
    end_if
return
' ------------------------------------------------------------------------------
executerCodeSource:
    dir_change dossier$
    numeroAffichette% = int(number_click / 10) - 9
    if champCodeSource$(numeroAffichette%) = ""
        return
    end_if    

    fichier$ = file_extract_name$(champCodeSource$(numeroAffichette%))
    
    if file_exists("temp\" + fichier$) = 1
        file_delete "temp\" + fichier$
    end_if
    
    file_copy champCodeSource$(numeroAffichette%),"temp\" + fichier$
    item_add 87,"temp\" + fichier$

    if file_exists("temp\" + left$(fichier$,len(fichier$)-4) + ".exe") = 0
        execute_wait dossier$ + "Make_Exe.exe| -e temp\" + fichier$
    end_if
    
    fichier$ = left$(fichier$,len(fichier$)-4) + ".exe"
    item_add 87,"temp\" + fichier$
    execute "temp\" + fichier$
return
' ------------------------------------------------------------------------------
fermerFenetreEdition:
    active 0
    to_foreground 0
    set_focus 99
return
' ------------------------------------------------------------------------------
quitter:
    dir_change dossier$
    ' suppression des fichiers temporaires
    if count(87) > 0
        for i% = 1 to count(87)
            fichier$ = item_read$(87,i%)
            if file_exists(fichier$) = 1
                file_delete fichier$
            end_if
        next i%
    end_if    
return

' //////////////////////////////////////////////////////////////////////////////
' Edition des listes AUTEURS et THEMES 
' ------------------------------------------------------------------------------
afficherEditeurListe:
    dir_change dossier$
    show 15
    inactive 50
    to_foreground 15
    liste% = number_click
    if liste% = 60 :' bouton Editer la liste des thmes
        caption 23," THEMES"
        if file_exists("data\themes.txt") = 1
            file_load 17,"data\themes.txt"
        end_if    
    else
        caption 23,"AUTEURS"
        if file_exists("data\auteurs.txt") = 1
            file_load 17,"data\auteurs.txt"
        end_if    
    end_if
    set_focus 18
return
' ------------------------------------------------------------------------------
fermerEditeurListe:
    dir_change dossier$
    if liste% = 60
        file_save 17,"data\themes.txt"
        file_load 3,"data\themes.txt"
        file_load 59,"data\themes.txt" 
    else
        file_save 17,"data\auteurs.txt"
        file_load 4,"data\auteurs.txt"
        file_load 57,"data\auteurs.txt"
    end_if
    text 18,""
    clear 17
    hide 15
    active 50
    to_foreground 50
return
' ------------------------------------------------------------------------------
nouveau:
    text 18,"" 
    ' astuce pour dslectionner la ligne du LIST 
    item_add 17,"zzzzz"
    item_select 17,count(17)
    item_delete 17,count(17)
    set_focus 18    
return
' ------------------------------------------------------------------------------
supprimer:
    item_delete 17,item_index(17)    
    pause 20
    ' astuce pour dslectionner la ligne du LIST 
    item_add 17,"zzzzz"
    item_select 17,count(17)
    item_delete 17,count(17)
    text 18,""
    set_focus 18    
return
' ------------------------------------------------------------------------------
valider:
    verifierDoublon()
    set_focus 18
return
' ------------------------------------------------------------------------------
sub verifierDoublon()
    dim_local n%

    if text$(18) = ""
        exit_sub
    end_if
    
    if item_index(17) > 0
        item_delete 17,item_index(17)
    end_if

    ' recherche doublon
    if count(17) > 0
        for n% = 1 to count(17)
            if lower$(item_read$(17,n%)) = lower$(text$(18))
                if message_warning_ok("Doublon") < 3 
                    exit_sub
                end_if
            end_if
        next n%
    end_if    
    item_add 17,text$(18)
    text 18,""

    ' astuce pour dslectionner la ligne du LIST 
    item_add 17,"zzzzz"
    item_select 17,count(17)
    item_delete 17,count(17)
end_sub
' ------------------------------------------------------------------------------
selection:
    text 18,item_index$(17)
    set_focus 18
    caret_position 18,len(text$(18))
return
' ------------------------------------------------------------------------------
redim15:
    off_resize 15
    height 15,height(15) - height_client(15) + 455
    width 15,width(15) - width_client(15) + 350
    on_resize 15,redim15
return

' //////////////////////////////////////////////////////////////////////////////
' INTERFACES GRAPHIQUES
' ------------------------------------------------------------------------------
sub creerInterfaceUtilisateur()
    dim_local i%,x%,y%,n%,nb%
    x% = screen_x

    if x% > 1900
        nombreAffichettesEcran% = 15
        width 0,width(0)-width_client(0) + 1900
        height 0,height(0)-height_client(0) + 1000
    else
        nombreAffichettesEcran% = 6
        width 0,width(0)-width_client(0) + 1346
        height 0,height(0)-height_client(0) + 688
    end_if        

    on_resize 0,redim0
    on_close 0,quitter
    
    ' objet refuge non visible pour le focus
    edit 99
    width 99,1
    height 99,1 
    
    ' base de donnes
    dlist 80
    bd% = 80

    ' base de donnes trie 
    dlist 79
    
    ' boite de dialogue 
    open_dialog 85

    ' objet cach pour le traitement de l'image
    picture 82
    hide 82
    
    ' DIST mise en mmoire des fichiers temporaires crs en vue de les effacer  la sortie du programme
    dlist 87
    
    ' fond d'cran
    picture 1
    width 1,width(0)
    height 1,height(0)
'    color 1,230,230,220
    color 1,255,255,254

    creerEntete()
    creerOptionsAffichage(88,115)
 
    ' lien Internet vers le forum PANORAMIC
    alpha 6
    color 6,255,255,254
    left 6,88
    top 6,height_client(0) - 40
    font_name 6,"Arial"
    font_size 6,12
    font_underline 6
    font_color 6,0,0,255
    caption 6,"https://panoramic.1fr1.net/"
    cursor_point 6
    on_click 6,goForum
    
    ' crer bouton "Ajout fiche"
    creerIconeAjoutFiche()

    ' creer navigateur pages haut et bas de fentre 
    creerChoixPage(30,width_client(0) - 244,115)
    creerChoixPage(40,width_client(0) - 244,height_client(0)-43)
    creerGoToPage()
    
    creerEditeurFiche()
    creerEditeurListe()
    creerFenetreImage()
    
    ' crer affichettes
    n% = 101
    
    if nombreAffichettesEcran% = 15
        x% = 60
    else
        x% = 93
    end_if    
    
    y% = 168
    
    for i% = 1 to nombreAffichettesEcran%
        picture n%+7
        top n%+7,y%-10
        left n%+7,x%-10
        height n%+7,140
        width n%+7,580
        color n%+7,245,245,245

        picture n% :' miniature
        top n%,y%
        left n%,x%
        height n%,120
        width n%,213
        color n%,255,255,255
        stretch_on n%
        hint n%,"Cliquez pour agrandir l'image !"
        cursor_point n%
        on_click n%,afficherImage
        
        alpha n%+1 :' Nom
        color n%+1,245,245,245
        top n%+1,y%
        left n%+1,x% + 230
        font_name n%+1,"Calibri"
        font_size n%+1,16

        alpha n%+2 :' lgende auteur
        color n%+2,245,245,245
        top n%+2,y% + 59
        left n%+2,x% + 230
        font_name n%+2,"Arial"
        font_size n%+2,10
        font_italic n%+2
        caption n%+2,"Auteur :"
        
        alpha n%+3 :' champ auteur
        color n%+3,245,245,245
        top n%+3,y% + 58
        left n%+3,x% + 280
        font_name n%+3,"Arial"
        font_size n%+3,11

        creerBoutonLienArticleForum(n%+4,x%,y%)
        creerBoutonCopierCode(n%+5,x%,y%)
        creerBoutonExecuter(n%+6,x%,y%)
    
        n% = n% + 10
        x% = x% + 600
        
        if nombreAffichettesEcran% = 15
            if x% > 1500
                y% = y% + 160
                x% = 60
            end_if
        else
            if x% > 700
                y% = y% + 160
                x% = 93
            end_if
        end_if
    next i%
end_sub
' ------------------------------------------------------------------------------
sub creerEntete()
    ' bandeau
    2d_target_is 1
    2d_pen_color 40,40,140
    2d_fill_color 40,40,140
    2d_rectangle 0,0,width(0),95

    ' Titre
    print_target_is 1
    2d_fill_color 40,40,140
    font_color 1,255,255,255
    font_name 1,"Calibri"
    font_size 1,32
    if nombreAffichettesEcran% = 6
        print_locate 298,20
    else    
        print_locate 608,20
    end_if
    print "PANORAMIC - Ralisations et Codes sources"

    ' Insrer logo Panoramic
    picture 2
    top 2,10
    left 2,10
    width 2,75
    height 2,75
    cursor_point 2
    on_mouse_up 2,modeEdition
    if file_exists("logo75.jpg") = 1
        file_load 2,"logo75.jpg"
    else
        i% = message_information_ok("Dfaut bnin :"+chr$(13)+"L'image du logo 'PANORAMIC' n'a pas t trouve !")
    end_if    
end_sub
' ------------------------------------------------------------------------------
sub creerOptionsAffichage(x%,y%)
    combo 3
    font_size 3,10
    left 3,x% + 59
    top 3,y%
    text 3,"* Tous les thmes *"
    on_click 3,triBase

    combo 4
    font_size 4,10
    left 4,x% + 321
    top 4,y%
    text 4,"* Tous les auteurs *"
    on_click 4,triBase

    edit 5
    font_size 5,10
    left 5,x% + 612
    top 5,y%
    width 5,145

    ' lgendes
    2d_fill_color 255,255,254
    font_color 1,0,0,0
    font_size 1,12
    font_italic 1
    print_locate x%,y% + 1
    print "Thme :"
    print_locate x% + 264,y% + 1
    print "Auteur :"
    print_locate x% + 525,y% + 1
    print "Rechercher :"
    
        ' dessiner bouton thme "Annuler"
    picture 7
    width 7,23
    height 7,23
    top 7,y%
    left 7,x% + 205
    color 7,255,255,254
    2d_target_is 7
    2d_fill_off
    2d_pen_color 160,160,160
    2d_rectangle 0,0,23,23
    2d_pen_color 255,0,0
    2d_line 6,7,16,17
    2d_line 6,6,17,17
    2d_line 7,6,17,16
    2d_line 15,6,5,16
    2d_line 16,6,5,17
    2d_line 16,7,6,17
    cursor_point 7
    on_click 7,annulTriTheme
    
    ' copier en mmoire le modle du bouton "Annuler" 
    image 8
    2d_image_copy 8,0,0,23,23
    
    ' dessiner bouton auteur "Annuler"
    picture 9
    width 9,23
    height 9,23
    top 9,y%
    left 9,x% + 467
    2d_target_is 9
    2d_image_paste 8,0,0
    cursor_point 9
    on_click 9,annulTriAuteur

    ' dessiner bouton rechercher "OK"
    picture 10
    width 10,23
    height 10,23
    top 10,y%
    left 10,x% + 758
    color 10,255,255,254
    2d_target_is 10
    2d_pen_color 160,160,160
    2d_fill_off
    2d_rectangle 0,0,23,23
    2d_fill_color 255,255,254
    print_target_is 10
    font_size 10,10
    print_locate 3,4
    print "Ok"
    cursor_point 10
    on_click 10,recherche

    ' desiner bouton rechercher "Annuler"
    picture 11
    width 11,23
    height 11,23
    top 11,y%
    left 11,x% + 782
    2d_target_is 11
    2d_image_paste 8,0,0
    cursor_point 11
    on_click 11,annulRecherche
end_sub
' ------------------------------------------------------------------------------
sub creerIconeAjoutFiche()
    picture 12
    top 12,112
    left 12,940
    width 12,116
    height 12,28
    hide 12
    color 12,255,255,254
    2d_target_is 12
    ' dessiner cadre
    2d_fill_off
    2d_pen_color 0,40,0
    2d_line 5,0,111,0
    2d_line 111,1,113,1
    2d_point 113,2
    2d_line 114,3,114,5
    2d_line 115,5,115,23
    2d_line 114,23,114,25
    2d_point 113,25
    2d_line 111,26,113,26
    2d_line 5,27,111,27
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 1,23,1,25
    2d_line 0,5,0,23
    2d_line 1,3,1,5
    2d_point 2,2
    2d_line 3,1,5,1
    2d_flood 2,6,0,80,0
    ' lgende
    2d_fill_color 0,90,0
    print_target_is 12
    font_name 12,"Arial"
    font_color 12,255,255,255
    font_size 12,12
'    font_bold 12
    print_locate 10,5
    print "Nouvelle fiche"

    cursor_point 12
    on_click 12,creerNouvelleFiche 
end_sub
' ------------------------------------------------------------------------------
sub creerChoixPage(n%,x%,y%)
    panel n%
    top n%,y%
    left n%,x%
    width n%,174
    height n%,25
    
    command_target_is n%
    
    ' bouton Premire page
    picture n%+2
    width n%+2,21
    height n%+2,21
    top n%+2,2
    left n%+2,2
    color n%+2,240,240,240
    2d_target_is n%+2
    2d_pen_color 160,160,160
    2d_fill_off
    2d_rectangle 0,0,21,21
    2d_pen_color 0,0,0
    2d_rectangle 4,2,6,19
    2d_line 15,2,6,11
    2d_line 16,2,7,11
    2d_line 17,2,7,12
    2d_line 17,3,8,12
    2d_line 9,9,18,18
    2d_line 8,9,18,19
    2d_line 8,10,17,19
    2d_line 7,10,16,19
    cursor_point n%+2
    hint n%+2,"Premire page"
    on_click n%+2,afficherPremierePage
        
    ' bouton page prcdente
    picture n%+3
    width n%+3,21
    height n%+3,21
    top n%+3,2
    left n%+3,26
    color n%+3,240,240,240
    2d_target_is n%+3
    2d_pen_color 160,160,160
    2d_fill_off
    2d_rectangle 0,0,21,21
    2d_pen_color 0,0,0
    2d_line 13,2,4,11
    2d_line 14,2,5,11
    2d_line 15,2,5,12
    2d_line 15,3,6,12
    2d_line 9,11,16,18
    2d_line 6,9,16,19
    2d_line 6,10,15,19
    2d_line 5,10,14,19
    cursor_point n%+3
    hint n%+3,"Page prcdent"
    on_click n%+3,afficherPagePrecedente
    
    ' numro de page
    panel n%+4
    color n%+4,240,240,240
    width n%+4,76
    height n%+4,21
    left n%+4,49
    top n%+4,2
    font_name n%+4,"Arial"
    font_size n%+4,"12"
    cursor_point n%+4
    on_click n%+4,goToPage

    ' bouton "Page suivante"
    picture n%+5
    width n%+5,21
    height n%+5,21
    top n%+5,2
    left n%+5,127
    color n%+5,240,240,240
    2d_target_is n%+5
    2d_pen_color 160,160,160
    2d_fill_off
    2d_rectangle 0,0,21,21
    2d_pen_color 0,0,0
    2d_line 5,3,14,12
    2d_line 5,2,15,12
    2d_line 6,2,15,11
    2d_line 7,2,16,11
    2d_line 12,10,4,18
    2d_line 14,9,4,19
    2d_line 14,10,5,19
    2d_line 15,10,6,19
    cursor_point n%+5
    hint n%+5,"Page suivante"
    on_click n%+5,afficherPageSuivante

    ' bouton "Dernire page"
    picture n%+6
    width n%+6,21
    height n%+6,21
    top n%+6,2
    left n%+6,151
    color n%+6,240,240,240
    2d_target_is n%+6
    2d_pen_color 160,160,160
    2d_fill_off
    2d_rectangle 0,0,21,21
    2d_pen_color 0,0,0
    2d_rectangle 15,2,17,19
    2d_line 3,3,12,12
    2d_line 3,2,13,12
    2d_line 4,2,13,11 
    2d_line 5,2,14,11
    2d_line 10,10,2,18
    2d_line 12,9,2,19
    2d_line 12,10,3,19
    2d_line 13,10,4,19
    cursor_point n%+6
    hint n%+6,"Dernire page"
    on_click n%+6,afficherDernierePage
    
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerGoTOPage()
    form 70
    border_hide 70
    hide 70
    width 70,174
    height 70,120

    picture 71
    parent 71,70
    width 71,174
    height 71,120
    color 71,240,240,240
    2d_target_is 71

    ' bandeau blanc
    2d_fill_color 255,255,255
    2d_pen_color 255,255,255
    2d_rectangle 0,0,174,25

    ' pourtour gris
    2d_fill_off
    2d_pen_color 127,127,127
    2d_rectangle 0,0,174,120

    ' lgende dans le bandeau
    alpha 72
    parent 72,70
    color 72,255,255,255
    font_size 72,10
    top 72,4
    left 72,6
    caption 72,"Aller  la page :"

    ' zone de saisie
    edit 73
    parent 73,70
    font_size 73,12
    top 73,40
    left 73,42
    width 73,90

    ' bouton "OK"
    button 74
    parent 74,70
    top 74,81
    width 74,60
    left 74,18
    caption 74,"Ok"
    on_click 74,allerPage

    ' bouton "Annuler"
    button 75
    parent 75,70
    top 75,81
    width 75,60
    left 75,96
    caption 75,"Annuler"
    on_click 75,annulerGoToPage
end_sub
' ------------------------------------------------------------------------------
sub creerEditeurFiche()
    form 50
    border_small 50
    width 50,width(50) - width_client(50) + 1300
    height 50,height(50) - height_client(50) + 605
    top 50,(screen_y - height(50))/2
    left 50,(screen_x - width(50))/2
    hide 50
    on_close 50,fermerFenetreEdition
    command_target_is 50

    ' fond d'cran
    picture 51
    full_space 51
    color 51,198,228,255
    
    ' bandeau
    2d_target_is 51
    2d_fill_color 255,255,150
    2d_pen_color 255,255,150
    2d_rectangle 0,0,1300,90 

    ' titre du bandeau
    panel 52
    top 52,20
    left 52,325
    width 52,650
    height 52,50
    color 52,255,255,255
    font_color 52,0,0,0
    font_name 52,"Calibri"
    font_size 52,32
    
    ' image du logiciel
    picture 53
    top 53,150
    left 53,30
    width 53,425
    height 53,425

    ' Synedit pour accueillir le code source
    synedit 54
    top 54,150
    left 54,845
    width 54,425
    height 54,425
    
    ' Nom de logiciel (ligne 1/2)
    edit 55
    top 55,180
    left 55,485
    width 55,330
    font_name 55,"Calibri"
    font_size 55,16

    ' Nom de logiciel (ligne 2/2)
    edit 56
    top 56,230
    left 56,485
    width 56,330
    font_name 56,"Calibri"
    font_size 56,16

    ' Auteur
    combo 57
    font_size 57,10
    top 57,305
    left 57,530

    ' editer la liste des Auteurs
    button 58
    top 58,305
    left 58,693
    height 58,24
    caption 58,"<-- Editer"
    on_click 58,afficherEditeurListe
    
    ' Thme
    combo 59
    font_size 59,10
    top 59,362
    left 59,530

    ' editer la liste des Thmes
    button 60
    top 60,362
    left 60,693
    height 60,24
    caption 60,"<-- Editer"
    on_click 60,afficherEditeurListe

    ' Lien Internet vers l'article du forum Panoramic
    edit 61
    top 61,430
    left 61,485
    width 61,330
    
    ' Bouton "Enregistrer la fiche"
    button 62
    top 62,519
    left 62,533
    width 62,250
    height 62,30
    font_size 62,12
    caption 62,"Enregistrer la fiche"
    cursor_point 62
    on_click 62,enregistrerFiche

    ' icone ouvrir fichier image
    picture 63
    height 63,28
    width 63,28
    color 63,218,248,255
    top 63,120
    left 63,415
    cursor_point 63
    hint 63,"Charger une image"
    on_click 63,chargerImage
    2d_target_is 63
    2d_pen_color 0,0,0
    2d_line 16,4,20,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,23,7
    2d_line 22,5,22,8
    2d_line 5,9,11,9
    2d_line 10,11,21,11
    2d_line 11,16,25,16
    2d_line 5,22,19,22
    2d_line 5,9,5,23
    2d_line 10,9,10,12
    2d_line 20,11,20,17
    2d_line 5,22,12,15
    2d_line 18,22,25,15
    2d_flood 7,11,255,255,255
    2d_flood 12,18,250,250,0

    ' icone charger fichier source
    picture 64
    height 64,28
    width 64,28
    color 64,218,248,255
    top 64,120
    left 64,1127
    cursor_point 64
    hint 64,"Charger un code source"
    on_click 64,chargerCodeSource
    2d_target_is 64
    2d_pen_color 0,0,0
    2d_line 16,4,20,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,23,7
    2d_line 22,5,22,8
    2d_line 5,9,11,9
    2d_line 10,11,21,11
    2d_line 11,16,25,16
    2d_line 5,22,19,22
    2d_line 5,9,5,23
    2d_line 10,9,10,12
    2d_line 20,11,20,17
    2d_line 5,22,12,15
    2d_line 18,22,25,15
    2d_flood 7,11,255,255,255
    2d_flood 12,18,250,250,0

    ' icone coller
    picture 65
    height 65,28
    width 65,28
    Color 65,218,248,255
    top 65,120
    left 65,1161
    cursor_point 65
    hint 65,"Coller"
    on_click 65,CollerCodeSource
    2d_target_is 65
    2d_pen_color 0,0,0
    2d_line 11,3,15,3
    2d_point 10,4
    2d_point 15,4
    2d_line 4,5,22,5
    2d_point 8,6
    2d_point 17,6
    2d_line 8,7,18,7
    2d_line 4,5,4,22
    2d_line 4,21,13,21
    2d_line 21,5,21,15
    2d_line 20,13,24,17
    2d_line 23,16,23,24
    2d_line 23,23,11,23
    2d_line 12,23,12,11
    2d_line 12,12,20,12
    2d_flood 13,13,255,255,255
    2d_line 19,12,19,18
    2d_line 19,17,24,17
    2d_line 14,15,18,15
    2d_line 14,17,18,17
    2d_line 14,19,22,19
    2d_line 14,21,22,21
    2d_flood 5,6,200,150,80
    2d_flood 20,12,200,150,80
    2d_flood 9,6,120,120,120
    2d_flood 11,4,120,120,120

    ' icone excuter
    picture 66
    height 66,28
    width 66,28
    color 66,218,248,255
    top 66,120
    left 66,1195
    cursor_point 66
    hint 66,"Excuter le code source"
    on_click 66,TestExecuterCodeSource
    2d_target_is 66
    2d_pen_color 255,0,0
    2d_line 14,5,21,5
    2d_line 14,6,20,6
    2d_line 13,7,19,7
    2d_line 12,8,18,8
    2d_line 11,9,17,9
    2d_line 11,10,16,10
    2d_line 10,11,15,11
    2d_line 10,12,14,12
    2d_line 9,13,18,13
    2d_line 13,14,17,14
    2d_line 12,15,16,15
    2d_line 12,16,15,16
    2d_line 11,17,14,17
    2d_line 10,18,13,18
    2d_line 10,19,12,19
    2d_line 9,20,11,20
    2d_line 8,21,10,21
    2d_point 8,22
    2d_point 7,23
    2d_point 6,24
    ' contour de l'clair
    2d_pen_color 90,0,0
    2d_line 14,4,23,4
    2d_line 13,5,13,7
    2d_point 12,7
    2d_line 11,8,11,10
    2d_point 10,10
    2d_line 9,11,9,13
    2d_point 8,13
    2d_line 7,14,13,14
    2d_line 11,15,11,17
    2d_point 10,17
    2d_line 9,18,9,20
    2d_point 8,20
    2d_line 7,21,7,23
    2d_point 6,23
    2d_line 5,24,5,26
    2d_line 19,12,5,26
    2d_line 14,12,20,12
    2d_line 22,4,13,13
    
    ' case  cocher code source autonome
    check 67
    top 67,475
    left 67,564
    width 67,200
    color 67,198,228,255
    font_name 67,"Arial"
    font_size 67,"11"
    font_italic 67
    caption 67,"Code source autonome"

    ' Icne "Effacer le code source"
    picture 68
    height 68,28
    width 68,28
    color 68,218,248,255
    top 68,120
    left 68,1229
    cursor_point 68
    hint 68,"Effacer le code source"
    on_click 68,effacerCodeSource
    2d_target_is 68
    2d_pen_color 0,0,0
    2d_line 8,5,23,20
    2d_line 5,8,20,23
    2d_line 5,19,9,23
    2d_line 19,5,23,9
    2d_line 8,5,4,9
    2d_line 19,5,4,20
    2d_line 22,8,7,23
    2d_line 22,19,18,23
    2d_pen_color 255,0,0
    2d_line 8,6,22,20
    2d_line 8,7,21,20
    2d_line 7,7,21,21
    2d_line 7,8,20,21
    2d_line 6,8,20,22
    2d_line 19,6,5,20
    2d_line 19,7,6,20
    2d_line 20,7,6,21
    2d_line 20,8,7,21
    2d_line 21,8,7,22

    ' Lgendes
    2d_target_is 51
    2d_fill_color 198,228,255
    print_target_is 51
    font_name 51,"Arial"
    font_size 51,"11"
    font_italic 51

    print_locate 44,130
    print "Image du logiciel :"
   
    print_locate 860,130
    print "Code source :"
    
    print_locate 493,160
    print "Titre de l'article (2 lignes) :"
    
    print_locate 539,286
    print "Auteur :"
    
    print_locate 539,343
    print "Thme :"
    
    print_locate 493,411
    print "Lien vers l'article du Forum :"
end_sub
' ------------------------------------------------------------------------------
sub creerEditeurListe()
    form 15
    border_small 15
    height 15,height(15) - height_client(15) + 455
    width 15,width(15) - width_client(15) + 350
    top 15,(screen_y - height(15))/2
    left 15,(screen_x - width(15))/2
    on_resize 15,redim15
    hide 15
    font_size 15,10
    caption 15,"Editeur de liste"

    command_target_is 15

    ' couleur de fond de la fentre
    picture 16
    full_space 16
    color 16,143,191,233
    
    ' affichage de la liste  diter
    list 17
    left 17,25
    top 17,60
    height 17,370
    width 17,130
    sort_on 17
    on_click 17,selection
    
    ' Zone d'dition
    edit 18
    left 18,192
    top 18,135
    height 18,25

    ' bouton quitter
    button 19
    left 19,215
    top 19,370
    caption 19,"Quitter"
    on_click 19,fermerEditeurListe

    ' bouton nouveau
    button 20
    left 20,215
    top 20,220
    caption 20,"Nouveau"
    on_click 20,nouveau

    ' bouton Supprimer
    button 21
    left 21,215
    top 21,270
    caption 21,"Supprimer"
    on_click 21,supprimer
    
    ' bouton Valider
    button 22
    left 22,215
    top 22,320
    caption 22,"Valider"
    on_click 22,valider
    
    ' Titre
    alpha 23
    top 23,10
    left 23,113
    color 23,143,191,233
    font_size 23,24
    font_name 23,"Calibri"
    caption 23,"AUTEURS"

    ' lgende
    print_target_is 16
    2d_target_is 16
    2d_fill_color 143,191,233
    font_size 1,10
    print_locate 195,118
    print "Zone de saisie :"

    On_close 15,fermerEditeurListe
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonLienArticleForum(n%,x%,y%)
    dim_local i%
    picture n%
    top n%,y% + 88
    left n%,x% + 230
    height n%,28
    width n%,83
    cursor_point n%
    on_click n%,goToArticleForum
    2d_target_is n%
    color n%,80,180,255
    2d_fill_off
    2d_pen_color 0,0,255
    2d_rectangle 0,0,83,28 
    2d_pen_color 240,240,230
    2d_rectangle 0,0,5,2
    2d_rectangle 0,0,2,5
    2d_rectangle 0,23,2,28
    2d_rectangle 0,26,5,28
    2d_rectangle 78,0,83,2
    2d_rectangle 81,0,83,5
    2d_rectangle 81,23,83,28
    2d_rectangle 78,26,83,28 
    2d_pen_color 0,0,255
    2d_line 1,3,1,5
    2d_line 3,1,5,1
    2d_point 2,2
    2d_line 1,23,1,25
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 78,1,80,1
    2d_line 81,3,81,5
    2d_point 80,2
    2d_line 78,26,80,26
    2d_line 81,23,81,25
    2d_point 80,25
    
    ' dessiner symbole "Article"
    2d_pen_color 40,40,40
    2d_fill_off
    2d_rectangle 4,7,16,22
    2d_flood 6,9,255,255,255
    2d_rectangle 11,7,16,12
    2d_line 12,7,15,10
    2d_line 6,11,10,11
    2d_line 6,13,14,13
    2d_line 6,15,14,15
    2d_line 6,17,14,17
    2d_line 6,19,14,19
    2d_pen_color 80,180,255
    2d_line 13,7,16,7
    2d_line 15,7,15,10
    2d_point 14,8 

    ' crayon
    2d_pen_color 0,0,100
    2d_line 12,18,23,7
    2d_line 13,18,23,8
    2d_line 13,19,24,8
    2d_pen_color 0,0,0
    2d_point 12,19

    print_target_is n%
    print_locate 30,5
    2d_fill_color 80,180,255
    font_name n%,"Calibri"
    font_italic n%
    font_size n%,12
    print "Article"
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonCopierCode(n%,x%,y%)
    dim_local i%
    picture n%
    top n%,y% + 88
    left n%,x% + 320
    height n%,28
    width n%,83
    cursor_point n%
    on_click n%,copierCodeSource
    2d_target_is n%
    color n%,180,255,180
    2d_fill_off
    2d_pen_color 0,100,0
    2d_rectangle 0,0,83,28 
    2d_pen_color 240,240,230
    2d_rectangle 0,0,5,2
    2d_rectangle 0,0,2,5
    2d_rectangle 0,23,2,28
    2d_rectangle 0,26,5,28
    2d_rectangle 78,0,83,2
    2d_rectangle 81,0,83,5
    2d_rectangle 81,23,83,28
    2d_rectangle 78,26,83,28 
    2d_pen_color 0,100,0
    2d_line 1,3,1,5
    2d_line 3,1,5,1
    2d_point 2,2
    2d_line 1,23,1,25
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 78,1,80,1
    2d_line 81,3,81,5
    2d_point 80,2
    2d_line 78,26,80,26
    2d_line 81,23,81,25
    2d_point 80,25
    
    ' dessiner symbole "Copier" 
    2d_pen_color 0,0,0
    2d_line 4,5,13,5
    2d_line 12,5,16,9
    2d_line 16,9,21,9
    2d_line 20,9,24,13
    2d_line 23,12,23,24
    2d_line 23,23,11,23
    2d_line 12,23,12,19
    2d_line 12,19,3,19
    2d_line 4,19,4,4
    2d_flood 7,7,255,255,255
    2d_line 11,5,11,10
    2d_line 12,9,12,24
    2d_line 19,9,19,14
    2d_line 6,9,10,9
    2d_line 11,9,21,9
    2d_line 6,11,13,11
    2d_line 6,13,13,13
    2d_line 14,13,18,13
    2d_line 19,13,24,13
    2d_line 6,15,13,15
    2d_line 14,15,22,15
    2d_line 6,17,13,17
    2d_line 14,17,22,17
    2d_line 14,19,22,19
    2d_line 14,21,22,21

    print_target_is n%
    print_locate 33,5
    2d_fill_color 180,255,180
    font_name n%,"Calibri"
    font_italic n%
    font_size n%,12
    print "Code"
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonExecuter(n%,x%,y%)
    picture n%
    top n%,y% + 88
    left n%,x% + 410
    height n%,28
    width n%,28
    cursor_point n%
    on_click n%,executerCodeSource
    2d_target_is n%
    color n%,240,240,230
    2d_pen_color 80,80,80
    2d_line 5,0,23,0
    2d_line 23,1,25,1
    2d_point 25,2
    2d_line 26,3,26,5
    2d_line 27,5,27,23
    2d_line 26,23,26,25
    2d_point 25,25
    2d_line 23,26,25,26
    2d_line 5,27,23,27
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 1,23,1,25
    2d_line 0,5,0,23
    2d_line 1,3,1,5
    2d_point 2,2
    2d_line 3,1,5,1
    2d_flood 4,4,255,255,255
    2d_pen_color 0,0,0
    ' contour de l'clair
    2d_pen_color 90,0,0
    2d_line 14,3,23,3
    2d_line 13,4,13,6
    2d_point 12,6
    2d_line 11,7,11,9
    2d_point 10,9
    2d_line 9,10,9,12
    2d_point 8,12
    2d_line 7,13,13,13
    2d_line 11,14,11,16
    2d_point 10,16
    2d_line 9,17,9,19
    2d_point 8,19
    2d_line 7,20,7,22
    2d_point 6,22
    2d_line 5,23,5,25
    2d_line 19,11,5,25
    2d_line 14,11,20,11
    2d_line 22,3,13,12
    2d_flood 16,5,255,0,0
    2d_pen_color 255,0,0
    2d_point 7,22
    2d_point 6,23
end_sub
