
rem ============================================================================
rem                    Tapis de Sierpinski
rem                        Par Papydall
rem ============================================================================
dim order,side,x,y,x0,y0,cote,t$
width 0,800 : height 0,800
picture 10 : full_space 10 : 2d_target_is 10 : color 10,20,100,200
alpha 20 : top 20,300 : left 20,320 : font_bold 20 : font_color 20,250,100,20
color 20,20,100,200 : font_size 20,30
t$ = "Papydall" + chr$(13) + "  vous" + chr$(13) + " salue !"
caption 0,"Tapis de Sierpinski... Trac en cours ... <ESC> pour arrter ..."
order = 5
side = power(3,order)
x0 = 30 : y0 = 10 : cote = 15/order
2d_fill_color 255,255,255
for y = 0 to side-1
    for x = 0 to side-1
        2d_pen_color 255,255,0
        if (odd(x) = 0) or (odd(y) = 0)
           2d_pen_color 255,0,0
        end_if
          
        if (odd(x) = 0) and (odd(y) = 0)
           2d_pen_color 0,255,0
        end_if
        if (odd(x) = 1) and (odd(y) = 1)
           2d_pen_color 0,0,255
        end_if
        if incarpet(x,y) = 1
           2d_rectangle x0+x*cote,y0+y*cote , x0+cote*(x+1),y0+cote*(y+1)
        end_if            
    next x
    if scancode = 27 then end
next y
caption 0,"Tapis de Sierpinski... <ESC> pour sortir ..."
repeat
    font_color 20,255,000,000 : caption 20,t$ : pause 1000
    font_color 20,255,255,000 : caption 20,t$ : pause 1000
until scancode = 27
for x = 800 to 20 step -10
    height 0,x : pause 100
next x
terminate
rem ============================================================================
FNC incarpet(x,y)
    repeat
        if (mod(x,3) = 1) and (mod(y,3) = 1) then result 0 : exit_fnc
        x = int(x/3)
        y = int(y/3)
    until (x = 0) and (y = 0)
    result 1          
END_FNC
rem ============================================================================