
rem ============================================================================
rem                 Le  Problme  de  Josphe
rem ============================================================================
rem Josephus Flavius tait un clbre historien du premier sicle.
rem Durant une guerre il fut pris au pige dans une cave avec son groupe de 40
rem soldats, entour par les troupes ennemies.
rem La lgende raconte que le groupe encercl prfra se suicider plutt que
rem dtre captur.
rem Ainsi Josephus et ses soldats formrent un cercle et dcidrent de se tuer
rem mutuellement et successivement, de manire  ce quune personne tue la
rem troisime personne sur sa gauche, que la personne  droite du mort tue  son
rem tour la troisime personne sur sa gauche, et ainsi de suite jusqu ce quil
rem ne reste quun seul survivant.
rem Restant seul, ce dernier est cens se suicider lui-mme.
rem Josephus, qui ne souhaitait pas mourir, trouva rapidement la place sre,
rem cest--dire la place de la dernire personne debout, sans que quiconque ne
rem reste pour le tuer.
rem Ainsi il resta en vie et put par la suite raconter cette lgende.
rem Trouver cette place sre est maintenant appel le problme de Josephus.
rem ============================================================================
rem La fonction FNC Josephe(n,k) est ultra courte, lgante et rapide pour trouver
rem la solution dun problme apparemment difficile !
rem ============================================================================
' Exemples d'utilisation de la fonction
print josephe(40,3)           : ' <--- 28
print Josephe(41,3)           : ' <--- 31
print Josephe(8,3)            : ' <--- 7
print Josephe(100,7)          : ' <--- 50
print Josephe(30,9)           : ' <--- 21
print Josephe(6000,3)         : ' <--- 5864
print Josephe(12345,1234)     : ' <--- 10745
end
rem ============================================================================
' n : nombre de soldats
' k : numro du soldat  liminer
FNC Josephe(n%,k%)
    dim_local res%,i%
    if (n% <= 1) or (k% <= 1)
       message "!!! Les paramtres n et k doivent tre > 1 tous les deux !!!"
       exit_fnc
    end_if
    for i% = 1 to n% : res% = mod(res% + k%,i%) : next i%
    result res%+1 : ' Le +1 c'est parce qu'on a suppos que les prisonniers sont
                   ' numrots de 1  n
                   ' Enlevez le +1 s'ils sont numrots de 0  n-1
END_FNC
rem ============================================================================