
rem ============================================================================
rem           Un SCROLL_BAR qui en voit de toutes les couleurs
rem                     Auteur : Marc
rem                     Modif  : Papydall
rem ============================================================================
DIM r%,v%,b%,luminance
DIM valeurScrollbar%
LABEL couleurPicture

WIDTH 0,400 : HEIGHT 0,400 : COLOR 0,0,0,0
' Un PICTURE pour visualiser la couleur selectionne
PICTURE 1 : TOP 1,50 : LEFT 1,75 : HEIGHT 1,50 : WIDTH 1,250 : COLOR 1, 255,0,0                
' Un SCROLL_BAR pour visualiser une glissire avec des marqueurs
SCROLL_BAR 10 : HEIGHT 10,20 : TOP 10,300 : LEFT 10,75 : WIDTH 10,250 : MIN 10,0 : MAX 10,299
' Un ALPHA pour afficher les valeurs RVB
ALPHA 99 : TOP 99,120 : LEFT 99,150 : FONT_COLOR 99,255,255,255
' Un ALPHA pour afficher la valeur de luminance
ALPHA 97 : TOP 97,160 : LEFT 97,130 : FONT_COLOR 97,255,255,255
' un ALPHA pour afficher PNORAMIC dans le PICTURE 1
ALPHA 98 : TOP 98,52 : LEFT 98,98 : FONT_SIZE 98,28
COLOR 98,255,0,0 : CAPTION 98,"PANORAMIC"

ON_CHANGE 10,couleurPicture

END
rem ============================================================================
couleurPicture:
    valeurScrollbar% = POSITION(10)
    IF valeurScrollbar% => 0 AND valeurScrollbar% < 42
        r%= 255
        v%= valeurScrollbar%*6
        b%= 0
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 41 AND valeurScrollbar% < 85
        r%= 255-((valeurScrollbar%-42)*6)
        v%= 255
        b%= 0
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 84 AND valeurScrollbar% < 128
        r%= 0
        v%= 255
        b%= (valeurScrollbar%-85)*6
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 127 AND valeurScrollbar% < 171
        r%= 0
        v%= 255-((valeurScrollbar%-128)*6)
        b%= 255
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 170 AND valeurScrollbar% < 214
        r%= (valeurScrollbar%-171)*6
        v%= 0
        b%= 255
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 213 AND valeurScrollbar% < 257
        r%= 255
        v%= 0
        b%= 255-((valeurScrollbar%-214)*6)
        COLOR 1,r%,v%,b%
    END_IF

    IF valeurScrollbar% > 256 AND valeurScrollbar% < 300
        r%= 255-((valeurScrollbar%-257)*6)
        v%= 255-((valeurScrollbar%-257)*6)
        b%= 255-((valeurScrollbar%-257)*6)
        COLOR 1,r%,v%,b%
    END_IF
    
    ' On rcupre les valeurs RVB
    CAPTION 99,"R = " + str$(r%) + chr$(13) +"V = " + str$(v%) + chr$(13) +"B = " + str$(b%)
    
    ' Affichage PANORAMIC
    COLOR 98,r%,v%,b%
    luminance = (r%*0.2126)+(v%*0.7152)+(b%*0.0722)
    CAPTION 97,"Luminance : " + STR$(INT(luminance))
    IF luminance > 127
        FONT_COLOR 98,0,0,0
    ELSE    
        FONT_COLOR 98,255,255,255
    END_IF
        
RETURN
rem ============================================================================