' Rpertoire d'adresses
' Marc - Novembre 2020
dim debug%, nom$, prenom$, adresse1$, adresse2$, adresse3$, cp$, ville$, pays$
dim telephone1$, telephone2$, email1$, email2$, notes$, cleIndex%, Modif%, ongletActif%
dim iconeActive%, r%(13), v%(13), b%(13)

label tailleFenetrePrincipale, editer, nouvelleFiche, validerFiche, supprimer, exporter, choixOnglet, afficherFiche, quitter
label survolIconeNouvelleFiche, survolIconeValider, survolIconeSupprimer, survolIconeExporter, survolForm0
label tailleFenetreExport, fermerFenetreExport, creerFichierExport

debug% = 0

chargementBaseDeDonnees()

dessinerInterfaceUtilisateur()

subnouvelleFiche()

end

' ------------------------------------------------------------------------------
nouvelleFiche:
    subnouvelleFiche()
return

' ------------------------------------------------------------------------------
sub subnouvelleFiche()
    
    if modif% = 1
        if testFicheVierge() = 1
            dessinerIconeNouvelleFiche(0)
            if message_warning_yes_no("La fiche est en cours d'dition !" +chr$(13) + chr$(13) + "Souhaitez-vous abandonner ?") <> 1 
                exit_sub
            end_if
        end_if    
    end_if

    cleIndex% = 0
    
    effacerZoneAffichageFiche()

end_sub

' ------------------------------------------------------------------------------
validerFiche:
    subValiderFiche()
return

' ------------------------------------------------------------------------------
sub subValiderFiche()    

    ' vrifier si des donnes sont prsentes
    if modif% = 0
        exit_sub
    else
        if testFicheVierge() = 0
            effacerZoneAffichageFiche()
            exit_sub
        end_if
    end_if

    if text$(71) = "" :' champ Nom
        dessinerIconeValider(0)
        if message_warning_ok("Saisie obligatoire : Le champ Nom doit tre rempli !") < 2
            exit_sub
        end_if
    end_if
    
    if editerValiderChamp() = 1
        exit_sub
    end_if

    enregistrerFiche()

    modif% = 0
    set_focus 0
    
end_sub

' ------------------------------------------------------------------------------
editer:
    editerValiderChamp()
return

' ------------------------------------------------------------------------------
fnc editerValiderChamp()
    dim_local numeroObjet%, objetClique%, champAValider%, temp$, res%

    result 1

    ' avant de passer en dition, on valide le champ prcdent qui tait en cours d'dition

    ' valider MEMO 
    color 65,r%(3),v%(3),b%(3)
    font_color 65,r%(4),v%(4),b%(4)
    cursor_point 65
    on_click 65,editer
    
    ' rechercher champ prcdent  valider
    for numeroObjet% = 71 to 93 step 2
        if show(numeroObjet%) = 1
            champAValider% = numeroObjet%
            exit_for
        end_if
    next numeroObjet%    

    ' appliquer rgles de saisie en fonction du champ
    select champAValider%
        case 71 :' nom
            temp$ = upper$(trim$(text$(champAValider%)))
            if temp$ <> ""
                if (asc(temp$) > 64 and asc(temp$)< 91) or (asc(temp$) > 191 and asc(temp$)< 221)
                    text champAValider%,temp$  
                else
                    dessinerIconeValider(0)
                    if message_warning_ok("Le Nom doit commencer par une lettre de l'alphabet !") < 2
                        exit_fnc
                    end_if    
                end_if         
            end_if
 
        case 73 :' Prnom
            text champAValider%,trim$(text$(champAValider%))
            temp$ = controleSaisiePrenom$(text$(champAValider%))
            text champAValider%, temp$

        case 75 :' ligne adresse 1
            text champAValider%,trim$(text$(champAValider%))
        
        case 77 :' ligne adresse 2
            text champAValider%,trim$(text$(champAValider%))
        
        case 79 :' ligne adresse 3
            text champAValider%,trim$(text$(champAValider%))
        
        case 81 :' code postal
            text champAValider%,trim$(text$(champAValider%))
        
        case 83 :' ville
            text champAValider%,upper$(trim$(text$(champAValider%)))
            temp$ = controleSaisieVille$(text$(champAValider%))
            text champAValider%, temp$

        case 85 :' pays
            text champAValider%,upper$(trim$(text$(champAValider%)))  
        
        case 87 :' tlphone 1
            text champAValider%, trim$(text$(champAValider%))
            if numeric(text$(champAValider%)) = 1 and instr(text$(champAValider%),".") = 0
                temp$ = controleSaisieTelephone$(text$(champAValider%))
                text champAValider%, temp$
            end_if

        case 89 :' tlphine 2
            text champAValider%, trim$(text$(champAValider%))
            if numeric(text$(champAValider%)) = 1 and instr(text$(champAValider%),".") = 0
                temp$ = controleSaisieTelephone$(text$(champAValider%))
                text champAValider%, temp$
            end_if
        
        case 91 :' e-mail 1
            text champAValider%,trim$(text$(champAValider%))
                if text$(champAValider%) <> ""
                    res% = controleSaisieMail%(text$(champAValider%))
                    if res% = 1
                        dessinerIconeValider(0)
                        if message_warning_yes_no("L'adresse e-mail ne semble pas valide !" + chr$(13)+chr$(13)+"Souhaitez-vous la modifier ?") = 1
                            exit_fnc
                        end_if
                    end_if
                end_if    
       
        case 93 :' e-mail 2
            text champAValider%,trim$(text$(champAValider%))
                if text$(champAValider%) <> ""
                    res% = controleSaisieMail%(text$(champAValider%))
                    if res% = 1
                        dessinerIconeValider(0)
                        if message_warning_yes_no("L'adresse e-mail ne semble pas valide !" + chr$(13)+chr$(13)+"Souhaitez-vous la modifier ?") = 1
                            exit_fnc
                        end_if
                    end_if
                end_if    
        
    end_select

    if champAValider% <> 0
        caption champAValider%-30,text$(champAValider%)+string$(150," ")
        hide champAValider%
        modif% = 0
    end_if

    ' passer en mode dition sur le champ cliqu 
    objetClique%=number_click

    if objetClique% = 64 :' caption MEMO
        objetClique% = 65 :' MEMO
    end_if

    if objetClique% = 65 :' MEMO
        off_click 65
        cursor_default 65
        color 65,r%(5),v%(5),b%(5)
        font_color 65,r%(6),v%(6),b%(6)
        set_focus 65
        caret_position 65,len(text$(65))
        modif% = 1
    else
        if even(objetClique%) = 1
            objetClique% = objetClique% + 1
        end_if
        if objetClique% > 40 and objetClique% < 64
            show objetClique%+30
            set_focus objetClique%+30
            caret_position objetClique%+30,len(text$(objetClique%+30))
            modif% = 1
        end_if
    end_if    

    result 0

end_fnc

' ------------------------------------------------------------------------------
fnc controleSaisieVille$(ville$)
    dim_local caractere$, pos%, txt$
    for pos% = 1 to len(ville$)
        caractere$ = mid$(ville$,pos%,1)

        if caractere$ = " "
            if mid$(ville$,pos% +1,1) <> " "
                if mid$(ville$,pos% -1,1) <> " "
                    caractere$ = "-"
                end_if
            end_if        
        end_if    

        txt$ = txt$ + caractere$
    next pos%
    result txt$
end_fnc

' ------------------------------------------------------------------------------
fnc controleSaisiePrenom$(prenom$)
    dim_local caractere$, pos%, majuscule% ,txt$ 
    majuscule% = 1

    for pos% = 1 to len(prenom$)
        caractere$ = mid$(prenom$,pos%,1)

        if majuscule% = 1
            caractere$ = upper$(caractere$)
            majuscule% = 0
        else
            caractere$ = lower$(caractere$)
            if caractere$ = " " or caractere$ = "-" or caractere$ = "_" or caractere$ =","
                majuscule% = 1
            end_if
        end_if

        txt$ = txt$ + caractere$
    next pos%                              

    result txt$
end_fnc

' ------------------------------------------------------------------------------
fnc controleSaisieMail%(email$)
    dim_local positionArobase%, long%, nomUtilisateur$, nomDomaine$

    long% = len(email$)
    
    positionArobase% = instr(email$,"@")

    ' doit contenir le caractere "@"
    if positionArobase% < 2
        result 1
        exit_fnc
    end_if

    ' l'e-mail ne doit pas exder 254 caractres
    if long% > 254 
        result 1
        exit_fnc
    end_if    

    ' ne doit pas comporter d'espace
    if instr(email$," ") > 0
        result 1
        exit_fnc
    end_if    

    ' ne comporte qu'un seul et unique caractere "@"
    if instr_last(email$,"@") <> positionArobase%
        result 1
        exit_fnc
    end_if

    nomUtilisateur$ = left$(email$,positionArobase% - 1)
    
    nomDomaine$ = right$(email$,long% - len(nomUtilisateur$) - 1)    

    ' le nom d'utilisateur ne doit pas exder 64 caractres
    if len(nomUtilisateur$) > 64
        result 1
        exit_fnc
    end_if

    ' le nom de domaine doit comporter un point et au moins un caractre avant le point
    if instr(nomDomaine$,".") < 2
        result 1
        exit_fnc
    end_if     

    ' le nom de domaine doit comporter au moins un caractre aprs le point
    if instr_last(nomDomaine$,".") = len(nomDomaine$)
        result 1
        exit_fnc
    end_if
        
    result 0
    
end_fnc

' ------------------------------------------------------------------------------
fnc controleSaisieTelephone$(nombre$)
   dim_local p
   p=len(nombre$)+1
   while p>3
      p=p-2
      nombre$=insert$(nombre$," ",p)
   end_while
   result nombre$
end_fnc

' ------------------------------------------------------------------------------
fnc TestFicheVierge()
    dim_local objetATester%, vierge%
    
    ' test pour savoir si tous les EDIT sont vierges
    for objetATester% = 71 to 93 step 2
        if text$(objetATester%) <> ""
            vierge% = 1
            exit_for
        end_if
    next objetATester%

    if vierge% = 0
        ' test pour savoir si tous les CAPTION sont vierges
        for objetATester% = 41 to 63 step 2
            if trim$(caption$(objetATester%)) <> ""
                vierge% = 1
                exit_for
            end_if
        next objetATester%

    ' test pour savoir si le MEMO est vierge
        if trim$(text$(65)) <> ""
            vierge% = 1
        end_if
    end_if

    result vierge%
end_fnc

' ------------------------------------------------------------------------------
sub effacerZoneAffichageFiche()
    dim_local n%
    ' effacer et cacher tous les EDIT
    for n% = 71 to 93 step 2
        text n%, ""
        hide n%
    next n%
    
    ' effacer tous les ALPHA et
    ' remplir avec le caractere espace pour creer des zones cliquables 
    for n% = 71 to 93 step 2 
        caption n%-30,text$(n%) + string$(130," ")
    next n%

    ' effacer le memo
    clear 65
    color 65,r%(3),v%(3),b%(3)
    font_color 65,r%(4),v%(4),b%(4)
    cursor_point 65
    on_click 65,editer
    
    modif% = 0
    set_focus 0
end_sub

' ------------------------------------------------------------------------------
sub enregistrerFiche()
    dim_local fiche$, sourceMemo$, nouveauCodageMemo$, pos%, index%, car$, n%
    
    sourceMemo$ = text$(65)
    
    ' Dans le fichier du MEMO, rechercher les fins de ligne OD OA (en dcimal : 13 10)
    ' et les remplacer par \n en (en dcimal : 92 110)
    for pos% = 1 to len(sourceMemo$)
        car$ = mid$(sourceMemo$,pos%,1) 
        if car$ = chr$(13)
            car$ = chr$(92)+chr$(110)
            pos% = pos% + 1
        end_if
        nouveauCodageMemo$ = nouveauCodageMemo$ + car$
    next pos%    
    
    ' concatner tous les lments de la fiche en une seule ligne 
    fiche$ = text$(71) + chr$(9) + text$(73) + chr$(9) + text$(75) + chr$(9)
    fiche$ = fiche$ + text$(77) + chr$(9) + text$(79) + chr$(9) + text$(81) + chr$(9)
    fiche$ = fiche$ + text$(83) + chr$(9) + text$(85) + chr$(9) + text$(87) + chr$(9)
    fiche$ = fiche$ + text$(89) + chr$(9) + text$(91) + chr$(9) + text$(93) + chr$(9)
    fiche$ = fiche$ + nouveauCodageMemo$ + chr$(124) 
    
    if cleIndex% > 0 :' Cas d'une fiche existante
        item_delete 100,cleIndex%
    end_if

    n% = asc(text$(71))

    if n% = 65 or n% = 192 or n% = 193 or n% = 194 or n% = 195 or n% = 196
        n% = 65 :' lettre A + les A accentus
    else
        if n% = 69 or n% = 200 or n% = 201 or n% = 202 or n% = 203
            n% = 69 :' lettre E + les E accentus
        else
            if n% = 73 or n% = 204 or n% = 205 or n% = 206 or n% = 207
                n% = 73 :' lettre I + les I accentus
            else
                if n% = 79 or n% = 210 or n% = 211 or n% = 212 or n% = 213 or n% = 214
                    n% = 79 :' lettre O + les O accentus
                else
                    if n% = 85 or n% = 217 or n% = 218 or n% = 219 or n% = 220
                        n% = 85 :' lettre U + les U accentus    
                    else
                        if n% = 67 or n% = 199
                            n% = 67 :' lettre C + le C cdille
                        end_if
                    end_if
                end_if
            end_if
        end_if
    end_if                             

    n% = n% - 63
    item_add 100,fiche$
    cleIndex% = count(100)

    modif% = 0
    
    subChoixOnglet(n%)

    miseEnSurbrillanceItemListeOnglet()

end_sub

' ------------------------------------------------------------------------------
sub miseEnSurbrillanceItemListeOnglet()
    dim_local ligne%

    for ligne% = 1 to count(1)
        if instr(item_read$(1,ligne%),trim$(caption$(41))) = 1
            if instr(item_read$(1,ligne%),str$(cleIndex%)) > 0
                item_select 1,ligne%
                exit_for
            end_if    
        end_if
    next ligne%

end_sub

' ------------------------------------------------------------------------------
afficherFiche:
    subAfficherFiche()
return

' ------------------------------------------------------------------------------
sub subAfficherFiche()
    dim_local long%, pos%, fiche$, champ$, debut%, fin%, car$, tmp$, a$

    if modif% = 1
        if testFicheVierge() = 1
            a$ = "La fiche n'a pas t enregistre !" + chr$(13) + chr$(13)
            a$ = a$ + "Voulez-vous abandonner l'dition de la fiche en cours ?"
            if message_warning_yes_no(a$) <> 1
                miseEnSurbrillanceItemListeOnglet()
                exit_sub
            end_if
        end_if
        effacerZoneAffichageFiche()
    end_if        
 
    long% = len(item_index$(1))

    pos% = instr_last(item_index$(1)," ")

    long% = long% - pos%

    cleIndex% = val(right$(item_index$(1),long%))

    fiche$ = item_read$(100,cleIndex%)

    ' extraction champ Nom de la chaine fiche$
    debut% = 1
    fin% = instr(fiche$,chr$(9))-1
    champ$ = left$(fiche$,fin%)
    caption 41,champ$ + string$(120," ")
    text 71,champ$
    
    ' extraction champ Prnom de la chaine fiche$
    debut% = fin% + 2
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 43,champ$ + string$(120," ")
    text 73,champ$
    
    ' extraction champ Adresse1 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 45,champ$ + string$(120," ")
    text 75,champ$
    
    ' extraction champ Adresse2 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 47,champ$ + string$(120," ")
    text 77,champ$
    
    ' extraction champ Adresse3 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 49,champ$ + string$(120," ")
    text 79,champ$

    ' extraction champ Code Postal de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 51,champ$ + string$(120," ")
    text 81,champ$

    ' extraction champ Ville de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 53,champ$ + string$(120," ")
    text 83,champ$

    ' extraction champ Pays de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 55,champ$ + string$(120," ")
    text 85,champ$

    ' extraction champ Tlphone1 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 57,champ$ + string$(120," ")
    text 87,champ$

    ' extraction champ Tlphone2 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 59,champ$ + string$(120," ")
    text 89,champ$

    ' extraction champ E-mail1 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 61,champ$ + string$(120," ")
    text 91,champ$
    
    ' extraction champ E-mail2 de la chaine fiche$
    debut% = fin% + 1
    fin% = instr_pos(fiche$,chr$(9),debut%)
    long% = fin% - debut%
    champ$ = mid$(fiche$,debut%,long%)
    caption 63,champ$ + string$(120," ")
    text 93,champ$

    ' extraction MEMO de la chaine fiche$ et mise en forme pour l'affichage
    champ$ = ""
    debut% = fin% + 1
    fin% = len(fiche$)
    long% = fin% - debut%
    tmp$ = mid$(fiche$,debut%,long%)
    ' Dans le fichier champ$, rechercher les fins de ligne \n (en dcimal : 92 110)
    ' et les remplacer par OD OA (en dcimal : 13 10)
    for pos% = 1 to len(tmp$)
        car$ = mid$(tmp$,pos%,1) 
        if car$ = chr$(92)
            car$ = chr$(13)+chr$(10)
            pos% = pos% + 1
        end_if
        champ$  = champ$ + car$
    next pos%    
    text 65,champ$

end_sub

' ------------------------------------------------------------------------------
choixOnglet:
    subChoixOnglet(number_click)
return

' ------------------------------------------------------------------------------
sub subChoixOnglet(n%)
    dim_local ligne%, caractere%, pos1%, pos2%, nom$, prenom$

    if modif% = 1
        if testFicheVierge() = 1
            if message_warning_yes_no("Souhaitez-vous abandonner la modification de la fiche en cours ?") <> 1
                exit_sub
            end_if
        end_if
        effacerZoneAffichageFiche()        
    end_if

    changerCouleurOngletActif(n%)

    clear 1

    if count(100) > 0
        for ligne% = 1 to count(100)
            caractere% = asc(item_read$(100,ligne%))
            if n% = 2 :' onglet lettre A
                if caractere% = 65 or caractere% = 192 or caractere% = 193 or caractere% = 194 or caractere% = 195 or caractere% = 196 
                    pos1% = instr(item_read$(100,ligne%),chr$(9))
                    pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                    nom$ =left$(item_read$(100,ligne%),pos1%)
                    prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)

                    if debug% = 0
                        item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                    else
                        item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                    end_if
                end_if
            else
                if n% = 6 :' onglet lettre E
                    if caractere% = 69 or caractere% = 200 or caractere% = 201 or caractere% = 202 or caractere% = 203 
                        pos1% = instr(item_read$(100,ligne%),chr$(9))
                        pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                        nom$ =left$(item_read$(100,ligne%),pos1%)
                        prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)

                        if debug% = 0
                            item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                        else
                            item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                        end_if
                    end_if
                else
                    if n% = 10 :' onglet lettre I
                        if caractere% = 73 or caractere% = 204 or caractere% = 205 or caractere% = 206 or caractere% = 207 
                            pos1% = instr(item_read$(100,ligne%),chr$(9))
                            pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                            nom$ =left$(item_read$(100,ligne%),pos1%)
                            prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)
                  
                            if debug% = 0
                                item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                            else
                                item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                            end_if
                        end_if
                    else
                        if n% = 16 :' onglet lettre O
                            if caractere% = 79 or caractere% = 210 or caractere% = 211 or caractere% = 212 or caractere% = 213 or caractere% = 214 
                                pos1% = instr(item_read$(100,ligne%),chr$(9))
                                pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                                nom$ =left$(item_read$(100,ligne%),pos1%)
                                prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)

                                if debug% = 0
                                    item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                                else
                                    item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                                end_if
                            end_if    
                        else
                            if n% = 22 :' onglet lettre U
                                if caractere% = 85 or caractere% = 217 or caractere% = 218 or caractere% = 219 or caractere% = 220 
                                    pos1% = instr(item_read$(100,ligne%),chr$(9))
                                    pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                                    nom$ =left$(item_read$(100,ligne%),pos1%)
                                    prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)
                          
                                    if debug% = 0
                                        item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                                    else
                                        item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                                    end_if
                                end_if
                            else
                                if n% = 4 :' onglet lette C
                                    if caractere% = 67 or caractere% = 199 
                                        pos1% = instr(item_read$(100,ligne%),chr$(9))
                                        pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                                        nom$ =left$(item_read$(100,ligne%),pos1%)
                                        prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)
                          
                                        if debug% = 0
                                            item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                                        else
                                            item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                                        end_if
                                    end_if
                                else
                                    if caractere% = n% + 63     
                                        pos1% = instr(item_read$(100,ligne%),chr$(9))
                                        pos2% = instr_pos(item_read$(100,ligne%),chr$(9),pos1% + 1)
                                        nom$ =left$(item_read$(100,ligne%),pos1%)
                                        prenom$ = mid$(item_read$(100,ligne%),pos1% + 1,pos2% - pos1% - 1)

                                        if debug% = 0
                                            item_add 1,nom$ + chr$(32)+prenom$ + string$(50," ") + str$(ligne%)
                                        else
                                            item_add 1,nom$ + chr$(32)+prenom$ + chr$(32) + str$(ligne%)
                                        end_if
                                    end_if    
                               end_if
                            end_if
                        end_if
                    end_if
                end_if
            end_if                        
        next ligne%
    end_if

    sort 1
    
    set_focus 0
    
end_sub

' ------------------------------------------------------------------------------
sub changerCouleurOngletActif(onglet%)

   ' "teindre" ancien onglet actif
    if ongletActif% <> 0
        2d_target_is ongletActif%
        2d_flood 1,1,r%(9),v%(9),b%(9)
        2d_pen_color r%(9),v%(9),b%(9)
        2d_fill_color r%(9),v%(9),b%(9)
        2d_rectangle 2,4,20,20 
        print_target_is ongletActif%
        font_color ongletActif%,r%(10),v%(10),b%(10)
        print_locate 8,2
        print chr$(ongletActif% + 63)
        if ongletActif% <> 2
            2d_target_is ongletActif% - 1
            2d_flood 21,24,r%(9),v%(9),b%(9)
        end_if
    end_if      

    ' "allumer" nouvel onglet actif
    2d_target_is onglet%
    2d_flood 1,1,r%(11),v%(11),b%(11)
    2d_pen_color r%(11),v%(11),b%(11)
    2d_fill_color r%(11),v%(11),b%(11)
    2d_rectangle 2,4,20,20 
    print_target_is onglet%
    font_color onglet%,r%(12),v%(12),b%(12)
    print_locate 8,2
    print chr$(onglet% + 63)
    if onglet% <> 2
        2d_target_is onglet% - 1
        2d_flood 21,24,r%(11),v%(11),b%(11)
    end_if

    ongletActif% = onglet%

end_sub

' ------------------------------------------------------------------------------
survolIconeNouvelleFiche:
    if iconeActive% = 30
        return
    end_if
    iconeActive% = 30
    animationIcone(30) 
return

' ------------------------------------------------------------------------------
survolIconeValider:
    if iconeActive% = 31
        return
    end_if
    iconeActive% = 31
    animationIcone(31) 
return

' ------------------------------------------------------------------------------
survolIconeSupprimer:
    if iconeActive% = 32
        return
    end_if
    iconeActive% = 32
    animationIcone(32) 
return 

' ------------------------------------------------------------------------------
survolIconeExporter:
    if iconeActive% = 33
        return
    end_if
    iconeActive% = 33
    animationIcone(33) 
return

' ------------------------------------------------------------------------------
survolForm0:
    if iconeActive% = 0
        return
    end_if
    iconeActive% = 0
    animationIcone(0) 

return

' ------------------------------------------------------------------------------
sub animationIcone(n%)

    off_mouse_move 33
    off_mouse_move 32  
    off_mouse_move 31  
    off_mouse_move 30
    off_mouse_move 0  

    select n%
        case 0
             dessinerIconeNouvelleFiche(0)
             dessinerIconeValider(0)
             dessinerIconeSupprimer(0)
             dessinerIconeExporter(0)             

        case 30
             dessinerIconeNouvelleFiche(1)
             dessinerIconeValider(0)
             dessinerIconeSupprimer(0)
             dessinerIconeExporter(0)             

        case 31
             dessinerIconeNouvelleFiche(0)
             dessinerIconeValider(1)
             dessinerIconeSupprimer(0)
             dessinerIconeExporter(0)             
        
        case 32
             dessinerIconeNouvelleFiche(0)
             dessinerIconeValider(0)
             dessinerIconeSupprimer(1)
             dessinerIconeExporter(0)             

        case 33
             dessinerIconeNouvelleFiche(0)
             dessinerIconeValider(0)
             dessinerIconeSupprimer(0)
             dessinerIconeExporter(1)             
    end_select

    on_mouse_move 0,survolForm0
    on_mouse_move 30,survolIconeNouvelleFiche
    on_mouse_move 31,survolIconeValider
    on_mouse_move 32,survolIconeSupprimer
    on_mouse_move 33,survolIconeExporter
end_sub

' ------------------------------------------------------------------------------
supprimer:
    subSupprimer()
return

' ------------------------------------------------------------------------------
sub subSupprimer()
    dim_local n%
    
    ' cas d'une fiche vierge, pas de modif en cours et pas de cl-Index
    if (modif% = 0 and cleIndex% = 0) or (modif% = 1 and testFicheVierge() = 0) 
        effacerZoneAffichageFiche()
        exit_sub
    end_if
    
    ' cas d'une fiche existante en cours d'dition
    if modif% = 1 and cleIndex% > 0
        dessinerIconeSupprimer(0)
        if message_warning_yes_no("Souhaitez-vous abandonner la modification de la fiche en cours ?") = 1
            modif% = 0
            effacerZoneAffichageFiche()
            subAfficherFiche()
            exit_sub
        else
            exit_sub
        end_if    
    end_if

    ' cas d'une nouvelle fiche en cours de saisie
    if modif% = 1 and cleIndex% = 0
        dessinerIconeSupprimer(0)
        if message_warning_yes_no("Souhaitez-vous abandonner la saisie de la fiche en cours ?") = 1
            modif% = 0
            effacerZoneAffichageFiche()
            exit_sub
        else
            exit_sub
        end_if    
    end_if

    ' cas d'une fiche existante en consultation
    if modif% = 0 and cleIndex% > 0
        dessinerIconeSupprimer(0)
        if message_warning_yes_no("Confirmez-vous la suppression de la fiche ?") = 1
            item_delete 100,cleIndex%
            subChoixOnglet(ongletactif%) 
            modif% = 0
            subnouvelleFiche()
            exit_sub
        else
            exit_sub
        end_if    
    end_if

end_sub


' ==============================================================================
' - EXPORT - EXPORT - EXPORT - EXPORT - EXPORT - EXPORT - EXPORT - EXPORT -  
' ------------------------------------------------------------------------------
exporter:
    subExporter()
return

' ------------------------------------------------------------------------------
sub subExporter()
    dim_local i%, a$

    dessinerIconeExporter(0)

    if modif% = 1
        a$ = "Une fiche est en cours d'dition." + chr$(13) + chr$(13)
        a$ = a$ + "Les modifications de cette fiche ne seront pas prises en compte dans le fichier d'export." + chr$(13) + chr$(13)
        a$ = a$ + "Souhaitez-vous quand mme procder  l'export du carnet d'adresses ?"
        if message_warning_yes_no(a$) <> 1
            exit_sub
        end_if
    end_if
    
    if count(100) = 0
        if message_warning_ok("Le fichier est vide !" + chr$(13) + chr$(13) + "Export impossible !") < 2
            exit_sub
        end_if      
    end_if
    
    if object_exists(110) = 0
         creerFenetreExport()
    else
        hide 121
        left 120,450
        caption 120,"Annuler"
        for i% = 113 to 120
            show i%
        next i%
        show 110
    end_if

    inactive 0
end_sub

' ------------------------------------------------------------------------------
sub creerFenetreExport()
    dim_local txt$, taille%
        
    form 110
    width 110, width(110) - width_client(110) + 690 
    height 110, height(110) - height_client(110) + 280
    top 110,top(0) + 210
    left 110,left(0) + 155
    font_size 110,11
    caption 110,"Carnet d'adresses : Export"
    on_resize 110,tailleFenetreExport
    on_close 110,fermerFenetreExport
    color 110,r%(0),v%(0),b%(0)

    command_target_is 110

    alpha 111
    font_size 111,20
    font_color 111,r%(1),v%(1),b%(1)
    top 111,10
    txt$ = " Export des donnes en fichier Texte "
    taille% = text_width(txt$,111)
    left 111,(width_client(110) - taille%) / 2
    caption 111,txt$

    alpha 112
    top 112,48
    font_size 112,12
    font_color 112,r%(1),v%(1),b%(1)
    txt$ = "Les mmos ne sont pas exports."
    taille% = text_width(txt$,112)
    left 112,(width_client(110) - taille%) / 2
    caption 112,txt$

    alpha 113
    top 113,90
    left 113,60
    font_color 113,r%(2),v%(2),b%(2)
    caption 113,"Codage texte : "

    combo 114
    top 114,115
    left 114,60
    width 114,130
    item_add 114," Windows-1252"
    item_add 114," UTF-8"
    item_add 114," UTF-8 BOM"
    item_select 114,1
    
    alpha 115
    top 115,90
    left 115,280
    font_color 115,r%(2),v%(2),b%(2)
    caption 115,"Dlimiteur champs"
    
    combo 116
    width 116,130
    top 116,115
    left 116,280
    item_add 116," TAB"
    item_add 116," Virgule"
    item_add 116," Point-virgule"
    item_select 116,1
    
    alpha 117
    top 117,90 
    left 117,500
    font_color 117,r%(2),v%(2),b%(2)
    caption 117,"Dlimiteur enregistrements"
    
    combo 118
    width 118,130
    top 118,115
    left 118,500
    item_add 118," CR + LF"
    item_add 118," LF"
    item_add 118," CR"
    item_select 118,1
    
    button 119
    top 119,210
    left 119,160
    width 119,80
    caption 119,"Exporter"
    on_click 119,creerFichierExport
    
    button 120
    top 120,210
    left 120,450
    width 120,80
    caption 120,"Annuler"
    on_click 120,fermerFenetreExport

    create_hide

    alpha 121
    font_color 121,r%(2),v%(2),b%(2)
    font_size 121,16
    top 121,130
    memo 125

    create_show

    save_dialog 126
end_sub

' ------------------------------------------------------------------------------
tailleFenetreExport:
    inactive 110
    width 110, width(110) - width_client(110) + 690 
    height 110, height(110) - height_client(110) + 280
    active 110
return

' ------------------------------------------------------------------------------
fermerFenetreExport:
    active 0
    hide 110
    set_focus 0
return

' ------------------------------------------------------------------------------
creerFichierExport:
    subcreerFichierExport()
return

'-------------------------------------------------------------------------------
sub subcreerFichierExport()
    dim_local long%, pos%, fiche$, champ$, debut%, fin%, car$, numeroFiche%, i%
    dim_local exportNom$, exportPrenom$, exportAdr1$, exportAdr2$, exportAdr3$, exportCodePostal$
    dim_local exportVille$, exportPays$, exportTel1$, exportTel2$, exportMail1$, exportMail2$
    dim_local ligneExport$, delimiteurChamp$, delimiteurEnregistrement$, fichierExport$, fichierConverti$
    dim_local codageExport$, nomFichierDeSortie$, a$, nbPixels%

    codageExport$ = trim$(text$(114))

    if codageExport$ <> "Windows-1252" and codageExport$ <> "UTF-8" and codageExport$ <> "UTF-8 BOM"
        if message_warning_ok("Erreur dans la norme de Codage du texte !") < 2
            exit_sub
        end_if    
    end_if
    
    delimiteurChamp$ = text$(116)
    if delimiteurChamp$ = " TAB"
        delimiteurChamp$ = chr$(9)
    else
        if delimiteurChamp$ = " Virgule"
            delimiteurChamp$ = chr$(44)
        else
            if delimiteurChamp$ = " Point-virgule"
                delimiteurChamp$ = chr$(59)
            else
                if message_warning_ok("Erreur dans le Dlimiteur de champ !") < 2
                    exit_sub
                end_if    
            end_if
        end_if
    end_if                    

    delimiteurEnregistrement$ = text$(118)
    if delimiteurEnregistrement$ = " CR + LF"
        delimiteurEnregistrement$ = chr$(13) + chr$(10)
    else
        if delimiteurEnregistrement$ = " LF"
            delimiteurEnregistrement$ = chr$(10)
        else
            if delimiteurEnregistrement$ = " CR"
                delimiteurEnregistrement$ = chr$(13)
            else
                if message_warning_ok("Erreur dans le Dlimiteur d'enregistrement !") < 2
                    exit_sub
                end_if    
            end_if
        end_if
    end_if                    
    
    filter 126,"Fichier texte|*.txt"
    nomFichierDeSortie$ = FILE_name$(126)

    if nomFichierDeSortie$ = "_" OR nomFichierDeSortie$ = ""
        exit_sub
    end_if    

    if file_extract_extension$(nomFichierDeSortie$) = ""
        nomFichierDeSortie$ = nomFichierDeSortie$ + ".txt"
    else
        if file_extract_extension$(nomFichierDeSortie$) <> ".txt"
            pos% = instr_right(nomFichierDeSortie$,".")
            long% = len(nomFichierDeSortie$)
            nomFichierDeSortie$ = left$(nomFichierDeSortie$,long% - pos%)
            nomFichierDeSortie$ = nomFichierDeSortie$ + ".txt"
        end_if
    end_if
        
    if FILE_EXISTS(nomFichierDeSortie$) = 1
        if message_warning_yes_no("Le fichier existe !" + chr$(13) + chr$(13) + "Voulez-vous le remplacer ?") <> 1
            exit_sub
        end_if
    end_if
    
    for i% = 113 to 120
        hide i%
    next i%

    show 121

    for numeroFiche% = 1 to count(100)
        fiche$ = item_read$(100,numeroFiche%)

        a$ = "Traitement en cours de la fiche n " + str$(numeroFiche%)
        nbPixels% = text_width(a$,121)
        left 121,(width_client(110) - nbPixels%) / 2
        caption 121,a$

        ' extraction champ Nom de la chaine fiche$
        debut% = 1
        fin% = instr(fiche$,chr$(9))-1
        champ$ = left$(fiche$,fin%)
        exportNom$ = champ$
    
        ' extraction champ Prnom de la chaine fiche$
        debut% = fin% + 2
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportPrenom$ = champ$
    
        ' extraction champ Adresse1 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportAdr1$ = champ$
    
        ' extraction champ Adresse2 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportAdr2$ = champ$
    
        ' extraction champ Adresse3 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportAdr3$ = champ$

        ' extraction champ Code Postal de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportCodePostal$ = champ$
        
       ' extraction champ Ville de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportVille$ = champ$

        ' extraction champ Pays de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportPays$ = champ$
        
        ' extraction champ Tlphone1 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportTel1$ = champ$

        ' extraction champ Tlphone2 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportTel2$ = champ$

        ' extraction champ E-mail1 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportTel2$ = champ$
    
        ' extraction champ E-mail2 de la chaine fiche$
        debut% = fin% + 1
        fin% = instr_pos(fiche$,chr$(9),debut%)
        long% = fin% - debut%
        champ$ = mid$(fiche$,debut%,long%)
        exportTel2$ = champ$

        ligneExport$ = exportNom$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportPrenom$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportAdr1$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportAdr2$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportAdr3$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportCodePostal$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportVille$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportpays$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportTel1$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportTel2$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportMail1$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + exportMail2$ + delimiteurChamp$
        ligneExport$ = ligneExport$ + delimiteurEnregistrement$

        fichierExport$ = fichierExport$ + ligneExport$ 

    next numeroFiche%

    a$ = "Conversion du fichier en " + codageExport$
    nbPixels% = text_width(a$,121)
    left 121,(width_client(110) - nbPixels%) / 2
    caption 121,a$

    if codageExport$ = "UTF-8"
        fichierConverti$ = Ansi_to_Utf8$(fichierExport$,0)
    else
        if codageExport$ = "UTF-8 BOM"
            fichierConverti$ = Ansi_to_Utf8$(fichierExport$,1)
        else
            fichierConverti$ = fichierExport$
        end_if
    end_if    

    text 125,fichierConverti$

    a$ = "Enregistrement du fichier sur disque"
    nbPixels% = text_width(a$,121)
    left 121,(width_client(110) - nbPixels%) / 2
    caption 121,a$

    file_save 125,nomFichierDeSortie$

    a$ = "Le fichier " + file_extract_name$(nomFichierDeSortie$) + " a t cr avec succs !"
    nbPixels% = text_width(a$,121)
    left 121,(width_client(110) - nbPixels%) / 2
    caption 121,a$

    left 120,305
    caption 120,"Quitter"
    show 120

end_sub

' ----------------------------------------------------------------------
fnc Ansi_to_Utf8$(texteAnsi$,BOM%)
    dim_local texteUtf8$, index%, bom$, longueurAnsi%, caracterecourant$, caracteresuivant$

    longueurAnsi% = len(texteAnsi$)

    index% = 1
    
    if BOM% = 1
        texteUtf8$ = chr$(239) + chr$(187) + chr$(191)
    end_if

    while index% <= longueurAnsi%

        caracterecourant$ = mid$(texteAnsi$,index%,1)
        
        if asc(caracterecourant$) < 128
            texteUtf8$ = texteUtf8$ + caracterecourant$
        else
            if asc(caracterecourant$) = 128 :' encodage caractere EURO
                texteUtf8$ = texteUtf8$ + chr$(226) + chr$(130) + chr$(172)      
            else
                if asc(caracterecourant$) < 192
                    texteUtf8$ = texteUtf8$ + chr$(194) + caracterecourant$
                else
                    texteUtf8$ = texteUtf8$ + chr$(195) + chr$(asc(caracterecourant$) - 64)
                end_if            
            end_if
        end_if
    
    index% = index% + 1

    end_while        

    result texteUtf8$

end_fnc

' ------------------------------------------------------------------------------
sub ChargementBaseDeDonnees()

    if debug% = 1
        form 999
        width 999,screen_x -100
        height 999,200
        list 100
        parent 100,999
        width 100, width_client(999)
        height 100, height_client(999)
        to_foreground 0
    else    
        dlist 100
    end_if

    if file_exists("carnetAdresses.dat") = 1
        file_load 100,"carnetAdresses.dat"
    end_if

end_sub


' ==============================================================================
' - Interface Utilisateur - Interface Utilisateur - Interface Utilisateur - 
' ------------------------------------------------------------------------------
sub dessinerInterfaceUtilisateur()
    couleurInterfaceUtilisateur()
    dessinerFenetrePrincipale()
    creerZoneAffichage()
    creerZoneSaisie()
    creerZoneAffichageListeNoms()
    creerOngletsAlphabetique()
    creerIcones()
    creerTitre()
end_sub

' ------------------------------------------------------------------------------
sub couleurInterfaceUtilisateur()
    r%(0) = 100  :' couleur de fond FORM 0 et des icones
    v%(0) = 100  :' couleur de fond FORM 0 et des icones 
    b%(0) = 150  :' couleur de fond FORM 0 et des icones 

    r%(1) = 255 :' couleur titre principal 
    v%(1) = 240 :' couleur titre principal 
    b%(1) = 0   :' couleur titre principal 

    r%(2) = 250 :' couleur des lgendes et du dessin des icones 
    v%(2) = 250 :' couleur des lgendes et du dessin des icones
    b%(2) = 250 :' couleur des lgendes et du dessin des icones


    r%(3) = 10  :' couleur fond Fiche et MEMO en mode consultation
    v%(3) = 10  :' couleur fond Fiche et MEMO en mode consultation
    b%(3) = 60  :' couleur fond Fiche et MEMO en mode consultation
                   
    r%(4) = 250 :' couleur police Fiche et MEMO en mode consultation
    v%(4) = 240 :' couleur police Fiche et MEMO en mode consultation
    b%(4) = 40  :' couleur police Fiche et MEMO en mode consultation

    r%(5) = 255 :' couleur fond EDIT et MEMO en mode modification
    v%(5) = 255 :' couleur fond EDIT et MEMO en mode modification
    b%(5) = 255 :' couleur fond EDIT et MEMO en mode modification

    r%(6) = 10 :' couleur police EDIT et MEMO en mode modification
    v%(6) = 10 :' couleur police EDIT et MEMO en mode modification
    b%(6) = 10 :' couleur police EDIT et MEMO en mode modification


    r%(7) = 10 :' couleur fond liste de noms (LIST) 
    v%(7) = 10 :' couleur fond liste de noms (LIST)
    b%(7) = 60 :' couleur fond liste de noms (LIST)
                                          
    r%(8) = 200 :' couleur police liste de noms (LIST)
    v%(8) = 200 :' couleur police liste de noms (LIST)
    b%(8) = 100 :' couleur police liste de noms (LIST)


    r%(9) = 140 :' couleur de fond onglets non slectionns 
    v%(9) = 140 :' couleur de fond onglets non slectionns   
    b%(9) = 140 :' couleur de fond onglets non slectionns  
                                         
    r%(10) = 255 :' couleur des lettres sur les onglets non slectionns 
    v%(10) = 255 :' couleur des lettres sur les onglets non slectionns 
    b%(10) = 255 :' couleur des lettres sur les onglets non slectionns 

    r%(11) = 255 :' couleur de fond de l'onglet slectionn 
    v%(11) = 255 :' couleur de fond de l'onglet slectionn
    b%(11) = 255 :' couleur de fond de l'onglet slectionn
                                          
    r%(12) = 0 :' couleur des lettres sur l'onglet slectionn
    v%(12) = 0 :' couleur des lettres sur l'onglet slectionn
    b%(12) = 0 :' couleur des lettres sur l'onglet slectionn

    r%(13) = 70 :' couleur trait de sparation entre les onglets
    v%(13) = 70 :' couleur trait de sparation entre les onglets
    b%(13) = 70 :' couleur trait de sparation entre les onglets

end_sub

' ------------------------------------------------------------------------------
sub dessinerFenetrePrincipale()
    width 0,width(0) - width_client(0) + 1000
    height 0,height(0) - height_client(0) + 700
    top 0,(screen_y - height(0)) / 2 
    left 0,(screen_x - width(0)) / 2 
    color 0,r%(0),v%(0),b%(0)
    caption 0,"Carnet d'adresses"
    on_resize 0,tailleFenetrePrincipale
    on_mouse_move 0,survolForm0
    on_close 0,quitter 
end_sub

' ------------------------------------------------------------------------------
sub creerZoneAffichage()

    picture 39
    top 39,90
    left 39,130
    width 39,550
    height 39,367
    color 39,r%(3),v%(3),b%(3)
    
    alpha 40
    top 40,99
    left 40,80
    font_name 40,"Arial"
    font_italic 40
    font_size 40,12
    font_color 40,r%(2),v%(2),b%(2)
    on_click 40,editer
    caption 40,"Nom :"
    cursor_point 40

    alpha 41
    top 41,100
    left 41,140
    color 41,r%(3),v%(3),b%(3)
    font_name 41,"Arial"
    font_size 41,12
    font_color 41,r%(4),v%(4),b%(4)
    on_click 41,editer
    cursor_point 41
    
    alpha 42
    top 42,129
    left 42,58
    font_name 42,"Arial"
    font_italic 42
    font_size 42,12
    font_color 42,r%(2),v%(2),b%(2)
    on_click 42,editer
    caption 42,"Prnom :"
    cursor_point 42
 
    alpha 43
    top 43,130
    left 43,140
    color 43,r%(3),v%(3),b%(3)
    font_name 43,"Arial"
    font_size 43,12
    font_color 43,r%(4),v%(4),b%(4)
    on_click 43,editer
    cursor_point 43

    alpha 44
    top 44,159
    left 44,43
    font_name 44,"Arial"
    font_italic 44
    font_size 44,12
    font_color 44,r%(2),v%(2),b%(2)
    on_click 44,editer
    caption 44,"Adresse 1 :"
    cursor_point 44
  
    alpha 45
    top 45,160
    left 45,140
    color 45,r%(3),v%(3),b%(3)
    font_name 45,"Arial"
    font_size 45,12
    font_color 45,r%(4),v%(4),b%(4)
    on_click 45,editer
    cursor_point 45
    
    alpha 46
    top 46,189
    left 46,43
    font_name 46,"Arial"
    font_italic 46
    font_size 46,12
    font_color 46,r%(2),v%(2),b%(2)
    on_click 46,editer
    caption 46,"Adresse 2 :"
    cursor_point 46
    
    alpha 47
    top 47,190
    left 47,140
    color 47,r%(3),v%(3),b%(3)
    font_name 47,"Arial"
    font_size 47,12
    font_color 47,r%(4),v%(4),b%(4)
    on_click 47,editer
    cursor_point 47
    
    alpha 48
    top 48,219
    left 48,43
    font_name 48,"Arial"
    font_italic 48
    font_size 48,12
    font_color 48,r%(2),v%(2),b%(2)
    on_click 48,editer
    caption 48,"Adresse 3 :"
    cursor_point 48
    
    alpha 49
    top 49,220
    left 49,140
    color 49,r%(3),v%(3),b%(3)
    font_name 49,"Arial"
    font_size 49,12
    font_color 49,r%(4),v%(4),b%(4)
    on_click 49,editer
    cursor_point 49
    
    alpha 50
    top 50,249
    left 50,27
    font_name 50,"Arial"
    font_italic 50
    font_size 50,12
    font_color 50,r%(2),v%(2),b%(2)
    on_click 50,editer
    caption 50,"Code Postal :"
    cursor_point 50
    
    alpha 51
    top 51,250
    left 51,140
    color 51,r%(3),v%(3),b%(3)
    font_name 51,"Arial"
    font_size 51,12
    font_color 51,r%(4),v%(4),b%(4)
    on_click 51,editer
    cursor_point 51

    alpha 52
    top 52,279
    left 52,83
    font_name 52,"Arial"
    font_italic 52
    font_size 52,12
    font_color 52,r%(2),v%(2),b%(2)
    on_click 52,editer
    caption 52,"Ville :"
    cursor_point 52
    
    alpha 53
    top 53,280
    left 53,140
    color 53,r%(3),v%(3),b%(3)
    font_name 53,"Arial"
    font_size 53,12
    font_color 53,r%(4),v%(4),b%(4)
    on_click 53,editer
    cursor_point 53

    alpha 54
    top 54,309
    left 54,79
    font_name 54,"Arial"
    font_italic 54
    font_size 54,12
    font_color 54,r%(2),v%(2),b%(2)
    on_click 54,editer
    caption 54,"Pays :"
    cursor_point 54
    
    alpha 55
    top 55,310
    left 55,140
    color 55,r%(3),v%(3),b%(3)
    font_name 55,"Arial"
    font_size 55,12
    font_color 55,r%(4),v%(4),b%(4)
    on_click 55,editer
    cursor_point 55
    
    alpha 56
    top 56,339
    left 56,25
    font_name 56,"Arial"
    font_italic 56
    font_size 56,12
    font_color 56,r%(2),v%(2),b%(2)
    on_click 56,editer
    caption 56,"Tlphone 1 :"
    cursor_point 56
    
    alpha 57
    top 57,340
    left 57,140
    color 57,r%(3),v%(3),b%(3)
    font_name 57,"Arial"
    font_size 57,12
    font_color 57,r%(4),v%(4),b%(4)
    on_click 57,editer
    cursor_point 57
    
    alpha 58
    top 58,369
    left 58,25
    font_name 58,"Arial"
    font_italic 58
    font_size 58,12
    font_color 58,r%(2),v%(2),b%(2)
    on_click 58,editer
    caption 58,"Tlphone 2 :"
    cursor_point 58
    
    alpha 59
    top 59,370
    left 59,140
    color 59,r%(3),v%(3),b%(3)
    font_name 59,"Arial"
    font_size 59,12
    font_color 59,r%(4),v%(4),b%(4)
    on_click 59,editer
    cursor_point 59

    alpha 60
    top 60,399
    left 60,55
    font_name 60,"Arial"
    font_italic 60
    font_size 60,12
    font_color 60,r%(2),v%(2),b%(2)
    on_click 60,editer
    caption 60,"E-mail 1 :"
    cursor_point 60
    
    alpha 61
    top 61,400
    left 61,140
    color 61,r%(3),v%(3),b%(3)
    font_name 61,"Arial"
    font_size 61,12
    font_color 61,r%(4),v%(4),b%(4)
    on_click 61,editer
    cursor_point 61
                                   
    alpha 62
    top 62,429
    left 62,55
    font_name 62,"Arial"
    font_italic 62
    font_size 62,12
    font_color 62,r%(2),v%(2),b%(2)
    on_click 62,editer
    caption 62,"E-mail 2 :"
    cursor_point 62
    
    alpha 63
    top 63,430
    left 63,140
    color 63,r%(3),v%(3),b%(3)
    font_name 63,"Arial"
    font_size 63,12
    font_color 63,r%(4),v%(4),b%(4)
    on_click 63,editer
    cursor_point 63

    alpha 64
    top 64,466
    left 64,69
    font_name 64,"Arial"
    font_italic 64
    font_size 64,12
    font_color 64,r%(2),v%(2),b%(2)
    on_click 64,editer
    caption 64,"Memo :"
    cursor_point 64

    memo 65
    top 65,464
    left 65,130
    width 65,550
    height 65,120
    color 65,r%(3),v%(3),b%(3)
    font_name 65,"Arial"
    font_size 65,12
    on_click 65,editer
    font_color 65,r%(4),v%(4),b%(4)
    cursor_point 65
    
    ' picture pour cacher la fin des ALPHA [41-63] s'ils sont trop longs
    picture 66
    top 66,90
    left 66,670
    width 66,333
    height 66,367
    color 66,r%(0),v%(0),b%(0)
    2d_target_is 66
    2d_pen_color r%(3),v%(3),b%(3)
    2d_fill_color r%(3),v%(3),b%(3)
    2d_rectangle 0,0,10,367
    
end_sub

' ------------------------------------------------------------------------------
sub creerZoneSaisie()

    create_hide
    
    edit 71
    font_size 71,12
    top 71,96
    left 71,137
    width 71,538
    color 71,r%(5),v%(5),b%(5)
    font_color 71,r%(6),v%(6),b%(6)

    edit 73
    font_size 73,12
    top 73,126
    left 73,137
    width 73,538
    color 73,r%(5),v%(5),b%(5)
    font_color 73,r%(6),v%(6),b%(6)

    edit 75
    font_size 75,12
    top 75,156
    left 75,137
    width 75,538
    color 75,r%(5),v%(5),b%(5)
    font_color 75,r%(6),v%(6),b%(6)

    edit 77
    font_size 77,12
    top 77,186
    left 77,137
    width 77,538
    color 77,r%(5),v%(5),b%(5)
    font_color 77,r%(6),v%(6),b%(6)

    edit 79
    font_size 79,12
    top 79,216
    left 79,137
    width 79,538
    color 79,r%(5),v%(5),b%(5)
    font_color 79,r%(6),v%(6),b%(6)

    edit 81
    font_size 81,12
    top 81,246
    left 81,137
    width 81,538
    color 81,r%(5),v%(5),b%(5)
    font_color 81,r%(6),v%(6),b%(6)

    edit 83
    font_size 83,12
    top 83,276
    left 83,137
    width 83,538
    color 83,r%(5),v%(5),b%(5)
    font_color 83,r%(6),v%(6),b%(6)

    edit 85
    font_size 85,12
    top 85,306
    left 85,137
    width 85,538
    color 85,r%(5),v%(5),b%(5)
    font_color 85,r%(6),v%(6),b%(6)

    edit 87
    font_size 87,12
    top 87,336
    left 87,137
    width 87,538
    color 87,r%(5),v%(5),b%(5)
    font_color 87,r%(6),v%(6),b%(6)

    edit 89
    font_size 89,12
    top 89,366
    left 89,137
    width 89,538
    color 89,r%(5),v%(5),b%(5)
    font_color 89,r%(6),v%(6),b%(6)

    edit 91
    font_size 91,12
    top 91,396
    left 91,137
    width 91,538
    color 91,r%(5),v%(5),b%(5)
    font_color 91,r%(6),v%(6),b%(6)

    edit 93
    font_size 93,12
    top 93,426
    left 93,137
    width 93,538
    color 93,r%(5),v%(5),b%(5)
    font_color 93,r%(6),v%(6),b%(6)

    create_show

end_sub

' ------------------------------------------------------------------------------
sub creerZoneAffichageListeNoms()
    list 1
    width 1,250
    height 1,650
    top 1,25
    left 1,700
    color 1,r%(7),v%(7),b%(7)
    font_color 1,r%(8),v%(8),b%(8)
    font_size 1,12
    on_click 1,afficherFiche
end_sub

' ------------------------------------------------------------------------------
sub creerOngletsAlphabetique()
    dim_local n%, y%, caratere%
    
    y%=25
    caratere% = 65
    for n% = 2 to 27
        picture n% 
        width n%,24
        height n%,25
        color n%,r%(9),v%(9),b%(9)
        left n%,950
        top n%,y%
        cursor_point n%
        on_click n%,choixOnglet
        
        print_target_is n%
        font_name n%,"Consolas"
        font_size n%,12
        font_bold n%
        font_color n%,r%(10),v%(10),b%(10)
        2d_target_is n% 
        2d_fill_color r%(9),v%(9),b%(9)
        print_locate 8,2
        print chr$(caratere%)
        
        2d_pen_color r%(13),v%(13),b%(13)
        2d_line 23,0,23,28

        if n% <> 27
            2d_line 0,24,19,24
            2d_line 18,23,21,23
            2d_line 20,22,22,22
            2d_point 21,21
            2d_line 22,19,22,22
            2d_point 22,18
        end_if
        
        y% = y% + 25

        caratere% = caratere% + 1            
    next n%

end_sub

' ------------------------------------------------------------------------------
sub creerIcones()
    creerIconeNouvelleFiche()
    creerIconeSupprimer()
    creerIconeExporter()
    creerIconeValider()
end_sub

' ------------------------------------------------------------------------------
sub creerIconeNouvelleFiche()
    picture 30
    width 30,50
    height 30,50
    top 30,617
    left 30,100
    dessinerIconeNouvelleFiche(0)
end_sub

' ------------------------------------------------------------------------------
sub dessinerIconeNouvelleFiche(on%)    
    if on% = 0
        color 30,r%(0),v%(0),b%(0)
        2d_target_is 30
        2d_pen_color r%(2),v%(2),b%(2)
        2d_fill_color r%(2),v%(2),b%(2)
        2d_rectangle 23,10,27,40
        2d_rectangle 10,23,40,27  
    else
        color 30,r%(2),v%(2),b%(2)
        2d_target_is 30
        2d_pen_color r%(0),v%(0),b%(0)
        2d_fill_color r%(0),v%(0),b%(0)
        2d_rectangle 23,10,27,40
        2d_rectangle 10,23,40,27  
    end_if
    on_mouse_move 30,survolIconeNouvelleFiche
    on_click 30,nouvelleFiche
    cursor_point 30
    hint 30,"Nouvelle fiche"
end_sub

' ------------------------------------------------------------------------------
sub creerIconeValider()
    picture 31
    width 31,50
    height 31,50
    top 31,617
    left 31,250
    dessinerIconeValider(0)
end_sub

' ------------------------------------------------------------------------------
sub dessinerIconeValider(on%)    
    if on% = 0
        color 31,r%(0),v%(0),b%(0)
        2d_target_is 31
        2d_pen_color r%(2),v%(2),b%(2)
        2d_pen_width 4
        2d_line 23,38,11,25
        2d_line 23,38,39,8
    else
        color 31,r%(2),v%(2),b%(2)
        2d_target_is 31
        2d_pen_color r%(0),v%(0),b%(0)
        2d_pen_width 4
        2d_line 23,38,11,25
        2d_line 23,38,39,8
    end_if      
    on_mouse_move 31,survolIconeValider
    on_click 31,validerFiche
    cursor_point 31
    hint 31,"Enregistrer la fiche"
end_sub

' ------------------------------------------------------------------------------
sub creerIconeSupprimer()
    picture 32
    width 32,50
    height 32,50
    top 32,617
    left 32,400
    dessinerIconeSupprimer(0)
end_sub

' ------------------------------------------------------------------------------
sub dessinerIconeSupprimer(on%)    
    if on% = 0
        color 32,r%(0),v%(0),b%(0)
        2d_target_is 32
        2d_pen_color r%(2),v%(2),b%(2)
        2d_pen_width 4
        2d_line 10,10,40,40
        2d_line 10,39,40,9
    else
        color 32,r%(2),v%(2),b%(2)
        2d_target_is 32
        2d_pen_color r%(0),v%(0),b%(0)
        2d_pen_width 4
        2d_line 10,10,40,40
        2d_line 10,39,40,9
    end_if      
    on_mouse_move 32,survolIconeSupprimer
    on_click 32,supprimer
    cursor_point 32
    hint 32,"Annuler"
end_sub

' ------------------------------------------------------------------------------
sub creerIconeExporter()
    picture 33
    width 33,50
    height 33,50
    top 33,617
    left 33,550
    dessinerIconeExporter(0)
end_sub

' ------------------------------------------------------------------------------
sub dessinerIconeExporter(on%)    
    if on% = 0
        color 33,r%(0),v%(0),b%(0)
        2d_target_is 33
        2d_pen_color r%(2),v%(2),b%(2)
        2d_pen_width 4
        2d_line 10,39,39,10
        2d_line 25,11,40,11
        2d_line 40,24,40,13
    else
        color 33,r%(2),v%(2),b%(2)
        2d_target_is 33
        2d_pen_color r%(0),v%(0),b%(0)
        2d_pen_width 4
        2d_line 10,39,39,10
        2d_line 25,11,40,11
        2d_line 40,24,40,13
    end_if      
    on_mouse_move 33,survolIconeExporter
    on_click 33,exporter
    cursor_point 33
    hint 33,"Exporter"
end_sub

' ------------------------------------------------------------------------------
sub creerTitre()
    alpha 34
    top 34,25
    left 34,243
    font_name 34,"Arial"
    font_italic 34
    font_size 34,30
    font_color 34,r%(1),v%(1),b%(1)
    caption 34,"Carnet d'adresses "
end_sub

' ------------------------------------------------------------------------------
tailleFenetrePrincipale:
    inactive 0
    width 0,width(0) - width_client(0) + 1000
    height 0,height(0) - height_client(0) + 700
    active 0
return

' ------------------------------------------------------------------------------
quitter:

    close_inactive

    if TestFicheVierge() = 1
        if modif% = 1
            if message_warning_yes_no("La fiche en cours d'dition n'a pas t valide !"+chr$(13)+chr$(13)+"Souhaitez-vous quitter quand mme le carnet d'adresses ?") <> 1 
                return
            end_if    
        end_if
    end_if

    close_active

    file_save 100,"carnetAdresses.dat"

return