
rem ============================================================================
rem       Trac des rectangles  coins arrondis
rem ============================================================================
picture 10 : full_space 10 : 2d_target_is 10
' Exemples d'appel
Rounded_Rectangle(20,20,500,400,100,150,20)
Rounded_Rectangle(50,40,400,300,10,150,200)
Rounded_Rectangle(80,50,100,40,200,150,0)
Rounded_Rectangle(300,50,50,250,10,10,200)
Rounded_Rectangle(80,200,150,120,255,10,20)
Rounded_Rectangle(60,350,400,40,0,0,0)
end
rem ============================================================================
' Paramtres :
' cx,cy : coordonnes du coin haut gauche du rectangle
' w , h : respectivement largeur et hauteur du rectangle
' r,g,b : composantes RGB de la couleur du rectangle
SUB Rounded_Rectangle(cx,cy,w,h,r,g,b)
    dim_local cz
    cz = min(w,h)/6 : ' Valeur empirique pour arrondir les coins en fonction
                    : ' de w,et h  ajuster selon le got  
    degrees : 2d_pen_width 2 : 2d_pen_color r,g,b
    ' trac des cts du rectangle dpourvu de ses coins
    2d_line cx+cz/2,cy,cx+w-cz/2,cy      
    2d_line cx+cz/2,cy+h,cx+w-cz/2,cy+h
    2d_line cx,cy+cz/2,cx,cy+h-cz/2
    2d_line cx+w,cy+cz/2,cx+w,cy+h-cz/2
    ' Trac des arcs pour les coins
    2d_arc cx+cz/2,cy+cz/2,cz/2,180,90
    2d_arc cx+w-cz/2,cy+cz/2,cz/2,90,0
    2d_arc cx+cz/2,cy+h-cz/2,cz/2,270,180
    2d_arc cx+w-cz/2,cy+h-cz/2,cz/2,0,270      
END_SUB
rem ============================================================================
  