
rem ============================================================================
rem              Fractale de  Mandelbrot
rem ============================================================================
dim cr(15),cg(15),cb(15)
dim real,imag,incr,x,y,r
width 0,700 : height 0,520
picture 10 : full_space 10 : 2d_target_is 10
caption 0,"Veuillez patienter ... Trac en cours ... <ESC> pour arrter ..."
Init()
Tracer()
caption 0,"Termin"

end
rem ============================================================================
' palette 16 couleurs
DATA 0,63,63,63,63,63,31,0,0,31,31,31,47,63,63,63
DATA 0,0,15,31,47,63,63,63,63,31,15,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,31,63,63,63,63,63,42,21
rem ============================================================================
SUB Init()
    dim_local i    
    FOR i = 0 TO 15 : READ CR(i) : NEXT i
    FOR i = 0 TO 15 : READ CG(i) : NEXT i
    FOR i = 0 TO 15 : READ CB(i) : NEXT i
    ' valeurs initiales
    real = -2.2
    imag = -1.2
    incr = 0.005

END_SUB
rem ============================================================================
SUB Tracer()
    dim_local colour
    FOR y = 0 TO 240  
    r = real
    FOR x = 0 TO 700  
        colour = mod((64 - mandel(r, imag, 64)) , 16)
        2d_pen_color cr(colour)*4,cg(colour)*4,cb(colour)*4
        2d_point x, y : 2d_point x,480-y :  display
        r = r + incr
        if scancode = 27 then terminate
    NEXT x
    imag = imag + incr
NEXT y
END_SUB
rem ============================================================================
FNC Mandel(ox,oy,limit)
    dim_local c%,x,y,xx,yy
    x = ox : y = oy
    FOR c% = limit TO 1 STEP -1
        xx = x * x : yy = y * y
        IF xx + yy >= 4 THEN EXIT_FOR
        y = x * y * 2 + oy
        x = xx - yy + ox
   NEXT c%
   result c%
END_FNC
rem ============================================================================