DIM r,g,b,a$,k
Palette216(30,40)
a$ = CLIPBOARD_STRING_PASTE$
k = INSTR(a$,","): r = VAL(LEFT$(a$,k-1)): a$ = RIGHT_POS$(a$,k+1)
k = INSTR(a$,","): g = VAL(LEFT$(a$,k-1)): b = VAL(RIGHT_POS$(a$,k+1))
PRINT "R = "+STR$(r)+", G = "+STR$(g)+", B = "+STR$(b)
end

SUB Palette216(x,y)
  ' Choix d'une couleur dans une palette de 216 (couleurs html) affiche en x,y
  ' de l'cran total.
  ' Rsultat dans le clipboard sous forme d'une chane r,g,b (ex. "192,24,33")
  IF LABEL("Aff_pal216") = 0 THEN LABEL Aff_pal216
  IF LABEL("Qui_pal216") = 0 THEN LABEL Qui_pal216
  DIM_LOCAL a$, nf, np, nq, nt, nb, wc, hc, r, g, b, i, j
  wc = 15: hc = 12
  nf=3000: WHILE OBJECT_EXISTS(nf)=1: nf=nf+1: END_WHILE
  FORM nf: TOP nf,y: LEFT nf,x: WIDTH nf,12*(wc+1)+16: HEIGHT nf,18*hc+84
  BORDER_SMALL nf
  CAPTION nf," PALETTE 216 COULEURS HTML": ON_CLOSE nf,Qui_pal216
  np=nf+1: WHILE OBJECT_EXISTS(np)=1: np=np+1: END_WHILE
  PICTURE np: PARENT np,nf: FULL_SPACE np: 2D_TARGET_IS np
  ON_CLICK np,Aff_pal216
  nq=np+1: WHILE OBJECT_EXISTS(nq)=1: nq=nq+1: END_WHILE
  PICTURE nq: PARENT nq,nf: TOP nq,18*hc+22: LEFT nq,5: WIDTH nq,3*wc
  HEIGHT nq,25
  nt=nq+1: WHILE OBJECT_EXISTS(nt)=1: nt=nt+1: END_WHILE
  ALPHA nt: PARENT nt,nf: TOP nt,TOP(nq): LEFT nt,LEFT(nq)+WIDTH(nq)+5
  FONT_NAME nt,"Lucida Console"
  nb=nt+1: WHILE OBJECT_EXISTS(nb)=1: nb=nb+1: END_WHILE
  BUTTON nb: PARENT nb,nf:TOP nb,TOP(nq): WIDTH nb,50: LEFT nb,WIDTH(nf)-70
  CAPTION nb,"OK"
  ON_CLICK nb,Qui_pal216
  r = 0: g = 0: b = 0
  FOR j=0 TO 17
      y = j*(hc+1)
      FOR i = 0 TO 11
          x = i*(wc+1): 2D_PEN_COLOR r,g,b: 2D_FILL_COLOR r,g,b
          2D_RECTANGLE x,y,x+wc,y+hc
          b=b+51
          IF b>255
              b=0: g=g+51
              IF g>255
                  g=0: r=r+51
              END_IF
          END_IF
      NEXT i
  NEXT j
  r=0: g=0: b=0: COLOR nq,r,g,b
  CAPTION nt,"#00 00 00"+CHR$(10)+STR$(r)+","+STR$(g)+","+STR$(b)
  2D_TARGET_IS nq: 2D_PEN_COLOR 164,164,164
  WHILE 1>0: WAIT 100: TO_FOREGROUND nf: END_WHILE
Aff_pal216:
  x=MOUSE_X_LEFT_DOWN(np): y=MOUSE_Y_LEFT_DOWN(np)
  r=COLOR_PIXEL_RED(np,x,y): g=COLOR_PIXEL_GREEN(np,x,y): b=COLOR_PIXEL_BLUE(np,x,y)
  2D_FILL_COLOR r,g,b: 2D_RECTANGLE 0,0,WIDTH(nq),HEIGHT(nq)
  a$ = "#"+RIGHT$("0"+HEX$(r),2)+" "+RIGHT$("0"+HEX$(g),2)+" "+RIGHT$("0"+HEX$(b),2)
  a$ = a$ + CHR$(10)+STR$(r)+","+STR$(g)+","+STR$(b)
  CAPTION nt,a$
RETURN
Qui_pal216:
  2D_TARGET_IS 0: DELETE nf
  CLIPBOARD_STRING_COPY STR$(r)+","+STR$(g)+","+STR$(b)
END_SUB