
rem ' Mah-Jong-Multilingue - par jjn4 - le 20/02/2018 =========================
   dim IJP% : rem Indice de Jeu Possible
   dim IQTS% , IETS% : rem Indice de Tuiles Superposes (Quelle et Endroit)
   dim LC%(2) : rem Langue des mots Cliqus (0=franais 1=tranger)
   dim LU$ : rem Langue trangre Utilise
   dim MC$(2) : rem Nature des Mots Cliqus
   dim ME$(25) , MF$(25) : rem Mots trangers et leur traduction Franaise
   dim NB$(9) : rem Nom des Boutons
   dim NJ% : rem Niveau de Jeu
   dim NLD% , NLD$(5) : rem Nombre de Langues Disponibles et leur nom
   dim NTC% : rem Numro de la dernire Tuile Clique (1 ou 2)
   dim PCL% : rem Paramtre de Choix de la Langue
   dim PI$(9) : rem Phrases de l`Introduction
   dim QL$ : rem En quelle langue le mot clef de l`aide
   dim SAI% : rem Sons Actifs ou Inactifs (1 ou 0)
   dim TC%(2) : rem Numro des deux Tuiles Cliques (points rouges)
   dim V1M% , V2M% , V3M% , V4 , V5 , V6$ : rem Variables  utilisation Multiple
   dim VC1% , VC2% : rem Variables de calcul de la vitesse de l`ordinateur
   dim VP$ : rem Version du Programme
   NJ%=1 : VP$="Ver-200218.1.2"
   label clic : rem Redirection de tous les on-click
   label change : rem Redirection des on-change

rem Form0 et prparatifs de jeu ===============================================
   width 0,1365
   height 0,725
   for V1M% = 1 to 9
      read NB$(V1M%)
   next V1M%
   for V1M% = 1 to 9
      read PI$(V1M%)
   next V1M%
   VC1%=heure()
   V6$=file_find_first$
   while V6$<>"_"
      if left$(V6$,6)="MJM-P-"
         NLD%=NLD%+1
         NLD$(NLD%)=mid$(V6$,7,len(V6$)-10)
      end_if
      V6$=file_find_next$
   end_while

rem Choix de la langue ========================================================
   form 10
      width 10,1365
      height 10,725
      border_hide 10
   panel 20
      parent 20,10
      hide 20
      left 20,400
      top 20,20
      width 20,480
      height 20,120*NLD%+40
   if NLD%>1
      show 20
      for V1M% = 1 to NLD% : rem n 22  30
         picture V1M%*2+20
            parent V1M%*2+20,20
            left V1M%*2+20,20
            top V1M%*2+20,(V1M%-1)*120+40
            width V1M%*2+20,110
            height V1M%*2+20,110
            file_load V1M%*2+20,"MJM-P-"+NLD$(V1M%)+".jpg"
            on_click V1M%*2+20,clic
         option V1M%*2+30 : rem n 32  40
            parent V1M%*2+30,20
            left V1M%*2+30,140
            top V1M%*2+30,(V1M%-1)*120+70
            width V1M%*2+30,300
            height V1M%*2+30,70
            font_bold V1M%*2+30
            font_size V1M%*2+30,40
            font_color V1M%*2+30,0,0,255
            caption V1M%*2+30,NLD$(V1M%)
            on_click V1M%*2+30,clic
      next V1M%
      alpha 50
         parent 50,20
         left 50,20
         top 50,4
         font_bold 50
         font_size 50,20
         font_color 50,255,0,0
         caption 50,"Choisissez la langue  apprendre"
         while PCL%=0
         end_while
         hide 20
   end_if
   file_open_read 1,"MJM-Langue.txt"
      file_readln 1,LU$
   file_close 1
   V6$=left$(LU$,1)
   if V6$="a" or V6$="e" or V6$="i" or V6$="o" or V6$="u"
      PI$(4)=PI$(4)+"'"
   else
      PI$(4)=PI$(4)+"e "
   end_if
   PI$(4)=PI$(4)+LU$
   caption 0,"   Mah-Jong multilingue - par jjn4 - "+VP$+" - Langue : "+LU$
   file_open_read 1,"MJM-Qlang.txt"
      while file_eof(1)<>1
         file_readln 1,V6$
         file_readln 1,QL$
         if V6$=LU$
            exit_while
         end_if
      end_while
   file_close 1
   picture 70
      parent 70,10
      full_space 70
      stretch_on 70
      file_load 70,"MJM-Image-Intro.jpg"
      2d_target_is 70
      2d_fill_color 255,0,0
   picture 80
      parent 80,10
      hide 80
      width 80,650
      height 80,650
      color 80,0,0,0
      2d_target_is 80
      2d_pen_color 255,255,255
      2d_fill_color 255,255,255
      for V1M% = 1 to 100
         2d_point int(rnd(1360))+1,int(rnd(720))+1
      next V1M%
      file_save 80,"Etoiles-1.bmp"
      for V1M% = 1 to 50
         2d_circle int(rnd(1360))+1,int(rnd(720))+1,2
      next V1M%
      file_save 80,"Etoiles-2.bmp"

rem Plateau des tuiles (n 111  585) =========================================
   panel 90
      left 90,5
      top 90,5
      width 90,1340
      height 90,318
   picture 95
      parent 95,90
      full_space 95
   for V3M% = 1 to 5
      for V2M% = 1 to 8
         for V1M% = 9 to 1 step -1
            if V1M%=>V3M%
               if (10-V1M%)=>V3M%
                  picture V1M%+V2M%*10+V3M%*100
                     parent V1M%+V2M%*10+V3M%*100,90
                     left V1M%+V2M%*10+V3M%*100,(V1M%-1)*147+(V3M%-1)*7+5
                     top V1M%+V2M%*10+V3M%*100,(V2M%-1)*36-(V3M%-1)*6+27
                     width V1M%+V2M%*10+V3M%*100,153
                     height V1M%+V2M%*10+V3M%*100,35
                     font_size V1M%+V2M%*10+V3M%*100,12
                     on_click V1M%+V2M%*10+V3M%*100,clic
               end_if
            end_if
         next V1M%
      next V2M%
   next V3M%
   2d_target_is 70
   2d_circle 150,250,3
   
rem Affichage de la zone d`information ========================================
   panel 600
      left 600,5
      top 600,325
      width 600,980
      height 600,355
      color 600,200,255,200
   for V1M% = 1 to 3 : rem Affichage des trois smileys (610  630)
      picture V1M%*10+600
         parent V1M%*10+600,600
         left V1M%*10+600,860
         top V1M%*10+600,(V1M%-1)*115+7
         width V1M%*10+600,110
         height V1M%*10+600,110
   next V1M%
   file_load 610,"MJM-Euh.jpg"
   file_load 620,"MJM-Ben.jpg"
   file_load 630,"MJM-Ouh.jpg"
   picture 650 : rem Affichage du tableau des Scores et Records
      parent 650,600
      left 650,2
      top 650,2
      width 650,280
      height 650,175
      file_load 650,"MJM-Tableau-S-R.jpg"
   alpha 660
      parent 660,600
      left 660,21
      top 660,85
      font_bold 660
      font_size 660,36
      font_color 660,255,255,255
      font_name 660,"Arial"
      color 660,0,0,0
      caption 660,"0000"
   alpha 670
      parent 670,600
      left 670,153
      top 670,85
      font_bold 670
      font_size 670,36
      font_color 670,255,255,255
      font_name 670,"Arial"
      color 670,0,0,0
      caption 670,"0000"
   picture 700 : rem Affichage de la copie des mots cliqus
      parent 700,600
      left 700,650
      top 700,10
      width 700,200
      height 700,49
      file_load 700,"MJM-Mot-X.jpg"
   alpha 710
      parent 710,600
      left 710,650
      top 710,67
      width 710,200
      height 710,50
      color 710,110,225,250
   alpha 720
      parent 720,600
      left 720,655
      top 720,80
      font_bold 720
      font_size 720,16
      font_name 720,"Arial"
      font_color 720,200,0,0
      color 720,110,225,250
   alpha 730
      parent 730,600
      left 730,650
      top 730,123
      width 730,200
      height 730,50
      color 730,200,215,40
   alpha 740
      parent 740,600
      left 740,655
      top 740,136
      font_bold 740
      font_size 740,16
      font_name 740,"Arial"
      font_color 740,0,0,255
      color 740,200,215,40
   picture 750
      parent 750,600
      left 750,650
      top 750,180
      width 750,200
      height 750,49
      file_load 750,"MJM-Mot-X.jpg"
   alpha 760 : rem Panneau pour quitter le programme
      parent 760,600
      left 760,280
      top 760,180
      font_bold 760
      font_size 760,16
      font_name 760,"Arial"
      font_color 760,170,0,255
      caption 760,"Eh, vous n'avez pas encore"+chr$(13)+"termin votre apprentissage !"+chr$(13)+"Vous voulez vraiment partir ?"
   picture 770
      parent 770,600
      left 770,320
      top 770,255
      width 770,90
      height 770,90
      font_bold 770
      font_size 770,20
      font_name 770,"Arial"
      stretch_on 770
      file_load 770,"MJM-Bouton.bmp"
      2d_target_is 770
      2d_flood 50,50,0,255,0
      print_target_is 770
      print_locate 30,40
      print "Oui"
      on_click 770,clic
   picture 780
      parent 780,600
      left 780,430
      top 780,255
      width 780,90
      height 780,90
      font_bold 780
      font_size 780,20
      font_name 780,"Arial"
      stretch_on 780
      file_load 780,"MJM-Bouton.bmp"
      2d_target_is 780
      2d_flood 50,50,255,50,50
      print_target_is 780
      print_locate 30,40
      print "Non"
      on_click 780,clic
   memo 800 : rem Zone de dialogue de l`ordinateur
      parent 800,600
      left 800,10
      top 800,182
      width 800,630
      height 800,165
      font_size 800,18
      font_name 800,"Arial"
      color 800,255,255,0
      inactive 800
   picture 850 : rem Zone de traduction d`un mot franais ou non
      parent 850,600
      left 850,290
      top 850,14
      width 850,130
      height 850,57
      file_load 850,"MJM-Fleche-T-Gris.jpg"
   edit 860
      parent 860,600
      left 860,425
      top 860,25
      width 860,215
      font_size 860,18
      font_name 860,"Arial"
      color 860,255,255,0
      inactive 860
      on_change 860,change
   picture 870
      parent 870,600
      left 870,295
      top 870,87
      width 870,84
      height 870,84
      inactive 870
      file_load 870,"MJM-Bouton-Go-Gris.jpg"
      on_click 870,clic
   alpha 880
      parent 880,600
      left 880,450
      top 880,67
      font_bold 880
      font_size 880,24
      font_name 880,"Arial"
      font_color 880,0,0,255
      caption 880,"Rponse :"
   alpha 885
      parent 885,600
      left 885,392
      top 885,110
      width 885,247
      height 885,65
      color 885,255,255,0
   alpha 890
      parent 890,600
      left 890,400
      top 890,125
      font_size 890,20
      font_name 890,"Arial"
      font_color 890,0,0,255
      color 890,255,255,0
   for V1M% = 1 to 2 : rem Affichage des boutons verts ronds (950  960)
      picture V1M%*10+940 : rem                               955  965
         parent V1M%*10+940,600
         left V1M%*10+940,(V1M%-1)*105+650
         top V1M%*10+940,240
         width V1M%*10+940,96
         height V1M%*10+940,96
         file_load V1M%*10+940,"MJM-Bouton-vert.jpg"
         on_click V1M%*10+940,clic
      alpha V1M%*10+945
         parent V1M%*10+945,600
         left V1M%*10+945,(V1M%-1)*105+680
         top V1M%*10+945,282
         color V1M%*10+945,0,255,127
         font_size V1M%*10+945,28
         font_name V1M%*10+945,"Webdings"
         on_click V1M%*10+945,clic
   next V1M%
   caption 955,chr$(151)
   caption 965,chr$(175)
   2d_target_is 70
   2d_fill_color 0,0,0
   2d_circle 150,250,3

rem Affichage de la zone des boutons de commande (n1010  1090) ==============
   panel 1000 : rem                               n1015  1095 pour les +
      left 1000,990 : rem                         n1017  1097 pour les -
      top 1000,325
      width 1000,355
      height 1000,355
      color 1000,200,255,200
   for V1M% = 1 to 3
      for V2M% = 1 to 3
         picture (V2M%-1)*30+V1M%*10+1000
            parent (V2M%-1)*30+V1M%*10+1000,1000
            left (V2M%-1)*30+V1M%*10+1000,(V1M%-1)*117+5
            top (V2M%-1)*30+V1M%*10+1000,(V2M%-1)*117+5
            width (V2M%-1)*30+V1M%*10+1000,110
            height (V2M%-1)*30+V1M%*10+1000,110
            font_bold (V2M%-1)*30+V1M%*10+1000
            font_size (V2M%-1)*30+V1M%*10+1000,14
            font_name (V2M%-1)*30+V1M%*10+1000,"Arial"
            file_load (V2M%-1)*30+V1M%*10+1000,"MJM-Bouton.bmp"
            2d_target_is (V2M%-1)*30+V1M%*10+1000
            select V2M%
               case 1 : 2d_flood 55,55,255,100,255
               case 2 : 2d_flood 55,55,255,155,0
               case 3 : 2d_flood 55,55,0,220,120
            end_select
            print_target_is (V2M%-1)*30+V1M%*10+1000
            print_locate 18,55
            print NB$((V2M%-1)*3+V1M%)
            on_click (V2M%-1)*30+V1M%*10+1000,clic
         picture (V2M%-1)*30+V1M%*10+1005
            parent (V2M%-1)*30+V1M%*10+1005,1000
            left (V2M%-1)*30+V1M%*10+1005,(V1M%-1)*117+40
            top (V2M%-1)*30+V1M%*10+1005,(V2M%-1)*117+22
            width (V2M%-1)*30+V1M%*10+1005,40
            height (V2M%-1)*30+V1M%*10+1005,40
            file_load (V2M%-1)*30+V1M%*10+1005,"MJM-Bouton-"+str$((V2M%-1)*3+V1M%)+".jpg"
            on_click (V2M%-1)*30+V1M%*10+1005,clic
         picture (V2M%-1)*30+V1M%*10+1007
            parent (V2M%-1)*30+V1M%*10+1007,1000
            left (V2M%-1)*30+V1M%*10+1007,(V1M%-1)*117+40
            top (V2M%-1)*30+V1M%*10+1007,(V2M%-1)*117+22
            width (V2M%-1)*30+V1M%*10+1007,40
            height (V2M%-1)*30+V1M%*10+1007,40
            hide (V2M%-1)*30+V1M%*10+1007
            file_load (V2M%-1)*30+V1M%*10+1007,"MJM-Cadenas-"+str$(V2M%)+".jpg"
      next V2M%
   next V1M%

rem Liste de travail de l`ordinateur ==========================================
   for V1M% = 1 to 3 : rem n 2010  2030
      dlist V1M%*10+2000
         file_load V1M%*10+2000,"MJM-"+LU$+"-Niv"+str$(V1M%)+".txt"
   next V1M%
   dlist 2040 : rem Liste de travail provisoire
   dlist 2050 : rem Liste o vont tre inscrits les mots choisis
   dlist 2060 : rem Liste des emplacements des mots choisis
   dlist 2070 : rem Deuxime liste de travail provisoire

rem Affichage du panneau d`aide ===============================================
   panel 2500
      left 2500,-1010
      top 2500,10
      width 2500,1000
      height 2500,665
      color 2500,200,255,200
   alpha 2510
      parent 2510,2500
      left 2510,70
      top 2510,5
      font_bold 2510
      font_size 2510,32
      font_name 2510,"Arial"
      font_color 2510,0,0,255
      color 2510,255,255,0
      caption 2510," Explications sur le fonctionnement du jeu "
   for V1M% = 1 to 5 : rem N 2520  2560
      alpha V1M%*10+2510
         parent V1M%*10+2510,2500
         left V1M%*10+2510,190
         top V1M%*10+2510,(V1M%-1)*100+90
         if V1M%*10+2510>2540
            top V1M%*10+2510,(V1M%-1)*100+120
         end_if
         font_size V1M%*10+2510,16
         font_name V1M%*10+2510,"Arial"
   next V1M%
   left 2530,50
   font_color 2520,255,0,0
   font_color 2530,0,100,0
   font_color 2540,150,0,255
   font_color 2550,255,100,0
   font_color 2560,0,0,255
   file_load 2040,"MJM-Aide.txt"
   V2M%=2510 : V6$=""
   for V1M% = 1 to 19
      V6$=V6$+item_read$(2040,V1M%)+chr$(13)
      if item_read$(2040,V1M%)=""
         V2M%=V2M%+10
         caption V2M%,V6$
         V6$=""
      end_if
   next V1M%
   picture 2570
      parent 2570,2500
      left 2570,20
      top 2570,75
      width 2570,153
      height 2570,35
      font_size 2570,12
      font_color 2570,0,0,255
      file_load 2570,"MJM-Tuile verte.jpg"
      2d_target_is 2570
      2d_fill_color 200,215,40
      print_target_is 2570
      print_locate 16,5
      print QL$
      2d_fill_color 255,0,0
      2d_pen_color 255,0,0
      2d_circle 135,15,14
   picture 2580
      parent 2580,2500
      left 2580,20
      top 2580,115
      width 2580,153
      height 2580,35
      font_size 2580,12
      font_color 2580,200,0,0
      file_load 2580,"MJM-Tuile bleue.jpg"
      2d_target_is 2580
      2d_fill_color 110,230,250
      print_target_is 2580
      print_locate 16,5
      print "soeur"
      2d_fill_color 255,0,0
      2d_pen_color 255,0,0
      2d_circle 135,15,14
   picture 2590
      parent 2590,2500
      left 2590,650
      top 2590,160
      width 2590,110
      height 2590,110
      font_bold 2590
      font_size 2590,16
      file_load 2590,"MJM-Bouton.bmp"
      2d_target_is 2590
      2d_flood 50,50,255,155,0
      2d_fill_color 255,155,0
      print_target_is 2590
      print_locate 20,40
      print "Niveau"
   for V1M% = 1 to 2 : rem N 2600  2610
      picture V1M%*10+2590
         parent V1M%*10+2590,2500
         left V1M%*10+2590,45
         top V1M%*10+2590,V1M%*120+155
         width V1M%*10+2590,110
         height V1M%*10+2590,110
         file_load V1M%*10+2590,"MJM-Bouton.bmp"
         2d_target_is V1M%*10+2590
         2d_flood 50,50,255,100,255
         2d_fill_color 255,100,255
         print_target_is V1M%*10+2590
         print_locate 17,45
         if V1M%=1
            font_bold V1M%*10+2590
            font_size V1M%*10+2590,14
            print "Annuler"
         else
            font_size V1M%*10+2590,12
            print "Suggestion"
         end_if
   next V1M%
   picture 2620
      parent 2620,2500
      left 2620,52
      top 2620,515
      width 2620,96
      height 2620,96
      font_size 2620,28
      font_name 2620,"Webdings"
      file_load 2620,"MJM-Bouton-vert.jpg"
      2d_target_is 2620
      2d_fill_color 0,255,127
      print_target_is 2620
      print_locate 30,40
      print chr$(175)
   for V1M% = 1 to 4 : rem N 2630  2660
      picture V1M%*10+2620
         parent V1M%*10+2620,2500
         if even(V1M%)=0
            left V1M%*10+2620,860
         else
            left V1M%*10+2620,800
         end_if
         top V1M%*10+2620,V1M%*110+100
         width V1M%*10+2620,110
         height V1M%*10+2620,110
         font_size V1M%*10+2620,14
         if V1M%=2
            font_size V1M%*10+2620,10
         end_if
         file_load V1M%*10+2620,"MJM-Bouton.bmp"
         2d_target_is V1M%*10+2620
         print_target_is V1M%*10+2620
         print_locate 20,40
         if V1M%=1
            print_locate 28,40
         end_if
         select V1M%
            case 1 : 2d_fill_color 255,100,255 : 2d_flood 50,50,255,100,255 : print "Retirer"
            case 2 : 2d_fill_color 255,155,0 : 2d_flood 50,50,255,155,0 : print "Restructurer"
            case 3 : 2d_fill_color 0,220,120 : 2d_flood 50,50,0,220,120 : print "Traduire"
            case 4
               font_bold V1M%*10+2620
               font_size V1M%*10+2620,16
               2d_fill_color 0,155,255
               2d_flood 50,50,0,155,255
               print "Fermer"
         end_select
   next V1M%
   on_click 2660,clic
   alpha 2670
      parent 2670,2500
      left 2670,190
      top 2670,600
      font_bold 2670
      font_size 2670,16
      font_name 2670,"Arial"
      font_color 2670,0,0,255
      color 2670,255,255,0
      caption 2670,"  Pour enlever ce tableau, cliquez sur FERMER  "
   alpha 2680
      parent 2680,2500
      left 2680,700
      top 2680,570
      font_size 2680,60
      font_name 2680,"Wingdings"
      font_color 2680,0,0,255
      caption 2680,chr$(240)
   
rem Derniers prparatifs avant le jeu =========================================
   sound 2900
   midi_on
   midi_volume 127
   rejouer(0)
   son()
   
rem Prsentation de l`introduction ============================================
   scene3d 3010
      parent 3010,10
      full_space 3010
      3d_skybox 15
      3d_load_texture_front 15,"Etoiles-2.bmp"
      3d_load_texture_left 15,"Etoiles-1.bmp"
      3d_load_texture_right 15,"Etoiles-1.bmp"
      for V1M% = 1 to 9
         3d_text V1M%,PI$(V1M%)
         3d_position V1M%,-7,-5.5,0
      next V1M%
      3d_text 3010,"Pour luder cette introduction, cliquez sur votre avatar"
      3d_scale 3010,0.3,0.3,0.3
      3d_position 3010,-5,4,0
      3d_color 3010,255,255,255
      file_load 2900,"Bonjour.mp3"
      play 2900
   panel 3030
      parent 3030,10
      hide 3030
      left 3030,950
      top 3030,10
      width 3030,94
      height 3030,120
   picture 3035
      parent 3035,3030
      full_space 3035
      file_load 3035,"MJM-Avatar.jpg"
      on_click 3035,clic

rem Parcours du discours d`introduction =======================================
   VC2%=heure()
   VC2%=int((VC2%-VC1%)/5)
   if VC2%=0
      VC2%=1
   end_if
   for V4 = -5.5 to 4.8 step 0.03*VC2%
      for V5 = 1 to 9
         3d_position V5,-7+(0.7*(V4+5))-(V5/4),1+V4-V5/2,0
         3d_scale V5,0.5-(0.05*(V4+5))+(V5/60),0.5-(0.05*(V4+5))+(V5/60),0.5-(0.05*(V4+5))+(V5/60)
         if (1+V4-V5/2)>1.2
            3d_hide V5
         end_if
         display
      next V5
      if V4>-5
         show 3030
      end_if
   next V4
   hide 10
   file_delete "Etoiles-1.bmp"
   file_delete "Etoiles-2.bmp"

end : ' Dbut des routines ====================================================

sub activer() : rem Activer les tuiles disponibles ============================
   dim_local v1ac% , v2ac% , v3ac% , v4ac% , v5ac%
   inactive 90
   for v1ac% = 111 to 585
      if object_exists(v1ac%)=1
         active v1ac%
      end_if
   next v1ac%
   for v1ac% = 1 to 4
      for v2ac% = 1 to 8
         for v3ac% = 2 to 8
            v4ac%=v1ac%*100+v2ac%*10+v3ac%
            if object_exists(v4ac%)=1
               if object_exists(v4ac%-1)=1
                  if object_exists(v4ac%+1)=1
                     if show(v4ac%)=1
                        if show(v4ac%-1)=1
                           if show(v4ac%+1)=1
                              inactive v4ac%
                           end_if
                        end_if
                     end_if
                  end_if
               end_if
            end_if
            if object_exists(v4ac%+100)=1
               if show(v4ac%+100)=1
                  inactive v4ac%
               end_if
            end_if
         next v3ac%
      next v2ac%
   next v1ac%
end_sub

sub aide() : rem Explications sur le fonctionnement du jeu ====================
   dim_local v1ai%
   inactive 90
   inactive 1000
   for v1ai% = -1010 to -10 step 20
      left 2500,v1ai%
   next v1ai%
end_sub

sub annule(qo%) : rem Annule les points rouges affichs =======================
   dim_local v1an% , v2an% , v3an% , v4an%
   rem qo% : rem Quelle Origine de la demande
   for v1an% = 1 to 2
      for v2an% = 1 to count(2060)
         if TC%(v1an%)=val(item_read$(2060,v2an%))
            v4an%=0
            for v3an% = 1 to 25
               if MF$(v3an%)=item_read$(2050,v2an%)
                  v4an%=1
               end_if
            next v3an%
            ecrire(val(item_read$(2060,v2an%)),item_read$(2050,v2an%),v4an%)
            exit_for
         end_if
      next v2an%
   next v1an%
   for v1an% = 1 to 2
      TC%(v1an%)=0
      LC%(v1an%)=0
      MC$(v1an%)=""
   next v1an%
   if qo%>0
      vide()
      NTC%=0
      file_load 630,"MJM-Ouf.jpg"
   end_if
   if qo%=2
      if SAI%=1
         v1an%=int(rnd(2))+1
         if v1an%=1
            file_load 2900,"Whaou.mp3"
         else
            file_load 2900,"Arg.mp3"
         end_if
         play 2900
      end_if
      clear 800
      item_add 800,"Ouf, c'est plus prudent."
      item_add 800,"Un peu plus et c'tait la gaffe."
   end_if
end_sub

sub bruit() : rem Fait des petits bruits ======================================
   dim_local v1br%
   inactive 950
   inactive 955
   v1br%=int(rnd(6))+1
   select v1br%
      case 1 : file_load 2900,"Bl-bl.mp3"
      case 2 : file_load 2900,"Chut.mp3"
      case 3 : file_load 2900,"Houla.mp3"
      case 4 : file_load 2900,"Pouet.mp3"
      case 5 : file_load 2900,"Siffle.mp3"
      case 6 : file_load 2900,"Tut.mp3"
   end_select
   play 2900
   pause 1000
   active 950
   active 955
end_sub

change: : rem Redirection des on-change =======================================
   file_load 870,"MJM-Bouton-Go.jpg"
   if text$(860)<>""
      active 870
   end_if
return

sub choix() : rem Choix de la langue  apprendre ==============================
   dim_local v1ch% , v2ch$
   v1ch%=number_click
   if v1ch%<31
      v1ch%=v1ch%+10
      off_click v1ch%
      mark_on v1ch%
   end_if
   v1ch%=v1ch%/2-15
   if NLD$(v1ch%)<>""
      file_open_write 1,"MJM-Langue.txt"
         file_writeln 1,NLD$(v1ch%)
      file_close 1
   end_if
end_sub

clic: : rem Redirection de tous les on-click ==================================
   if number_click>21 and number_click<41
      choix()
      PCL%=1
   end_if
   if number_click>110 and number_click<586
      rouge()
      show 1057
      inactive 1050
      inactive 1055
   end_if
   if number_click>765 and number_click<1097
      if right$(str$(number_click),1)="0"
         V1M%=5
      else
         V1M%=-5
      end_if
      left number_click,left(number_click)-1
      top number_click,top(number_click)+1
      if number_click>900
         left number_click+V1M%,left(number_click+V1M%)-1
         top number_click+V1M%,top(number_click+V1M%)+1
      end_if
      display
      midi_instrument 120
      midi_play 105,10
   end_if
   select number_click
      case 770 : oui()
      case 780 : non()
      case 870 : go()
      case 950 : bruit()
      case 955 : bruit()
      case 960 : son()
      case 965 : son()
      case 1010 : retire()
      case 1015 : retire()
      case 1020 : annule(2)
      case 1025 : annule(2)
      case 1030 : suggest(1)
      case 1035 : suggest(1)
      case 1040 : restruct()
      case 1045 : restruct()
      case 1050 : niveau()
      case 1055 : niveau()
      case 1060 : rejouer(1)
      case 1065 : rejouer(1)
      case 1070 : traduire()
      case 1075 : traduire()
      case 1080 : aide()
      case 1085 : aide()
      case 1090 : quitter()
      case 1095 : quitter()
      case 2660 : fermer()
      case 3035 : V4=4.8
   end_select
   if number_click>765 and number_click<1097
      left number_click,left(number_click)+1
      top number_click,top(number_click)-1
      if number_click>900
         left number_click+V1M%,left(number_click+V1M%)+1
         top number_click+V1M%,top(number_click+V1M%)-1
      end_if
      display
   end_if
return

rem Datas =====================================================================
   data " Retirer" , "Annuler" , "Sugges" , "Restruc" , " Niveau" , "Rejouer"
   data "Traduir" , "   Aide" , " Quitter"
   data "Cela fait longtemps que vous rvez d'tre admis  l'cole des padawans"
   data "pour devenir Chevalier Jedi et pouvoir sauver la fdration galactique."
   data "Mais, pour cela, il vous faut d'abord matriser la langue internationale"
   data "qui est parle dans toute la galaxie, et qui se trouve tre l"
   data "(dites-vous que vous avez de la chance, car a a failli tre le chinois)"
   data "Mais ne vous faites pas de souci, voici le logiciel qui va vous permettre"
   data "d'apprendre la langue sans effort, car il vous suffira simplement de jouer."
   data "Attention, l'admission dans une cole prestigieuse comme celle des padawans"
   data "exige un sans faute. Accrochez-vous pour vous hisser jusqu' la victoire !"
rem Fin des datas

sub ecrire(qn%,qm$,qc%) : rem crire sur les tuiles ===========================
   rem qn%=Quel numro - qm$=Quel mot - qc%=Quelle Couleur
   dim_local v1ec%
   2d_target_is qn%
   if qc%=1
      font_color qn%,200,0,0
      file_load qn%,"MJM-Tuile bleue.jpg"
      2d_fill_color 110,230,250
   else
      font_color qn%,0,0,255
      file_load qn%,"MJM-Tuile verte.jpg"
      2d_fill_color 200,215,40
   end_if
   v1ec%=((15-len(qm$))/2)*8
   if v1ec%<0
      v1ec%=0
   end_if
   print_target_is qn%
   print_locate v1ec%+8,5
   print qm$
end_sub

sub fermer() : rem Fermer le panneau d`aide ===================================
   dim_local v1fe%
   for v1fe% = -10 to -1010 step -20
      left 2500,v1fe%
   next v1fe%
   active 1000
   active 90
end_sub

sub fini() : rem Il n`y a plus de tuile et le jeu est termin =================
   dim_local v1fi% , v2fi%
   for v1fi% = 1010 to 1040 step 10
      inactive v1fi%
      inactive v1fi%+5
      show v1fi%+7
   next v1fi%
   v1fi%=val(caption$(660))
   v2fi%=val(caption$(670))
   clear 800
   if v1fi%=v2fi%
      item_add 800,"Bravo, vous avez russi le sans faute !"
      item_add 800,"Vous pouvez entrer  l'cole des padawans"
      select NJ%
         case 1 : item_add 800,"comme dbutant ou tenter le niveau 2"
         case 2 : item_add 800,"en 2 anne ou tenter le niveau 3"
         case 3
            item_add 800,"o vous deviendrez sans doute Jedi"
            item_add 800,"en trs peu de temps."
      end_select
      file_load 2900,"Bravo-1.mp3"
   else
      item_add 800,"Bravo, votre rsultat est trs encourageant !"
      item_add 800,"Il vous faudra cependant encore progresser pour"
      item_add 800,"esprer pouvoir entrer  l'cole des padawans."
      item_add 800,"Cliquez sur  Rejouer  pour une nouvelle partie."
      file_load 2900,"Bravo-0.mp3"
   end_if
   play 2900
end_sub

sub fond() : rem Changer le fond d`cran ======================================
   dim_local v1im% , v2im$
   v1im%=int(rnd(10))+1
   v2im$=str$(v1im%)
   if len(v2im$)<2
      v2im$="0"+v2im$
   end_if
   file_load 95,"MJM-"+LU$+"-Fond-"+v2im$+".jpg"
end_sub

sub go() : rem Traduction du mot entr ========================================
   dim_local v1go% , v2go$
   file_load 850,"MJM-Fleche-T-Gris.jpg"
   file_load 870,"MJM-Bouton-Go-Gris.jpg"
   hide 1077
   inactive 860
   inactive 870
   if text$(860)<>""
      for v1go% = 1 to count(2010)
         if item_read$(2010,v1go%)=text$(860)
            if even(v1go%)=1
               v2go$=item_read$(2010,v1go%-1)
            else
               v2go$=item_read$(2010,v1go%+1)
            end_if
            exit_for
         end_if
      next v1go%
      if v2go$=""
         for v1go% = 1 to count(2020)
            if item_read$(2020,v1go%)=text$(860)
               if even(v1go%)=1
                  v2go$=item_read$(2020,v1go%-1)
               else
                  v2go$=item_read$(2020,v1go%+1)
               end_if
               exit_for
            end_if
         next v1go%
      end_if
      if v2go$=""
         for v1go% = 1 to count(2030)
            if item_read$(2030,v1go%)=text$(860)
               if even(v1go%)=1
                  v2go$=item_read$(2030,v1go%-1)
               else
                  v2go$=item_read$(2030,v1go%+1)
               end_if
               exit_for
            end_if
         next v1go%
      end_if
      if v2go$<>""
         caption 890,v2go$
         if active(1010)=1
            clear 800
            item_add 800,"Cette aide excessive vous cote 2 points"
            v1go%=val(caption$(660))
            v1go%=v1go%-2
            caption 660,v1go%
         end_if
      else
         caption 890,"Pas trouv...?"
      end_if
   else
      caption 890,"Entrez un mot..."
   end_if
   active 1070
   active 1075
end_sub

fnc heure() : rem Calcul de l`heure selon windows 7 ou 8-10 ===================
   dim_local v1he$ , v2he%
   dim_local hhe% , mhe%
   v1he$=time$
   v2he%=instr(v1he$,":") : caption 0,v2he%
   if v2he%=3
      hhe%=val(left$(v1he$,2))
   else
      hhe%=val(left$(v1he$,1))
   end_if
   mhe%=mid$(v1he$,v2he%+1,2)
   result hhe%*60+mhe%
end_fnc

sub niveau() : rem Modification du niveau de jeu ==============================
   dim_local v1ni% , v2ni% , v3ni%
   inactive 90
   inactive 1000
   NJ%=NJ%+1
   if NJ%>3
      NJ%=1
   end_if
   print_target_is 1050
   print_locate 50,75
   print NJ%
   for v1ni% = 111 to 585
      if object_exists(v1ni%)=1
         hide v1ni%
         v2ni%=0
         if val(mid$(str$(v1ni%),2,1))<(power(2,NJ%)+1)
            if NJ%<3
               if val(left$(str$(v1ni%),1))>4
                  v2ni%=1
               end_if
            end_if
            if v2ni%=0
               show v1ni%
            end_if
         end_if
      end_if
   next v1ni%
   file_load 2040,"MJM-"+LU$+"-Niv"+str$(NJ%)+".txt"
   v2ni%=power(2,NJ%)*3
   if NJ%=3
      v2ni%=v2ni%+1
   end_if
   clear 2050
   for v1ni% = 1 to v2ni%
      v3ni%=(int(rnd((count(2040)/2)))+1)*2-1
      item_add 2050,item_read$(2040,v3ni%)
      item_add 2050,item_read$(2040,v3ni%+1)
      item_delete 2040,v3ni%
      item_delete 2040,v3ni%
   next v1ni%
   for v1ni% = 1 to 25
      ME$(v1ni%)="" : MF$(v1ni%)=""
   next v1ni%
   for v1ni% = 2 to count(2050) step 2
      ME$(v1ni%/2)=item_read$(2050,v1ni%-1)
      MF$(v1ni%/2)=item_read$(2050,v1ni%)
   next v1ni%
   clear 2040
   for v1ni% = 1 to count(2050)
      item_add 2040,item_read$(2050,v1ni%)
   next v1ni%
   for v1ni% = 1 to 3
      for v3ni% = 1 to count(2040)
         item_add 2050,item_read$(2040,v3ni%)
      next v3ni%
   next v1ni%
   clear 2060
   for v1ni% = 111 to 585
      if object_exists(v1ni%)=1
         if show(v1ni%)=1
            item_add 2060,v1ni%
         end_if
      end_if
   next v1ni%
   for v1ni% = 1 to count(2060)*2
      v3ni%=int(rnd(count(2060)))+1
      item_add 2060,item_read$(2060,v3ni%)
      item_delete 2060,v3ni%
   next v1ni%
   for v1ni% = 1 to count(2060)
      ecrire(val(item_read$(2060,v1ni%)),item_read$(2050,v1ni%),even(v1ni%))
   next v1ni%
   annule(1)
   v1ni%=NJ%*480
   if NJ%=3
      v1ni%=2000
   end_if
   caption 670,v1ni%
   if NJ%<3
      left 670,168
   else
      left 670,153
   end_if
   clear 800
   select NJ%
      case 1
         item_add 800,"Le niveau 1 permet d'entrer comme dbutant"
         item_add 800," l'cole des padawans (le sans faute est exig)."
      case 2
         item_add 800,"Le niveau 2 vous permet d'accder directement"
         item_add 800," la 2 anne de l'cole des padawans, mais"
         item_add 800,"pour y parvenir, il faut faire un sans faute."
      case 3
         item_add 800,"Le niveau 3 vous ouvre les portes de la dernire"
         item_add 800,"anne de l'cole des padawans et vous permettra de"
         item_add 800,"devenir Chevalier Jedi en trs peu de temps. Bien"
         item_add 800,"sr, pour cela, il vous faudra russir le sans faute."
   end_select
   active 1000
   active 90
end_sub

sub non() : rem Rponse non  la question de quitter ==========================
   dim_local v1no%
   for v1no% = -400 to 10 step 10
      left 800,v1no%
   next v1no%
   hide 1097
   active 1095
   active 1090
end_sub

sub oui() : rem Rponse oui  la question de quitter ==========================
   file_load 2900,"Au-revoir.mp3"
   play 2900
   pause 999
   terminate
end_sub

sub quitter() : rem Fermer le programme =======================================
   dim_local v1qu%
   for v1qu% = 10 to -400 step -10
      left 800,v1qu%
   next v1qu%
   show 1097
   inactive 1095
   inactive 1090
end_sub

sub rejouer(qo%) : rem Refaire une nouvelle partie ============================
   rem qo%=Quelle Origine de la demande
   dim_local v1rj%
   NJ%=NJ%-1
   fond()
   niveau()
   activer()
   if qo%=1
      clear 800
      item_add 800,"Voici une nouvelle grille de jeu."
      item_add 800,"Si vous le souhaitez,"
      item_add 800,"vous pouvez changer de niveau."
   end_if
   caption 660,"0000"
   left 660,21
   for v1rj% = 1010 to 1050 step 10
      active v1rj%
      active v1rj%+5
      hide v1rj%+7
   next v1rj%
   remet()
   active 90
end_sub

sub remet() : rem Remet la tuile dplace  sa place ==========================
   if IQTS%>0
      left IQTS%,IETS%
      IQTS%=0
      IETS%=0
   end_if
end_sub

sub restruct() : rem Restructurer les tuiles restantes ========================
   dim_local v1rs% , v2rs% , v3rs% , v4rs%
   inactive 90
   inactive 1000
   clear 2040
   clear 2070
   clear 800
   item_add 800,"Restructuration en cours."
   suggest(0)
   for v1rs% = 1 to count(2050)
      if show(val(item_read$(2060,v1rs%)))=1
         item_add 2070,item_read$(2060,v1rs%)
         item_add 2040,item_read$(2050,v1rs%)
      end_if
   next v1rs%
   for v1rs% = 1 to count(2070)*2
      v2rs%=int(rnd(count(2070)))+1
      item_add 2070,item_read$(2070,v2rs%)
      item_delete 2070,v2rs%
   next v1rs%
   clear 2050
   clear 2060
   for v1rs% = 1 to count(2040)
      item_add 2050,item_read$(2040,v1rs%)
      item_add 2060,item_read$(2070,v1rs%)
   next v1rs%
   for v1rs% = 1 to count(2050)
      v3rs%=0
      for v2rs% = 1 to 25
         if MF$(v2rs%)=item_read$(2050,v1rs%)
            v3rs%=1
            v4rs%=v4rs%+1
         end_if
      next v2rs%
      ecrire(val(item_read$(2060,v1rs%)),item_read$(2050,v1rs%),v3rs%)
   next v1rs%
   if v4rs%=1
      if abs(left(val(item_read$(2060,1)))-left(val(item_read$(2060,2))))=7
         if abs(top(val(item_read$(2060,1)))-top(val(item_read$(2060,2))))=6
            IQTS%=val(item_read$(2060,1))
            IETS%=left(val(item_read$(2060,1)))
            left IQTS%,IETS%+160
            active IQTS%
            active val(item_read$(2060,2))
         end_if
      end_if
   end_if
   NTC%=0
   TC%(1)=0
   TC%(2)=0
   clear 800
   item_add 800,"Restructuration termine."
   item_add 800,"La disposition des tuiles a t modifie."
   if IJP%=1
      item_add 800,"(mais il y avait encore des possibilits)"
      item_add 800,"(cela vous cote 1 point)"
      v1rs%=val(caption$(660))
      v1rs%=v1rs%-1
      caption 660,v1rs%
   end_if
   active 1000
   active 90
end_sub

sub retire() : rem Retirer deux tuiles ========================================
   dim_local v1rt% , v2rt$ , v3rt$ , v4rt% , v5rt%
   inactive 90
   inactive 1000
   if TC%(1)>0 and TC%(2)>0
      for v1rt% = 1 to count(2060)
         if val(item_read$(2060,v1rt%))=TC%(1)
            v2rt$=item_read$(2050,v1rt%)
            exit_for
         end_if
      next v1rt%
      for v1rt% = 1 to count(2060)
         if val(item_read$(2060,v1rt%))=TC%(2)
            v3rt$=item_read$(2050,v1rt%)
            exit_for
         end_if
      next v1rt%
      for v1rt% = 1 to 25
         if (v2rt$=ME$(v1rt%) and v3rt$=MF$(v1rt%)) or (v3rt$=ME$(v1rt%) and v2rt$=MF$(v1rt%))
            v4rt%=1
            exit_for
         end_if
      next v1rt%
      if v4rt%=1
         hide TC%(1)
         hide TC%(2)
         remet()
         v1rt%=val(caption$(660))
         v1rt%=v1rt%+20
         caption 660,v1rt%
         if NJ%<3
            left 660,36
         else
            left 660,21
         end_if
         clear 800
         item_add 800,"Bravo, vous avez trouv !"
         item_add 800,"Vous gagnez 20 points."
         file_load 630,"MJM-Yes.jpg"
         if SAI%=1
            v5rt%=int(rnd(8))+1
            select v5rt%
               case 1 : file_load 2900,"Foule-Eh.mp3"
               case 2 : file_load 2900,"Yee-Ah.mp3"
               case 3 : file_load 2900,"Ole.mp3"
               case 4 : file_load 2900,"Tambour.mp3"
               case 5 : file_load 2900,"Merveil.mp3"
               case 6 : file_load 2900,"Impression.mp3"
               case 7 : file_load 2900,"Eh-ben.mp3"
               case 8 : file_load 2900,"Bisou.mp3"
            end_select
            play 2900
         end_if
         annule(0)
         activer()
         active 90
      else
         clear 800
         if LC%(1)=LC%(2)
            v1rt%=val(caption$(660))
            v1rt%=v1rt%-20
            caption 660,v1rt%
            item_add 800,"Dsol, c'est deux fois la mme langue."
            item_add 800,"Vous perdez 20 points."
            file_load 630,"MJM-Nul.jpg"
            if SAI%=1
               v5rt%=int(rnd(2))+1
               if v5rt%=1
                  file_load 2900,"Surprise.mp3"
               else
                  file_load 2900,"Beurk.mp3"
               end_if
               play 2900
            end_if
         else
            v1rt%=val(caption$(660))
            v1rt%=v1rt%-10
            caption 660,v1rt%
            item_add 800,"Eh non, dsol, ce n'est pas a."
            item_add 800,"Vous perdez 10 points."
            file_load 630,"MJM-Oh.jpg"
            if SAI%=1
               v5rt%=int(rnd(2))+1
               if v5rt%=1
                  file_load 2900,"Bah.mp3"
               else
                  file_load 2900,"Foule-Ah.mp3"
               end_if
               play 2900
            end_if
         end_if
         annule(0)
      end_if
   end_if
   v4rt%=0
   for v1rt% = 1 to count(2060)
      if show(val(item_read$(2060,v1rt%)))=1
         v4rt%=1
      end_if
   next v1rt%
   active 1000
   active 90
   if v4rt%=0
      fini()
   end_if
end_sub

sub rouge() : rem Affichage d`un point rouge sur la tuile =====================
   dim_local v1ro%
   inactive 90
   inactive 1000
   NTC%=NTC%+1
   if NTC%>2
      NTC%=1
      annule(0)
      TC%(2)=0
   end_if
   if NTC%=1
      vide()
   end_if
   TC%(NTC%)=number_click
   2d_target_is TC%(NTC%)
   2d_pen_color 255,0,0
   2d_fill_color 255,0,0
   2d_circle 135,15,14
   if NTC%=1
      clear 800
   end_if
   item_add 800,"Cible "+str$(NTC%)+" repre"
   for v1ro% = 1 to count(2060)
      if val(item_read$(2060,v1ro%))=number_click
         MC$(NTC%)=item_read$(2050,v1ro%)
         exit_for
      end_if
   next v1ro%
   for v1ro% = 1 to 25
      if MC$(NTC%)=ME$(v1ro%)
         LC%(NTC%)=1
         exit_for
      end_if
   next v1ro% 
   if NTC%=1
      caption 720,MC$(1)
      if LC%(1)=1
         file_load 700,"MJM-Mot-"+LU$+".jpg"
         file_load 610,"MJM-P-"+LU$+".jpg"
         color 710,200,215,40
         color 720,200,215,40
         font_color 720,0,0,255
      else
         file_load 700,"MJM-Mot-francais.jpg"
         file_load 610,"MJM-France.jpg"
         color 710,110,230,250
         color 720,110,230,250
         font_color 720,200,0,0
      end_if
   else
      caption 740,MC$(2)
      if LC%(2)=1
         file_load 750,"MJM-Mot-"+LU$+".jpg"
         file_load 620,"MJM-P-"+LU$+".jpg"
         color 730,200,215,40
         color 740,200,215,40
         font_color 740,0,0,255
      else
         file_load 750,"MJM-Mot-francais.jpg"
         file_load 620,"MJM-France.jpg"
         color 730,110,230,250
         color 740,110,230,250
         font_color 740,200,0,0
      end_if
      if LC%(1)=LC%(2)
         file_load 630,"MJM-Stop.jpg"
      else
         v1ro%=int(rnd(2))+1
         if v1ro%=1
            file_load 630,"MJM-Euh.jpg"
         else
            file_load 630,"MJM-Ben.jpg"
         end_if
      end_if
   end_if
   if active(860)=1
      text 860,MC$(NTC%)
   end_if
   active 1000
   active 90
end_sub

sub son() : rem Coupe le son ou le remet ======================================
   SAI%=1-SAI%
   if SAI%=1
      font_color 965,0,0,0
   else
      font_color 965,150,150,150
   end_if
end_sub

sub suggest(qo%) : rem Suggestion de jeu ======================================
   dim_local v1su% , v2su% , v3su% , v4su% , v5su%
   rem qo%=Quelle origine de la demande
   inactive 90
   inactive 1000
   IJP%=0
   if qo%=1
      clear 800
      item_add 800,"Voici une suggestion de jeu correct."
      item_add 800,"Observez les tuiles clignotantes."
   end_if
   for v1su% = 1 to 25
      for v2su% = 1 to count(2050)
         if item_read$(2050,v2su%)=ME$(v1su%)
            if show(val(item_read$(2060,v2su%)))=1
               if active(val(item_read$(2060,v2su%)))=1
                  for v3su% = 1 to count(2050)
                     if item_read$(2050,v3su%)=MF$(v1su%)
                        if show(val(item_read$(2060,v3su%)))=1
                           if active(val(item_read$(2060,v3su%)))=1
                              v4su%=val(item_read$(2060,v2su%))
                              v5su%=val(item_read$(2060,v3su%))
                              IJP%=1
                              exit_for
                           end_if
                        end_if
                     end_if
                  next v3su%
                  if v4su%>0
                     exit_for
                  end_if
               end_if
            end_if
         end_if
      next v2su%
      if v4su%>0
         exit_for
      end_if
   next v1su%
   if qo%=1
      if v4su%>0
         for v1su% = 1 to 4
            hide v4su%
            pause 75
            show v4su%
            pause 150
         next v1su%
         for v1su% = 1 to 4
            hide v5su%
            pause 75
            show v5su%
            pause 150
         next v1su%
         item_add 800,"Cette aide excessive vous cote 2 points."
         v1su%=val(caption$(660))
         v1su%=v1su%-2
         caption 660,v1su%
      else
         clear 800
         item_add 800,"Aucune possibilit de jeu."
         item_add 800,"Restructurez la disposition des tuiles."
      end_if
   end_if
   active 1000
   active 90
end_sub

sub traduire() : rem Traduire un mot franais ou tranger =====================
   file_load 850,"MJM-Fleche-T.jpg"
   show 1077
   inactive 1070
   inactive 1075
   text 860,""
   caption 890,""
   file_load 870,"MJM-Bouton-Go-Gris.jpg"
   active 860
   set_focus 860
end_sub

sub vide() : rem Faire le vide au niveau des inscription des mots =============
   file_load 610,"MJM-Euh.jpg"
   file_load 620,"MJM-Ben.jpg"
   file_load 630,"MJM-Ouh.jpg"
   file_load 700,"MJM-Mot-X.jpg"
   file_load 750,"MJM-Mot-X.jpg"
   caption 720,""
   caption 740,""
end_sub



