' Affichage matriciel defilant
' Marc - 19/10/2020
' http://panoramic.1fr1.net/

' matrice 6 x 7

dim afficheur%(200,7), texte$

label espace,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
label chiffre1, chiffre2, chiffre3, chiffre4, chiffre5, chiffre6, chiffre7, chiffre8, chiffre9, chiffre0
label signeApostrophe, signePourCent, signeEtoile, signePoint, signeVirgule
label signeDeuxPoints, signepointVirgule, signeMoins, signeExclamation, signeInterrogation, signeFraction, signePlus
label signeEgal, signeSuperieur, signeInferieur, signeCrochetOuvert, signeCrochetFerme, signeParentheseOuverte
label signeParentheseFermee, signeDiese, signeGuillemets

texte$ = "Bienvenue sur le forum Panoramic"

creerFenetrePrincipale()
creerAfficheur()
chargerTexte(texte$)
affichageTexte()

end



sub affichageTexte()

    dim_local i%, x%,y%

    for i% = 1000 to -800 step -10
        for x% = 1 to 200
            for y% = 1 to 7
                if afficheur%(x%,y%) = 1
                    2d_fill_color 250,0,0
                    2d_pen_color 250,0,0
                    2d_circle (x%*10)+i%,y%*10,4
                else
                    2d_fill_color 20,20,20
                    2d_pen_color 20,20,20
                    2d_circle (x%*10)+i%,y%*10,4
                end_if    
            next y%
        display
        next x%        
        pause 20
    next i%        

end_sub



sub chargerTexte(txt$)
    dim_local caractere$, index%, lectureData$, x%, y%, longueurTexte%, colonne%
    
    txt$=upper$(txt$)
    
    longueurTexte% = len(txt$)

    colonne% = 1

    for index% = 1 to longueurTexte%
        caractere$ = mid$(txt$,index%,1)

        positionnementIndexlectureData(caractere$)

        for x% = colonne% to colonne% + 5
            read lectureData$
            for y% = 1 to 7
                afficheur%(x%,y%) = mid$(lectureData$,y%,1)
            next y%          
        next x%      
        colonne% = colonne% + 6

    next index%
    
end_sub          



sub creerAfficheur()
    dim_local i%, j%
    2d_pen_color 20,20,20
    2d_fill_color 20,20,20

    for i% = 1 to 130
        for j% = 1 to 7
            2d_circle i%*10,j%*10,4
        next j%
    next i%        
          
end_sub



SUB creerFenetrePrincipale()
    width 0,1200
    height 0,750
    left 0,(screen_x - width(0))/2
    top 0,(screen_y - height(0))/2
    color 0,0,0,0
end_sub



sub positionnementIndexlectureData(caractere$)
    dim_local valeurAscii%
    
    valeurAscii% = ASC(caractere$)
    
    select valeurAscii%
        case 32
            restore_label espace
        case 65
            restore_label a
        case 66
            restore_label b
        case 67
            restore_label c
        case 68
            restore_label d
        case 69
            restore_label e
        case 70
            restore_label f
        case 71
            restore_label g
        case 72
            restore_label h
        case 73
            restore_label i
        case 74
            restore_label j
        case 75
            restore_label k
        case 76
            restore_label l
        case 77
            restore_label m
        case 78
            restore_label n
        case 79
            restore_label o
        case 80
            restore_label p
        case 81
            restore_label q
        case 82
            restore_label r
        case 83
            restore_label s
        case 84
            restore_label t
        case 85
            restore_label u
        case 86
            restore_label v
        case 87
            restore_label w
        case 88
            restore_label x
        case 89
            restore_label y
        case 90
            restore_label z
        case 49
            restore_label chiffre1
        case 50
            restore_label chiffre2
        case 51
            restore_label chiffre3
        case 52
            restore_label chiffre4
        case 53
            restore_label chiffre5
        case 54
            restore_label chiffre6
        case 55
            restore_label chiffre7
        case 56
            restore_label chiffre8
        case 57
            restore_label chiffre9
        case 48
            restore_label chiffre0
        case 39
            restore_label signeApostrophe
        case 37
            restore_label signePourCent
        case 42        
            restore_label signeEtoile
        case 46    
            restore_label signePoint
        case 44
            restore_label signeVirgule
        case 58
            restore_label signeDeuxPoints
        case 59
            restore_label signePointVirgule
        case 45
            restore_label signemoins
        case 33
            restore_label signeExclamation
        case 63
            restore_label signeInterrogation
        case 47
            restore_label signefraction
        case 43
            restore_label signePlus
        case 61
            restore_label signeEgal
        case 62
            restore_label signeSuperieur
        case 60
            restore_label signeInferieur
        case 91
            restore_label signeCrochetOuvert
        case 93
            restore_label signeCrochetFerme
        case 40
            restore_label signeParentheseOuverte
        case 41
            restore_label signeParentheseFermee
        case 35
            restore_label signeDiese
        case 34
            restore_label signeGuillemets
      end_select
end_sub


' caractere espace
espace:
data "0000000","0000000","0000000","0000000","0000000","0000000"

' caractere A
a:
data "0000000","0111111","1001000","1001000","1001000","0111111"

' caractere B
b:
data "0000000","1111111","1001001","1001001","1001001","0110110"

' caractere C
c:
data "0000000","0111110","1000001","1000001","1000001","0100010"

' caractere D
d:
data "0000000","1111111","1000001","1000001","1000001","0111110"

' caractere E
e:
data "0000000","1111111","1001001","1001001","1001001","1000001"

' caractere F
f:
data "0000000","1111111","1001000","1001000","1001000","1001000"

' caractere G
g:
data "0000000","0111110","1000001","1000001","1000101","0100110"

' caractere H
h:
data "0000000","1111111","0001000","0001000","0001000","1111111"

' caractere I
i:
data "0000000","1000001","1000001","1111111","1000001","1000001"

' caractere J
j:
data "0000000","0000010","0000001","0000001","0000001","1111110"

' caractere K
k:
data "0000000","1111111","0001000","0010100","0100010","1000001"

' caractere L
l:
data "0000000","1111111","0000001","0000001","0000001","0000001"

' caractere M
m:
data "0000000","1111111","0100000","0010000","0100000","1111111"

' caractere N
n:
data "0000000","1111111","0010000","0001000","0000100","1111111"

' caractere O
o:
data "0000000","0111110","1000001","1000001","1000001","0111110"

' caractere P
p:
data "0000000","1111111","1001000","1001000","1001000","0110000"

' caractere Q
Q:
data "0000000","0111110","1000001","1000101","1000011","0111111"

' caractere R
r:
data "0000000","1111111","1001000","1001100","1001010","0110001"
' caractere S

s:
data "0000000","0110010","1001001","1001001","1001001","0100110"

' caractere T
t:
data "0000000","1000000","1000000","1111111","1000000","1000000"

' caractere U
u:
data "0000000","1111110","0000001","0000001","0000001","1111110"

' caractere V
v:
data "0000000","1111100","0000010","0000001","0000010","1111100"

' caractere W
W:
data "0000000","1111110","0000001","0000110","0000001","1111110"

' caractere X
x:
data "0000000","1100011","0010100","0001000","0010100","1100011"

' caractere Y
y:
data "0000000","1100000","0010000","0001111","0010000","1100000"

' caractere Z
Z:
data "0000000","1000011","1000101","1001001","1010001","1100001"

' caractere 1
chiffre1:
data "0000000","0000001","0100001","1111111","0000001","0000001"

' caractere 2
chiffre2:
data "0000000","0100001","1000011","1000101","1001001","0110001"

' caractere 3
chiffre3:
data "0000000","0110010","1000001","1001001","1001001","0110110"

' caractere 4
chiffre4:
data "0000000","0001100","0010100","0100100","1000100","1111111"

' caractere 5
chiffre5:
data "0000000","0111001","1001001","1001001","1001001","1000110"

' caractere 6
chiffre6:
data "0000000","0111110","1001001","1001001","1001001","0000110"

' caractere 7
chiffre7:
data "0000000","1000001","1000010","1000100","1001000","0110000"

' caractere 8
chiffre8:
data "0000000","0111110","1001001","1001001","1001001","0111110"

' caractere 9
chiffre9:
data "0000000","01100000","1001001","1001001","1001001","0111110"

' caractere 0
chiffre0:
data "0000000","0111110","1000001","1000001","1000001","0111110"

' caractere apostrophe '
signeApostrophe:
data "0000000","0000000","0000000","1100000","0000000","0000000"

' caractere %
signePourCent:
data "0000000","0110010","0110100","0001000","0010110","0100110"

' caractere *
signeEtoile:
data "0000000","0000000","1010000","0100000","1010000","0000000"

' caratere .
signePoint:
data "0000000","0000000","0000000","0000010","0000000","0000000"

' caractere ,
signeVirgule:
data "0000000","0000000","0000001","0000010","0000000","0000000"

' caractere :
signeDeuxPoints:
data "0000000","0000000","0000000","0100010","0000000","0000000"

' caractere ;
signePointVirgule:
data "0000000","0000000","0000001","0100010","0000000","0000000"

' caractere -
signeMoins:
data "0000000","0000000","0001000","0001000","0001000","0000000"

' caractere !
signeExclamation:
data "0000000","0000000","0000000","1111101","0000000","0000000"

' caractere ?
signeInterrogation:
data "0000000","0100000","1000000","1001101","1001000","0110000"

' caractere /
signeFraction:
data "0000000","0000010","0000100","0001000","0010000","0100000"

' caratere +
signePlus:
data "0000000","0001000","0001000","0111110","0001000","0001000"

' caractere =
signeEgal:
data "0000000","0010100","0010100","0010100","0010100","0010100"

' caractere <
signeInferieur:
data "0000000","0000000","0001000","0010100","0100010","0000000"

' caractere >
signeSuperieur:
data "0000000","0000000","0100010","0010100","0001000","0000000"

' caractere [
signeCrochetOuvert:
data "0000000","0000000","1111111","1000001","1000001","0000000"

' caractere ]
signeCrochetFerme:
data "0000000","0000000","1000001","1000001","1111111","0000000"

' caractere(
signeParentheseOuverte:
data "0000000","0011100","0100010","1000001","1000001","0000000"

' caractere )
signeParentheseFermee:
data "0000000","0000000","1000001","1000001","0100010","0011100"

' caractere #
signeDiese:
data "0000000","0010100","1111111","0010100","1111111","0010100"

' caractere "
signeGuillemets:
data "0000000","0000000","1100000","0000000","1100000","0000000"
        