
rem ============================================================================
rem                         Courbe des Larmes
rem ============================================================================
rem
rem              Paramtrisation cartsienne de la courbe
rem               ______________________________________
rem              |                                      |                               |
rem              |  x = a * sin(t) * power(sin(t/2),n)  |
rem              |  y = a * cos(t)                      |
rem              |______________________________________|
rem
rem ============================================================================
dim xc,yc,n
width 0,1000 : caption 0,"Courbes des larmes"
picture 10 : full_space 10 : 2d_target_is 10 : color 10,50,200,100 : 2d_pen_color 255,255,0
xc = 240 : yc = height_client(10)/2
alpha 20 : top 20,20 : left 20,3*xc/2 : font_bold 20 : font_name 20,forte
font_size 20,20 : font_color 20,255,255,0 : color 20,50,200,100
for n = 1 to 100 : Larme(150,n) : next n
repeat
    font_color 20,255,255,0 : caption 20,"Il n'y a plus de larmes": pause 1000
    font_color 20,255,000,0 : caption 20,"Il n'y a plus de larmes": pause 1000
until scancode <> 0
end
rem ============================================================================
SUB Larme(a,n)
    dim_local x,y,t
    degrees : 2d_pen_width 2
    2d_pen_color rnd(n+a),rnd(a),abs(mod(rnd(360),255))
    2d_poly_from xc/2 , yc+a
    for t = 0 to 360        
        x = a * sin(t) * power(sin(t/2),n)
        y = a * cos(t)        
        2d_poly_to xc/2+x,yc+y
    next t
  
    2d_poly_from 3*xc/2, yc+a
    for t = 0 to 360
        x = a * sin(t) * power(sin(t/2),n)
        y = a * cos(t)
        2d_poly_to 3*xc/2-x,yc+y
    next t
    
    2d_poly_from 5*xc/2,yc+a
    for t = 0 to 360
        x = a * sin(t) * power(sin(t/2),n)
        y = a * cos(t)
        2d_poly_to 5*xc/2-x,yc+y
    next t
    2d_poly_from 7*xc/2,yc+a
    for t = 0 to 360
        x = a * sin(t) * power(sin(t/2),n)
        y = a * cos(t)
        2d_poly_to 7*xc/2-x,yc+y
    next t    
    display    
END_SUB
rem ============================================================================