
rem ============================================================================
rem    Algorithme pour les fonctions circulaires sinus x et cosinus x
rem ============================================================================      
dim x
height 0,700 : width 0,1000
caption 0,"Algorithme pour les fonctions circulaires sinus x et cosinus x"
list 10 : top 10,20 : left 10,020 : width 10,200 : height 10,560
list 20 : top 20,20 : left 20,250 : width 20,250 : height 20,560
list 30 : top 30,20 : left 30,520 : width 30,220 : height 30,560
list 40 : top 40,20 : left 40,750 : width 40,200 : height 40,560
alpha 50 : top 50,600 : left 50,150 : font_bold 50 : font_size 50,14  
caption 50,"Remarquez la bonne prcision des calculs ... <ESC> pour sortir ..."


for x = 10 to 40 step 10 : font_name x,"arial black" : font_color x,0,0,255 : next x

item_add 10,"Angles en Radians"
item_add 20,"Calcul de sinus par FNC Sinus(x)"
item_add 30,"Calcul de sinus par Panoramic"
item_add 40,"Diffrences"

for x = 0 to 2*pi step pi/8
    item_add 10, "x = " + str$(x)
    item_add 20, str$(sinus(x))
    item_add 30, str$(sin(x))
    item_add 40, str$(sinus(x) - sin(x))
next x
for x = 10 to 40 step 10 : item_add x,string$(20,"=") : item_add x,"" : next x
item_add 10,"Angles en Radians"
item_add 20,"Calcul de cosinus par FNC Cosinus(x)"
item_add 30,"Calcul de cosinus par Panoramic"
item_add 40,"Diffrences"

for x = 0 to 2*pi step pi/8
    item_add 10, "x = " + str$(x)
    item_add 20, str$(cosinus(x))
    item_add 30, str$(cos(x))
    item_add 40, str$(cosinus(x) - cos(x))
next x

repeat
    font_color 50,20,100,200 : pause 500
    font_color 50,255,0,0    : pause 500
    font_color 50,200,100,20 : pause 500
until scancode = 27

terminate
rem ============================================================================
FNC Sinus(x)
    dim_local s,n
    n = 16 : s = 2*x / power(3,n)
    repeat
         s = s * (3-s*s) : n = n - 1
    until n = 0
    result s/2
END_FNC
rem ============================================================================
FNC Cosinus(x)
    dim_local c,n
    n = 16 : c = x*x / (2*power(4,n))
    repeat
        c = 2*c*(2-c) : n = n-1
    until n = 0
    result 1-c
END_FNC
rem ============================================================================