
rem ============================================================================
rem       Convertisseur Dcimal ---> Binaire, Octal, Hexadcimal, ...
rem                 Papydall le 20 / 11 / 2018
rem             PANORAMIC-EDITOR Version 0.9.29i5
rem ============================================================================
rem    Convertir un nombre en base 10 vers un nombre en base 2  36
rem Saisissez un nombre entier en base 10 dans la zone de lEDIT et le programme
rem affichera instantanment le nombre converti dans les diffrentes bases proposes
rem Pour une base autre que celles proposes, choisissez celle qui vous convient
rem dans la LIST en bas  gauche (de la base 2  la base 36).
rem ============================================================================

GO()

end
rem ============================================================================
SUB GO()
    label clic, quitter
    dim b, n, i

    width 0,1000 : height 0,500 : color 0,20,200,150
    caption 0,"Convertisseur entre bases"

    edit 010  : top 010,020 : left 010,200 : set_focus 10 : on_change 10,clic
    hint 10,"Saisir un nombre entier en dcimal"
    alpha 020 : top 020,020 : left 020,020 : caption 20,"Nombre  convertir"
    
    memo 030  : top 030,070 : left 030,200 : hint 30,"Valeur en base 2"
    alpha 040 : top 040,080 : left 040,120 : caption 40,"Binaire"
  
    memo 050  : top 050,120 : left 050,200 : hint 50,"Valeur en base 4"
    alpha 060 : top 060,130 : left 060,080 : caption 60,"Quaternaire"

    memo 070  : top 070,170 : left 070,200 : hint 70,"Valeur en base 8"
    alpha 080 : top 080,180 : left 080,135 : caption 80,"Octal"

    memo 090  : top 090,220 : left 090,200 : hint 90,"Valeur en base 10"
    alpha 100 : top 100,230 : left 100,110 : caption 100,"Dcimal"

    memo 110  : top 110,270 : left 110,200 : hint 110,"Valeur en base 16"
    alpha 120 : top 120,280 : left 120,070 : caption 120,"Hexadcimal"

    memo 130  : top 130,360 : left 130,200
    alpha 140 : top 140,370 : left 140,010 : caption 140,"Autre Base :"

    list 150  : top 150,320 : left 150,140 : height 150,120 : width 150,50
    font_bold 150 : font_size 150,12  : on_click 150,clic
    hint 150,"Choisir la base de la conversion"
        
    for i = 2 to 36 : item_add 150,i : next i
    item_select 150,2

    for i = 10 to 140 step 10
        font_bold i : font_name  i,"tahoma"  : font_color i,0,0,255
        width i,700 : height i,45 : font_size i,11
    next i
  
    on_close 0, quitter
    close_inactive
    
END_SUB
rem ============================================================================
Quitter:
    if message_information_yes_no("Vous voulez vraiment quitter ?") = 1
      Close_Main_Form() : close_active
   end_if
   Convertir()
return
rem ============================================================================
Clic:
   off_change 10
   b = item_index(150)+1

   if numeric(text$(10)) = 0
      message "Un nombre en base dcimale, SVP !!!"
      for i = 10 to 130 step 20 : text i,"" : next i
      caret_position 10,len(text$(10))
      on_change 10,clic
      return
   end_if
   n = val(text$(10))
   if n <> int(n)
      text 10,str$(int(n)) : caret_position 10,len(text$(10))
      on_change 10,clic
      return
   end_if
   caption 140,"Autre Base : " + str$(b)
   item_select 150,b-1
   off_change 10
   Convertir()
   set_focus 10 : caret_position 10,len(text$(10))  
   on_change 10,clic
return
rem ============================================================================
SUB Convertir()    
    item_add 30,Decimal2BaseB$(n,2)
    item_add 50,Decimal2BaseB$(n,4)
    item_add 70,Decimal2BaseB$(n,8)
    item_add 90,Decimal2BaseB$(n,10)
    item_add 110,Decimal2BaseB$(n,16)
    item_add 130,Decimal2BaseB$(n,b)
    hint 130,"Valeur en base " + str$(b)
END_SUB
rem ============================================================================
SUB Close_Main_Form()
    dim_local k,w,h
    For k = 100 To 60 Step -1
        w = width(0) : h = height(0)
        width 0,w*k/92 : height 0,h*k/92
        top 0,(screen_y - height(0))/2 : left 0,(screen_x - width(0))/2
        pause 100
    next k
    terminate
END_SUB
rem ============================================================================
' ************************************************************
' * Conversion d'un nombre dcimal vers un nombre en base B  *
' ************************************************************
FNC Decimal2BaseB$(Decimal,base)
    DIM_local chiffres$ : chiffres$="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    DIM_LOCAL tmp$
  
    if Decimal = 0 then result "0" : Exit_FNC
    WHILE Decimal > 0
       IF FRAC(Decimal / base) = 0
          tmp$ = "0" + tmp$
       ELSE
          tmp$ = MID$(chiffres$,(Decimal - (INT(Decimal / base) * base)) + 1,1) + tmp$
       END_IF
       Decimal = INT(Decimal / base)
    END_WHILE
    RESULT tmp$    
END_FNC
rem ============================================================================