
rem ============================================================================
rem              Conversion entre bases de 2  36
rem                 Papydall le 21 / 11 / 2018
rem             PANORAMIC-EDITOR Version 0.9.29i5
rem ============================================================================
rem Convertir un nombre en base B1 vers un nombre en base B2
rem B1 et/ou B2 de 2  36
rem Par dfaut le programme propose de convertir de la base 10 vers la base 2
rem Pour toute autre base, slectionnez celle qui vous convient dans la LISTE
rem  gauche et/ou celle  droite
rem ============================================================================
rem Essayez de convertir
rem 47524133 (dcimal) vers la base 36
rem 25435343763 (dcimal) vers la base 36
rem 9591492602340 (dcimal) vers la base 28
rem ============================================================================

Go()

end
rem ============================================================================
SUB Go()
    label clic, quitter
    dim i,b1,b2,n$,erreur
    width 0,1000 : color 0,100,50,255
    caption 0,"Conversion entre bases"
    alpha 10 : top 10,65 : left 10,25 : font_bold 10 : font_name 10,"arim"
    caption 10,"De la base :" : font_size 10,14 : font_color 10,255,255,0
    alpha 20 : top 20,65 : left 20,525 : font_bold 20 : font_name 20,"arimo"
    caption 20,"vers la base :" : font_size 20,14 : font_color 20,255,255,0
    
    edit 30 : top 30,20 : left 30,025 : width 30,450 : font_bold 30 : font_size 30,14
    font_name 30,"arimo" : set_focus 30 : on_change 30,clic
    hint 30,"Saisissez un nombre  convertir" + chr$(13) + "de la base  gauche  celle de droite"
    
    memo 40 : top 40,10 : left 40,525 : width 40,450 : font_bold 40 : font_size 40,14
    height 40, 50 : font_name 30,"arimo" : font_size 40,14 : font_name 40,"arimo"
    
    list 50 : top 50,100 : left 50,25 : width 50,450 : height 50,240 : font_bold 50
    font_size 50,14 : hint 50,"Selectionnez la base de dpart" : on_click 50,clic
    
    list 60 : top 60,100 : left 60,525 : width 60,450 : height 60,240 : font_bold 60
    font_size 60,14 : hint 60,"Selectionnez la base d'arrive" : on_click 50,clic
    
    for i = 2 to 36
        item_add 50,"Base : " + str$(i) : item_add 60,"Base : " + str$(i)
    next i
    item_select 50,9 : item_select 60,1
    
    alpha 70 : top 70,350 : left 70,25 : font_bold 70 : font_name 70,"arim"
    caption 70,"Rsultat :" : font_size 70,14 : font_color 70,255,255,0
    
    memo 80 : top 80,390 : left 80,25 : width 80,950 : font_bold 80 : font_size 80,14
    height 80,50 : font_name 80,"arimo" : font_size 80,14 : font_name 80,"arimo"
        
    on_close 0, quitter
    close_inactive
    
END_SUB
rem ============================================================================
Clic:
   off_click 50 : off_click 60 : off_change 30
   b1 = item_index(50) + 1 : b2 = item_index(60) + 1 : text 30,upper$(text$(30))
   n$ = text$(30)      
   Convertir()
   set_focus 30 : caret_position 30,len(text$(30))
   on_click 50,clic : on_click 60,clic : on_change 30,clic    
return
rem ============================================================================
SUB Convertir()
    dim_local deci
    erreur = 0
    deci = BaseB2Decimal(n$,b1)
    if erreur = 0
       item_add 40,Decimal2BaseB$(Deci,b2)
       item_add 80,n$ + " (base-" + str$(b1) + " ) = " + Decimal2BaseB$(Deci,b2)  + " (base- "+str$(b2)+")"
    else
       item_add 40, "Valeur invalide !!!"
       item_add 80,"Entre invalide !!!"      
    end_if    
END_SUB
rem ============================================================================
Quitter:
    if message_information_yes_no("Vous voulez vraiment quitter ?") = 1
      Close_Main_Form() : close_active
    end_if
return
rem ============================================================================
SUB Close_Main_Form()
    dim_local k,w,h
    For k = 100 To 60 Step -1
        w = width(0) : h = height(0)
        width 0,w*k/92 : height 0,h*k/92
        top 0,(screen_y - height(0))/2 : left 0,(screen_x - width(0))/2
        pause 100
    next k
    terminate
END_SUB
rem ============================================================================
' Conversion d'un nombre dcimal vers un nombre en base Base  
FNC Decimal2BaseB$(Decimal,Base)
    DIM_local chiffres$ : chiffres$="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    DIM_LOCAL tmp$  
    if Decimal = 0 then result "0" : Exit_FNC
    WHILE Decimal > 0
       IF FRAC(Decimal / base) = 0
          tmp$ = "0" + tmp$
       ELSE
          tmp$ = MID$(chiffres$,(Decimal - (INT(Decimal / base) * base)) + 1,1) + tmp$
       END_IF
       Decimal = INT(Decimal / base)
    END_WHILE
    RESULT tmp$    
END_FNC
rem ============================================================================
' Conversion d'un nombre en base B >= 2 vers un nombre dcimal
' Paramtres :
' BaseB$ est une chaine de caractres reprsentant la valeur du nombre dans
' la base Base
FNC BaseB2Decimal(BaseB$,Base)
    DIM_local chiffres$ : chiffres$="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    DIM_LOCAL Decimal
    chiffres$ = left$(chiffres$,base)    
    WHILE BaseB$ <> ""
        if INSTR(chiffres$,LEFT$(BaseB$,1)) = 0
           erreur = 1 :  exit_fnc
        end_if    
        Decimal = (Decimal * base) + INSTR(chiffres$,LEFT$(BaseB$,1))-1
        BaseB$ = RIGHT$(BaseB$,LEN(BaseB$)-1)
    END_WHILE
    RESULT Decimal
END_FNC
rem ============================================================================