
rem ============================================================================
rem             Tracer quatre courbes de Levy
rem              par une procdure rcursive
rem ============================================================================
dim order  : order = 10 : ' Ordre de la courbe
dim length : length = 2 : ' Longueur de la ligne  tracer
dim dx(8),dy(8)         : ' Tableaux pour stocker les directions et les longueurs des lignes
dim depth,direction,x,y,oldx,oldy,i
for i = 0 to 7
    dx(i+1) = cos(i/4*pi) * length
    dy(i+1) = sin(i/4*pi) * length
next i
picture 10 : full_space 10 : 2d_target_is 10 : color 10,0,0,0
caption 0,"4 Courbes de Levy ... Trac en cours ..."
for i = 0 to 3
    depth = 0 : direction = i*2
    x = width_client(10) / 2
    y = height_client(10) /2
    select i
        case 0 : 2d_pen_color 255,0,0
        case 1 : 2d_pen_color 0,255,0
        case 2 : 2d_pen_color 0,0,255
        case 3 : 2d_pen_color 255,255,0
    end_select
    Forward()
next i
caption 0,"Termin"
end
rem ============================================================================
' Procdure rcursive
SUB Forward()
    if depth <= order
       depth = depth + 1
       direction = direction + 1 : if direction > 7 then direction = 0  
       Forward() : ' 1er appel rcursif
       direction = direction - 1 : if direction < 0 then direction = 7  
       direction = direction - 1 : if direction < 0 then direction = 7  
       Forward() : ' 2me appel rcursif
       direction = direction + 1 : if direction > 7 then direction = 0  
       depth = depth - 1
    else
       oldx = x : oldy = y
       x = x + dy(direction) : y = y + dx(direction)
       2d_line oldx, oldy, x, y : display
    end_if  
END_SUB
rem ============================================================================