
rem ============================================================================
rem          Courbes en coordonnes polaires
rem              Les jolis papillons
rem                 Par Papydall
rem ============================================================================
dim s,x0,y0
width 0,900 : height 0,700 : color 0,150,100,50
x0 = width(0)/2 : y0 = height(0)/2
alpha 10 : top 10,150 : left 10,220 : font_size 10,20 : font_name 10,"arial black"
caption 0,"Les jolis Papillons ....  <CLICK> pour arrter !"
font_bold 0: font_size 0,12 : font_color 0,255,255,255 : font_name 0,"tahoma"
print_locate 50,10
print "Les jolis Papillons .... : Equation polaire : r = a + b*cos(2*t) + sin(5*t)*sin(5*t)*sin(5*t)"
for s = 2 to 90 :' step 2
    Papillon(x0,y0,s)           : ' papillon centre
    Papillon(x0/2,y0*.25,s/3)   : ' papillon haut gauche
    Papillon(x0/2,y0*1.7,s/3)   : ' papillon bas gauche
    Papillon(x0*1.5,y0*.25,s/3) : ' papillon haut droite
    Papillon(x0*1.5,y0*1.7,s/3) : ' papillon bas droite
    if scancode <> 0 then terminate
next s

repeat
   font_color 10,0,0,0
   caption 10,"Que c'est beau ! Que c'est joli !" : pause 1000
   font_color 10,0,0,255
   caption 10,"Que c'est beau ! Que c'est joli !" : pause 1000
until scancode <> 0
end
rem ============================================================================
SUB Papillon(x0,y0,s)
    dim_local r,a,b,t,x,y,cr,cg,cb
    a = 1.6 : b = 1.1
    degrees : ' on travaille avec les degrs au lieu des radians
    cr = abs(3*s-255) : cg = 150+s : cb = abs(2*s-255)
    2d_pen_color cr,cg,cb : 2d_fill_color cr,cg,cb : ' 2d_pen_width 2
    2d_poly_from x0 + s*(a+b),y0
    for t = 0 to 360 step 2
        r = a + b*cos(2*t) + sin(5*t)*sin(5*t)*sin(5*t)
        x = x0+s*r*cos(t) : y = y0-s*r*sin(t)
        2d_poly_to x,y
       display
    next t
END_SUB
rem ============================================================================