
rem ============================================================================
rem         OVE
rem ============================================================================
' Ref : http://serge.mehl.free.fr/anx/ovale.html
' L'ovale ne possde pas d'quation mathmatique simple
' Une tude de l'quation de l'ove aboutit  une quation paramtrique au moyen
' des fonctions logiques pas vraiment simple.
rem ============================================================================
rem x(t) = cos(t)*(t<=p)+(1+2cos(t))*(t>p)*(t<=5p/4)+(2-sqrt(2))cos(t)*(t>5p/4)*(t<=7p/4)
rem      +(-1+2cos(t))*(t>7p/4)
rem y(t) = sin(t)*(t<=p)+2sin(t)*(t>pi)*(t<=5p/4)+(-1+(2-sqrt(2))*sin(t))*(t>5p/4)*(t<=7p/4)
rem        +2sin(t)*(t>7p/4)
rem ============================================================================
' Panoramic ne permettant pas de manipuler des telles quations logiques, on
' peut les transformer sous une autre forme utilisant la partie entire (INT)
' que Panoramic sait trs bien s'en servir.
' on obtient :
rem ============================================================================
rem  x(t) = cos(t)*(1-int(t/pi))+(1+2cos(t))*int(t/pi)*(1-int(4t/5/pi))
rem         +(2-sqrt(2))cos(t)*int(4t/5/pi)*(1-int(4t/7/pi))+(-1+2cos(t))*int(4t/7/pi)*(1-int(t/2/pi))
rem  y(t) = sin(t)*(1-int(t/pi))+2sin(t)*int(t/pi)*(1-int(4t/5/pi))
rem         +(-1+(2-sqrt(2))sin(t))*int(4t/5/pi)*(1-int(4t/7/pi))+2sin(t)*int(4t/7/pi)*(1-int(t/2/pi))
rem ============================================================================
rem &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
rem ============================================================================
Ove(300,250,150)
Ove(80,100,50) : Ove(530,100,50)
Ove(80,240,50) : Ove(530,240,50)
Ove(80,380,50) : Ove(530,380,50)
end
rem ============================================================================
SUB Ove(xc,yc,r)
    dim_local x,y,t,p
    p = pi/180
    color 0,0,0,0 : 2d_pen_color 200,150,100 : 2d_poly_from xc+r,yc
    for t = 0 to 2*pi step p
        x = cos(t)*(1-int(t/pi))+(1+2*cos(t))*int(t/pi)*(1-int(4*t/5/pi))
        x = x +(2-sqr(2))*cos(t)*int(4*t/5/pi)*(1-int(4*t/7/pi))
        x = x +(-1+2*cos(t))*int(4*t/7/pi)*(1-int(t/2/pi))
        y = sin(t)*(1-int(t/pi))+2*sin(t)*int(t/pi)*(1-int(4*t/5/pi))
        y = y +(-1+(2-sqr(2))*sin(t))*int(4*t/5/pi)*(1-int(4*t/7/pi))
        y = y +2*sin(t)*int(4*t/7/pi)*(1-int(t/2/pi))
        2d_poly_to xc+r*x,yc+r*y
    next t
    2d_flood xc,yc,200,150,100
END_SUB
rem ============================================================================