
rem ============================================================================
rem    Extraction de la racine carre dun nombre par lalgorithme de Hron
rem ============================================================================

print " Racine carre (ALGO) de 123456789 = " + str$(Racine_Carree(123456789))
print " Racine carre (PANO) de 123456789 = " + str$(sqr(123456789))

end
rem ============================================================================
' Calcul de la racine carre par l'algorithme de Hron d'Alexandrie
' Cet algorithme donne trs vite un grand nombre de dcimales correctes.
' C'est un algo d'une efficacit exceptionnelle
FNC Racine_Carree(n)
    dim_local x,x1,i,epsilon
    epsilon = power(10,0-10)
    x = 1 : ' Valeur arbitraire de dpart
    repeat
        x1 = x
        x = 0.5 * (x + (n/x))
    until abs(x-x1) < epsilon
    result x    
END_FNC
rem ============================================================================