
rem ' Jeu du marchand - par jjn4 - le 15/02/2021 ==============================
   dim ABV$ : rem Affichage de la Balance Vide
   dim CBP%(8) : rem Coordonnes du Bas des Pices
   dim CDP%(8) : rem Coordonnes du Dbut des Pices
   dim CFP%(8) : rem Coordonnes de la Fin des Pices
   dim CHP%(8) : rem Coordonnes du Haut des Pices
   dim HVB%(56) : rem Hauteur des Vgtaux sur la Balance
   dim IMS% : rem Indice de Mode Silencieux
   dim IVD% : rem Indice de Vgtaux Diffrents
   dim NFL$(56) : rem Nom des Fruits et Lgumes
   dim LHB% : rem Limite Horizontale des Billets
   dim LVB% : rem Limite Verticale des Billets
   dim NBS% : rem Numro des Billets Supplmentaires
   dim NDS$(8) : rem Noms des Divers Sons
   dim NPS% : rem Numro des Pices Supplmentaires
   dim NVA%(6) : rem Numro des Vgtaux  Accent
   dim NVA$(6) : rem Nom des Vgtaux  Accent
   dim NVB$(56) : rem Nom des Vgtaux sur la Balance
   dim NVC$(56) : rem Nom des Vgtaux de la Cagette
   dim PVK(56) , PVK$(56) : rem Prix des Vgtaux au Kilo
   dim PTP : rem Prix Total de la Pese
   dim QDC% : rem Quantit Demande par la Cliente
   dim SDC% : rem Somme Donne par la Cliente
   dim TAP : rem Total A Payer
   dim TVA$(8) : rem Texte de Voix de l`Aide
   dim TFA$ : rem Titre de la Fentre d`Aide
   dim TGP$ : rem Titre Gnral du Programme
   dim TRC : rem Total Rendu  la Cliente
   dim VBV%(6) : rem Valeur des Billets Verticaux
   dim VFM%(17) : rem Valeur de la Fausse Monnaie
   dim VPM$(8) , VPM(8) : rem Valeur des Pices de Monnaie
   dim V1M% , V2M% , V3M% : rem Variables  utilisation Multiple
   ABV$="0,000 Kg  x  ??,?? /Kg  =  ??,?? "
   LVB%=50 : NBS%=6999 : NPS%=4999
   TFA$="   Explications concernant le jeu du Marchand"
   TGP$="   Jeu du Marchand de fruits et lgumes - par jjn4 - Ver.150221.2"
   label clic : rem Gestion de tous les on-click
   label close : rem Gestion de l`on-close

rem Form0 =====================================================================
   width 0,1365
   height 0,720
   on_close 0,close
   caption 0,TGP$
   
rem Construction de la prsentation ===========================================
   form 10 : rem Base de la photo
      width 10,1365
      height 10,720
      caption 10,"   Jeu du marchand - Le jeu se prpare"
   picture 15 : rem Photo de prsentation
      parent 15,10
      full_space 15
      file_load 15,"JM-Intro.jpg"
      font_bold 15
      font_size 15,30
      print_target_is 15
      print_locate 1100,70
      print "Bonjour"
   picture 17 : rem Image de la carotte
      parent 17,10
      left 17,1140
      top 17,135
      width 17,100
      height 17,20
      file_load 17,"JM-Carotte.jpg"
      on_click 17,clic
      hide 17
   prepa()
   dlist 90 : rem Liste de travail du jeu
   
rem Construction de la faade du jeu ==========================================
   panel 100 : rem Base de la faade complte
      left 100,-1039
      width 100,2388
      height 100,720
      color 100,0,100,0
   alpha 200 : rem Base de la demande de la cliente
      parent 200,100
      left 200,1349
      width 200,1039
      height 200,35
      color 200,200,255,0
   alpha 210 : rem Texte de la demande de la cliente
      parent 210,100
      left 210,1364
      font_bold 210
      font_size 210,20
      font_name 210,"Arial"
      color 210,200,255,0
      font_color 210,0,0,255   
      caption 210,"Pour commencer  jouer, appuie sur le petit bonhomme vert qui te salue"
   alpha 220 : rem Base du paiement de la cliente
      parent 220,100
      width 220,1038
      height 220,35
      color 220,200,255,0
   alpha 230 : rem Texte du paiement de la cliente
      parent 230,100
      left 230,14
      font_bold 230
      font_size 230,20
      font_name 230,"Arial"
      color 230,200,255,0
      font_color 230,0,0,255
      caption 230,"BUREAU D'ENCAISSEMENT - Clique sur le bonhomme vert"
   alpha 240 : rem Affichage des commentaires du tableau de droite
      parent 240,100
      left 240,2130
      top 240,4
      font_bold 240
      font_size 240,18
      font_name 240,"Arial"
      color 240,200,255,0
      font_color 240,255,0,0
      hide 240
   alpha 250 : rem Affichage des commentaires du tableau de gauche
      parent 250,100
      left 250,730
      top 250,4
      font_bold 250
      font_size 250,18
      font_name 250,"Arial"
      color 250,200,255,0
      font_color 250,255,0,0 
      hide 250
   panel 260 : rem Affichage de l`invitation  cliquer flche gauche
      parent 260,100
      left 260,2120
      width 260,240
      height 260,35
      color 260,0,255,255
      hide 260
   alpha 262 : rem Texte de 260
      parent 262,260
      left 262,15
      top 262,4
      font_bold 262
      font_size 262,20
      font_name 262,"Arial"
      font_color 262,255,0,0
      caption 262,"CLIQUE sur"
   alpha 263 : rem Pourtour de la flche suivante
      parent 263,260
      left 263,180
      top 263,3
      width 263,50
      height 263,30
      color 263,255,255,0
   alpha 264 : rem Image de la flche dans 260
      parent 264,260
      left 264,185
      top 264,3
      font_bold 264
      font_size 264,20
      font_name 264,"Wingdings"
      font_color 264,0,0,255
      color 264,255,255,0
      caption 264,chr$(231)      
   panel 270 : rem Affichage de l`invitation  cliquer flche droite
      parent 270,100
      left 270,780
      width 270,240
      height 270,35
      color 270,0,255,255
      hide 270
   alpha 272 : rem Texte de 270
      parent 272,270
      left 272,15
      top 272,4
      font_bold 272
      font_size 272,20
      font_name 272,"Arial"
      font_color 272,255,0,0
      caption 272,"CLIQUE sur"
   alpha 273 : rem Fond de la flche suivante
      parent 273,270
      left 273,180
      top 273,3
      width 273,50
      height 273,30
      color 273,255,255,0
   alpha 274 : rem Image de la flche dans 270
      parent 274,270
      left 274,185
      top 274,3
      font_bold 274
      font_size 274,20
      font_name 274,"Wingdings"
      font_color 274,0,0,255
      color 274,255,255,0
      caption 274,chr$(232)
   panel 280 : rem Affichage de l`indication  se mettre en colre
      parent 280,100
      left 280,790
      width 280,225
      height 280,35
      color 280,0,255,255
      hide 280
   alpha 282 : rem Texte de 280
      parent 282,280
      left 282,15
      font_bold 282
      font_size 282,16
      font_name 282,"Arial"
      font_color 282,255,0,0
      caption 282,"CLIQUE sur"
   alpha 284 : rem Texte Grosse colre de 282
      parent 284,280
      left 284,15
      top 284,20
      font_bold 284
      font_name 284,"Arial"
      font_color 284,255,0,0
      caption 284,"G r o s s e   c o l  r e"
   picture 286 : rem Image de la colre dans 280
      parent 286,280
      left 286,145
      top 286,3
      width 286,43
      height 286,29
      stretch_on 286
      file_load 286,"JM-Colere.jpg"
   picture 288 : rem Flche de 280
      parent 288,280
      left 288,190
      top 288,3
      width 288,20
      height 288,29
      color 288,0,255,255
      2d_target_is 288
      2d_pen_width 3
      2d_line 2,2,18,27
      2d_line 18,27,9,23
      2d_line 18,27,18,19
   picture 300 : rem Affichage de la tronche de la cliente
      parent 300,100
      left 300,1039
      top 300,35
      width 300,310
      height 300,329
      file_load 300,"JM-Debut.jpg"
   picture 310 : rem Affichage du porte-monnaie
      parent 310,100
      left 310,821
      top 310,35
      width 310,218
      height 310,275
      file_load 310,"JM-Porte-monnaie.jpg"
   picture 320 : rem Affichage du billet tendu
      parent 320,100
      left 320,595
      top 320,50
      width 320,228
      height 320,150
      hide 320
   for V1M% = 1 to 6
      V2M%=V1M%*10+320 : rem N 330  380  pas de 10 - LIASSES
      picture V2M%
         parent V2M%,100
         left V2M%,V1M%*115+V1M%*2+211
         top V2M%,466-(V1M%-1)*4
         width V2M%,116+V1M%*2
         height V2M%,224+V1M%*4
         file_load V2M%,"JM-Liasse.jpg"
      V2M%=V1M%*10+380 : rem N 390  440  pas de 10 - BILLETS DE BANQUE
      picture V2M%
         parent V2M%,100
         left V2M%,V1M%*115+V1M%*2+218
         top V2M%,473-(V1M%-1)*4
         width V2M%,108+V1M%*2
         height V2M%,204+V1M%*4
         file_load V2M%,"JM-BV"+str$(VBV%(V1M%))+"e.jpg"
         on_click V2M%,clic
         inactive V2M%
   next V1M%
   scene2d 500 : rem Base verticale des pices de monnaie
      parent 500,100
      top 500,35
      width 500,328
      height 500,646
      color 500,0,100,0
      on_click 500,clic
      inactive 500
   scene2d 505 : rem Cache du haut de la base verticale
      parent 505,100
      top 505,35
      width 505,328
      height 505,318
      color 505,0,100,0
      hide 505
   scene2d 510 : rem Base horizontale des pices de maonnaie
      parent 510,100
      top 510,35
      width 510,821
      height 510,318
      color 510,0,100,0
      hide 510
      sprite_target_is 500
   for V1M% = 1 to 2 : rem Affichage des 2 premires pices rouges
      sprite V1M%*10+510 : rem N 520 et 530
         sprite_file_load V1M%*10+510,"JM-P"+str$(V1M%)+"c.bmp"
         sprite_position V1M%*10+510,(V1M%-1)*80+10,340-V1M%*8
   next V1M%
   sprite 540 : rem Pice de 5 centimes
      sprite_file_load 540,"JM-P5c.bmp"
      sprite_position 540,180,320
   for V1M% = 1 to 2 : rem Affichage des 2 premires pices jaunes
      sprite V1M%*10+540 : rem N 550 et 560
         sprite_file_load V1M%*10+540,"JM-P"+str$(V1M%*10)+"c.bmp"
         sprite_position V1M%*10+540,(V1M%-1)*90+5,430-V1M%*10
   next V1M%
   sprite 570 : rem Pice de 50 centimes
      sprite_file_load 570,"JM-P50c.bmp"
      sprite_position 570,205,405
   for V1M% = 1 to 2 : rem Affichage des pices de 1 et 2 
      sprite V1M%*10+570 : rem N 580 et 590
         sprite_file_load V1M%*10+570,"JM-P"+str$(V1M%)+"e.bmp"
         sprite_position V1M%*10+570,(V1M%-1)*150+10,540-V1M%*7
   next V1M%
   
rem Tableau d`aide ============================================================
   panel 700
      width 700,1349
      height 700,681
      hide 700
   picture 710
      parent 710,700
      full_space 710
      file_load 710,"JM-Intro.jpg"
      font_bold 710
      font_size 710,22
      font_color 710,0,0,255
      print_target_is 710
      print_locate 1070,55
      print "Clique sur les"
      print_locate 1085,95
      print "Boutons bleus"
   for V1M% = 1 to 4                  : rem N 720 et 730
      for V2M% = 1 to 2               : rem N 740 et 750
         V3M%=(V1M%-1)*20+V2M%*10+710 : rem N 760 et 770
         panel V3M%                   : rem N 780 et 790
            parent V3M%,700
            left V3M%,(V2M%-1)*250+50
            top V3M%,(V1M%-1)*165+22
            width V3M%,200
            height V3M%,144
            color V3M%,0,135,255
         picture V3M%+5               : rem N 725  735
            parent V3M%+5,V3M%        : rem N 745  755
            left V3M%+5,10            : rem N 765  775
            top V3M%+5,10             : rem N 785  795
            width V3M%+5,180
            height V3M%+5,120
            file_load V3M%+5,"JM-Aide"+str$((V1M%-1)*2+V2M%)+".jpg"
            on_click V3M%+5,clic
      next V2M%
   next V1M%
   panel 797
      parent 797,700
      left 797,1130
      top 797,518
      width 797,200
      height 797,144
      color 797,0,135,255
   picture 798
      parent 798,797
      left 798,10
      top 798,10
      width 798,180
      height 798,120
      file_load 798,"JM-Aide9.jpg"
      on_click 798,clic
   midi_on 
   midi_volume 127
   sound 9000
      
rem Fin des prparatifs de jeu ================================================
   balance(2000)
   pesee(2000,0)
   boutons(3000)
   menu(800)
   cagettes(1000)
   file_load 15,"JM-Intro.jpg"
   on_click 15,clic
   font_size 15,26
   print_target_is 15
   print_locate 1085,45
   print "Clique sur"
   print_locate 1070,85
   print "les carottes"
   show 17
   midi_instrument 112
   midi_play 80,10   
   
end : ' Dbut des routines ====================================================

sub achat(n%) : rem Gestion des achats des clientes ===========================
   dim_local v2ac% , v3ac%
   for v2ac% = 1 to 5
      if show(2150+v2ac%*10)=0
         show 2150+v2ac%*10
         top 2150+v2ac%*10,240-HVB%(n%)
         file_load 2150+v2ac%*10,NVB$(n%)
         caption 240,upper$(NFL$(n%))
         show 240
         if upper$(NFL$(n%))=right$(caption$(210),len(NFL$(n%)))
            if IMS%=0
               midi_instrument 97
               midi_play 60,10
            end_if
            active 3080
         else
            if IMS%=0
               midi_instrument 111
               midi_play 60,11
            end_if
            IVD%=1
         end_if
         pesee(2000,v2ac%*200)
         v3ac%=1
         exit_for
      end_if
   next v2ac%
   for v2ac% = 1 to 5
      if hide(2150+v2ac%*10)=1
         v3ac%=1
         exit_for
      end_if
   next v2ac%
   if v3ac%=0
      hide 240
      pause 90
      caption 240,"Videz la balance"
      show 240
      if IMS%=0
         midi_instrument 114
         midi_play 64,10
      end_if
   end_if
end_sub

sub aide() : rem Affichage de l`aide gnrale du jeu ==========================
   close_inactive
   show 700
   caption 0,TFA$
end_sub

sub balance(n%) : rem Gestion de la balance ===================================
   dim_local v1ca% , v2ca% , v3ca$
   panel n% : rem Support d`ensemble balance et caisse enregistreuse
      parent n%,100   
      left n%,1039
      top n%,364
      width n%,310
      height n%,265
      color n%,175,150,0
   panel n%+10 : rem Support de la balance
      parent n%+10,n%
      left n%+10,5
      top n%+10,75
      width n%+10,300
      height n%+10,100
   scene2d n%+20 : rem Cadran de la balance
      parent n%+20,n%+10
      full_space n%+20
      font_size n%+20,14
      font_color n%+20,0,255,255
      sprite_target_is n%+20
   for v1ca% = 1 to 6 : rem N N%+30  n%+80 (chiffres de la balance)
      if v1ca%=1
         v2ca%=0
      else
         v2ca%=12
      end_if
      if v1ca%=6
         v3ca$="1Kg"
      else
         v3ca$=str$((v1ca%-1)*200)
      end_if
      sprite n%+v1ca%*10+20 : rem Affichage des chiffres de la balance
         sprite_text n%+v1ca%*10+20,v3ca$
         sprite_position n%+v1ca%*10+20,(v1ca%-1)*50+10-v2ca%,5
   next v1ca%
   sprite n%+90 : rem Affichage de la flche de la balance
      sprite_file_load n%+90,"JM-Fleche.bmp"
      sprite_position n%+90,1,30
   picture n%+100 : rem Affichage du plateau de la balance
      parent n%+100,n%
      left n%+100,5
      top n%+100,240
      width n%+100,300
      height n%+100,20
      file_load n%+100,"JM-Plateau.jpg"
   alpha n%+110 : rem Affichage du fond de la caisse enregistreuse
      parent n%+110,n%
      left n%+110,5
      top n%+110,5
      width n%+110,300
      height n%+110,65
      color n%+110,0,0,0
   alpha n%+120 : rem Affiche de l`indication Total
      parent n%+120,n%
      left n%+120,50
      top n%+120,10
      font_bold n%+120
      font_size n%+120,16
      font_name n%+120,"Arial"
      font_color n%+120,255,0,0
      color n%+120,0,0,0
      caption n%+120,"TOTAL :"
   alpha n%+130 : rem Affichage du rsultat de la pese
      parent n%+130,n%
      left n%+130,20
      top n%+130,40
      font_bold n%+130
      font_size n%+130,13
      font_name n%+130,"Arial"
      font_color n%+130,255,255,0
      color n%+130,0,0,0
      caption n%+130,ABV$
   alpha n%+140 : rem Affichage du cumul  payer
      parent n%+140,n%
      left n%+140,170
      top n%+140,10
      font_bold n%+140
      font_size n%+140,16
      font_name n%+140,"Arial"
      font_color n%+140,255,0,0
      color n%+140,0,0,0
      caption n%+140,"0 "
   alpha n%+150 : rem : rem Affichage du fond du dessus du plateau
      parent n%+150,n%
      left n%+150,5
      top n%+150,180
      width n%+150,300
      height n%+150,60
      color n%+150,255,255,255
   for v1ca% = 1 to 5 : rem Affichage des fruits et lgumes
      picture n%+v1ca%*10+150
         parent n%+v1ca%*10+150,n%
         left n%+v1ca%*10+150,(v1ca%-1)*60+5
         top n%+v1ca%*10+150,115
         width n%+v1ca%*10+150,60
         height n%+v1ca%*10+150,60
         color n%+v1ca%*10+150,255,255,255
         hide n%+v1ca%*10+150
   next v1ca%
end_sub

sub billets() : rem Gestion des billets rendus aux clientes ===================
   dim_local v1bi% : rem Variables  utilisation multiple
   dim_local nbi% : rem Numro des billets
   LHB%=LHB%+20
   if LHB%>140
      LVB%=LVB%+30
      LHB%=20
   end_if
   if LVB%>160
      LVB%=50
      LHB%=20
   end_if 
   hide 250                     
   nbi%=(number_click/10)-38
   if NBS%<8000
      NBS%=NBS%+1
      if IMS%=0
         file_load 9000,"JM-Billet.mp3"
         play 9000
      end_if
      picture NBS%
         parent NBS%,100
         left NBS%,nbi%*115+nbi%*2+218
         top NBS%,473-(nbi%-1)*4
         width NBS%,108+nbi%*2
         height NBS%,204+nbi%*4
         file_load NBS%,"JM-BV"+str$(VBV%(nbi%))+"e.jpg"
         for v1bi% = 1 to 240 step 2
            if nbi%>3
               left NBS%,nbi%*115+nbi%*2+218-v1bi%
            else
               left NBS%,nbi%*115+nbi%*2+218
            end_if
            top NBS%,473-(nbi%-1)*4-v1bi%
            display
         next v1bi%
         for v1bi% = left(NBS%) to 330 step -2
            left NBS%,v1bi%
            display
         next v1bi%
         for v1bi% = top(NBS%) to 50 step -2
            top NBS%,v1bi%
            display
         next v1bi%
         for v1bi% = left(NBS%) to 330+LHB% step 2
            left NBS%,v1bi%
            if LVB%>top(NBS%)
               top NBS%,LVB%
            end_if
            display
         next v1bi%
         TRC=TRC+VBV%(nbi%)
   end_if 
   montre()      
end_sub

sub boutons(n%) : rem Gestion des boutons situs sous la balance ==============
   dim_local v1bo%
   panel n% : rem Support des boutons
      parent n%,100
      left n%,1039
      top n%,629
      width n%,310
      height n%,52
   for v1bo% = 1 to 4 : rem N n%+10  n%+40 - Premire range de boutons
      panel v1bo%*10+n%                  : rem Bouton vers la gauche        (1)
         parent v1bo%*10+n%,n%           : rem Bouton vider la balance      (2)
         left v1bo%*10+n%,(v1bo%-1)*77+2 : rem Bouton aide du tableau droit (3)
         width v1bo%*10+n%,75            : rem Bouton vers la droite        (4)
         height v1bo%*10+n%,50
         font_bold v1bo%*10+n%
         font_size v1bo%*10+n%,30
         font_color v1bo%*10+n%,0,0,255
         font_name v1bo%*10+n%,"Wingdings"
         on_click v1bo%*10+n%,clic
   next v1bo%
   color n%+10,255,255,0
   color n%+40,255,255,0
   caption n%+10,chr$(231)
   caption n%+40,chr$(232)
   inactive n%+40
   picture n%+25 : rem Affichage du symbole pour vider la balance
      parent n%+25,n%+20
      full_space n%+25
      file_load n%+25,"JM-Vider1.jpg"
      on_click n%+25,clic
   picture n%+35 : rem Affichage du symbole de l`aide (pour le tableau droit)
      parent n%+35,n%+30
      full_space n%+35
      file_load n%+35,"JM-Aide.jpg"
      on_click n%+35,clic
   for v1bo% = 1 to 4 : rem N n%+50  n%+80    - Deuxime range de boutons
      panel v1bo%*10+n%+40                  : rem Bouton porte-monnaie         (1)
         parent v1bo%*10+n%+40,n%           : rem Bouton vider le bureau       (2)
         left v1bo%*10+n%+40,(v1bo%-1)*77+2 : rem Bouton aide du tableau droit (3)
         width v1bo%*10+n%+40,75            : rem Bouton grosse colre         (4)
         height v1bo%*10+n%+40,50
         font_bold v1bo%*10+n%+40
         font_size v1bo%*10+n%+40,30
         font_color v1bo%*10+n%+40,0,0,255
         font_name v1bo%*10+n%+40,"Wingdings"
         hide v1bo%*10+n%+40
   next v1bo%
   show n%+80
   inactive n%+80
   picture n%+55 : rem Affichage du symbole du porte-monnaie
      parent n%+55,n%+50
      full_space n%+55
      file_load n%+55,"JM-Empocher.jpg"
      on_click n%+55,clic
   picture n%+65 : rem Affichage du symbole pour vider le bureau d`encaissement
      parent n%+65,n%+60
      full_space n%+65
      file_load n%+65,"JM-Vider2.jpg"
      on_click n%+65,clic
   picture n%+75 : rem Affichage du symbole d`aide pour le tableau gauche
      parent n%+75,n%+70
      full_space n%+75
      file_load n%+75,"JM-Aide.jpg"
      on_click n%+75,clic
   picture n%+85 : rem Affichage du panier o mettre les produits achets
      parent n%+85,n%+80
      full_space n%+85
      file_load n%+85,"JM-Panier.jpg"
      on_click n%+85,clic
   panel n%+90 : rem Bouton supplmentaire pour dbuter la partie
      parent n%+90,n%
      left n%+90,2
      width n%+90,75
      height n%+90,50
   picture n%+95 : rem Affichage du symbole de dbut de jeu
      parent n%+95,n%+90
      full_space n%+95
      file_load n%+95,"JM-Salut.jpg"
      on_click n%+95,clic
   panel n%+100 : rem Bouton supplmentaire pour la grosse colre
      parent n%+100,n%
      left n%+100,233
      width n%+100,75
      height n%+100,50
      hide n%+100
   picture n%+105 : rem Affichage du symbole de la grosse colre
      parent n%+105,n%+100
      full_space n%+105
      file_load n%+105,"JM-Colere.jpg"
      on_click n%+105,clic
   panel n%+110 : rem Bouton de bruits divers
      parent n%+110,n%
      left n%+110,2
      width n%+110,75
      height n%+110,50
      hide n%+110
   picture n%+115 : rem Affichage du symbole de bruits
      parent n%+115,n%+110
      full_space n%+115
      file_load n%+115,"JM-Trompette.jpg"
      on_click n%+115,clic
   panel n%+120 : rem Affichage du bonhomme vert de suite du jeu
      parent n%+120,n%
      left n%+120,233
      width n%+120,75
      height n%+120,50
      hide n%+120
   picture n%+125 : rem Affichage du bonhomme vert de continuation du jeu
      parent n%+125,n%+120
      full_space n%+125
      file_load n%+125,"JM-Bonhomme.jpg"
      on_click n%+125,clic    
end_sub

sub cagettes(n%) : rem Gestion du remplissage des cagettes ====================
   dim_local v1ca% , v2ca% , v3ca$
   picture n%
      parent n%,100
      left n%,1348
      top n%,35
      width n%,1040
      height n%,646
      color n%,240,200,85
   for v1ca% = 1 to 7                                        : rem n%+10  n%+80 
      for v2ca% = 1 to 8                                     : rem n%+90  n%+160
         picture (v1ca%-1)*80+v2ca%*10+n%                    : rem n%+170  n%+240
            parent (v1ca%-1)*80+v2ca%*10+n%,100              : rem n%+250  n%+320
            left (v1ca%-1)*80+v2ca%*10+n%,(v2ca%-1)*130+1350 : rem n%+330  n%+400
            top (v1ca%-1)*80+v2ca%*10+n%,(v1ca%-1)*92+37     : rem n%+410  n%+480
            width (v1ca%-1)*80+v2ca%*10+n%,125               : rem n%+490  n%+560
            height (v1ca%-1)*80+v2ca%*10+n%,90
            on_click (v1ca%-1)*80+v2ca%*10+n%,clic
            inactive (v1ca%-1)*80+v2ca%*10+n%
      next v2ca%
   next v1ca%
   v1ca%=1
   v3ca$=file_find_first$
   while v3ca$<>"_"
      if right$(v3ca$,6)="_p.jpg"
         NVC$(v1ca%)=v3ca$
         NFL$(v1ca%)=mid$(v3ca$,4,len(v3ca$)-9)
         file_load v1ca%*10+1000,NVC$(v1ca%)
         v1ca%=v1ca%+1
      end_if
      v3ca$=file_find_next$
   end_while
   file_find_close
   v1ca%=1
   v3ca$=file_find_first$
   while v3ca$<>"_"
      if right$(v3ca$,6)="-b.jpg"
         NVB$(v1ca%)=v3ca$
         v2ca%=instr(v3ca$,"_")
         HVB%(v1ca%)=val(mid$(v3ca$,v2ca%+1,2))
         v1ca%=v1ca%+1
      end_if
      v3ca$=file_find_next$
   end_while
   file_find_close
   for v1ca% = 1 to 6
      for v2ca% = 1 to 56
         if v2ca%=NVA%(v1ca%)
            NFL$(v2ca%)=NVA$(v1ca%)
            exit_for
         end_if
      next v2ca%
   next v1ca%
end_sub

fnc choix1() : rem Choix d`un aliment  acheter ===============================
   dim_local v1ch% , v2ch% , v3ch%
   repeat
      v1ch%=int(rnd(56))+1
      v3ch%=0
      if count(90)>0 and count(90)<50
         for v2ch% = 1 to count(90)
            if item_read$(90,v2ch%)=str$(v1ch%)
               v3ch%=1
               exit_for
            end_if
         next v2ch%
      end_if
   until v3ch%=0
   item_add 90,v1ch%
   result v1ch%
end_fnc

fnc choix2() : rem Choix de la quantit  acheter =============================
   dim_local v1c2%
   v1c2%=int(rnd(5))+1
   QDC%=v1c2%
   v1c2%=v1c2%*200
   result v1c2%
end_fnc

clic: : rem Gestion de tous les on-clicks =====================================
   inactive 100
   select number_click
      case 15 : intro()
      case 17 : intro()
      case 500 : pieces()
      case 798 : sortir()
      case 810 : submenu(800)
      case 814 : submenu(800)
      case 816 : submenu(800)
      case 820 : rejouer()
      case 830 : aide()
      case 840 : sons()
      case 850 : quitter()
      case 920 : rejouer()
      case 930 : aide()
      case 940 : sons()
      case 950 : quitter()
      case 3010 : gauche()
      case 3025 : vider1()
      case 3035 : pleure()
      case 3040 : droite()
      case 3055 : empocher()
      case 3065 : vider2()
      case 3075 : pleurer()
      case 3085 : panier()
      case 3095 : debut()
      case 3105 : colere()
      case 3115 : trompette()
      case 3125 : continuer()
   end_select
   if number_click>1000 and number_click<1600
      V1M%=(number_click-1000)/10
      achat(V1M%)
   end_if
   if number_click>724 and number_click<796
       voix()
   end_if
   if number_click>389 and number_click<441
      billets()
   end_if
   active 100
return

sub clientes() : rem Affichage de la tronche de la cliente concerne ==========
   dim_local v1cl% , v2cl$ , v3cl%
   v1cl%=int(rnd(134))+1
   v3cl%=int(rnd(2))+1
   if v3cl%=2
      v1cl%=135-v1cl%
   end_if
   v2cl$=str$(v1cl%)
   if len(v2cl$)<2
      v2cl$="0"+v2cl$
   end_if
   if len(v2cl$)<3
      v2cl$="0"+v2cl$
   end_if
   file_load 300,"JM-F-"+v2cl$+".jpg"
end_sub

close: : rem Gestion de l`on-close ============================================
   if IMS%=0 and show(700)=1
      beep
   end_if
   caption 0,""
   pause 200
   caption 0,"   Pour sortir de ce tableau, clique sur le bouton n 9"
return

sub colere() : rem La cliente a refil de la fausse monnaie ===================
   dim_local v1cl% , v2cl%
   if SDC%=999
      hide 280
      display
      caption 250,"A l'ARNAQUE !!!"
      show 250
      if IMS%=0
         midi_instrument 87
         midi_play 21,10
      end_if
      v2cl%=int(rnd(2))+1
      if v2cl%=1
         file_load 9000,"JM-Colere.mp3"
      else
         file_load 9000,"JM-Quoi.mp3"
      end_if
      if IMS%=0
         play 9000
      end_if
      pause 2000
      hide 320
      pause 200
      repeat
         v1cl%=int(rnd(6))+1
      until VBV%(v1cl%)>TAP
      file_load 320,"JM-BH"+str$(VBV%(v1cl%))+"e.jpg"
      caption 230,"Oups pardon, je me suis trompe. Voici "+str$(VBV%(v1cl%))+" euros"
      show 320
      if IMS%=0
         file_load 9000,"JM-Oups.mp3"
         play 9000
      end_if
      SDC%=VBV%(v1cl%)
      vider2()
      inactive 3040
      left 320,595
      hide 250
      hide 280
      TRC=0
   else
      if IMS%=0
         file_load 9000,"JM-Gargamel.mp3"
         play 9000
      end_if
   end_if
end_sub

sub continuer() : rem Pour faire dbuter le tableau de gauche =================
   dim_local v1co% , v2co% , v3co$
   v3co$=". Rends-moi la monnaie"
   hide 3120
   show 3100
   v1co%=int(rnd(3))+1
   if v1co%=3
      repeat
         v2co%=int(rnd(17))+1
      until VFM%(v2co%)>TAP
      file_load 320,"JM-FM"+str$(VFM%(v2co%))+"e.jpg"
      caption 230,"Voici un billet de "+str$(VFM%(v2co%))+" euros"+v3co$
      SDC%=999     
   else
      repeat
         v2co%=int(rnd(6))+1
      until VBV%(v2co%)>TAP
      file_load 320,"JM-BH"+str$(VBV%(v2co%))+"e.jpg"
      caption 230,"Voici un billet de "+str$(VBV%(v2co%))+" euros"+v3co$
      SDC%=VBV%(v2co%)
      inactive 3040
   end_if
   show 320
   if v1co%=3 and (v2co%=3 or v2co%=4 or v2co%=5)
      left 320,671
      caption 230,"Voici une pice de "+str$(VFM%(v2co%))+" euros"+v3co$
      SDC%=999
   else
      left 320,595
   end_if
   for v1co% = 390 to 440 step 10
      active v1co%
   next v1co%
   active 500
   if IMS%=0
      file_load 9000,"JM-Allez-hop.mp3"
      play 9000
   end_if
end_sub 

rem Datas =====================================================================
   data 5 , 10 , 20 , 50 , 100 , 200 , "1c" , "2c" , "5c" , "10c" , "20c" , "50c" , "1e" , "2e"
   data 0.01 , 0.02 , 0.05 , 0.10 , 0.20 , 0.50 , 1 , 2
   data "CLERI",12,"CHTAIGNES",15,"CLMENTINES",18,"FVES",24,"MRES",32,"PCHES",43
   data 10,73,332,395,90,165,324,399,180,263,320,403,5,83,420,498
   data 95,193,410,508,205,318,405,518,10,115,533,638,160,280,526,646
   data 3.5,18.8,3,3.5,7.5,3.2,20,1.75,1.3,7,0.85,1.2,14,2.3,6.85,1.3,1.8,1.25
   data 0.9,2.4,11.9,1.85,1.6,1.5,2.35,7.8,34,30.6,6.1,2.5,2.5,36,32,1.6,5.9
   data 8.6,5,1.7,1.35,1.5,1.7,1.8,25,4.5,20,1.1,1.2,2.85,1,1,1.5,2.1,1,3.6,1.1,2.2
   data "Boing","Carillon","Klaxon","Reveil","Sonnette","Telephone","Trompet","Velo"
   data 1 , 2 , 3 , 5 , 6 , 12 , 15 , 22 , 25 , 30 , 122 , 150 , 250 , 300 , 520 , 600 , 1000
   data "Tu vends des fruits et des lgumes"
   data "Tu les pses sur la balance"
   data "Tu tiens la caisse"
   data "La cliente te paie"
   data "Tu rends la monnaie"
   data "Fais bien attention aux arnaqueuses"
   data "Tu passes  la cliente suivante"
   data "Si tu ne comprends pas quelque chose, clique sur le bonhomme bleu qui pleure"
rem Fin des datas

sub debut() : rem Dbut du jeu ================================================
   dim_local v1de%
   hide 3090
   show 3110
   active 3080
   clientes()
   if IMS%=0
      file_load 9000,"JM-Bonjour.mp3"
      play 9000
   end_if
   for v1de% = 1010 to 1560 step 10
      active v1de%
   next v1de%
   demande()
end_sub

sub demande() : rem Choix de ce que demande la cliente ========================
   dim_local v1de% , v2de% , v3de$ , v4de$ , v5de$ , v6de$
   v1de%=choix1()
   v2de%=choix2()
   if TAP>0
      v3de$="aussi "
   end_if
   v4de$=upper$(NFL$(v1de%))
   v5de$=left$(v4de$,1)
   if v5de$="A" or v5de$="E" or v5de$="O"
      v6de$="'"
   else
      v6de$="e "
   end_if
   if v2de%=1000
      caption 210,"Je voudrais "+v3de$+"1 Kilo d"+v6de$+v4de$
   else
      caption 210,"Je voudrais "+v3de$+str$(v2de%)+" grammes d"+v6de$+v4de$
   end_if
end_sub

sub droite() : rem Passage au tableau de la dlivrance des vgtaux ===========
   dim_local v1dr%
   hide 3050
   hide 3060
   hide 3070
   show 3080
   inactive 3080
   inactive 3040
   for v1dr%= 1 to -1039 step -100
      left 100,v1dr%
      pause 1
      display
   next v1dr%
   left 100,-1039
   top 320,50
   show 3090
   color 320,255,255,255
   hide 240
   hide 250
   hide 270
   clear 90
end_sub

sub empocher() : rem La cliente empoche billets et pices =====================
   dim_local v1em% , v2em%
   if SDC%<>999
      if TRC+TAP=SDC%
         for v1em% = 50 to 360 step 3
            top 320,v1em%
            display
         next v1em%
         top 320,460
         pause 1
         caption 230,"Attends, je recompte"
         if NBS%>6999
            if IMS%=0
               file_load 9000,"JM-Billet.mp3"
               play 9000
            end_if
            for v1em% = NBS% to 7000 step -1
               for v2em% = left(v1em%) to 720 step 4
                 left v1em%,v2em%
                  display
               next v2em%
               delete v1em%
               pause 1
            next v1em%
         end_if
         NBS%=6999
         pause 1
         show 505
         show 510
         sprite_target_is 510
         if NPS%>4999
            if NPS%<5016
               for v1em% = NPS%+1000 to 6000 step -1
                  for v2em% = 180 to 830 step 10
                     sprite_position v1em%,v2em%,140
                     display
                  next v2em%
                  pause 1
               next v1em%
            else
               for v1em% = 0 to 821 step 10
                  left 510,v1em%
                  width 510,821-v1em%
                  display
                  pause 1
               next v1em%
            end_if
            if IMS%=0
               file_load 9000,"JM-Piece.mp3"
               play 9000
            end_if
            pause 200
         end_if
         vider2()
         hide 505
         hide 510
         left 510,0
         width 510,821
         caption 230,"Oui, BRAVO !  C'est bien a !  C'est SUPER !"
         if IMS%=0
            file_load 9000,"JM-Au-revoir.mp3"
            play 9000
         end_if
         hide 3100
         active 3040
         file_load 300,"JM-Debut.jpg"
         caption 2140,"0 "
         show 270
         hide 310
         caption 210,"Pour continuer, appuie sur le petit bonhomme vert qui te salue"
         TAP=0
         TRC=0
         for v1em% = 390 to 440 step 10
            inactive v1em%
         next v1em%
         inactive 500 
      else
         if caption$(2140)<>"0 " and show(3120)=0
            caption 250,"Non, ERREUR"
            show 250
            if IMS%=0
               file_load 9000,"JM-Pouet.mp3"
               play 9000
            end_if
            vider2()
            TRC=0
         end_if
      end_if
   else
      if IMS%=0
         file_load 9000,"JM-Pouet.mp3"
         play 9000
      end_if
      show 250
      caption 250,"Non, FAUSSE MONNAIE"
   end_if
   hide 280
end_sub

sub gauche() : rem Passage au tableau du paiement final =======================
   dim_local v1ga%
   show 3050
   show 3060
   show 3070
   hide 3080
   hide 320
   for v1ga% = -1039 to 1 step 100
      left 100,v1ga%
      pause 1
      display
   next v1ga%
   left 100,1
   active 3040
   show 3120
   hide 250
   hide 260
   show 310
   caption 230,"BUREAU D'ENCAISSEMENT - Clique sur le bonhomme vert"
end_sub

sub intro() : rem Engagement du jeu  partir des carottes de l`intro ==========
   dim_local v1in%
   if mouse_x_position(15)>40 and mouse_x_position(15)<290
      if mouse_y_position(15)>255 and mouse_y_position(15)<350
         hide 10
         v1in%=1
         file_load 9000,"JM-Allez-hop.mp3"
      end_if
   end_if
   if v1in%=0
      file_load 9000,"JM-Pouet.mp3"
   end_if
   if IMS%=0
      play 9000
   end_if
end_sub

sub menu(n%) : rem Gestion des commandes du menu largi =======================
   dim_local v1me%
   panel n%
      parent n%,100
      left n%,1039
      top n%,-170
      width n%,310
      height n%,200
      font_bold n%
      font_size n%,26
      font_name n%,"Arial"
      font_color n%,0,0,255      
   for v1me% = 1 to 4
      alpha v1me%*10+n%+10 : rem N = n+20  n+50
         parent v1me%*10+n%+10,n%
         top v1me%*10+n%+10,(v1me%-1)*50
         width v1me%*10+n%+10,310
         height v1me%*10+n%+10,48
         color v1me%*10+n%+10,100,255,0
         on_click v1me%*10+n%+10,clic
      alpha v1me%*10+n%+110 : rem N = n+120  n%+150  
         parent v1me%*10+n%+110,n%
         left v1me%*10+n%+110,90
         top v1me%*10+n%+110,(v1me%-1)*50+4
         color v1me%*10+n%+110,100,255,0
         on_click v1me%*10+n%+110,clic
   next v1me%
   left n%+130,110
   caption n%+120,"Rejouer"
   caption n%+130,"Aide"
   caption n%+140,"Sons  +"
   caption n%+150,"Quitter"         
   panel n%+10
      parent n%+10,100
      left n%+10,1039
      width n%+10,310
      height n%+10,35
      color n%+10,255,255,0
      font_bold n%+10
      font_size n%+10,20
      font_name n%+10,"Arial"
      font_color n%+10,0,0,255
      caption n%+10,"M E N U"
      on_click n%+10,clic 
   alpha n%+14
      parent n%+14,n%+10
      left n%+14,35
      font_bold n%+14
      font_size n%+14,20
      font_name n%+14,"Wingdings"
      font_color n%+14,255,0,0
      caption n%+14,chr$(244)
      on_click n%+14,clic
   alpha n%+16
      parent n%+16,n%+10
      left n%+16,250
      font_bold n%+16
      font_size n%+16,20
      font_name n%+16,"Wingdings"
      font_color n%+16,255,0,0
      caption n%+16,chr$(244)
      on_click n%+16,clic     
end_sub

sub montre() : rem Montre progressivement le total rendu ======================
   dim_local v1mo$ , v2mo%
   v1mo$=str$(TRC)
   v2mo%=instr(v1mo$,".")
   if v2mo%>0
      v1mo$=left$(v1mo$,v2mo%-1)+","+right_pos$(v1mo$,v2mo%+1)
      if len(v1mo$)-v2mo%<2
         v1mo$=v1mo$+"0"
      end_if
   end_if 
   if left$(caption$(230),7)="Tu dois"
      caption 250,v1mo$+" euros"
      show 250
   end_if
end_sub

sub panier() : rem Mise des vgtaux pess dans le panier =====================
   dim_local v1pa% , v2pa% , v3pa$ , v4pa% , v5pa%
   for v1pa% = 1 to 5
      if show(v1pa%*10+2150)=1
         v2pa%=v2pa%+1
      end_if
   next v1pa%
   TAP=TAP+PTP
   v3pa$=str$(TAP)
   v4pa%=instr(v3pa$,".")
   if v4pa%>0
      v3pa$=left$(v3pa$,v4pa%-1)+","+right_pos$(v3pa$,v4pa%+1)
   end_if
   v4pa%=instr(v3pa$,",")
   if (v4pa%>0) and ((len(v3pa$)-v4pa%)<2)
      v3pa$=v3pa$+"0"
   end_if
   if v2pa%=QDC% and IVD%=0
      caption 2140,v3pa$+" "
      if IMS%=0
         file_load 9000,"JM-Caisse.mp3"
         play 9000
      end_if
      caption 2130,ABV$
      vider1()
      v5pa%=int(rnd(4))+1
      if v5pa%<>4 and TAP<161
         demande()
      else
         caption 210,"MERCI, ce sera tout pour aujourd'hui"
         hide 3110
         show 260
         inactive 3080
         inactive 3040
         for v1pa% = 1010 to 1560 step 10
            inactive v1pa%
         next v1pa%
         if IMS%=0
            midi_instrument 116
            midi_play 108,10
         end_if
      end_if
   else
      if IMS%=0
         file_load 9000,"JM-Pouet.mp3"
         play 9000
      end_if
      caption 240,"Erreur, recommence"
      show 240
   end_if
end_sub

sub pesee(n%,q%) : rem Pese des vgtaux mis sur la balance ==================
   dim_local v1pe$ , v2pe% , v3pe$ , v4pe%
   sprite_position n%+90,int(q%/4),30
   v2pe%=(number_click/10)-100
   if q%=1000
      v1pe$="1,000 Kg"
   else
      v1pe$="0,"+str$(q%)+" Kg"
   end_if
   if q%>0
      if IVD%=0
         v3pe$=str$((q%/1000)*PVK(v2pe%))
         PTP=(q%/1000)*PVK(v2pe%)
         v4pe%=instr(v3pe$,".")
         if v4pe%>0
            v3pe$=left$(v3pe$,v4pe%-1)+","+right_pos$(v3pe$,v4pe%+1)
         end_if
         v4pe%=instr(v3pe$,",")
         if (v4pe%>0) and ((len(v3pe$)-v4pe%)<2)
            v3pe$=v3pe$+"0"
         end_if
         caption 2130,v1pe$+"  x  "+PVK$(v2pe%)+" /Kg  =  "+v3pe$+" "
      else
         caption 2130,ABV$
      end_if
   end_if
end_sub
      
sub pieces() : rem Gestion des pices de monnaie rendues ======================
   dim_local hpi% , vpi% : rem Coordonnes des pices de base
   dim_local v1pi% , v2pi% : rem Variables  utilisation multiple
   dim_local vvpi% : rem Distance alatoire  parcourir 
   hpi%=mouse_x_position(500)
   vpi%=mouse_y_position(500)
   vvpi%=int(rnd(190))+1
   for v2pi% = 1 to 8
      if hpi%>CDP%(v2pi%) and hpi%<CFP%(v2pi%) and vpi%>CHP%(v2pi%) and vpi%<CBP%(v2pi%)
         NPS%=NPS%+1
         if NPS%<6000
            sprite_target_is 500
            sprite NPS%
               sprite_file_load NPS%,"JM-P"+VPM$(v2pi%)+".bmp"
               sprite_position NPS%,CDP%(v2pi%),CHP%(v2pi%)
            for v1pi% = CHP%(v2pi%) to vvpi% step -5
               sprite_position NPS%,CDP%(v2pi%),v1pi%
               display
            next v1pi%
            sprite_position NPS%,CDP%(v2pi%),vvpi%
            sprite_target_is 510
            sprite NPS%+1000
               sprite_file_load NPS%+1000,"JM-P"+VPM$(v2pi%)+".bmp"
               sprite_position NPS%+1000,CDP%(v2pi%),vvpi%
            TRC=TRC+VPM(v2pi%)
            if IMS%=0
               file_load 9000,"JM-Piece.mp3"
               play 9000
            end_if
            exit_for
         end_if
      end_if
   next v2pi%
   hide 250
   montre()
end_sub

sub pleure() : rem Gestion de l`aide propose au tableau de droite ============
   dim_local v1pl% , v2pl% , v3pl%
   if hide(3090)=1 
      if right$(caption$(210),4)=right$(caption$(240),4) and IVD%=0
         2d_target_is 3085
         2d_fill_color 255,0,0
         2d_circle 37,25,15
         pause 250
         file_load 3085,"JM-Panier.jpg"
      else
         for v1pl% = 1 to 7
            for v2pl% = 1 to 8
               if upper$(NFL$((v1pl%-1)*8+v2pl%))=right$(caption$(210),len(NFL$((v1pl%-1)*8+v2pl%)))
                  hide (v1pl%-1)*80+v2pl%*10+1000
                  pause 90
                  show (v1pl%-1)*80+v2pl%*10+1000
                  v3pl%=1
                  exit_for
               end_if
            next v2pl%
            if v3pl%=1
               exit_for
            end_if
         next v1pl%
         hide 240
      end_if
   end_if
   if IMS%=0
      midi_volume 114
      midi_play 88,10
   end_if
end_sub

sub pleurer() : rem Gestion de l`aide propose au tableau de gauche ===========
   dim_local v1pr$ , v2pr%
   if hide(3120)=1 and caption$(2140)<>"0 "
      if SDC%=999
         hide 250
         display
         show 280
         if IMS%=0
            file_load 9000,"JM-Ohoh.mp3"
            play 9000
         end_if
      else
         v1pr$=str$(abs(SDC%-TAP))
         v2pr%=instr(v1pr$,".")
         if v2pr%>0
            v1pr$=left$(v1pr$,v2pr%-1)+","+right_pos$(v1pr$,v2pr%+1)
            if len(v1pr$)-v2pr%<2
               v1pr$=v1pr$+"0"
            end_if
         end_if   
         caption 230,"Tu dois rendre : "+v1pr$+" euros"
         if IMS%=0
            midi_instrument 100
            midi_play 60,10
         end_if
      end_if
   end_if
end_sub 

sub prepa() : rem Prparation du jeu ==========================================
   for V1M% = 1 to 6 : read VBV%(V1M%) : next V1M%
   for V1M% = 1 to 8 : read VPM$(V1M%) : next V1M%
   for V1M% = 1 to 8 : read VPM(V1M%) : next V1M%
   for V1M% = 1 to 6 : read NVA$(V1M%) : read NVA%(V1M%) : next V1M%
   for V1M% = 1 to 8
      read CDP%(V1M%) : read CFP%(V1M%) : read CHP%(V1M%) : read CBP%(V1M%)
   next V1M%
   for V1M% = 1 to 56 : read PVK(V1M%) : PVK$(V1M%)=str$(PVK(V1M%)) : next V1M%
   for V1M% = 1 to 56
      V2M%=instr(PVK$(V1M%),".")
      if V2M%>0
         PVK$(V1M%)=left$(PVK$(V1M%),V2M%-1)+","+right_pos$(PVK$(V1M%),V2M%+1)
      end_if
      V2M%=instr(PVK$(V1M%),",")
      if (V2M%>0) and ((len(PVK$(V1M%))-V2M%)<2)
         PVK$(V1M%)=PVK$(V1M%)+"0"
      end_if
   next V1M%
   for V1M% = 1 to 8 : read NDS$(V1M%) : next V1M%
   for V1M% = 1 to 17 : read VFM%(V1M%) : next V1M%
   for V1M% = 1 to 8 : read TVA$(V1M%) : next V1M%
end_sub

sub quitter() : rem Quitter le jeu ============================================
   midi_off
   terminate
end_sub

sub rejouer() : rem Le joueur demande  recommencer le jeu ====================
   dim_local v1re%
   IVD%=0
   vider1()
   vider2()
   NBS%=6999
   NPS%=4999
   PTP=0
   TAP=0
   TRC=0
   caption 210,"Pour commencer  jouer, appuie sur le petit bonhomme vert qui te salue"
   for v1re% = 240 to 280 step 10
      hide v1re%
   next v1re%
   file_load 300,"JM-Debut.jpg"
   hide 320
   for v1re% = 390 to 440 step 10
      inactive v1re%
   next v1re%
   inactive 500
   caption 2130,ABV$
   caption 2140,"0 "
   for v1re% = 2160 to 2200 step 10
      hide v1re%
   next v1re%
   hide 3060
   hide 3070
   show 3080
   inactive 3080
   show 3090
   hide 3100
   hide 3110
   hide 3120
   if left(100)>-100
      droite()
   end_if
   clear 90
   submenu(800)
end_sub

sub sons() : rem Couper le son ou le remettre =================================
   if IMS%=0 
      IMS%=1 : rem Mode silencieux
      caption 940,"Sons  "
   else
      IMS%=0 : rem Mode bruyant
      caption 940,"Sons  +"
      midi_instrument 112
      midi_play 80,10
   end_if
   pause 200
   submenu(800)
end_sub

sub sortir() : rem Sortie du panneau d`aide ===================================
   if IMS%=0
      midi_instrument 112
      midi_play 80,10
   end_if
   hide 700
   submenu(800)
   close_active
   caption 0,TGP$
end_sub

sub submenu(n%) : rem Apparition ou disparition des submenus ==================
   dim_local v1su%
   if top(n%)<0
      for v1su% = top(n%) to 35 step 10
         top n%,v1su%
         pause 1
      next v1su%
   else
      for v1su% = top(n%) to -170 step -10
         top n%,v1su%
         pause 1
      next v1su%
   end_if
end_sub

sub trompette() : rem Bouton qui fait des bruits ==============================
   dim_local v1tr%
   v1tr%=int(rnd(8))+1
   if IMS%=0
      file_load 9000,"JM-"+NDS$(v1tr%)+".mp3"
      play 9000
   end_if
end_sub

sub vider1() : rem Vider la balance ===========================================
   dim_local v1vi%
   pesee(2000,0)
   for v1vi% = 1 to 5
      hide 2150+v1vi%*10
   next v1vi%
   hide 240
   if IMS%=0
      midi_instrument 11
      midi_play 70,10
   end_if
   caption 2130,ABV$
   IVD%=0
end_sub

sub vider2() : rem Vider billets et pices du plateau suprieur ===============
   dim_local v1v2%
   if NPS%>4999
      for v1v2% = 5000 to NPS%
         sprite_delete v1v2%
         sprite_delete v1v2%+1000
      next v1v2%
   end_if
   NPS%=4999
   if NBS%>6999
      for v1v2% = 7000 to NBS%
         delete v1v2%
      next v1v2%
   end_if
   if caption$(250)<>"Non, ERREUR"
      hide 250
   end_if
   hide 280
   NBS%=6999
   LHB%=0
   LVB%=50
   TRC=0
   if IMS%=0
      midi_instrument 116
      midi_play 108,10
   end_if
end_sub

sub voix() : rem Explications donnes au niveau de l`aide =====================
   dim_local v1vo%
   caption 0,TFA$
   v1vo%=((number_click-5)/10)-71
   if IMS%=0
      file_load 9000,"JM-Voix"+str$(v1vo%)+".mp3"
      play 9000
   else
      caption 0,TVA$(v1vo%)
   end_if
end_sub
