
rem ============================================================================
rem              La Dame, La Maison, La Voiture
rem ============================================================================

full_space 0
picture 10 : full_space 10 : 2d_target_is 10 : color 10,92,128,128
La_Dame(200,50,0,100,50,1)
La_Dame(950,500,150,100,50,1/4)
La_Dame(10,10,255,0,0,1/2)
La_Dame(300,600,0,255,255,1/10)
La_Dame(600,100,255,255,0,1.5)

La_Maison(800,100,2)
La_Maison(100,600,1/2)
La_Maison(300,500,1/4)

La_Voiture(1200,500,1)
La_Voiture(350,600,0.1)
La_Voiture(800,600,1/2)
end
rem ============================================================================
SUB La_Dame(x,y,r,g,b,e)
    if x < 110*e then x = 110*e
    if y < 040*e then y = 40*e
    2d_fill_on : 2d_fill_color r,g,b : 2d_circle x,y,40*e
    2d_poly_from x-80*e,y+50*e
    2d_poly_to x+80*e,y+50*e : 2d_poly_to x+120*e,y+170*e
    2d_poly_to x+90*e,y+170*e : 2d_poly_to x+60*e,y+90*e
    2d_poly_to x+20*e,y+150*e : 2d_poly_to x+80*e,y+300*e
    2d_poly_to x+30*e,y+300*e : 2d_poly_to x+10*e,y+450*e
    2d_poly_to x-20*e,y+450*e : 2d_poly_to x-40*e,y+300*e
    2d_poly_to x-90*e,y+300*e : 2d_poly_to x-20*e,y+150*e
    2d_poly_to x-60*e,y+100*e : 2d_poly_to x-90*e,y+170*e
    2d_poly_to x-120*e,y+170*e : 2d_poly_to x-80*e,y+50*e
    2d_flood x+70*e,y+100*e,r,g,b
END_SUB
rem ============================================================================
rem ============================================================================
' x,y : Coordonnes du dbut du toit
' e   : Facteur d'aggrandissement / rapetissement
SUB La_Maison(x,y,e)
    2d_pen_color 0,0,255 : 2d_poly_from x+80*e,y+20*e
    2d_poly_to x+220*e,y+20*e : 2d_poly_to x+280*e,y+80*e
    2d_poly_to x+140*e,y+80*e : 2d_poly_to x+80*e,y+20*e
    2d_flood x+220*e,y+20*e+5,0,0,255
    2d_pen_color 100,50,20  : 2d_fill_color 100,50,20
    2d_rectangle x+140*e,y+80*e,x+270*e,y+170*e

    2d_pen_color 50,100,50 : 2d_poly_from x+87*e,y+27*e
    2d_poly_to x+140*e,y+80*e : 2d_poly_to x+140*e,y+170*e
    2d_poly_to x+30*e,y+170*e
    2d_poly_to x+30*e,y+80*e : 2d_poly_to x+87*e,y+27*e
    2d_flood x+30*e+10,y+80*e, 200,200,50

    2d_pen_color 0,0,0 : 2d_poly_from x+80*e,y+20*e
    2d_poly_to x+87*e,y+27*e : 2d_poly_to x+30*e,y+80*e
    2d_poly_to x+20*e,y+80*e : 2d_poly_to x+80*e,y+20*e
    2d_flood x+80*e,y+20*e+2,0,0,0
    2d_fill_color 0,0,0
    2d_rectangle x+20*e,y+170*e,x+280*e,y+180*e
    2d_rectangle x+170*e,y+90*e,x+240*e,y+155*e

    2d_fill_color 255,255,0
    2d_rectangle x+175*e,y+95*e,x+202*e,y+120*e  
    2d_rectangle x+208*e,y+95*e,x+235*e,y+120*e
    2d_rectangle x+175*e,y+125*e,x+202*e,y+150*e
    2d_rectangle x+208*e,y+125*e,x+235*e,y+150*e
    
    2d_fill_color 0,200,200 : 2d_rectangle x+60*e,y+80*e,x+110*e,y+170*e
    2d_fill_color 0,0,0     : 2d_rectangle x+195*e,y+15*e,x+205*e,y+30*e
    2d_poly_from x+200*e,y+10*e
    2d_poly_to x+210*e,y+15*e : 2d_poly_to x+190*e,y+15*e
    2d_poly_to x+200*e,y+10*e
    2d_flood x+200*e,y+10*e+2,0,0,0
    2d_fill_color 255,255,0 : 2d_circle x+100*e,y+120*e,5*e
    
    2d_fill_color 255,0,0
END_SUB
rem ============================================================================
SUB La_Voiture(x,y,e)
    if x < 0 then x = 0
    if y < 0 then y = 0
    if e > 1 then e = 1
    if e < .1 then e = .1
' Les roues
    2d_pen_color 0,0,255 : 2d_fill_color 0,0,255
    2d_circle x+50*e,y+120*e,20*e : 2d_circle x+200*e,y+120*e,20*e
' Le corps
    2d_pen_color 255,0,0 : 2d_fill_color 255,0,0
    2d_rectangle x+50*e,y+0*e,x+250*e,y+100*e
    2d_rectangle x+0*e,y+50*e,x+100*e,y+100*e
' Les fentres
    2d_pen_color 0,255,255 : 2d_fill_color 0,255,255
    2d_rectangle x+60*e,y+10*e,x+90*e,y+30*e
    2d_rectangle x+100*e,y+10*e,x+130*e,y+30*e
    2d_rectangle x+140*e,y+10*e,x+170*e,y+30*e
    2d_rectangle x+180*e,y+10*e,x+210*e,y+30*e
' Echappement
    2d_pen_color 0,0,0 : 2d_fill_color 0,0,0
    2d_rectangle x+250*e,y+80*e,x+280*e,y+90*e
' Fume
    2d_circle x+290*e,y+70*e,10*e : 2d_circle x+300*e,y+50*e,8*e
END_SUB
rem ============================================================================