
rem ============================================================================
rem           Courbe en coordonnes polaire
rem                      OVOIDE
rem Equation polaire :
rem       __________________________
rem      |                          |
rem      |  r = a * power(cos(t),3) |
rem      |__________________________|
rem
rem ============================================================================

Picture 10 : full_space 10 : 2d_target_is 10
Ovoide(300,420,2)
Ovoide(100,220,1)
Ovoide(100,350,1/2)
Ovoide(100,400,1/8)

end
rem ============================================================================
' xc,yc : coordonnes de la pointe basse de l'ovode
SUB Ovoide(xc,yc,echelle)
    dim_local a,x,y,t,r
    a = 200
    degrees
    2d_poly_from xc,yc
    for t = 0 to 360
        r = a*power(sin(t),3)        
        x = r*cos(t)
        y = r*sin(t)
        2d_poly_to xc+x*echelle,yc-y*echelle
    next t
    2d_flood xc,yc-2,250,200,50
END_SUB
rem ============================================================================