
rem ============================================================================
rem                    Carte de France des rgions
rem ============================================================================
Init()
Tracer_Carte()
Marquer_Villes()
Noms_Villes()  
Colorier_Carte()
end
rem ============================================================================
SUB Init()
    width 0,800 : height 0,800
    top 0,(screen_y - height(0)) /2 : left 0,(screen_x - width(0)) / 2
    picture 10 : width 10,720 : height 10,730 : top 10,15 : left 10,25
    2d_target_is 10 : print_target_is 10 : color 10, 250,240,250
    font_name 10,"arial" : font_bold 10 : font_color 10, 0,0,255
    2d_pen_color 0,0,0 : font_size 10,9
    hide 10 : ' Mettre cette ligne en REM pour suivre le trac de la carte
    caption 0,"Carte de France des rgions"
          
END_SUB
rem ============================================================================
SUB Tracer_Carte()
    dim_local i
    for i = 1 to 26 : Read_Data() : next i  
END_SUB
rem ============================================================================
SUB Read_Data()
    dim_local x,y
    read x : read y : 2d_poly_from x,y
    read x
    while x <> 999
        read y : 2d_poly_to x,y : read x
    end_while
END_SUB
rem ============================================================================
SUB Colorier_Carte()
    2d_flood 10,10 ,0,0,255
    2d_flood 715,725,0,0,255
    2d_flood 405,115, 0,255,0
    2d_flood 431,69,255,255,0
    2d_flood 370,190,255,0,0
    2d_flood 305,150,0,128,128
    2d_flood 463,180,0,128,128
    2d_flood 220,180,255,255,0
    2d_flood 550,184,255,255,0
    2d_flood 640,240,0,255,0 : 2d_flood 650,185,0,255,0
    2d_flood 100,215,0,255,0
    2d_flood 250,270,128,0,128
    2d_flood 360,320,0,255,0
    2d_flood 490,340,255,255,0
    2d_flood 580,280,128,0,128 : 2d_flood 570,350,128,0,128
    2d_flood 560,430,0,255,0
    2d_flood 430,380,128,0,128
    2d_flood 360,400,255,255,0
    2d_flood 260,420,0,128,128
    2d_flood 240,530,0,255,0
    2d_flood 360,520,0,128,128
    2d_flood 400,620,255,255,0
    2d_flood 600,540,0,128,128
    2d_flood 700,680,255,255,0
    show 10
END_SUB
rem ============================================================================
SUB Marquer_Villes()
    dim_local r
    2d_pen_color 0,0,0 : 2d_fill_color 0,0,0 : r = 6
    2d_circle 396,193,r
    2d_circle 395,115,r
    2d_circle 431,059,r
    2d_circle 335,149,r
    2d_circle 265,166,r
    2d_circle 497,184,r
    2d_circle 586,171,r
    2d_circle 664,206,r
    2d_circle 583,309,r
    2d_circle 532,305,r
    2d_circle 374,264,r
    2d_circle 196,243,r
    2d_circle 200,307,r
    2d_circle 291,359,r
    2d_circle 339,417,r
    2d_circle 434,421,r
    2d_circle 527,421,r
    2d_circle 238,486,r
    2d_circle 345,581,r
    2d_circle 477,584,r
    2d_circle 559,603,r
    2d_circle 680,674,r
END_SUB
rem ============================================================================
SUB Noms_Villes()    
    2d_fill_color 255,255,255    
    print_locate 380,202 : print "Paris"  
    print_locate 378,127 : print "Amiens"
    print_locate 401,72  : print "Lille"
    print_locate 305,162 : print "Rouen"
    print_locate 226,181 : print "Caen"
    print_locate 463,190 : print "Chlons"
    print_locate 485,210 : print "en"
    print_locate 463,230 : print "Champagne"
    print_locate 564,184 : print "Metz"
    print_locate 617,222 : print "Strasbourg"
    print_locate 554,320 : print "Besanon"
    print_locate 468,307 : print "Dijon"
    print_locate 337,287 : print "Orlans"
    print_locate 130,227 : print "Rennes"
    print_locate 185,283 : print "Nantes"
    print_locate 258,376 : print "Poitiers"
    print_locate 339,430 : print "Limoges"
    print_locate 410,440 : print "Clermont"
    print_locate 410,460 : print "Ferrand"
    print_locate 515,443 : print "Lyon"
    print_locate 249,490 : print "Bordeaux"
    print_locate 310,550 : print "Toulouse"
    print_locate 450,554 : print "Montpellier"
    print_locate 536,572 : print "Marseille"
    print_locate 670,649 : print "Ajaccio"        
END_SUB
rem ============================================================================
data 669,562,706,549,708,537,716,531,720,521,736,508,754,513
data 759,518,762,515,775,522,773,0,448,0
data 406,26
' ------------------------------------------------------------------------------
data 999
data 0,564,89,581,99,589,108,584,115,583,131,591,134,596,142,596,148,596,155,597
data 162,594, 169,593
data 999
' ------------------------------------------------------------------------------
data 438,672,437,676,444,678,443,683,435,683,435,692,440,699
data 438,710,432,716,424,724,419,724,409,730,0,730,0,564
data 999
' ------------------------------------------------------------------------------
data 387,0,387,1, 362,14,353,18,334,25,335,35,331,37,324,33,320,38,308,38
data 299,47,290,45,284,46,286,41,274,36,254,41,251,44,248,38,250,37,233,37
data 226,36,217,29,219,37,213,38,201,41,188,41,196,45,193,49,173,46,168,55
data 165,54,168,49,150,38,129,40,128,43,122,43,117,54,118,61,113,65,111,72
data 107,74,106,69,99,71,99,64,96,63,87,60,82,61,77,59,67,59,61,57
data 61,62,57,66,48,71,44,65,42,66,42,71,39,74,40,77,41,78,34,84
data 30,77,21,71,18,75,13,75,13,70,18,66,23,66,44,49,47,40,52,40
data 55,37,71,23,72,9,77,6,81,11,90,8,86,5,89,0,387,0
data 999
rem ============================================================================
' Nord
data 487,109,487,109,485,107,485,104,487,103,486,97,483,97,484,91,484,87,478,80
data 472,79,468,79,463,82,462,74,456,69,453,69,453,67,449,68,441,66,439,58
data 440,55,435,48,426,49,426,53,424,53,415,46,411,47,410,40,412,37,407,25
data 406,26,390,29,368,35,366,40,362,41,363,51,360,56,361,65,366,69,361,68
data 361,78,364,79,366,81,370,79,377,84,378,87,384,87,384,92,388,92,390,90
data 402,89,399,96,399,99,401,101,403,96,417,102,416,105,421,102,423,106,430,104
data 435,106,455,104,461,101,471,106,473,104,477,109,483,109,487,109
data 999
rem ============================================================================
' Picardie
data 487,110,487,122,484,128,482,134,478,136,481,138,481,156,472,152,460,158,463,170
data 458,171,458,178,460,181,456,185,451,193,437,182,435,173,430,174,419,175,413,174
data 404,171,389,168,380,165,366,165,366,164,365,163,370,162,368,157,367,149,367,141
data 367,132,368,125,366,116,361,111,356,106,354,99,359,91,366,91,358,85,360,81
data 366,81,370,79,377,84,378,87,384,87,384,92,388,92,390,90,402,89,399,96
data 399,99,401,101,403,96,417,102,416,105,421,102,423,106,430,104,435,106,455,104
data 461,101,471,106,473,104,477,109,483,109,487,109,487,110
data 999
rem ============================================================================
' Haute Normandie
data 366,164,365,163,370,162,368,157,367,149,367,141,367,132,368,125,366,116,361,111
data 356,106,349,100,336,111,331,111,322,115,311,116,294,125,289,134,287,141,289,144
data 298,147,296,148,295,148,298,159,301,159,298,162,301,165,303,180,303,177,299,188
data 308,190,312,195,319,197,318,203,320,204,322,205,324,202,333,200,334,196,344,198
data 348,192,352,189,354,186,354,181,352,175,359,175,364,164,366,164
data 999
rem ============================================================================
' Basse Normandie
data 320,204,318,203,319,197,312,195,308,190,299,188,303,177,303,180,301,165,298,162
data 301,159,298,159,295,148,292,147,288,148,284,153,277,155,269,155,264,152,241,150
data 237,147,232,147,228,151,224,146,219,135,223,131,222,125,216,122,210,126,206,125
data 191,119,189,124,193,126,194,131,191,134,193,147,203,162,206,159,203,160,203,173
data 207,174,204,176,203,185,202,189,202,194,206,199,213,200,204,204,204,206,205,213
data 208,216,218,211,227,213,228,214,233,213,242,222,244,216,248,219,256,216,269,212
data 273,212,273,219,277,220,277,226,281,227,290,219,294,218,298,222,299,231,306,237
data 311,234,314,239,316,242,319,241,320,239,318,233,318,229,323,227,326,222,326,214
data 323,214,321,205,320,204
data 999
rem ============================================================================
' Bretagne
data 201,203,192,205,187,202,189,197,183,196,180,200,177,200,173,203,171,201,167,200
data 166,195,162,199,160,198,151,206,148,208,142,201,135,190,132,187,135,183,130,183
data 127,186,129,179,124,180,122,183,123,180,114,182,110,179,106,182,105,185,104,189
data 100,192,94,189,90,192,88,193,85,196,84,186,83,185,81,189,74,188,73,191
data 69,191,68,188,61,191,57,192,61,195,57,196,53,194,48,196,45,198,45,201
data 44,206,43,209,43,213,47,212,60,208,57,214,67,213,66,217,62,219,54,216
data 52,213,52,215,50,218,52,221,51,226,56,222,64,224,65,229,63,232,60,230
data 46,232,44,235,49,238,53,237,59,243,61,249,58,253,70,253,67,250,71,248
data 74,250,77,251,80,248,84,252,85,256,92,255,99,259,103,267,107,266,110,265
data 114,269,117,266,115,271,119,276,116,280,116,283,121,283,120,281,122,277,127,277
data 128,271,128,274,139,274,140,278,134,277,131,277,134,282,146,282,154,285,156,286
data 158,287,160,283,166,284,171,279,172,275,182,270,195,270,196,267,202,263,205,262
data 213,268,220,253,224,251,224,231,227,226,227,216,227,213,218,211,208,216,205,213
data 204,206,201,203
data 999
rem ============================================================================
' Pays de Loire
data 319,241,316,242,314,239,311,234,306,237,299,231,298,222,294,218,290,219,281,227
data 277,226,277,220,273,219,273,212,269,212,256,216,248,219,244,216,242,222,233,213
data 228,214,227,213,227,216,227,226,224,231,224,251,220,253,213,268,205,262,202,263
data 196,267,195,270,182,270,172,275,171,279,166,284,160,283,158,287,156,286,153,288
data 153,291,152,291,146,293,150,295,151,297,147,297,150,302,155,301,159,303,167,300
data 176,299,176,300,168,302,168,308,166,311,164,311,167,313,171,316,175,320,168,328
data 164,323,164,321,160,319,157,323,159,323,160,326,165,332,164,338,178,347,181,354
data 181,361,193,368,198,371,198,375,205,372,210,377,215,376,217,377,226,372,225,378
data 232,375,236,376,247,373,242,371,241,364,245,361,239,345,232,330,238,327,243,327
data 248,325,248,321,254,321,260,320,264,320,270,322,273,323,274,318,279,317,279,315
data 282,306,286,302,287,292,285,288,289,283,299,286,298,280,309,277,308,276,314,272
data 317,263,321,259,320,254,320,247,324,246,320,244,319,241
data 999
rem ============================================================================
' PoitouCharente
data 217,377,226,372,225,378,232,375,236,376,247,373,242,371,241,364,245,361,239,345
data 232,330,238,327,243,327,248,325,248,321,254,321,260,320,264,320,270,322,273,323
data 274,318,279,317,281,317,287,321,289,324,293,326,292,332,297,333,305,334,305,327
data 310,332,323,352,321,359,333,365,335,375,332,376,329,378,327,382,318,388,316,401
data 321,404,321,408,318,411,313,419,311,418,306,426,303,428,299,431,297,437,286,447
data 287,454,280,463,274,461,268,469,263,470,252,466,249,464,250,457,243,455,243,451
data 238,451,234,450,232,442,226,437,221,430,208,422,206,413,205,408,200,402,201,396
data 206,399,208,401,208,406,211,411,216,407,214,400,216,402,220,399,210,387,207,388
data 202,388,198,386,194,383,196,379,199,379,204,383,210,386,212,384,215,379,217,377
data 999
rem ============================================================================
' Aquitaine
data 303,428,299,431,297,437,286,447,287,454,280,463,274,461,268,469,263,470,252,466
data 249,464,250,457,243,455,243,451,238,451,235,456,233,460,231,459,230,452,223,443
data 216,436,216,433,214,434,209,438,201,499,207,492,215,500,211,500,208,500,201,509
data 197,535,187,574,177,590,167,592,171,600,175,599,177,604,182,601,189,603,184,615
data 189,620,191,614,196,618,206,621,209,624,212,626,223,625,225,635,231,642,237,639
data 242,639,247,637,249,634,253,623,254,619,259,614,265,608,264,602,268,599,263,585
data 253,581,254,571,259,561,255,558,266,555,270,558,272,557,274,553,281,549,285,552
data 297,548,300,547,304,551,312,542,314,542,316,537,318,533,316,530,318,526,324,526
data 322,512,331,502,338,499,339,493,345,489,346,480,344,476,344,471,340,470,336,458
data 340,452,338,447,332,443,330,437,327,433,319,430,318,436,314,433,313,428,308,427
data 303,428
data 999
rem ============================================================================
' Pyrnes
data 249,634,253,623,254,619,259,614,265,608,264,602,268,599,263,585,253,581,254,571
data 259,561,255,558,266,555,270,558,272,557,274,553,281,549,285,552,297,548,300,547
data 304,551,312,542,314,542,316,537,318,533,316,530,318,526,324,526,322,512,331,502
data 338,499,339,493,345,489,346,480,348,478,352,476,359,476,364,485,371,481,375,483
data 379,481,381,485,383,491,386,496,384,500,385,507,393,505,401,505,409,492,414,486
data 418,491,422,489,427,507,430,508,435,512,432,519,438,522,438,535,443,541,449,539
data 445,548,453,554,448,563,445,563,441,566,435,566,433,576,427,575,418,581,411,580
data 409,589,413,591,410,594,396,596,391,595,388,600,368,595,365,602,359,611,360,616
data 372,620,373,632,370,633,375,636,373,638,369,641,370,646,378,646,384,652,382,652
data 374,654,366,658,360,659,360,660,354,656,350,656,346,656,342,660,337,650,327,650
data 322,643,315,643,301,639,300,646,299,649,288,650,284,646,280,650,277,650,278,648
data 273,646,262,650,258,647,254,642,250,639,249,634
data 999
rem ============================================================================
' Languedoc
data 360,659,366,658,374,654,382,652,384,652,378,646,370,646,369,641,373,638,375,636
data 370,633,373,632,372,620,360,616,359,611,365,602,368,595,388,600,391,595,396,596
data 410,594,413,591,409,589,411,580,418,581,427,575,433,576,435,566,441,566,445,563
data 448,563,453,554,445,548,449,539,443,541,438,535,438,522,432,519,435,512,430,508
data 429,504,431,499,434,494,435,487,441,489,442,485,450,483,454,494,461,492,462,490
data 470,494,476,498,475,503,478,508,485,522,485,530,492,529,497,534,499,529,502,528
data 503,532,505,532,508,528,518,531,519,535,522,540,523,546,529,553,519,562,517,578
data 508,576,506,582,509,584,499,591,495,594,488,593,491,588,487,588,483,588,477,592
data 470,598,466,599,457,608,454,609,448,608,443,612,435,623,431,633,432,636,431,640
data 432,665,437,665,439,671,433,673,428,669,425,668,419,670,417,673,410,674,409,678
data 403,677,400,678,397,675,387,671,383,672,379,674,376,677,371,676,371,673,373,670
data 369,671,358,666,359,661,360,659
data 999
rem ============================================================================
' PACA
data 519,535,522,540,523,546,529,553,519,562,517,578,508,576,506,582,509,584,499,591
data 495,593,508,595,514,595,515,598,513,601,519,602,522,600,526,602,529,599,529,596
data 534,595,536,597,540,602,544,603,554,600,556,612,567,612,571,615,573,612,582,619
data 580,620,584,623,589,620,590,618,594,618,600,619,600,623,602,618,606,616,612,619
data 612,615,620,611,623,612,630,605,623,604,631,597,631,592,637,593,641,590,644,585
data 646,581,650,586,650,582,651,582,652,574,672,563,676,552,679,547,683,540,681,538
data 678,534,664,536,643,530,636,522,638,516,634,511,638,500,641,497,646,498,645,494
data 641,486,637,483,634,486,627,481,627,474,620,473,618,465,619,466,613,468,614,472
data 608,469,607,467,601,469,599,475,605,478,606,485,595,487,589,490,581,495,572,502
data 569,510,571,514,567,517,561,515,563,525,571,528,573,535,574,538,568,539,565,543
data 556,538,548,536,548,529,540,530,537,531,541,525,535,522,531,527,534,531,529,533
data 527,529,522,530,519,535
data 999
rem ============================================================================
' Rhone Alpes
data 619,466,613,468,614,472,608,469,607,467,601,469,599,475,605,478,606,485,595,487
data 589,490,581,495,572,502,569,510,571,514,567,517,561,515,563,525,571,528,573,535
data 574,538,568,539,565,543,556,538,548,536,548,529,540,530,537,531,541,525,535,522
data 531,527,534,531,529,533,527,529,522,530,519,535,518,531,508,528,505,532,503,532
data 502,528,499,529,497,534,492,529,485,530,485,522,478,508,475,503,479,494,483,489
data 488,489,494,481,499,480,503,470,507,466,505,459,502,460,501,452,493,451,488,452
data 480,452,475,448,481,446,479,437,471,430,467,422,468,414,465,412,466,406,470,406
data 470,387,475,385,476,385,477,391,481,393,487,391,497,393,501,391,501,385,513,384
data 517,385,521,393,529,367,534,367,540,365,548,370,549,374,559,383,564,379,570,379
data 571,383,577,383,586,372,586,373,592,374,587,383,583,387,585,392,593,391,600,384
data 596,380,599,374,603,376,609,369,624,371,623,375,627,382,624,390,629,390,632,399
data 635,396,638,405,628,413,629,424,635,426,637,435,647,445,644,451,646,455,644,458
data 637,459,630,464,625,463,621,465,619,466
data 999
rem ============================================================================
' Franche comt
data 549,374,559,383,564,379,570,379,571,383,577,383,586,372,585,372,590,362,588,359
data 604,345,604,329,615,327,627,307,629,301,632,300,634,297,629,299,629,293,630,289
data 636,289,638,286,637,279,631,281,631,277,633,273,623,266,618,263,611,256,603,260
data 602,257,598,255,593,257,585,256,586,250,583,251,574,257,575,259,569,265,565,267
data 567,272,558,275,551,279,550,281,555,284,555,290,550,293,548,295,555,301,551,322
data 548,327,546,334,550,336,557,341,549,343,554,355,551,362,553,366,550,369,549,374
data 999
rem ============================================================================
' Alsace
data 623,266,633,273,631,277,631,281,637,279,638,286,635,289,639,289,640,293,648,291
data 654,289,658,281,657,273,657,268,661,253,656,247,663,225,663,220,668,212,667,204
data 676,191,686,176,680,175,671,168,656,171,655,172,653,178,648,178,643,180,633,176
data 630,172,626,177,623,183,629,187,632,192,635,187,643,193,638,200,641,201,637,210
data 631,212,632,225,637,226,633,242,627,252,626,259,626,261,624,263,623,266
data 999
rem ============================================================================
' Lorraine
data 623,266,624,263,626,261,626,259,627,252,633,242,637,226,632,225,631,212,637,210
data 641,201,638,200,643,193,635,187,632,192,629,187,623,183,626,177,630,172,633,176
data 643,180,648,178,653,178,655,172,655,170,651,168,650,163,645,160,638,164,630,165
data 628,167,625,162,618,161,613,164,604,153,600,144,589,142,584,140,579,144,573,144
data 573,142,566,137,551,142,547,137,543,134,543,135,541,140,533,137,529,144,533,148
data 528,156,525,164,523,166,529,181,530,185,524,187,522,195,528,200,531,210,549,221
data 550,224,550,230,554,228,564,238,562,248,568,253,569,258,574,256,574,257,583,251
data 586,250,585,256,593,257,598,255,602,257,603,260,611,256,618,263,623,266
data 999
rem ============================================================================
' Champagne
data 485,108,492,107,499,111,502,110,508,105,509,98,516,92,519,95,516,101,517,111
data 519,112,517,116,521,122,526,121,533,127,538,128,543,135,541,140,533,137,529,144
data 533,148,528,156,525,164,523,166,529,181,530,185,524,187,522,195,528,200,531,210
data 549,221,550,224,550,230,554,228,564,238,562,248,568,253,569,258,574,256,575,259
data 569,265,565,267,567,272,558,275,551,279,550,281,548,284,543,284,538,279,530,279
data 526,274,527,270,525,262,522,262,520,254,512,253,507,253,507,257,497,258,494,262
data 492,259,474,261,469,244,462,244,459,242,460,236,457,231,453,230,449,227,449,220
data 450,215,458,211,453,208,453,202,452,193,453,191
data 999
rem ============================================================================
' Paris
data 449,227,449,220,450,215,458,211,453,208,453,202,452,193,451,193,437,182,435,173
data 430,174,419,175,413,174,404,171,389,168,380,165,366,165,366,164,364,164,359,175
data 352,175,354,181,357,187,360,198,360,203,359,205,370,216,369,221,375,224,377,235
data 389,232,390,230,393,232,398,234,407,240,400,246,424,246,428,242,431,238,431,232
data 431,230,448,228,449,227
data 999
rem ============================================================================
' Centre
data 428,242,424,246,400,246,407,240,398,234,393,232,390,230,389,232,377,235,375,224
data 369,221,370,216,359,205,360,203,360,198,357,187,354,186,352,189,348,192,344,198
data 334,196,333,200,324,202,322,205,320,204,321,205,323,214,326,214,326,222,323,227
data 318,229,318,233,320,239,319,241,320,244,324,246,320,247,320,254,321,259,317,263
data 314,272,308,276,309,277,298,280,299,286,289,283,285,288,287,292,286,302,282,306
data 279,315,281,317,287,321,289,324,293,326,292,332,297,333,305,334,305,327,310,332
data 323,352,321,359,333,365,335,375,342,377,344,375,347,377,352,373,363,375,364,371
data 391,374,395,368,398,364,407,365,410,360,407,359,414,351,419,349,430,345,431,341
data 434,328,431,326,429,311,422,306,426,297,420,289,427,290,423,276,429,273,431,263
data 436,258,429,244,428,242
data 999
rem ============================================================================
' Limousin
data 391,374,364,371,363,375,352,373,347,377,344,375,342,377,335,375,332,376,329,378
data 327,382,318,388,316,401,321,404,321,408,318,411,313,419,311,418,306,426,303,428
data 308,427,313,428,314,433,318,436,319,430,327,433,330,437,332,443,338,447,340,452
data 336,458,340,470,344,471,344,476,346,480,348,478,352,476,359,476,364,485,371,481
data 375,483,379,481,382,480,383,478,381,475,386,473,389,469,386,465,394,457,395,450
data 404,450,403,438,401,435,406,432,406,429,399,418,405,412,408,408,406,400,408,393
data 403,385,394,383,393,376,391,374
data 999
rem ============================================================================
' Auvergne
data 382,480,383,478,381,475,386,473,389,469,386,465,394,457,395,450,404,450,403,438
data 401,435,406,432,406,429,399,418,405,412,408,408,406,400,408,393,403,385,394,383
data 393,376,391,374,395,368,398,364,407,365,410,360,407,359,414,351,419,349,430,345
data 431,347,438,355,442,352,446,355,449,352,455,356,460,350,469,365,481,370,482,378
data 475,381,475,385,470,387,470,406,466,406,465,412,468,414,467,422,471,430,479,437
data 481,446,475,448,480,452,488,452,493,451,501,452,502,460,505,459,507,466,503,470
data 499,480,494,481,488,489,483,489,479,494,476,498,470,494,462,490,461,492,454,494
data 450,483,442,485,441,489,435,487,434,494,431,499,429,504,427,507,422,489,418,491
data 414,486,409,492,401,505,393,505,385,507,384,500,386,496,383,491,381,485,382,480
data 999
rem ============================================================================
' Bourgogne
data 431,347,438,355,442,352,446,355,449,352,455,356,460,350,469,365,481,370,482,378
data 475,381,476,385,477,391,481,393,487,391,497,393,501,391,501,385,513,384,517,385
data 521,393,529,367,534,367,540,365,548,370,550,369,553,366,551,362,554,355,549,343
data 557,341,550,336,546,334,548,327,551,322,555,301,548,295,550,293,555,290,555,284
data 550,281,548,284,543,284,538,279,530,279,526,274,527,270,525,262,522,262,520,254
data 512,253,507,253,507,257,497,258,494,262,492,259,474,261,469,244,462,244,459,242
data 460,236,457,231,453,230,449,227,449,227,448,228,431,230,431,232,431,238,428,242
data 428,242,429,244,436,258,431,263,429,273,423,276,427,290,420,289,426,297,422,306
data 429,311,431,326,434,328,431,341,430,345,431,347
data 999
rem ============================================================================
' Corse
data 703,594,704,602,703,609,704,620,701,615,695,614,689,621,684,622,679,627,675,628
data 670,629,670,633,671,640,666,645,670,649,673,651,665,656,666,662,677,668,670,673
data 669,679,674,678,679,681,674,690,687,693,681,699,681,702,691,707,698,710,700,715
data 708,715,709,709,709,704,713,693,713,684,713,671,720,658,720,643,718,639,718,626
data 713,620,710,619,711,610,714,608,708,593,703,594
data 999
rem ============================== F I N =======================================