' ------------------------------------------------------------------------------
'  PANORAMIC 3D Wheel / Roue 3D
'  Marc - May 2018 - Panoramic v0.9.28.i18
'  http://panoramic-language.pagesperso-orange.fr/French/index.html
'  http://panoramic.top-forum.net
' ------------------------------------------------------------------------------
' main
    Init()
    Skin()
    Wheel()
    Index()
    Instructions()
    ON_MOUSE_DOWN 100,Action
 END
' ------------------------------------------------------------------------------
SUB Init()
    LABEL Action,result,Quit
    DIM c,x,y,t,alea
    DIM BackColor_r%,BackColor_v%,BackColor_b%
    DIM CenterOption%
    BackColor_r% = 242
    BackColor_v% = 236
    BackColor_b% = 223
    CenterOption% = 1
    DEGREES
    c=1
    HEIGHT 0,540 + HEIGHT(0)-HEIGHT_CLIENT(0)
    WIDTH 0,500 + WIDTH(0)-WIDTH_CLIENT(0)
    LEFT 0,(SCREEN_X-WIDTH(0))/2
    TOP 0,(SCREEN_Y-HEIGHT(0))/2
    PICTURE 1
    WIDTH 1,500
    HEIGHT 1,500
    ON_CLOSE 0, Quit
END_SUB
' ------------------------------------------------------------------------------
SUB Wheel()
    DIM_LOCAL i%
    SCENE3D 100
    HEIGHT 100,500
    WIDTH 100,500
    COLOR 100,BackColor_r%,BackColor_v%,BackColor_b%
    CAM_MOVE -2.6
    3D_PLANE 1
    3D_V_TILE 1,1
    3D_U_TILE 1,1
    3D_IMAGE_TEXTURE 1,10
    3D_X_ROTATE 1,0
END_SUB
' ------------------------------------------------------------------------------
SUB Index()
    SCENE2D 200
    HEIGHT 200,40
    WIDTH 200,31
    COLOR 200,BackColor_r%,BackColor_v%,BackColor_b%
    LEFT 200,235
    PICTURE 201
    HEIGHT 201,40
    WIDTH 201,31
    COLOR 201,BackColor_r%,BackColor_v%,BackColor_b%
    2D_TARGET_IS 201
    2D_PEN_COLOR 50,50,50
    2D_POLY_FROM 0,0
    2D_POLY_TO 15,39
    2D_POLY_TO 30,0
    2D_POLY_TO 15,10
    2D_POLY_TO 0,0
    2D_FLOOD 15,20,50,50,50
    IMAGE 202
    2D_IMAGE_COPY 202,0,0,31,40
    SPRITE 1
    SPRITE_IMAGE_LOAD 1,202      
END_SUB
' ------------------------------------------------------------------------------
SUB Skin()
    DIM_LOCAL i%,x,y,r%,v%,b%
    2D_TARGET_IS 1
    COLOR 1,BackColor_r%,BackColor_v%,BackColor_b%
    2D_PEN_COLOR 100,100,100
    2D_CIRCLE 250,250,210
    FOR i% = 0 to 360 STEP 24
        x = COS(i%)*210+250
        y = SIN(i%)*210+250
        2D_LINE 250,250,x,y
    NEXT i%
    FOR i% = 12 to 354 STEP 24
        x = COS(i%)*190+250
        y = SIN(i%)*190 +250
        READ r%
        READ v%
        READ b%
        2D_FLOOD x,y,r%,v%,b%
    NEXT i%
    Center(CenterOption%)
    IMAGE 10
    2D_IMAGE_COPY 10,0,0,500,500
END_SUB
' ------------------------------------------------------------------------------
SUB Center(a)
    IF a = 1
        2D_FILL_COLOR BackColor_r%,BackColor_v%,BackColor_b%
        2D_CIRCLE 250,250,40
        PRINT_TARGET_IS 1
        FONT_NAME 1,"Times New Roman"
        FONT_SIZE 1,22
        PRINT_LOCATE 233,215
        PRINT "3D"
        FONT_SIZE 1,12
        PRINT_LOCATE 218,245
        PRINT "Panoramic"
        PRINT_LOCATE 230,265
        PRINT "Wheel"
    END_IF
END_SUB
' ------------------------------------------------------------------------------
SUB Instructions()
    PICTURE 50
    HEIGHT 50,40
    WIDTH 50,500
    TOP 50,500
    COLOR 50,200,200,200
    2D_TARGET_IS 50
    2D_FILL_COLOR 200,200,200
    PRINT_TARGET_IS 50
    FONT_NAME 50,"Times New Roman"
    FONT_SIZE 50,18
    FONT_ITALIC 50
    PRINT_LOCATE 55,8
    PRINT "Click on the wheel / Cliquez sur la roue"
END_SUB                        
' ------------------------------------------------------------------------------
Action:
    OFF_MOUSE_DOWN 100
    ON_MOUSE_UP 100, Result
    c = NUMBER_TICKS
RETURN
' ------------------------------------------------------------------------------
Result:
    OFF_MOUSE_UP 100
    alea = NUMBER_TICKS - c + RND(360)
    IF alea > 5000
        alea = 4000 + RND(360) + RND(180)
    END_IF
    Animation()
    ON_MOUSE_DOWN 100,Action
RETURN
' ------------------------------------------------------------------------------
SUB Animation()
    WHILE alea > 5
        c=alea/100
        3D_Z_ROTATE 1,WRAP_VALUE((c+t)*-1)
        t=c+t
        DISPLAY
        PAUSE 20
        alea=alea-c
        c = c*.95
    END_WHILE
 END_SUB
' ------------------------------------------------------------------------------
DATA 0,255,255
DATA 0,0,0
DATA 0,0,255
DATA 255,0,255
DATA 0,128,0
DATA 128,128,128
DATA 0,255,0
DATA 128,0,0
DATA 0,0,128
DATA 255,255,255
DATA 128,128,0
DATA 128,0,128
DATA 255,0,0
DATA 0,128,128
DATA 255,255,0
' ------------------------------------------------------------------------------
Quit:
    TERMINATE
RETURN