' ------------------------------------------------------------------------------
'  Premiers pas en 3D
'  Marc37 - mai 2017 - Panoramic v0.9.28i4
'  http://panoramic-language.pagesperso-orange.fr/French/index.html
' ------------------------------------------------------------------------------
Init()
Control_panel()
GOSUB Object_3D
Action()
END
' ------------------------------------------------------------------------------
Request:
    Action()
RETURN
' ------------------------------------------------------------------------------
SUB Action()
    SELECT NUMBER_CHANGE
        CASE 2
            IF POSITION(2)=1
                CAPTION 3,"AXES_SHOW"
                AXES_SHOW
            ELSE
                CAPTION 3,"AXES_HIDE"
                AXES_HIDE
            END_IF
        CASE 4
            CAM_X_POSITION POSITION(4)
            CAPTION 5, "CAM_X_POSITION : " + STR$(POSITION(4))+"  "
        CASE 6
            CAM_Y_POSITION POSITION(6)
            CAPTION 7, "CAM_Y_POSITION : " + STR$(POSITION(6))+"  "
        CASE 8
            CAM_Z_POSITION POSITION(8)
            CAPTION 9, "CAM_Z_POSITION : " + STR$(POSITION(8))+"  "
        CASE 10
            OFF_CHANGE 10
            IF Mem_cam_move% < POSITION(10) THEN CAM_MOVE 1
            IF Mem_cam_move% > POSITION(10) THEN CAM_MOVE -1
            Mem_cam_move%=POSITION(10)
            ON_CHANGE 10,Request
            CAPTION 11, "CAM_MOVE : " + STR$(Mem_cam_move%)+"  "
        CASE 12
            OFF_CHANGE 12
            IF Mem_cam_pitch% < POSITION(12) THEN CAM_PITCH 1
            IF Mem_cam_pitch% > POSITION(12) THEN CAM_PITCH -1
            Mem_cam_pitch%=POSITION(12)
            ON_CHANGE 12,Request
            CAPTION 13, "CAM_PITCH : " + STR$(Mem_cam_pitch%)+"  "
        CASE 14
            OFF_CHANGE 14
            IF Mem_cam_roll% < POSITION(14) THEN CAM_ROLL 1
            IF Mem_cam_roll% > POSITION(14) THEN CAM_ROLL -1
            Mem_cam_roll%=POSITION(14)
            ON_CHANGE 14,Request
            CAPTION 15, "CAM_ROLL : " + STR$(Mem_cam_roll%)+"  "
        CASE 16
            OFF_CHANGE 16
            IF Mem_cam_turn% < POSITION(16) THEN CAM_TURN 1
            IF Mem_cam_turn% > POSITION(16) THEN CAM_TURN -1
            Mem_cam_turn%=POSITION(16)
            ON_CHANGE 16,Request
            CAPTION 17, "CAM_TURN : " + STR$(Mem_cam_turn%)+"  "
        CASE 18
            POINT_X_POSITION POSITION(18)
            CAPTION 19, "POINT_X_POSITION : " + STR$(POSITION(18))+"  "
        CASE 20
            POINT_Y_POSITION POSITION(20)
            CAPTION 21, "POINT_Y_POSITION : " + STR$(POSITION(20))+"  "
        CASE 22
            POINT_Z_POSITION POSITION(22)
            CAPTION 23, "POINT_Z_POSITION : " + STR$(POSITION(22))+"  "
        CASE 24
            3D_X_POSITION 1,POSITION(24)
            CAPTION 25, "3D_X_POSITION : " + STR$(POSITION(24))+"  "
        CASE 26
            3D_Y_POSITION 1,POSITION(26)
            CAPTION 27, "3D_Y_POSITION : " + STR$(POSITION(26))+"  "
        CASE 28
            3D_Z_POSITION 1,POSITION(28)
            CAPTION 29, "3D_Z_POSITION : " + STR$(POSITION(28))+"  "
        CASE 30
            3D_X_ROTATE 1,POSITION(30)
            CAPTION 31, "3D_X_ROTATE : " + STR$(POSITION(30))+"  "
        CASE 32
            3D_Y_ROTATE 1,POSITION(32)
            CAPTION 33, "3D_Y_ROTATE : " + STR$(POSITION(32))+"  "
        CASE 34
            3D_Z_ROTATE 1,POSITION(34)
            CAPTION 35, "3D_Z_ROTATE : " + STR$(POSITION(34))+"  "
        CASE 54
            3D_X_SCALE 1,(POSITION(54)/10)
            CAPTION 55, "3D_X_SCALE : " + STR$((POSITION(54)/10))+"  "
        CASE 56
            3D_Y_SCALE 1,(POSITION(56)/10)
            CAPTION 57, "3D_Y_SCALE : " + STR$((POSITION(56)/10))+"  "
        CASE 58
            3D_Z_SCALE 1,(POSITION(58)/10)
            CAPTION 59, "3D_Z_SCALE : " + STR$((POSITION(58)/10))+"  "
        CASE 60
            OFF_CHANGE 60
            IF Mem_3D_move% < POSITION(60) THEN 3D_MOVE 1,1
            IF Mem_3D_move% > POSITION(60) THEN 3D_MOVE 1,-1
            Mem_3D_move%=POSITION(60)
            ON_CHANGE 60,Request
            CAPTION 61, "3D_MOVE : " + STR$(Mem_3D_move%)+"  "
        CASE 62
            LIGHT_X_POSITION POSITION(62)
            CAPTION 63, "LIGHT_X_POSITION : " + STR$(POSITION(62))+"  "
        CASE 64
            LIGHT_Y_POSITION POSITION(64)
            CAPTION 65, "LIGHT_Y_POSITION : " + STR$(POSITION(64))+"  "
        CASE 66
            LIGHT_Z_POSITION POSITION(66)
            CAPTION 67, "LIGHT_Z_POSITION : " + STR$(POSITION(66))+"  "
    END_SELECT
END_SUB
' ------------------------------------------------------------------------------
SUB Init()
    WIDTH 0,1360
    HEIGHT 0,680
    LABEL Object_3D
    LABEL Reset
    LABEL Request
    DIM Mem_cam_move%
    DIM Mem_cam_pitch%
    DIM Mem_cam_roll%
    DIM Mem_cam_turn%
    DIM Mem_3D_move%
    DIM Num_Object3D%
    SCENE3D 1
    WIDTH 1,600
    HEIGHT 1,600
    TOP 1,20
    LEFT 1,20
    COLOR 1,64,64,64
END_SUB
' ------------------------------------------------------------------------------
SUB Control_panel()
    SCROLL_BAR 2
        TOP 2,20
        LEFT 2,650
        WIDTH 2,70
        MIN 2,0
        MAX 2,1
        POSITION 2,1
        ON_CHANGE 2,Request
    ALPHA 3
        TOP 3,23
        LEFT 3, 730
        CAPTION 3, "AXES_SHOW"

    SCROLL_BAR 4
        TOP 4,55
        LEFT 4,650
        MIN 4,-10
        MAX 4,10
        POSITION 4,1
        ON_CHANGE 4,Request
    ALPHA 5
        TOP 5,58
        LEFT 5, 780
        CAPTION 5, "CAM_X_POSITION : " + STR$(POSITION(4))+"  "

    SCROLL_BAR 6
        TOP 6,80
        LEFT 6,650
        MIN 6,-10
        MAX 6,10
        POSITION 6,2
        ON_CHANGE 6,Request
    ALPHA 7
        TOP 7,83
        LEFT 7, 780
        CAPTION 7, "CAM_Y_POSITION : " + STR$(POSITION(6))+"  "

    SCROLL_BAR 8
        TOP 8,105
        LEFT 8,650
        MIN 8,-10
        MAX 8,10
        POSITION 8,5
        ON_CHANGE 8,Request
    ALPHA 9
        TOP 9,108
        LEFT 9, 780
        CAPTION 9, "CAM_Z_POSITION : " + STR$(POSITION(8))+"  "

    SCROLL_BAR 10
        TOP 10,140
        LEFT 10,650
        MIN 10,-10
        MAX 10,10
        ON_CHANGE 10,Request
    ALPHA 11
        TOP 11,143
        LEFT 11, 780
        CAPTION 11, "CAM_MOVE : " + STR$(POSITION(10))+"  "

    SCROLL_BAR 12
        TOP 12,175
        LEFT 12,650
        MIN 12,-10
        MAX 12,10
        ON_CHANGE 12,Request
    ALPHA 13
        TOP 13,178
        LEFT 13, 780
        CAPTION 13, "CAM_PITCH : " + STR$(POSITION(12))+"  "

    SCROLL_BAR 14
        TOP 14,200
        LEFT 14,650
        MIN 14,-10
        MAX 14,10
        ON_CHANGE 14,Request
    ALPHA 15
        TOP 15,203
        LEFT 15, 780
        CAPTION 15, "CAM_ROLL : " + STR$(POSITION(14))+"  "

    SCROLL_BAR 16
        TOP 16,225
        LEFT 16,650
        MIN 16,-10
        MAX 16,10
        ON_CHANGE 16,Request
    ALPHA 17
        TOP 17,228
        LEFT 17, 780
        CAPTION 17, "CAM_TURN : " + STR$(POSITION(16))+"  "

    SCROLL_BAR 18
        TOP 18,260
        LEFT 18,650
        MIN 18,-10
        MAX 18,10
        ON_CHANGE 18,Request
    ALPHA 19
        TOP 19,263
        LEFT 19, 780
        CAPTION 19, "POINT_X_POSITION : " + STR$(POSITION(18))+"  "

    SCROLL_BAR 20
        TOP 20,285
        LEFT 20,650
        MIN 20,-10
        MAX 20,10
        ON_CHANGE 20,Request
    ALPHA 21
        TOP 21,288
        LEFT 21, 780
        CAPTION 21, "POINT_Y_POSITION : " + STR$(POSITION(20))+"  "

    SCROLL_BAR 22
        TOP 22,310
        LEFT 22,650
        MIN 22,-10
        MAX 22,10
        ON_CHANGE 22,Request
    ALPHA 23
        TOP 23,313
        LEFT 23, 780
        CAPTION 23, "POINT_Z_POSITION : " + STR$(POSITION(22))+"  "

    SCROLL_BAR 24
        TOP 24,345
        LEFT 24,650
        MIN 24,-10
        MAX 24,10
        ON_CHANGE 24,Request
    ALPHA 25
        TOP 25,348
        LEFT 25, 780
        CAPTION 25, "3D_X_POSITION : " + STR$(POSITION(24))+"  "

    SCROLL_BAR 26
        TOP 26,370
        LEFT 26,650
        MIN 26,-10
        MAX 26,10
        ON_CHANGE 26,Request
    ALPHA 27
        TOP 27,373
        LEFT 27, 780
        CAPTION 27, "3D_Y_POSITION : " + STR$(POSITION(26))+"  "

    SCROLL_BAR 28
        TOP 28,395
        LEFT 28,650
        MIN 28,-10
        MAX 28,10
        ON_CHANGE 28,Request
    ALPHA 29
        TOP 29,398
        LEFT 29, 780
        CAPTION 29, "3D_Z_POSITION : " + STR$(POSITION(28))+"  "

    SCROLL_BAR 30
        TOP 30,430
        LEFT 30,650
        MIN 30,-180
        MAX 30,180
        ON_CHANGE 30,Request
    ALPHA 31
        TOP 31,433
        LEFT 31, 780
        CAPTION 31, "3D_X_ROTATE : " + STR$(POSITION(30))+"  "

    SCROLL_BAR 32
        TOP 32,455
        LEFT 32,650
        MIN 32,-180
        MAX 32,180
        ON_CHANGE 32,Request
    ALPHA 33
        TOP 33,458
        LEFT 33, 780
        CAPTION 33, "3D_Y_ROTATE : " + STR$(POSITION(32))+"  "

    SCROLL_BAR 34
        TOP 34,480
        LEFT 34,650
        MIN 34,-180
        MAX 34,180
        ON_CHANGE 34,Request
    ALPHA 35
        TOP 35,483
        LEFT 35, 780
        CAPTION 35, "3D_Z_ROTATE : " + STR$(POSITION(34))+"  "

    BUTTON 36
        WIDTH 36,17
        HEIGHT 36,17
        TOP 36,515
        LEFT 36, 650
        ON_CLICK 36, Object_3D
    BUTTON 37
        WIDTH 37,17
        HEIGHT 37,17
        TOP 37,540
        LEFT 37, 650
        ON_CLICK 37, Object_3D
    BUTTON 38
        WIDTH 38,17
        HEIGHT 38,17
        TOP 38,565
        LEFT 38, 650
        ON_CLICK 38, Object_3D
    BUTTON 39
        WIDTH 39,17
        HEIGHT 39,17
        TOP 39,590
        LEFT 39, 650
        ON_CLICK 39, Object_3D
    BUTTON 40
        WIDTH 40,17
        HEIGHT 40,17
        TOP 40,515
        LEFT 40, 754
        ON_CLICK 40, Object_3D
    BUTTON 41
        WIDTH 41,17
        HEIGHT 41,17
        TOP 41,540
        LEFT 41, 754
        ON_CLICK 41, Object_3D
    BUTTON 42
        WIDTH 42,17
        HEIGHT 42,17
        TOP 42,565
        LEFT 42, 754
        ON_CLICK 42, Object_3D
    BUTTON 43
        WIDTH 43,17
        HEIGHT 43,17
        TOP 43,590
        LEFT 43, 754
        ON_CLICK 43, Object_3D
    ALPHA 44
        TOP 44,518
        LEFT 44,672
        CAPTION 44,"3D_TEAPOT"
    ALPHA 45
        TOP 45,543
        LEFT 45,672
        CAPTION 45,"3D_CUBE"
    ALPHA 46
        TOP 46,568
        LEFT 46,672
        CAPTION 46,"3D_CONE"
    ALPHA 47
        TOP 47,593
        LEFT 47,672
        CAPTION 47,"3D_SPHERE"
    ALPHA 48
        TOP 48,518
        LEFT 48,775
        CAPTION 48,"3D_DODECAHEDRON"
    ALPHA 49
        TOP 49,543
        LEFT 49,775
        CAPTION 49,"3D_TORUS"
    ALPHA 50
        TOP 50,568
        LEFT 50,775
        CAPTION 50,"3D_CYLINDER"
    ALPHA 51
        TOP 51,593
        LEFT 51,775
        CAPTION 51,"3D_TEXT"
    ' *************** 2me colonne
    SCROLL_BAR 54
        TOP 54,55
        LEFT 54,1000
        MIN 54,1
        MAX 54,20
        POSITION 54,10
        ON_CHANGE 54,Request
    ALPHA 55
        TOP 55,58
        LEFT 55, 1130
        CAPTION 55, "3D_X_SCALE : " + STR$((POSITION(54)/10))+"  "

    SCROLL_BAR 56
        TOP 56,80
        LEFT 56,1000
        MIN 56,1
        MAX 56,20
        POSITION 56,10
        ON_CHANGE 56,Request
    ALPHA 57
        TOP 57,83
        LEFT 57, 1130
        CAPTION 57, "3D_Y_SCALE : " + STR$((POSITION(56)/10))+"  "

    SCROLL_BAR 58
        TOP 58,105
        LEFT 58,1000
        MIN 58,1
        MAX 58,20
        POSITION 58,10
        ON_CHANGE 58,Request
    ALPHA 59
        TOP 59,108
        LEFT 59, 1130
        CAPTION 59, "3D_Z_SCALE : " + STR$((POSITION(58)/10))+"  "

    SCROLL_BAR 60
        TOP 60,140
        LEFT 60,1000
        MIN 60,-10
        MAX 60,10
        ON_CHANGE 60,Request
    ALPHA 61
        TOP 61,143
        LEFT 61, 1130
        CAPTION 61, "3D_MOVE : " + STR$(POSITION(60))+"  "

    SCROLL_BAR 62
        TOP 62,175
        LEFT 62,1000
        MIN 62,-10
        MAX 62,10
        POSITION 62,0
        ON_CHANGE 62,Request
    ALPHA 63
        TOP 63,178
        LEFT 63, 1130
        CAPTION 63, "LIGHT_X_POSITION : " + STR$(POSITION(62))+"  "

    SCROLL_BAR 64
        TOP 64,200
        LEFT 64,1000
        MIN 64,-10
        MAX 64,10
        POSITION 64,0
        ON_CHANGE 64,Request
    ALPHA 65
        TOP 65,203
        LEFT 65, 1130
        CAPTION 65, "LIGHT_Y_POSITION : " + STR$(POSITION(64))+"  "

    SCROLL_BAR 66
        TOP 66,225
        LEFT 66,1000
        MIN 66,-10
        MAX 66,10
        POSITION 66,5
        ON_CHANGE 66,Request
    ALPHA 67
        TOP 67,228
        LEFT 67, 1130
        CAPTION 67, "LIGHT_Z_POSITION : " + STR$(POSITION(66))+"  "
END_SUB
' ------------------------------------------------------------------------------
Object_3D:
    GOSUB Reset
    IF NUMBER_CLICK > 35
        IF NUMBER_CLICK =36 THEN 3D_DELETE 1:3D_TEAPOT 1
        IF NUMBER_CLICK =37 THEN 3D_DELETE 1:3D_CUBE 1,1
        IF NUMBER_CLICK =38 THEN 3D_DELETE 1:3D_CONE 1,1.5,1.1
        IF NUMBER_CLICK =39 THEN 3D_DELETE 1:3D_SPHERE 1,1.5
        IF NUMBER_CLICK =40 THEN 3D_DELETE 1:3D_DODECAHEDRON 1
        IF NUMBER_CLICK =41 THEN 3D_DELETE 1:3D_TORUS 1,1,0.5
        IF NUMBER_CLICK =42 THEN 3D_DELETE 1:3D_CYLINDER 1,2,1,0.5
        IF NUMBER_CLICK =43 THEN 3D_DELETE 1:3D_TEXT 1,"Panoramic":3D_COLOR 1,0,250,0
    ELSE
        3D_TEAPOT 1
    END_IF
        AXES_SHOW
        CAM_POSITION 1,2,5
RETURN
' ------------------------------------------------------------------------------
Reset:
    POSITION 2,1
    POSITION 4,1
    POSITION 6,2
    POSITION 8,5
    POSITION 10,0
    POSITION 12,0
    POSITION 14,0
    POSITION 16,0
    POSITION 18,0
    POSITION 20,0
    POSITION 22,0
    POSITION 24,0
    POSITION 26,0
    POSITION 28,0
    POSITION 30,0
    POSITION 32,0
    POSITION 34,0
    POSITION 54,10
    POSITION 56,10
    POSITION 58,10
    POSITION 60,0
    POSITION 62,0
    POSITION 64,0
    POSITION 66,5
RETURN
' ------------------------------------------------------------------------------