' ------------------------------------------------------------------------------
' Mission : dsamorcer la bombe
' Marc - Janvier 2023
' Ecrit en langage Panoramic v0.9.29i9
' ------------------------------------------------------------------------------
dim nd1,nd2,na1,na2,Balance_on%,poids,tache%,x%,y%,t1,t2,t3,a,m,d,s$
dim progressionBarreChargement%

label Action,Chrono

degrees

interfaceUtilisateur()

Init()

on_click 2,Action
while a=0
    gosub Chrono
    pause 20
end_while
end
' ------------------------------------------------------------------------------
Action:
    off_click 2
    x%=mouse_x_position(2)
    y%=mouse_y_position(2)
    tache% = color_pixel_red(2,x%,y%)
    select tache%
        case 2 :' remplir seau 1
            na1=1000
        case 4 :' remplir seau 2
            na2=600
        case 6 :' vider seau 1
            na1=0
        case 8 :' vider seau 2
            na2=0
        case 10 :' transvaser seau 1
            if nd2<601
                if nd2+nd1>600
                   na2=600
                   na1=nd1-(600-nd2)
                else
                   na2=nd1+nd2
                   na1=0
                end_if
            end_if
        case 12 :' transvaser seau 2
            if nd1<1001
                if nd2+nd1>1000
                   na1=1000
                   na2=nd2-(1000-nd1)
                else
                   na1=nd1+nd2
                   na2=0
                end_if
            end_if
        case 14 :' balance on
            if Balance_on%=0
                Balance_on%=1
                Poids=0
            end_if
        case 16 :' tare
            Poids=0
        case 18 :' balance off
            Balance_on%=0
    end_select
    Ajuster_niveau()
    on_click 2,Action
return
' -----------------------------------------------------------------------------
sub Init()
    hide 99
    midi_on
    midi_instrument 47
    midi_volume 127
    nd1=600:t3=151:na1=600
    nd2=84:na2=84
    hide 1
    show 2
    show 4
    show 5
    sprite_show_all
    print_target_is 2
    2d_target_is 2
    font_name 2,"Arial"
    font_size 2,22
    2d_fill_color 185,175,165
    font_color 2,20,10,10
    if t3>151 then t3=151
    Ajuster_niveau()
    t1=int((number_ticks/1000)+0.5)
    gosub chrono
end_sub
' ------------------------------------------------------------------------------
sub Ajuster_niveau()
    dim_local i%
    for i% = 0 to 1000
        Affiche_poids()
        gosub Chrono
        sprite_position 1,0,(-1*nd1)/10
        sprite_position 3,0,(-1*nd2)/10
        if na1=nd1 and na2=nd2 then exit_for
        if na1<nd1 then nd1=nd1-1:Poids=Poids-1
        if na1>nd1 then nd1=nd1+1:Poids=Poids+1
        if na2<nd2 then nd2=nd2-1:Poids=Poids-1
        if na2>nd2 then nd2=nd2+1:Poids=Poids+1
    next i%
    if poids = 800 and Balance_on%=1
        a=1
        print_locate 397,63
        print "- -:- -  "
        midi_volume 127
        midi_instrument 71
        for i% = 60 to 44 step -2
            midi_play i%, 10
            midi_volume i%+60
            next i%
            midi_play 40,8
        for i% = 800 to 1 step -1
        width 0,i%
            height 0,i%-200
            display
            left 0,(screen_x-width(0))/2
            top 0,(screen_y-height(0))/2
        next i%
        terminate
    end_if
end_sub
' ------------------------------------------------------------------------------
sub Affiche_poids()
    print_locate 450,523
    if Balance_on%=1
        if Poids < 0
            print left$(str$(Poids*0.005+0.0005),6)+" kg  "
        else
            print left$(str$(Poids*0.005+0.0005),5)+" kg  "
        end_if
    else
        print "                 "
    end_if
end_sub
' ------------------------------------------------------------------------------
Chrono:
    if scancode=72 then a=1:terminate
    t2=int((number_ticks/1000)+0.5)
    if t2>t1
        m=int(t3/60)
        d=mod(t3,60)
        if d > 9
            s$=str$(d)
        else
            s$="0"+str$(d)
        end_if
    print_locate 401,63
    print str$(m)+":"+s$
    t3=t3-1
    if t3=-2
        a=1
        off_click 2
        hide 2
        hide 4
        hide 5
        show 3
        midi_play 21,0
        terminate
    end_if
    t1=int((number_ticks/1000)+0.5)
    end_if
return
' ------------------------------------------------------------------------------
sub actualiserProgressionBarre()
    progressionBarreChargement% = progressionBarreChargement% + 20
    position 99,progressionBarreChargement%
end_sub




' ******************************************************************************
sub interfaceUtilisateur()
    dim_local t1%,t2%
    border_hide 0
    width 0,800
    height 0,600
    left 0,(screen_x-width(0))/2
    top 0,(screen_y-height(0))/2

    creerPageAccueil()
    creerPageJeu()
    creerPageExplosion()

    ' attente temps de lecture page d'accueil et du chargement du programme
    t1% = number_ticks + 15000 
    t2% = number_click + 1000
    while t1% > number_ticks 
        if t2% < number_ticks
            progressionBarreChargement% = progressionBarreChargement% + 5
            position 99,progressionBarreChargement%
            t2% = number_ticks + 1000
        end_if 
    end_while
    position 99,600
    wait 200
    hide 99
end_sub
' ------------------------------------------------------------------------------
sub creerPageAccueil()
    picture 1
    width 1,800
    height 1,600
    color 1,20,20,20
    2d_target_is 1

    ' contour liseret de la page d'accueil
    2d_fill_off
    2d_pen_color 127,127,127
    2d_rectangle 0,0,800,600

    ' Rgles du jeu
    print_target_is 1
    2d_fill_color 20,20,20
    font_color 1,250,250,0
    font_name 1,"Arial"
    font_size 1, 18
    print_locate 30,40
    print "VOTRE MISSION : Dsamorcer la bombe."
    print_locate 30,100
    print "Ne cherchez pas d'aide : il n'y en a pas !"
    print_locate 30,140
    print "Ne cherchez pas d'indice : il n'y en a pas !"
    print_locate 30,180
    print "Ne cherchez pas de notice : il n'y en a pas !"
    print_locate 30,220
    print "Ne cherchez pas  gagner du temps : c'est peine perdue !"
    print_locate 30,260
    print "Vos seuls outils : vos neurones et votre souris !"
    print_locate 30,320
    print "Bonne chance !"
    print_locate 30,380
    print "Ce message s'autodtruira dans quelques secondes"
    print_locate 90,480
    font_size 1, 14
    print "Chargement en cours..."
    
    ' barre de progression du chargement du programme 
    progress_bar 99
    left 99,90
    top 99,510    
    width 99,620
    min 99,0
    max 99,600
    position 99,1
end_sub
' ------------------------------------------------------------------------------
sub creerPageJeu()
    create_hide
    picture 2 : ' page jeu
    create_show
    width 2,800
    height 2,600
    color 2,240,250,170
    2d_target_is 2

    ' contour liseret de la page de jeu
    2d_fill_off
    2d_pen_color 188,188,0
    2d_rectangle 0,0,800,600

    dessinerCablage()
    dessinerBombe()
    dessinerBalance()
    dessinerFleches()
    dessinerSeaux()
end_sub
' ------------------------------------------------------------------------------
sub dessinerCablage()
    2d_pen_color 0,0,250
    dessinerFil(500,340,240,2,20,50,140,205,0.025)
    actualiserProgressionBarre()
    2d_pen_color 33,128,19
    dessinerFil(495,345,240,2,20,50,140,205,0.025)
    actualiserProgressionBarre()
    2d_pen_color 250,0,0
    dessinerFil(505,315,238,2,20,50,140,205,0.025)
    actualiserProgressionBarre()
    2d_pen_color 0,0,10
    dessinerFil(500,55,40,2,10,30,100,200,0.1)
    actualiserProgressionBarre()
    2d_pen_color 255,20,20
    dessinerFil(498,57,40,2,10,20,100,210,0.1)
    actualiserProgressionBarre()
    2d_pen_color 255,0,0
    dessinerFil(491,57,40,2,10,20,100,210,0.1)
    actualiserProgressionBarre()
end_sub
' ------------------------------------------------------------------------------
sub dessinerFil(x0,y0,r1,b1,r2,b2,t1,t2,p)
    dim_local t,x1,y1,x2,y2
    degrees
    for t = t1 to t2 step p
        x1 = x0 + R1*cos(b1*t)
        y1 = y0 + R1*sin(b1*t)
        x2 = x1 + R2*cos(b2*t)
        y2 = y1 + R2*sin(b2*t)
        2d_point x2,y2
    next t
end_sub
' ------------------------------------------------------------------------------
sub dessinerBombe()
    dim_local i%
    for i% =0 to 12
        2d_pen_color 245-(i%*10),230-(i%*10),211-(i%*10)
        2d_line 275,50+i%,520,50+i%
    next i%
    actualiserProgressionBarre()
    for i% =12 to 47
        2d_pen_color 245-(i%*3),230-(i%*3),211-(i%*3)
        2d_line 263,50+i%,530,50+i%
    next i%
    actualiserProgressionBarre()
    for i% =47 to 82
        2d_pen_color 245-(i%*2),230-(i%*2),211-(i%*2)
        2d_line 265,50+i%,532,50+i%
    next i%
    actualiserProgressionBarre()
    for i% =82 to 100
        2d_pen_color 235-(i%*2),220-(i%*2),201-(i%*2)
        2d_line 277,50+i%,517,50+i%
    next i%
    actualiserProgressionBarre()
    2d_pen_color 20,20,20
    2d_fill_color 20,20,20
    for i% = 1 to 12
       2d_arc 479 + i%,99,185,197,164
       2d_arc 320 - i%,99,185,16,343
    next i%
    actualiserProgressionBarre()
    2d_pen_color 80,80,80
    2d_fill_color 185,175,165
    2d_pen_width 17
    2d_rectangle 360,50,500,110
    actualiserProgressionBarre()
end_sub
' ------------------------------------------------------------------------------
sub dessinerBalance()
    dim_local i%,j%
    2d_pen_width 1
    J%=200
    for i% = 1 to 20
        2d_pen_color 30+j%,30+j%,30+j%
        2d_line 130,475+i%,670,475+i%
        j%=j%-10
    next i%
    2d_pen_color 20,20,20
    for i% = 1 to 5
        2d_line 150,495+i%,650,495+i%
    next i%
    actualiserProgressionBarre()
    2d_poly_from 120,599
    2d_poly_to 140,500
    2d_poly_to 660,500
    2d_poly_to 680,599
    2d_poly_to 640,599
    2d_poly_to 630,580
    2d_poly_to 170,580
    2d_poly_to 160,599
    2d_poly_to 120,599
    2d_flood 400,540,240,235,235
    for i% = 1 to 40 : ' pour effacer les fils trop longs
        2d_pen_color 240,235,235
        2d_line 619+i%,501,633+i%,570
    next i%
    actualiserProgressionBarre()
    print_target_is 2
    font_name 2,"Arial"
    font_bold 2
    font_size 2,7
    print_locate 150,505
    print "SWC-12    Maxi 12kg   Mini 1g"
    2d_circle 180,540,15
    2d_circle 240,540,15
    2d_circle 300,540,15
    font_size 2,9
    print_locate 158,560
    print "power        Tare             OFF"
    font_size 2,18
    print_locate 365,525
    print "B"
    2d_pen_color 20,10,10
    2d_pen_width 3
    2d_line 357,531,357,546
    2d_line 357,531,367,546
    2d_line 357,527,379,527
    2d_line 357,551,379,551
    actualiserProgressionBarre()
    2d_pen_color 20,110,180
    2d_rectangle 420,515,600,565
    2d_flood 500,550,185,175,165
    2d_pen_width 1
    2d_circle 180,540,13
    2d_circle 240,540,13
    2d_circle 300,540,13
    actualiserProgressionBarre()
    2d_flood 180,540,14,12,12
    2d_flood 240,540,16,12,12
    2d_flood 300,540,18,12,12
end_sub
' ------------------------------------------------------------------------------
sub dessinerFleches()
    2d_pen_color 50,50,50

    ' Flche remplir seau gauche
    2d_arc 80,370,206,67,16
    2d_arc 111,389,182,79,25
    2d_line 160,180,160,198
    2d_line 160,198,143,212
    2d_flood 160,208,2,200,250
    actualiserProgressionBarre()

    ' Flche remplir seau droit
    2d_arc 720,370,206,163,113
    2d_arc 688,389,182,154,100
    2d_line 640,180,640,198
    2d_line 640,198,655,210
    2d_flood 640,208,4,200,250
    actualiserProgressionBarre()

    ' Flche vider seau gauche
    2d_arc 237,498,158,158,89
    2d_arc 218,518,150,148,81
    2d_line 240,340,235,355
    2d_line 235,355,240,370
    2d_flood 200,360,6,200,250
    actualiserProgressionBarre()

    ' Flche vider seau droit
    2d_arc 563,498,158,91,21
    2d_arc 582,518,150,99,34
    2d_line 560,340,565,355
    2d_line 565,355,560,370
    2d_flood 600,360,8,200,250
    actualiserProgressionBarre()

    ' Fleche transvaser seau gauche dans seau droit
    2d_arc 385,405,115,125,33
    2d_arc 402,417,109,132,44
    2d_line 320,310,330,320
    2d_line 330,320,330,335
    2d_flood 360,310,10,200,250
    actualiserProgressionBarre()

    ' Fleche_transvaser seau droit dans seau gauche
    2d_arc 415,345,115,144,55
    2d_arc 397,357,109,133,47
    2d_line 480,250,470,260
    2d_line 470,260,470,278
    2d_flood 440,250,12,200,250
    actualiserProgressionBarre()
end_sub
' ------------------------------------------------------------------------------
sub dessinerSeaux()
    sprite_create_hide
    dessinerEau()
    actualiserProgressionBarre()
    dessinerSeauGauche()
    actualiserProgressionBarre()
    dessinerSeauDroit()
end_sub
' ------------------------------------------------------------------------------
sub dessinerEau()
    create_hide
    picture 14
    create_show
    width 14,120
    height 14,200
    2d_target_is 14
    2d_pen_color 240,250,210
    2d_line 0,100,120,100
    2d_flood 50,50,240,250,210
    2d_flood 50,150,109,153,224

    image 15
    2d_image_copy 15,0,0,120,200

    image 16
    2d_image_copy 16,0,40,120,160

    actualiserProgressionBarre()
end_sub
' ------------------------------------------------------------------------------
sub dessinerSeauGauche()
    create_hide
    picture 10
    create_show
    width 10, 120
    height 10,100
    color 10,240,250,170
    2d_target_is 10
    2d_pen_color 32,78,153
    2d_line 10,0,20,100
    2d_line 110,0,100,100
    2d_line 20,99,100,99
    2d_flood 50,50,0,0,0
    image 11
    2d_image_copy 11,0,0,120,100

    create_hide
    scene2d 4
    create_show
    hide 4
    width 4,120
    height 4,100
    top 4,375
    left 4,220
    sprite_target_is 4

    sprite 1
    sprite_image_load 1,15

    sprite 2
    sprite_image_load 2,11
end_sub
' ------------------------------------------------------------------------------
sub dessinerSeauDroit()
    create_hide
    picture 12
    create_show
    width 12, 120
    height 12,60
    color 12,240,250,170
    2d_target_is 12
    2d_pen_color 32,78,153
    2d_line 13,0,20,60
    2d_line 107,0,100,60
    2d_line 20,59,100,59
    2d_flood 50,50,0,0,0

    image 13
    2d_image_copy 13,0,0,120,60

    create_hide
    scene2d 5
    create_show
    hide 5
    width 5,120
    height 5,60
    top 5,415
    left 5,460
    sprite_target_is 5

    sprite 3
    sprite_image_load 3,16

    sprite 4
    sprite_image_load 4,13
end_sub
' ------------------------------------------------------------------------------
sub creerPageExplosion() : ' Construction cran de fin
    create_hide
    picture 3
    create_show
    width 3,800
    height 3,600
    color 3,20,20,20
    2d_target_is 3

    ' contour liseret de la page Explosion
    2d_fill_off
    2d_pen_color 127,127,127
    2d_rectangle 0,0,800,600

    ' Lgende "BOOM !"
    print_target_is 3
    font_size 3,100
    font_bold 3
    font_color 3,250,250,20
    2d_fill_color 20,20,20
    print_locate 120,240
    print "B"
    print_locate 220,180
    print "O"
    print_locate 330,190
    print "O"
    print_locate 440,225
    print "M"
    font_size 3,150
    print_locate 580,200
    print "!"

    ' polygone
    2d_pen_color 250,250,20
    2d_pen_width 5
    2d_poly_from 220,40
    2d_poly_to 320,130
    2d_poly_to 400,40
    2d_poly_to 450,140
    2d_poly_to 530,80
    2d_poly_to 530,130
    2d_poly_to 680,100
    2d_poly_to 640,200
    2d_poly_to 740,180
    2d_poly_to 660,280
    2d_poly_to 760,300
    2d_poly_to 650,320
    2d_poly_to 720,420
    2d_poly_to 640,400
    2d_poly_to 720,580
    2d_poly_to 560,480
    2d_poly_to 530,590
    2d_poly_to 480,460
    2d_poly_to 400,560
    2d_poly_to 320,500
    2d_poly_to 200,598
    2d_poly_to 240,500
    2d_poly_to 140,540
    2d_poly_to 160,500
    2d_poly_to 40,560
    2d_poly_to 120,420
    2d_poly_to 5,360
    2d_poly_to 130,280
    2d_poly_to 40,200
    2d_poly_to 120,200
    2d_poly_to 50,90
    2d_poly_to 220,150
    2d_poly_to 220,40
end_sub
' ------------------------------------------------------------------------------