' Conversion Ancienne norme <-> Nouvelle norme graphique
' Marc - Aout 2022
' Ecrit en langage Panoramic 0.9.29.i9
' Mise en conformit des dessins 2D :
' cordonnes de fin de traage incluses ou non incluses dans les dessins
' pour les mots-cls 2D_LINE x1,y1,x2,y2 et 2D_RECTANGLE x1,y1,x2,y2

dim a$, reponseUtilisateur%, dossier$, nomProjetOriginal$, nomProjetConverti$, norme2D%

label ouvrirProjet, enregistrerProjet, fermerProjet, afficheAide, collerTexte, CopierTexte, old2New, new2Old, choixNorme2D, redim0

interfaceUtilisateur()

end
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    caption 0,"PANORAMIC : Conversion Ancienne norme graphique <-> Nouvelle norme graphique" 
    color 0,240,240,240
    width 0,900
    height 0,500
    top 0,(screen_y - height(0))/2
    left 0,(screen_x - width(0))/2
    on_resize 0,redim0
    creerBarreIcones()
    creerBoutonChoixNorme2d(55,8)
    creerZoneEditeurs()
    creerLegendes()
    creerMenuPop()
    creerFenetreAide()
    open_dialog 30
    save_dialog 31
end_sub
' ------------------------------------------------------------------------------
sub creerZoneEditeurs()
    ' affichage du projet original
    synedit 20
    top 20,80
    width 20,width_client(0)/2
    height 20,height_client(0)-80

    ' affichage du projet converti
    synedit 21
    top 21,80
    width 21,width_client(0)/2
    left 21,width_client(0)/2
    height 21,height_client(0)-80
end_sub
' ------------------------------------------------------------------------------
sub creerLegendes()    
    ' Lgende "Projet original"
    panel 15
    width 15,115
    height 15,22
    top 15,55
    left 15,(width(20)-115)/2
    picture 16
    parent 16,15
    width 16,150
    height 16,30
    color 16,240,240,240
    2d_target_is 16
    print_target_is 16
    2d_fill_color 240,240,240
    font_name 16,"Arial"
    font_size 16,12
    font_italic 16
    print_locate 1,1
    print "Projet original :"

    ' Lgende "Projet converti"
    panel 17
    width 17,115
    height 17,22
    top 17,55
    left 17,left(21) + (width(21)-115)/2 
    picture 18
    parent 18,17
    width 18,150
    height 18,30
    color 18,240,240,240
    2d_target_is 18
    print_target_is 18
    2d_fill_color 240,240,240
    font_name 18,"Arial"
    font_size 18,12
    font_italic 18
    print_locate 1,1
    print "Projet converti :"
end_sub
' ------------------------------------------------------------------------------
sub creerMenuPop()
    main_menu_pop 25
        sub_menu 26
            parent 26,25
            caption 26,"Coller votre projet  convertir"+chr$(9)+"Ctrl + V"
            on_click 26,CollerTexte
        sub_menu 27
            parent 27,25
            caption 27,"-"
        sub_menu 28
            parent 28,25
            caption 28,"Copier le projet converti" + chr$(9) + "Ctrl + C"
            on_click 28,CopierTexte
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreAide()
    form 35
    width 35,800
    height 35,500
    left 35,30
    top 35,30
    caption 35,"PANORAMIC Convertisseur norme graphique"
    command_target_is 35
    memo_rich 36
    color 36,240,240,230
    full_space 36
    bar_vertical 36
    notice()
    hide 35
end_sub
' ------------------------------------------------------------------------------
sub creerBarreIcones()
    creerIconeOuvrirProjet(8,8)
    creerIconeEnregistrerProjet(48,8)
    creerIconeFermer(88,8)
    creerIconeAide(328,8)
    creerBoutonOLD_NEW(128,8)
    creerBoutonNEW_OLD(228,8)
end_sub
' ------------------------------------------------------------------------------
sub creerIconeOuvrirProjet(x%,y%)
    picture 2
    height 2,28
    width 2,28
    top 2,y%
    left 2,x%
    cursor_point 2
    hint 2,"Ouvrir un projet  convertir"
    on_click 2,ouvrirProjet
    dessinerNewIconeOuvrirProjet()
end_sub
' ------------------------------------------------------------------------------
sub creerIconeEnregistrerProjet(x%,y%)
    picture 3
    height 3,28
    width 3,28
    top 3,y%
    left 3,x%
    cursor_point 3
    hint 3,"Enregistrer le projet converti"
    on_click 3,enregistrerProjet
    dessinerNewIconeEnregistrerProjet()
end_sub
' ------------------------------------------------------------------------------
sub creerIconeFermer(x%,y%)
    picture 4
    height 4,28
    width 4,28
    top 4,y%
    left 4,x%
    cursor_point 4
    hint 4,"Fermer le projet"
    on_click 4,fermerProjet
    dessinerNewIconeFermer()
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonOLD_NEW(x%,y%)
    picture 5
    height 5,28
    width 5,84
    top 5,y%
    left 5,x%
    cursor_point 5
    hint 5,"Norme graphique : Ancienne vers Nouvelle"
    on_click 5,old2New
    dessinerNewBoutonOLD_NEW()
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonNew_Old(x%,y%)
    picture 6
    height 6,28
    width 6,84
    top 6,y%
    left 6,x%
    cursor_point 6
    hint 6,"Norme graphique : Nouvelle vers Ancienne"
    on_click 6,new2Old
    dessinerNewBoutonNEW_OLD()
end_sub    
' ------------------------------------------------------------------------------
sub creerIconeAide(x%,y%)
    picture 19
    height 19,28
    width 19,28
    top 19,y%
    left 19,x%
    cursor_point 19
    Hint 19,"Aide"
    on_click 19,afficheAide
    dessinerNewIconeAide()
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonChoixNorme2d(x%,y%)
    panel 7
    height 7,28
    width 7,45
    top 7,y%
    left 7,width_client(0) - x%
    cursor_point 7
    hint 7,"Choix de la norme graphique du programme"
    
    picture 8
    parent 8,7
    height 8,height(7)
    width 8,width(7)

    ' bouton en positon haute
    picture 9
    parent 9,7
    height 9,12
    width 9,12
    left 9,30
    top 9,1

    ' bouton en positon basse
    create_hide
    picture 10
    parent 10,7
    height 10,12
    width 10,12
    left 10,30
    top 10,16
    create_show

    on_click 8,choixNorme2d
    on_click 9,choixNorme2d
    on_click 10,choixNorme2d
    dessinerNewBoutonChoixNormeGraphique()
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldIconeOuvrirProjet()   
    color 2,240,240,240
    2d_target_is 2
    2d_pen_color 0,0,0
    2d_line 16,4,20,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,23,7
    2d_line 22,5,22,8
    2d_line 5,9,11,9
    2d_line 10,11,21,11
    2d_line 11,16,25,16
    2d_line 5,22,19,22
    2d_line 5,9,5,23
    2d_line 10,9,10,12
    2d_line 20,11,20,17
    2d_line 5,22,12,15
    2d_line 18,22,25,15
    2d_flood 7,11,255,255,255
    2d_flood 12,18,250,250,0
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldIconeEnregistrerProjet()
    color 3,240,240,240
    2d_target_is 3
    2d_pen_color 0,0,0
    2d_line 7,5,20,5
    2d_line 19,6,21,6
    2d_line 20,7,22,7
    2d_line 7,22,21,22
    2d_line 6,6,6,22
    2d_line 21,7,21,22
    2d_flood 7,7,0,255,0
    2d_rectangle 8,14,20,21
    2d_line 10,16,18,16
    2d_line 10,18,18,18
    2d_rectangle 9,5,18,10
    2d_line 9,6,15,6
    2d_line 9,7,15,7
    2d_line 9,8,15,8
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldIconeFermer()
    color 4,240,240,240
    2d_target_is 4
    2d_pen_color 0,0,0
    2d_line 8,5,14,11
    2d_line 14,10,20,4
    2d_line 19,5,23,9
    2d_line 22,8,16,14
    2d_line 17,14,23,20
    2d_line 22,19,18,23
    2d_line 19,22,13,16
    2d_line 13,17,7,23
    2d_line 8,22,4,18
    2d_line 5,19,11,13
    2d_line 10,13,4,7
    2d_line 5,8,9,4
    2d_flood 8,8,255,0,0
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldBoutonOLD_NEW()
    color 5,240,240,240
    2d_target_is 5
    2d_pen_color 0,0,0
    ' cadre extrieur
    2d_line 5,0,79,0
    2d_line 79,1,81,1
    2d_point 81,2
    2d_line 82,3,82,5
    2d_line 83,5,83,23
    2d_line 82,23,82,25
    2d_point 81,25
    2d_line 79,26,81,26
    2d_line 5,27,79,27
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 1,23,1,25
    2d_line 0,5,0,23
    2d_line 1,2,1,5
    2d_point 2,2
    2d_line 3,1,5,1
    ' couleur du bouton
    2d_flood 3,3,50,200,50
    ' texte "Old >> New"
    2d_fill_color 50,200,50
    font_name 5,"Arial"
    font_size 5,10
    print_target_is 5
    print_locate 12,6
    print "Old " +chr$(187) + " New"
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldBoutonNEW_OLD()
    color 6,240,240,240
    2d_target_is 6
    2d_pen_color 0,0,0
    ' cadre extrieur
    2d_line 5,0,79,0
    2d_line 79,1,81,1
    2d_point 81,2
    2d_line 82,3,82,5
    2d_line 83,5,83,23
    2d_line 82,23,82,25
    2d_point 81,25
    2d_line 79,26,81,26
    2d_line 5,27,79,27
    2d_line 3,26,5,26
    2d_point 2,25
    2d_line 1,23,1,25
    2d_line 0,5,0,23
    2d_line 1,2,1,5
    2d_point 2,2
    2d_line 3,1,5,1
    ' couleur du bouton
    2d_flood 3,3,255,0,0
    ' texte Old New
    2d_fill_color 255,0,0
    font_name 6,"Arial"
    font_size 6,10
    font_color 6,255,255,255
    print_target_is 6
    print_locate 12,6
    print "New " + chr$(187) + " Old"
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldIconeAide()
    color 19,240,240,240
    2d_target_is 19
    2d_pen_color 0,0,255
    2d_line 10,3,17,3
    2d_line 9,4,19,4
    2d_line 8,5,20,5
    2d_line 7,6,21,6
    2d_line 6,7,11,7
    2d_line 15,7,22,7
    2d_line 6,8,10,8
    2d_line 16,8,22,8
    2d_line 6,9,9,9
    2d_line 17,9,22,9
    2d_line 17,10,22,10
    2d_line 17,11,22,11
    2d_line 16,12,21,12
    2d_line 15,13,20,13
    2d_line 14,14,19,14
    2d_line 13,15,18,15
    2d_line 12,16,17,16
    2d_line 12,17,16,17
    2d_line 12,18,16,18
    2d_line 12,21,16,21
    2d_line 12,22,16,22
    2d_line 12,23,16,23
    2d_line 12,24,16,24
end_sub
' ------------------------------------------------------------------------------
sub dessinerOldBoutonChoixNormeGraphique()
    color 8,240,240,240
    2d_target_is 8
    2d_pen_color 180,180,180
    2d_line 34,2,38,2
    2d_point 33,3
    2d_point 38,3
    2d_line 32,4,32,24
    2d_line 39,4,39,24
    2d_point 33,24
    2d_point 38,24
    2d_line 34,25,38,25
    2d_flood 36,4,255,255,255

    2d_fill_color 240,240,240
    print_target_is 8
    font_name 8,"Arial"
    font_size 8,8
    print_locate 3,0
    print "New"
    print_locate 9,15
    print "Old"
    
    ' bouton position haute
    color 9,240,240,240
    2d_target_is 9
    2d_pen_color 50,50,255
    2d_fill_color 50,50,255
    2d_circle 6,6,6
    2d_pen_color 180,180,180
    2d_point 2,11
    2d_point 9,11
    2d_pen_color 255,255,255
    2d_line 3,11,5,11
    2d_line 7,11,9,11

    ' bouton position basse
    color 10,240,240,240
    2d_target_is 10
    2d_pen_color 50,50,255
    2d_fill_color 50,50,255
    2d_circle 6,6,6
    2d_pen_color 180,180,180
    2d_point 2,0
    2d_point 9,0
    2d_pen_color 255,255,255
    2d_line 3,0,5,0
    2d_line 7,0,9,0
    create_show
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewIconeOuvrirProjet()   
    color 2,240,240,240
    2d_target_is 2
    2d_pen_color 0,0,0
    2d_line 16,4,19,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,22,7
    2d_line 22,5,22,7
    2d_line 5,9,10,9
    2d_line 10,11,20,11
    2d_line 11,16,24,16
    2d_line 5,22,18,22
    2d_line 5,9,5,22
    2d_line 10,9,10,11
    2d_line 20,11,20,16
    2d_line 5,22,11,16
    2d_line 18,22,24,16
    2d_flood 7,11,255,255,255
    2d_flood 12,18,250,250,0
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewIconeEnregistrerProjet()
    color 3,240,240,240
    2d_target_is 3
    2d_pen_color 0,0,0
    2d_line 7,5,19,5
    2d_line 19,6,20,6
    2d_line 20,7,21,7
    2d_line 7,22,20,22
    2d_line 6,6,6,21
    2d_line 21,7,21,21
    2d_flood 7,7,0,255,0
    2d_rectangle 8,14,19,20
    2d_line 10,16,17,16
    2d_line 10,18,17,18
    2d_rectangle 9,5,17,9
    2d_line 9,6,14,6
    2d_line 9,7,14,7
    2d_line 9,8,14,8
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewIconeFermer()
    color 4,240,240,240
    2d_target_is 4
    2d_pen_color 0,0,0
    2d_line 8,5,13,10
    2d_line 14,10,19,5
    2d_line 19,5,22,8
    2d_line 22,8,17,13
    2d_line 17,14,22,19
    2d_line 22,19,19,22
    2d_line 19,22,14,17
    2d_line 13,17,8,22
    2d_line 8,22,5,19
    2d_line 5,19,10,14
    2d_line 10,13,5,8
    2d_line 5,8,8,5
    2d_flood 8,8,255,0,0
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewBoutonOLD_NEW()
    color 5,240,240,240
    2d_target_is 5
    2d_pen_color 0,0,0
    ' cadre extrieur
    2d_line 5,0,78,0
    2d_line 79,1,80,1
    2d_point 81,2
    2d_line 82,3,82,4
    2d_line 83,5,83,22
    2d_line 82,23,82,24
    2d_point 81,25
    2d_line 79,26,80,26
    2d_line 5,27,78,27
    2d_line 3,26,4,26
    2d_point 2,25
    2d_line 1,23,1,24
    2d_line 0,5,0,22
    2d_line 1,2,1,4
    2d_point 2,2
    2d_line 3,1,4,1
    ' couleur du bouton
    2d_flood 3,3,50,200,50
    ' texte "Old >> New"
    2d_fill_color 50,200,50
    font_name 5,"Arial"
    font_size 5,10
    print_target_is 5
    print_locate 12,6
    print "Old " +chr$(187) + " New"
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewBoutonNEW_OLD()
    color 6,240,240,240
    2d_target_is 6
    2d_pen_color 0,0,0
    ' cadre extrieur
    2d_line 5,0,78,0
    2d_line 79,1,80,1
    2d_point 81,2
    2d_line 82,3,82,4
    2d_line 83,5,83,22
    2d_line 82,23,82,24
    2d_point 81,25
    2d_line 79,26,80,26
    2d_line 5,27,78,27
    2d_line 3,26,4,26
    2d_point 2,25
    2d_line 1,23,1,24
    2d_line 0,5,0,22
    2d_line 1,2,1,4
    2d_point 2,2
    2d_line 3,1,4,1
    ' couleur du bouton
    2d_flood 3,3,255,0,0
    ' texte Old New
    2d_fill_color 255,0,0
    font_name 6,"Arial"
    font_size 6,10
    font_color 6,255,255,255
    print_target_is 6
    print_locate 12,6
    print "New " + chr$(187) + " Old"
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewIconeAide()
    color 19,240,240,240
    2d_target_is 19
    2d_pen_color 0,0,255
    2d_line 10,3,16,3
    2d_line 9,4,18,4
    2d_line 8,5,19,5
    2d_line 7,6,20,6
    2d_line 6,7,10,7
    2d_line 15,7,21,7
    2d_line 6,8,9,8
    2d_line 16,8,21,8
    2d_line 6,9,8,9
    2d_line 17,9,21,9
    2d_line 17,10,21,10
    2d_line 17,11,21,11
    2d_line 16,12,20,12
    2d_line 15,13,19,13
    2d_line 14,14,18,14
    2d_line 13,15,17,15
    2d_line 12,16,16,16
    2d_line 12,17,15,17
    2d_line 12,18,15,18
    2d_line 12,21,15,21
    2d_line 12,22,15,22
    2d_line 12,23,15,23
    2d_line 12,24,15,24
end_sub
' ------------------------------------------------------------------------------
sub dessinerNewBoutonChoixNormeGraphique()
    color 8,240,240,240
    2d_target_is 8
    2d_pen_color 180,180,180
    2d_line 34,2,37,2
    2d_point 33,3
    2d_point 38,3
    2d_line 32,4,32,23
    2d_line 39,4,39,23
    2d_point 33,24
    2d_point 38,24
    2d_line 34,25,37,25
    2d_flood 36,4,255,255,255

    2d_fill_color 240,240,240
    print_target_is 8
    font_name 8,"Arial"
    font_size 8,8
    print_locate 3,0
    print "New"
    print_locate 9,15
    print "Old"
    
    ' bouton position haute
    color 9,240,240,240
    2d_target_is 9
    2d_pen_color 50,50,255
    2d_fill_color 50,50,255
    2d_circle 6,6,6
    2d_pen_color 180,180,180
    2d_point 2,11
    2d_point 9,11
    2d_pen_color 255,255,255
    2d_line 3,11,4,11
    2d_line 7,11,8,11

    ' bouton position basse
    color 10,240,240,240
    2d_target_is 10
    2d_pen_color 50,50,255
    2d_fill_color 50,50,255
    2d_circle 6,6,6
    2d_pen_color 180,180,180
    2d_point 2,0
    2d_point 9,0
    2d_pen_color 255,255,255
    2d_line 3,0,4,0
    2d_line 7,0,8,0
end_sub
' ------------------------------------------------------------------------------
choixNorme2d:
    if norme2D% = 0
        norme2D% = 1
        dessinerOldIconeOuvrirProjet()
        dessinerOldIconeEnregistrerProjet()
        dessinerOldIconeFermer()
        dessinerOldBoutonOLD_NEW()
        dessinerOldBoutonNEW_OLD()
        dessinerOldIconeAide()
        dessinerOldBoutonChoixNormeGraphique()
        hide 9
        show 10
    else
        norme2D% = 0
        dessinerNewIconeOuvrirProjet()
        dessinerNewIconeEnregistrerProjet()
        dessinerNewIconeFermer()
        dessinerNewBoutonOLD_NEW()
        dessinerNewBoutonNEW_OLD()
        dessinerNewIconeAide()
        dessinerNewBoutonChoixNormeGraphique()
        hide 10
        show 9
    end_if    
return
' ------------------------------------------------------------------------------
redim0:
    off_resize 0
    left 7,width_client(0) - 55
    width 20,width_client(0)/2
    height 20,height_client(0)-80
    width 21,width_client(0)/2
    left 21,width_client(0)/2
    height 21,height_client(0)-80
    left 15,(width(20)-115)/2
    left 17,left(21) + (width(21)-115)/2 
    on_resize 0,redim0
return
' ------------------------------------------------------------------------------
ouvrirProjet:
    filter 30,"Fichier basic (*.bas)|*.bas"
    a$=FILE_NAME$(30)

    if a$="_"
         return
    end_if
         
    if file_exists(a$) = 0
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(a$) + "''  est introuvable !")
        set_focus 0
        return
    end_if

    file_load 20,a$
    nomProjetOriginal$ = file_extract_name$(a$)
    dossier$ = file_extract_path$(a$)
return
' ------------------------------------------------------------------------------
enregistrerProjet:
    if text$(21) = ""
        return
    end_if
    filter 31,"Fichier basic|*.bas"
    dir_dialog 31,dossier$
    file_dialog 31,nomProjetOriginal$ + " (1).bas"
    nomProjetConverti$ = file_name$(31)
    file_save 21,nomProjetConverti$
return
' ------------------------------------------------------------------------------
old2New:
    inactive 0
    convertirOld2New()
    active 0
return
' ------------------------------------------------------------------------------
sub convertirOld2New()
    dim_local source$
    source$ = text$(20)
    if len(source$) < 15
        exit_sub
    end_if
    text 21,source$
    conversion2d_line(source$)
    conversion2d_rectangle(text$(21))
    message "Conversion termine !" + chr$(13) + "Enregistrez votre projet converti !"
end_sub
' ------------------------------------------------------------------------------
sub conversion2d_line(src$)
    dim_local p$(4), car$, parametres$, pos%, pos1%, index%, scan%, debut%, fin%, x1%, y1%, x2%, y2% 
    src$ = lower$(src$)
    pos% = instr(src$,"2d_line ")
    
    if pos% = 0 :' expression 2d_line non trouve
        exit_sub
    end_if     

    scan% = 1
    while scan% = 1
        while pos% <= len(src$) 
             ' analyse du caractre prcdent l'expression "2d_line "
            if pos% > 1
                car$ = mid$(src$,pos%-1,1)
                if car$ <> chr$(10) and car$ <> chr$(32) and car$ <> chr$(58)
                    pos% = pos% + 8
                    exit_while
                end_if
            end_if

            ' Slection des 4 parammtres de 2D_line 
            pos1% = pos% + 8
            pos% = pos% + 8
            debut% = pos%
            while 1=1
                car$ = mid$(src$,pos%,1)
                if car$ = ":"  or car$ = chr$(13) or pos% = len(src$) + 1
                    index% = 1
                    p$(1) = ""
                    select_text 21,debut%,len(parametres$)
                    
                    ' sparation des 4 parametres
                    ' premier paramtre
                     while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(1) = p$(1) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(1))=1
                        x1% = val(p$(1))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' deuxime paramtre
                    index% = index% + 1
                    p$(2) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(2) = p$(2) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(2))=1
                        y1% = val(p$(2))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    
                    
                   ' troisime paramtre
                    index% = index% + 1
                    p$(3) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(3) = p$(3) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(3))=1
                        x2% = val(p$(3))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                  ' quatrime paramtre
                    p$(4) = right$(parametres$,len(parametres$) - index%)
                    if numeric(p$(4))=1
                        y2% = val(p$(4))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' traitement des coordonnes
                    ' ligne horizontale
                    if y1% = y2%
                        if x1% < x2%
                            x2% = x2% - 1 
                        else
                            x2% = x2% + 1
                        end_if
                    end_if

                    ' ligne verticale
                    if x1% = x2%
                        if y1% < y2%
                            y2% = y2% - 1
                        else
                            y2% = y2% + 1
                        end_if
                    end_if
                     
                    ' ligne oblique nord-est
                    if x1% < x2% and y1% > y2%
                        x2% = x2% - 1
                        y2% = y2% + 1
                    end_if

                    ' ligne oblique sud-ouest
                    if x1% > x2% and y1% < y2%
                        x2% = x2% + 1
                        y2% = y2% - 1
                    end_if
                    
                    ' ligne oblique sud-est
                    if x1% < x2% and y1% < y2%
                        x2% = x2% - 1
                        y2% = y2% - 1
                    end_if

                    ' ligne oblique nord-ouest
                    if x1% > x2% and y1% > y2%
                        x2% = x2% + 1
                        y2% = y2% + 1
                    end_if

                    parametres$ = str$(x1%) + "," + str$(y1%) + "," + str$(x2%) + "," + str$(y2%)

                    select_delete 21
                    text_insert 21,debut% - 1,parametres$ 
                    src$ = lower$(text$(21))
                    parametres$ = ""
                    exit_while
                end_if
                parametres$ = parametres$ + car$
                pos% = pos% + 1
            end_while  

            ' recherche occurence suivante
            pos% = instr_pos(src$,"2d_line ",pos1%)
            if pos% = 0 :' plus de nouvelle occurence de "2d_line"
                scan% = 0
                exit_while
            end_if
        end_while
    end_while
end_sub
' ------------------------------------------------------------------------------
sub conversion2d_rectangle(src$)
    dim_local p$(4), car$, parametres$, pos%, pos1%, index%, scan%, debut%, fin%, x1%, y1%, x2%, y2% 
    src$ = lower$(src$)
    pos% = instr(src$,"2d_rectangle ")
    
    if pos% = 0 :' expression 2d_line non trouve
        exit_sub
    end_if     

    scan% = 1
    while scan% = 1
        while pos% <= len(src$) 
             ' analyse du caractre prcdent l'expression "2d_rectangle "
            if pos% > 1
                car$ = mid$(src$,pos%-1,1)
                if car$ <> chr$(10) and car$ <> chr$(32) and car$ <> chr$(58)
                    pos% = pos% + 13
                    exit_while
                end_if
            end_if

            ' Slection des 4 parammtres de 2d_rectangle 
            pos1% = pos% + 13
            pos% = pos% + 13
            debut% = pos%
            while 1=1
                car$ = mid$(src$,pos%,1)
                if car$ = ":"  or car$ = chr$(13) or pos% = len(src$) + 1
                    index% = 1
                    p$(1) = ""
                    select_text 21,debut%,len(parametres$)
                    
                    ' sparation des 4 parametres ******************************
                    ' premier paramtre
                     while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(1) = p$(1) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(1))=1
                        x1% = val(p$(1))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' deuxime paramtre
                    index% = index% + 1
                    p$(2) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(2) = p$(2) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(2))=1
                        y1% = val(p$(2))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    
                    
                   ' troisime paramtre
                    index% = index% + 1
                    p$(3) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(3) = p$(3) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(3))=1
                        x2% = val(p$(3))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                  ' quatrime paramtre
                    p$(4) = right$(parametres$,len(parametres$) - index%)
                    if numeric(p$(4))=1
                        y2% = val(p$(4))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' traitement des coordonnes *******************************
                    ' diagonale nord-est
                    if x1% < x2% and y1% > y2%
                        x2% = x2% - 1
                        y2% = y2% + 1
                    end_if

                    ' diagonale sud-ouest
                    if x1% > x2% and y1% < y2%
                        x2% = x2% + 1
                        y2% = y2% - 1
                    end_if
                    
                    ' diagonale sud-est
                    if x1% < x2% and y1% < y2%
                        x2% = x2% - 1
                        y2% = y2% - 1
                    end_if

                    ' diagonale nord-ouest
                    if x1% > x2% and y1% > y2%
                        x2% = x2% + 1
                        y2% = y2% + 1
                    end_if
 
                    parametres$ = str$(x1%) + "," + str$(y1%) + "," + str$(x2%) + "," + str$(y2%)

                    select_delete 21
                    text_insert 21,debut% - 1,parametres$ 
                    src$ = lower$(text$(21))
                    parametres$ = ""
                    exit_while
                end_if
                parametres$ = parametres$ + car$
                pos% = pos% + 1
            end_while  

            ' recherche occurence suivante
            pos% = instr_pos(src$,"2d_rectangle ",pos1%)
            if pos% = 0 :' plus de nouvelle occurence de "2d_line"
                scan% = 0
                exit_while
            end_if
        end_while
    end_while
end_sub
' ------------------------------------------------------------------------------
new2Old:
    inactive 0
    convertirNew2Old()
    active 0
return
' ------------------------------------------------------------------------------
sub convertirNew2Old()
    dim_local source$
    source$ = text$(20)
    if len(source$) < 15
        exit_sub
    end_if
    text 21,source$
    conversion2d_line1(source$)
    conversion2d_rectangle1(text$(21))
    message "Conversion termine !" + chr$(13) + "Enregistrez votre projet converti !"
end_sub
' ------------------------------------------------------------------------------
sub conversion2d_line1(src$)
    dim_local p$(4), car$, parametres$, pos%, pos1%, index%, scan%, debut%, fin%, x1%, y1%, x2%, y2% 
    src$ = lower$(src$)
    pos% = instr(src$,"2d_line ")
    
    if pos% = 0 :' expression 2d_line non trouve
        exit_sub
    end_if     

    scan% = 1
    while scan% = 1
        while pos% <= len(src$) 
             ' analyse du caractre prcdent l'expression "2d_line "
            if pos% > 1
                car$ = mid$(src$,pos%-1,1)
                if car$ <> chr$(10) and car$ <> chr$(32) and car$ <> chr$(58)
                    pos% = pos% + 8
                    exit_while
                end_if
            end_if

            ' Slection des 4 parammtres de 2D_line 
            pos1% = pos% + 8
            pos% = pos% + 8
            debut% = pos%
            while 1=1
                car$ = mid$(src$,pos%,1)
                if car$ = ":"  or car$ = chr$(13) or pos% = len(src$) + 1
                    index% = 1
                    p$(1) = ""
                    select_text 21,debut%,len(parametres$)
                    
                    ' sparation des 4 parametres
                    ' premier paramtre
                     while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(1) = p$(1) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(1))=1
                        x1% = val(p$(1))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' deuxime paramtre
                    index% = index% + 1
                    p$(2) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(2) = p$(2) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(2))=1
                        y1% = val(p$(2))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    
                    
                   ' troisime paramtre
                    index% = index% + 1
                    p$(3) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(3) = p$(3) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(3))=1
                        x2% = val(p$(3))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                  ' quatrime paramtre
                    p$(4) = right$(parametres$,len(parametres$) - index%)
                    if numeric(p$(4))=1
                        y2% = val(p$(4))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' traitement des coordonnes
                    ' ligne horizontale
                    if y1% = y2%
                        if x1% < x2%
                            x2% = x2% + 1 
                        else
                            x2% = x2% - 1
                        end_if
                    end_if

                    ' ligne verticale
                    if x1% = x2%
                        if y1% < y2%
                            y2% = y2% + 1
                        else
                            y2% = y2% - 1
                        end_if
                    end_if
                     
                    ' ligne oblique nord-est
                    if x1% < x2% and y1% > y2%
                        x2% = x2% + 1
                        y2% = y2% - 1
                    end_if

                    ' ligne oblique sud-ouest
                    if x1% > x2% and y1% < y2%
                        x2% = x2% - 1
                        y2% = y2% + 1
                    end_if
                    
                    ' ligne oblique sud-est
                    if x1% < x2% and y1% < y2%
                        x2% = x2% + 1
                        y2% = y2% + 1
                    end_if

                    ' ligne oblique nord-ouest
                    if x1% > x2% and y1% > y2%
                        x2% = x2% - 1
                        y2% = y2% - 1
                    end_if

                    parametres$ = str$(x1%) + "," + str$(y1%) + "," + str$(x2%) + "," + str$(y2%)

                    select_delete 21
                    text_insert 21,debut% - 1,parametres$ 
                    src$ = lower$(text$(21))
                    parametres$ = ""
                    exit_while
                end_if
                parametres$ = parametres$ + car$
                pos% = pos% + 1
            end_while  

            ' recherche occurence suivante
            pos% = instr_pos(src$,"2d_line ",pos1%)
            if pos% = 0 :' plus de nouvelle occurence de "2d_line"
                scan% = 0
                exit_while
            end_if
        end_while
    end_while
end_sub
' ------------------------------------------------------------------------------
sub conversion2d_rectangle1(src$)
    dim_local p$(4), car$, parametres$, pos%, pos1%, index%, scan%, debut%, fin%, x1%, y1%, x2%, y2% 
    src$ = lower$(src$)
    pos% = instr(src$,"2d_rectangle ")
    
    if pos% = 0 :' expression 2d_line non trouve
        exit_sub
    end_if     

    scan% = 1
    while scan% = 1
        while pos% <= len(src$) 
             ' analyse du caractre prcdent l'expression "2d_rectangle "
            if pos% > 1
                car$ = mid$(src$,pos%-1,1)
                if car$ <> chr$(10) and car$ <> chr$(32) and car$ <> chr$(58)
                    pos% = pos% + 13
                    exit_while
                end_if
            end_if

            ' Slection des 4 parammtres de 2d_rectangle 
            pos1% = pos% + 13
            pos% = pos% + 13
            debut% = pos%
            while 1=1
                car$ = mid$(src$,pos%,1)
                if car$ = ":"  or car$ = chr$(13) or pos% = len(src$) + 1
                    index% = 1
                    p$(1) = ""
                    select_text 21,debut%,len(parametres$)
                    
                    ' sparation des 4 parametres ******************************
                    ' premier paramtre
                     while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(1) = p$(1) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(1))=1
                        x1% = val(p$(1))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' deuxime paramtre
                    index% = index% + 1
                    p$(2) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(2) = p$(2) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(2))=1
                        y1% = val(p$(2))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    
                    
                   ' troisime paramtre
                    index% = index% + 1
                    p$(3) = ""
                    while 1=1
                        car$ = mid$(parametres$,index%,1)
                        if car$ = ","
                            exit_while
                        end_if
                        p$(3) = p$(3) + car$
                        index% = index% + 1
                    end_while
                    if numeric(p$(3))=1
                        x2% = val(p$(3))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                  ' quatrime paramtre
                    p$(4) = right$(parametres$,len(parametres$) - index%)
                    if numeric(p$(4))=1
                        y2% = val(p$(4))
                    else
                        parametres$ = ""
                        exit_while
                    end_if    

                    ' traitement des coordonnes *******************************
                    ' diagonale nord-est
                    if x1% < x2% and y1% > y2%
                        x2% = x2% + 1
                        y2% = y2% - 1
                    end_if

                    ' diagonale sud-ouest
                    if x1% > x2% and y1% < y2%
                        x2% = x2% - 1
                        y2% = y2% + 1
                    end_if
                    
                    ' diagonale sud-est
                    if x1% < x2% and y1% < y2%
                        x2% = x2% + 1
                        y2% = y2% + 1
                    end_if

                    ' diagonale nord-ouest
                    if x1% > x2% and y1% > y2%
                        x2% = x2% - 1
                        y2% = y2% - 1
                    end_if
 
                    parametres$ = str$(x1%) + "," + str$(y1%) + "," + str$(x2%) + "," + str$(y2%)

                    select_delete 21
                    text_insert 21,debut% - 1,parametres$ 
                    src$ = lower$(text$(21))
                    parametres$ = ""
                    exit_while
                end_if
                parametres$ = parametres$ + car$
                pos% = pos% + 1
            end_while  

            ' recherche occurence suivante
            pos% = instr_pos(src$,"2d_rectangle ",pos1%)
            if pos% = 0 :' plus de nouvelle occurence de "2d_line"
                scan% = 0
                exit_while
            end_if
        end_while
    end_while
end_sub
' ------------------------------------------------------------------------------
fermerProjet:
    clear 20
    clear 21
return
' ------------------------------------------------------------------------------
collerTexte:
    text 20,clipboard_string_paste$
return
' ------------------------------------------------------------------------------
CopierTexte:
    clipboard_string_copy text$(21)
return
' ------------------------------------------------------------------------------
afficheAide:
    show 35
    normal 35
    to_foreground 35
return
' ------------------------------------------------------------------------------
sub notice()
    dim_local tx$
    tx$ = tx$ + "{\rtf1\fbidis\ansi\ansicpg1252\deff0\deflang1036\deflangfe1036\deftab708{\fonttbl{\f0\fswiss\fprq2\fcharset0 Calibri;}}"
    tx$ = tx$ + "{\colortbl ;\red0\green0\blue255;}"
    tx$ = tx$ + "\viewkind4\uc1\pard\ltrpar\li708\qc\lang12\b\f0\fs32 PANORAMIC : Conversion des coordonn\'e9es graphiques"
    tx$ = tx$ + "\par 2D_LINE et 2D_RECTANGLE"
    tx$ = tx$ + "\par \pard\ltrpar\li708\fs22" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\ltrpar\li708\sl276\slmult1\b0 Ce programme permet de convertir la norme graphique d'un code-source."
    tx$ = tx$ + "\par \pard\ltrpar\li708\b" 
    tx$ = tx$ + "\par Rappel de la syntaxe :"
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\ltrpar\fi708\li708 2D_LINE x1,y1,x2,y2 \b0 : dessine une ligne entre les points (x1,y1) et (x2,y2)\b" 
    tx$ = tx$ + "\par \pard\ltrpar\li708"                                                                                                 
    tx$ = tx$ + "\par \pard\ltrpar\fi708\li708 2D_RECTANGLE x1,y1,x2,y2 \b0 : dessine un rectangle entre les points (x1,y1) et (x2,y2)\b" 
    tx$ = tx$ + "\par \pard\ltrpar\li708" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par Ancienne norme :"
    tx$ = tx$ + "\par \b0 Les coordonn\'e9es de d\'e9part (x1,y1) sont incluses dans le trac\'e9." 
    tx$ = tx$ + "\par Les coordonn\'e9es de fin (x2,y2) ne sont pas incluses dans le trac\'e9."
    tx$ = tx$ + "\par \b" 
    tx$ = tx$ + "\par Nouvelle norme :"
    tx$ = tx$ + "\par \b0 Les coordonn\'e9es de d\'e9but (x1,y1) et de fin (x2,y2) sont incluses dans le trac\'e9."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\ltrpar\li708\sl276\slmult1\b Utilisation :"
    tx$ = tx$ + "\par \b0 Par d\'e9faut, l'interface graphique de cet utilitaire utilise la nouvelle norme graphique."
    tx$ = tx$ + " Le commutateur NEW/OLD situ\'e9 en haut \'e0 droite de la fen\'eatre, permet de permuter vers l'ancienne norme. "
    tx$ = tx$ + "Ainsi, pour une utilisation avec une version de PANORAMIC jusqu'\'e0 0.9.29i11 incluse, le commutateur devra \'eatre positionn\'e9 sur \'ab OLD \'bb. "
    tx$ = tx$ + "Ce r\'e9glage n'influe que sur l'aspect esth\'e9tique du programme."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\ltrpar\fi-360\li1428\sl276\slmult1 1.\tab Chargez votre code \'e0 convertir dans la fen\'eatre de gauche. "
    tx$ = tx$ + "Pour ce faire, vous pouvez soit utiliser la premi\'e8re ic\'f4ne pour ouvrir un fichier .bas contenu sur un disque, "
    tx$ = tx$ + "soit copier-coller votre code \'e0 convertir directement dans la fen\'eatre de gauche. Utilisez le clic-gauche souris pour copier-coller."
    tx$ = tx$ + "\par \pard\ltrpar\li1428\sl276\slmult1" 
    tx$ = tx$ + "\par \pard\ltrpar\fi-360\li1428\sl276\slmult1 2.\tab Cliquez sur le bouton vert \'ab \b Old >> New\b0  \'bb. "
    tx$ = tx$ + "Le projet converti dans la nouvelle norme graphique apparaitra dans la fen\'eatre de droite."
    tx$ = tx$ + "\par \pard\ltrpar\li708\sl276\slmult1" 
    tx$ = tx$ + "\par \pard\ltrpar\fi-360\li1428\sl276\slmult1 3.\tab Cliquez sur la deuxi\'e8me ic\'f4ne pour enregistrer le nouveau fichier ou bien,"
    tx$ = tx$ + " faites un copier-coller pour le placer dans le presse-papiers. Utilisez le clic-gauche souris pour copier-coller."
    tx$ = tx$ + "\par \pard\ltrpar\li708\sl276\slmult1" 
    tx$ = tx$ + "\par Le programme permet aussi de convertir du nouveau standard vers l'ancien en utilisant le bouton rouge \'ab \b New >> Old\b0  \'bb."
    tx$ = tx$ + "\par \b" 
    tx$ = tx$ + "\par Astuces :"
    tx$ = tx$ + "\par \b0 Le clic gauche souris vous permet de copier-coller rapidement un code-source dans l'application."
    tx$ = tx$ + "\par La fen\'eatre du programme est redimensionnable."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \b Divers :"
    tx$ = tx$ + "\par \b0 Ce programme a \'e9t\'e9 \'e9crit par Marc en langage Panoramic 0.9.29i9."
    tx$ = tx$ + "\par Ao\'fbt 2022."
    tx$ = tx$ + "\par \pard\ltrpar\li708 Forum PANORAMIC : \cf1\ul <https://panoramic.1fr1.net/>\cf0\ulnone" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par }"
    text 36,tx$
 end_sub