' Commande des sorties digitales 2  53, pour l'Arduino MEGA 2560
' Marc - Aout 2022
' Ecrit en langage Panoramic 0.9.29i9

initalisationLiaisonSerie(4) :' Indiquez en paramtre le numro de port COM utilis par la carte Arduino

' exemples :
sortieDigitale(28,1) :' la sortie digitale 28 de l'Arduino est mise  1
sortieDigitale(49,1) :' la sortie digitale 49 de l'Arduino est mise  1

end
' ------------------------------------------------------------------------------
sub sortieDigitale(d_out%,etat%)
    if d_out% < 2 or d_out% > 53
        exit_sub
    end_if
    if etat% < 0 or etat% > 1
        exit_sub
    end_if
    serial_write 1,chr$(d_out%)+chr$(etat%)+chr$(255)
end_sub
' ------------------------------------------------------------------------------
sub initalisationLiaisonSerie(PortCom%)
    dim_local texte$
    if serial_port_exists(portCom%) = 0
        texte$ = "Le port COM" + str$(portCom%) + " n'est pas disponible !" + chr$(13) + chr$(13)
        texte$ = texte$ + "Vrifiez le numro de port COM ainsi que les connexions lectriques."
        if message_error_ok(texte$) < 2
            terminate
        end_if
    end_if
    serial 1
    serial_port 1,portCom%
    serial_baudrate 1,9600
    serial_databits 1,8
    serial_parity 1,0
    serial_stopbits 1,1
    serial_open 1
end_sub