' Regie lumire 8 canaux
' Marc - Juin 2022
' Ecrit en langage Panoramic 0.9.29i9
dim dossier$, etiquette%, editeur%, texte$, car$, legende$, null%, i%, j%, action%, delai%
dim on%, cadenas%, bandeau%, top0%, left0%, ySouris%, valeur, txt$, info$
dim etiquettes$(15), niveauPotentiometre%(10), memoire%(5,10), memorisationMaster%, memorisationTransition%
dim portCom%, parity%, sPortCom$, sBaudRate$, sParity$, sDataBit$, sStopBit$, serialOnOff%, trame$ 

label saisieEtiquette, contoleSaisie, appuiBoutonOnOff, appuiIconeCadenas, appuiIconeBandeau
label appuiMemoire1, appuiMemoire2, appuiMemoire3, appuiMemoire4, appuiMemoire5, quitter
label deplacerCurseur1, deplacerCurseur2, deplacerCurseur3 ,deplacerCurseur4, deplacerCurseur5
label deplacerCurseur6, deplacerCurseur7 ,deplacerCurseur8, deplacerCurseur9, deplacerCurseur10
label afficherApropos, fermerApropos, copierAdresseInternet, chargerModele, enregistrerModele
label AfficherReglages, fermerReglages, afficheAide
label choixMemorisationMaster, choixMemorisationTransition
label choixPortCom, choixBaudrate, choixNbBits, choixParity, choixBitstop

dossier$ = dir_current$ + chr$(92)

interfaceUtilisateur()

lectureFichierSauvegarde()

end
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    border_hide 0
    width 0,807
    height 0,367
    left 0,(screen_x - width(0))/2
    top 0,(screen_y - height(0))/2
    color 0,30,30,30
    caption 0,"PANORAMIC - Rgie lumire 8 canaux"
    on_close 0,quitter
    
    ' objet PICTURE servant de planche  dessins
    create_hide
    picture 1
    2d_target_is 1
    create_show

    ' objets IMAGE pour la copie des dessins effecus 
    image 2 :' image de fond potentiomtre
    image 3 :' bouton noir de potentiomtre
    image 4 :' bouton gris de potentiomtre
    image 5 :' bouton rouge de potentiomtre
    
    creerTitre(160,30)
    creerModuleBoutonsMemoire(20,20)
    creerModulePotentiometres(110,90)
    creerInterrupteurOnOff(670,20)
    creerModuleIcones(743,20)
    creerFenetreApropos(225,54)
    creerFenetreReglages()
    creerFenetreAide()
        
    application_title "Rgie lumire"
    
    open_dialog 230
    save_dialog 231
    serial 234
end_sub
' ------------------------------------------------------------------------------
sub creerTitre(x%,y%)
    alpha 7
    left 7,x%
    top 7,y%
    color 7,30,30,30
    font_name 7,"Arial"
    font_size 7,"24"
    font_color 7,180,180,180
    caption 7,"PANORAMIC  ~  Rgie lumire"
end_sub
' ------------------------------------------------------------------------------
sub creerModuleBoutonsMemoire(x%,y%)
    command_target_is 0
    panel 210
    height 210,326
    width 210,70
    top 210,y%
    left 210,x%
    command_target_is 210
    
    ' image de fond pour le panel 210
    picture 211
    width 211,70
    height 211,326
    color 211,30,30,30
    ' cadre arrondi
    2d_target_is 211
    2d_pen_color 127,127,127
    2d_point 2,2
    2d_line 3,1,5,1
    2d_line 5,0,65,0
    2d_line 65,1,67,1
    2d_point 67,2
    2d_line 68,3,68,5
    2d_line 69,5,69,321
    2d_line 68,321,68,323
    2d_point 67,323
    2d_line 65,324,67,324
    2d_line 5,325,65,325
    2d_line 3,324,5,324
    2d_point 2,323
    2d_line 1,321,1,323
    2d_line 0,5,0,321
    2d_line 1,3,1,5

    ' lgende "Mmoires"
    print_target_is 211
    2d_fill_color 30,30,30
    font_color 211,200,200,200    
    print_locate 13,5
    print "Mmoires"
 
    panel 212
    top 212,20
    left 212,8
    width 212,54
    height 212,300
    command_target_is 212

    ' habillage panel 212
    picture 213
    width 213,54
    height 213,300
    color 213,30,30,30

    creerBoutonMemoire(151,14,7)
    creerBoutonMemoire(161,14,67)
    creerBoutonMemoire(171,14,127)
    creerBoutonMemoire(181,14,187)
    creerBoutonMemoire(191,14,247)

    on_mouse_down 151,appuiMemoire1
    on_mouse_down 161,appuiMemoire2
    on_mouse_down 171,appuiMemoire3
    on_mouse_down 181,appuiMemoire4
    on_mouse_down 191,appuiMemoire5
end_sub
' ------------------------------------------------------------------------------
sub creerBoutonMemoire(n%,x%,y%)
    ' Bouton mmoire position repos (relch)
    picture n%
    top n%,y%
    left n%,x%
    height n%,26
    width n%,26
    color n%,60,60,60
    2d_target_is n%
    ' contours
    2d_pen_color 90,90,90
    2d_line 0,0,26,0
    2d_line 0,1,26,1
    2d_line 0,0,0,26
    2d_line 1,0,1,25
    2d_pen_color 50,50,50
    2d_line 24,2,24,25
    2d_line 2,24,25,24
    2d_pen_color 40,40,40
    2d_line 25,1,25,26
    2d_line 1,25,26,25
    cursor_point n%
    
    ' Bouton mmoire position travail (appuy)
    create_hide
    picture n% + 1
    top n% + 1,y%
    left n% + 1,x%
    height n% + 1,26
    width n% + 1,26
    color n% + 1,60,60,60
    2d_target_is n% + 1
    ' contour
    2d_pen_color 40,40,40
    2d_fill_off
    2d_rectangle 0,0,26,26
    ' contour voyant
    2d_pen_color 61,61,61
    2d_rectangle 3,3,23,23
    create_show
               
    ' Etiquette sous bouton memoire
    picture n% + 2
    top n% + 2 ,y% + 29 
    left n% + 2,x% - 14
    width n% + 2,54
    height n% + 2,18 
    color n% + 2,180,180,180
    on_click n% + 2,saisieEtiquette

    ' affichage tiquette sous bouton mmoire
    alpha n% + 3
    top n% + 3,y% + 31 
    left n% + 3,x% - 14
    height n% + 3,14
    color n% + 3,180,180,180
    on_click n% + 3,saisieEtiquette

    ' Memo pour l'dition de l'tiquette bouton mmoire
    create_hide
    memo n% + 4
    top n% + 4 ,y% + 29 
    left n% + 4,x% - 14 
    width n% + 4,54
    height n% + 4,18 
    color n% + 4,200,200,200
    create_show
end_sub    
' ------------------------------------------------------------------------------
sub creerModulePotentiometres(x%,y%)
    creerModelePotentiometre()
    creerModeleBoutonPotentiometre()

    ' creerPotentiometre(n objet, coordonne en x, coordonne en y, couleur bouton)
    creerPotentiometre(50,x%,y%,3):' Voie 1
    x% = x% + 57
    creerPotentiometre(60,x%,y%,3):' Voie 2
    x% = x% + 57
    creerPotentiometre(70,x%,y%,3):' Voie 3
    x% = x% + 57
    creerPotentiometre(80,x%,y%,3):' Voie 4
    x% = x% + 57
    creerPotentiometre(90,x%,y%,3):' Voie 5
    x% = x% + 57
    creerPotentiometre(100,x%,y%,3):' Voie 6
    x% = x% + 57
    creerPotentiometre(110,x%,y%,3):' Voie 7
    x% = x% + 57
    creerPotentiometre(120,x%,y%,3):' Voie 8
    x% = x% + 80
    creerPotentiometre(130,x%,y%,5):' Vitesse transition
    x% = x% + 80
    creerPotentiometre(140,x%,y%,4):' Master 

    on_mouse_down 52,deplacerCurseur1
    on_mouse_down 62,deplacerCurseur2
    on_mouse_down 72,deplacerCurseur3
    on_mouse_down 82,deplacerCurseur4
    on_mouse_down 92,deplacerCurseur5
    on_mouse_down 102,deplacerCurseur6
    on_mouse_down 112,deplacerCurseur7
    on_mouse_down 122,deplacerCurseur8
    on_mouse_down 132,deplacerCurseur9
    on_mouse_down 142,deplacerCurseur10
end_sub
' ------------------------------------------------------------------------------
sub creerModelePotentiometre()
   dim_local i%, e%, c%, l%, x1%, y1%

   ' dessiner le dcor de fond du potentiomtre
    width 1,54
    height 1,252
    color 1,66,63,70
    2d_target_is 1

    ' creer texture
    for i% = 0 to 1000
    c% = int(50+rnd(30))
    l% = int(rnd(10))
    x1% = int(rnd(55))
    y1% = int(rnd(253))
        2d_pen_color c%,c%,c% 
        2d_line x1%,y1%,x1%+l%,y1%
    next i% 

    ' srigraphie
    2d_pen_color 180,180,180
    e% = 39
    for i% = 1 to 10
        2d_line 12,e%,42,e%
        e% = e% + 15    
    next i% 
    2d_pen_color 10,10,10
    2d_fill_color 10,10,10
    2d_rectangle 25,30,29,183
 
    ' copie en mmoire du dessin effectu
    2d_image_copy 2,0,0,54,252
end_sub
' ------------------------------------------------------------------------------
sub creerModeleboutonPotentiometre()
    dim_local i%, r1%, v1%, b1%

    ' par dfaut, le bouton est noir
    
    for i% = 3 to 5
        ' bouton rouge
        if i% = 4
            r1% = 150
            v1% = 0
            b1% = 0
        end_if        
        ' bouton gris
        if i% = 5
            r1% = 100
            v1% = 100
            b1% = 100
        end_if

       ' dessiner le bouton du potentiomtre
       color 1,2,2,2 :' effacer planche  dessin (picture 1)
       2d_pen_color 10+r1%,10+v1%,10+b1%
       2d_line 0,0,16,0
       2d_pen_color 11+r1%,11+v1%,11+b1%
       2d_line 0,1,16,1
       2d_pen_color 12+r1%,12+v1%,12+b1%
       2d_line 0,2,16,2
       2d_pen_color 13+r1%,13+v1%,13+b1%
       2d_line 0,3,16,3
       2d_pen_color 14+r1%,14+v1%,14+b1%
       2d_line 0,4,16,4
       2d_pen_color 37+r1%,37+v1%,37+b1%
       2d_line 0,5,16,5
       2d_pen_color 38+r1%,38+v1%,38+b1%
       2d_line 0,6,16,6
       2d_pen_color 10+r1%,10+v1%,10+b1%
       2d_line 0,7,16,7
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,8,16,8
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,9,16,9
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,10,16,10
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,11,16,11
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,12,16,12
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,13,16,13
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,14,16,14
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,15,16,15
       2d_pen_color 20+r1%,20+v1%,20+b1%
       2d_line 0,16,16,16
       2d_pen_color 15+r1%,15+v1%,15+b1%
       2d_line 0,17,16,17
       2d_pen_color 180,180,180
       2d_line 0,18,16,18
       2d_pen_color 180,180,180
       2d_line 0,19,16,19
       2d_pen_color 11+r1%,11+v1%,11+b1%
       2d_line 0,20,16,20
       2d_pen_color 15+r1%,15+v1%,15+b1%
       2d_line 0,21,16,21
       2d_pen_color 11+r1%,11+v1%,11+b1%
       2d_line 0,22,16,22
       2d_pen_color 12+r1%,12+v1%,12+b1%
       2d_line 0,23,16,23
       2d_pen_color 18+r1%,18+v1%,18+b1%
       2d_line 0,24,16,24
       2d_pen_color 14+r1%,14+v1%,14+b1%
       2d_line 0,25,16,25
       2d_pen_color 20+r1%,20+v1%,20+b1%
       2d_line 0,26,16,26
       2d_pen_color 16+r1%,16+v1%,16+b1%
       2d_line 0,27,16,27
       2d_pen_color 19+r1%,19+v1%,19+b1%
       2d_line 0,28,16,28
       2d_pen_color 18+r1%,18+v1%,18+b1%
       2d_line 0,29,16,29
       2d_pen_color 20+r1%,20+v1%,20+b1%
       2d_line 0,30,16,30
       2d_pen_color 51+r1%,51+v1%,51+b1%
       2d_line 0,31,16,31
       2d_pen_color 50+r1%,50+v1%,50+b1%
       2d_line 0,32,16,32
       2d_pen_color 15+r1%,15+v1%,15+b1%
       2d_line 0,33,16,33
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,34,16,34
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,35,16,35
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,36,16,36
       2d_pen_color 2+r1%,2+v1%,2+b1%
       2d_line 0,37,16,37
       ' bords droit et gauche (effet de relief)
       r1% = r1% - 15
       v1% = v1% - 15
       b1% = b1% - 15
       if r1% < 1
          r1% = 1
       end_if
       if v1% < 1
          v1% = 1
       end_if
       if b1% < 1
          b1% = 1
       end_if
       2d_pen_color 1+r1%,1+v1%,1+b1%
       2d_line 0,0,0,38
       2d_line 15,0,15,38

       ' mise en memoire des boutons
       2d_image_copy i%,0,0,16,38
   next i%
end_sub
' ------------------------------------------------------------------------------
sub creerPotentiometre(n%,x%,y%,couleur%)
    command_target_is 0 
    panel n%
    left n%,x%
    top n%,y%
    width n%,54
    height n%,252
    command_target_is n%
   
    ' habillage panel
    picture n% + 1
    height n% + 1,252
    width n% +1,54
    2d_target_is n% + 1
    2d_image_paste 2,0,27
   
    ' Corps du potentiomtre
    scene2d n% + 2
    width n% + 2,54
    height n% + 2,195
    top n% + 2,27
    sprite_target_is n% + 2 

    ' creer sprite servant d'image de fond et copier le dessin dessus
    sprite n% + 1 
    sprite_image_load n% + 1,2
   
    ' creer le sprite du bouton et copier le dessin dessus
    sprite n% + 2
    sprite_image_load n% + 2,couleur%
    sprite_position n% + 2,19,120
    sprite_show n% + 2
   
    ' creer zone d'affichage de la lgende du potentiomtre
    picture n% + 3
    top n% + 3,226
    left n% + 3,0
    width n% + 3,54
    height n% + 3,18
    color n% + 3,180,180,180
    on_click n% + 3,saisieEtiquette
   
    ' affichage lgende du potentiomtre
    alpha n% + 4
    left n% + 4,8
    top n% + 4,228
    height n% + 4,14
    color n% + 4,180,180,180
    font_size n% + 4,8
    on_click n% + 4,saisieEtiquette
   
    ' creer le champ EDIT pour editer la lgende du potentiomtre
    memo n% + 5
    top n% + 5,226
    left n% + 5,0
    width n% + 5,54
    height n% + 5,18
    color n% + 5,200,200,200
    hide n% + 5

    ' creer afficheur
    picture n% + 6
    width n% + 6,54
    height n% + 6,24
    color n% + 6,10,10,10
  
    alpha n% + 7
    left n% + 7,8
    top n% + 7,4
    color n% + 7,10,10,10
    font_name n% + 7,"Arial"
    font_color n% + 7,0,180,0
    font_size n% + 7,10

    ' ligne de sparation afficheur / potentiometre
    picture n% + 8
    width n% + 8,54
    height n% + 8,3
    top n% + 8,24
    color n% + 8,30,30,30
end_sub
' ------------------------------------------------------------------------------
sub creerInterrupteurOnOff(x%,y%)
    command_target_is 0
    panel 200
    height 200,52
    width 200,52
    top 200,y%
    left 200,x%
    command_target_is 200
    
    ' image de fond pour le panel n%
    picture 201
    width 201,52
    height 201,52
    color 201,30,30,30
    ' cadre arrondi
    2d_target_is 201
    2d_pen_color 127,127,127
    2d_point 2,2
    2d_line 3,1,5,1
    2d_line 5,0,47,0
    2d_line 47,1,49,1
    2d_point 49,2
    2d_line 50,3,50,5
    2d_line 51,5,51,47
    2d_line 50,47,50,49
    2d_point 49,49
    2d_line 47,50,49,50
    2d_line 5,51,47,51
    2d_line 3,50,5,50
    2d_point 2,49
    2d_line 1,47,1,49
    2d_line 0,5,0,47
    2d_line 1,3,1,5
    
    ' image bouton relach
    picture 202
    2d_target_is 202
    width 202,38
    height 202,30
    top 202,7
    left 202,7
    color 202,60,60,60
    ' Pourtour du bouton pour obtenir un effet de relief
    2d_pen_color 90,90,90
    2d_line 0,0,38,0
    2d_line 0,1,37,1
    2d_line 0,0,0,30
    2d_line 1,0,1,29
    2d_pen_color 40,40,40
    2d_line 37,1,37,30
    2d_line 1,29,38,29
    2d_pen_color 50,50,50
    2d_line 2,28,37,28
    2d_line 36,2,36,29
    ' srigraphie
    ' lettre "O"
    2d_pen_color 200,200,200
    2d_line 14,5,17,5
    2d_line 17,6,17,11
    2d_line 14,11,17,11
    2d_line 13,6,13,11    
    ' lettre "n"
    2d_line 19,5,19,12
    2d_line 20,6,23,9
    2d_line 23,5,23,12
    2d_point 22,9
    ' barre horizontale de sparation 
    2d_line 8,14,30,14
    ' lettre "O"
    2d_line 13,17,16,17
    2d_line 16,18,16,23
    2d_line 13,23,16,23
    2d_line 12,18,12,23
    ' lettre "f"
    2d_line 18,17,22,17
    2d_line 18,17,18,24
    2d_line 18,20,21,20
    ' lettre "f"
    2d_line 23,17,27,17
    2d_line 23,17,23,24
    2d_line 23,20,26,20
    cursor_point 202

    ' image bouton enfonc
    create_hide
    picture 203
    2d_target_is 203
    width 203,38
    height 203,30
    top 203,7
    left 203,7
    color 203,60,60,60
    ' Pourtour du bouton pour obtenir un effet de relief
    2d_fill_off
    2d_pen_color 40,40,40
    2d_rectangle 0,0,38,30
    2d_pen_color 60,60,60
    2d_line 1,1,37,1
    2d_line 1,1,1,29
    ' srigraphie
    ' lettre "O"
    2d_pen_color 200,200,200
    2d_line 15,6,18,6
    2d_line 18,7,18,12
    2d_line 15,12,18,12
    2d_line 14,7,14,12    
    ' lettre "n"
    2d_line 20,6,20,13
    2d_line 21,7,24,10
    2d_line 24,6,24,13
    2d_point 23,10
    ' barre horizontale de sparation 
    2d_line 9,15,31,15
    ' lettre "O"
    2d_line 14,18,17,18
    2d_line 17,19,17,24
    2d_line 14,24,17,24
    2d_line 13,19,13,24
    ' lettre "f"
    2d_line 19,18,23,18
    2d_line 19,18,19,25
    2d_line 19,21,22,21
    ' lettre "f"
    2d_line 24,18,28,18
    2d_line 24,18,24,25
    2d_line 24,21,27,21
    create_show

    ' voyant
    picture 204
    width 204,38
    height 204,5
    top 204,41
    left 204,7
    color 204,255,0,0

    ' action sur le bouton (clic gauche)
    on_mouse_down 202,appuiBoutonOnOff  
end_sub
' ------------------------------------------------------------------------------
sub creerModuleIcones(x%,y%)
    command_target_is 0
    panel 10
    top 10,y%
    left 10,x%
    height 10,326
    width 10,44
    color 10,30,30,30
    command_target_is 10
    
    picture 11
    width 11,44
    height 11,326
    color 11,30,30,30
    2d_target_is 11
    ' cadre arrondi
    2d_pen_color 127,127,127
    2d_point 2,2
    2d_line 3,1,5,1
    2d_line 5,0,39,0
    2d_line 39,1,41,1
    2d_point 41,2
    2d_line 42,3,42,5
    2d_line 43,5,43,321
    2d_line 42,321,42,323
    2d_point 41,323
    2d_line 39,324,41,324
    2d_line 5,325,39,325
    2d_line 3,324,5,324
    2d_point 2,323
    2d_line 1,321,1,323
    2d_line 0,5,0,321
    2d_line 1,3,1,5
    
    creerIconeCadenas(9,9)
    creerIconeCacherBandeau(9,65)
    creerIconeReglages(9,121)
    creerIconeAide(9,177)
    creerIconeApropos(9,233)
    creerIconeQuitter(9,289)
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCadenas(x%,y%)
    picture 15
    top 15,y%
    left 15,x%
    width 15,26
    height 15,26
    color 15,30,30,30
    2d_target_is 15
    2d_pen_color 230,0,0
    2d_line 11,6,15,6
    2d_line 9,7,17,7
    2d_line 9,8,11,8
    2d_line 15,8,17,8
    2d_line 8,9,8,14
    2d_line 9,9,9,14
    2d_line 16,9,16,14
    2d_line 17,9,17,14
    2d_fill_off
    2d_rectangle 6,14,20,25
    2d_rectangle 7,15,19,24
    cursor_point 15
    hint 15,"Dverrouiller les commandes"
    on_click 15,appuiIconeCadenas
    
    picture 16
    top 16,y%
    left 16,x%
    width 16,26
    height 16,26
    color 16,30,30,30
    2d_target_is 16
    2d_pen_color 180,180,180
    2d_line 19,4,23,4
    2d_line 17,5,25,5
    2d_line 17,6,19,6
    2d_line 23,6,25,6
    2d_line 16,7,16,14
    2d_line 17,7,17,14
    2d_line 24,7,24,12
    2d_line 25,7,25,12
    2d_fill_off
    2d_rectangle 6,14,20,25
    2d_rectangle 7,15,19,24
    cursor_point 16
    hint 16,"Verrouiller les commandes"
    on_click 16,appuiIconeCadenas
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCacherBandeau(x%,y%)
    picture 20
    top 20,y%
    left 20,x%
    width 20,26
    height 20,26
    color 20,30,30,30
    2d_target_is 20
    2d_pen_color 180,180,180
    2d_fill_color 180,180,180
    2d_rectangle 0,6,26,10
    2d_fill_off
    2d_rectangle 0,9,26,22
    cursor_point 20
    hint 20,"Cacher / Afficher le bandeau"
    on_click 20,appuiIconeBandeau
end_sub
' ------------------------------------------------------------------------------
sub creerIconeReglages(x%,y%)
    picture 25
    top 25,y%
    left 25,x%
    width 25,26
    height 25,26
    color 25,30,30,30
    2d_target_is 25
    2d_pen_color 180,180,180
    2d_line 15,1,19,1
    2d_line 18,1,18,3
    2d_line 18,2,14,6
    2d_line 14,6,14,8
    2d_line 14,7,18,11
    2d_line 18,11,20,11
    2d_line 19,11,24,6
    2d_line 23,7,25,7
    2d_line 24,7,24,11
    2d_line 24,10,18,15
    2d_line 19,14,13,14
    2d_line 14,14,2,26
    2d_line 1,25,4,25
    2d_line 0,22,0,25
    2d_line 11,11,0,22
    2d_line 11,6,11,12
    2d_line 12,4,12,6
    2d_line 15,1,11,5
    2d_flood 14,11,180,180,180 
    ' trou dans la queue de la cl
    2d_pen_color 30,30,30
    2d_line 2,22,2,25
    2d_line 1,23,4,23

    cursor_point 25
    hint 25,"Rglages"
    on_click 25,AfficherReglages  
end_sub
' ------------------------------------------------------------------------------
sub creerIconeAide(x%,y%)
    picture 30
    top 30,y%
    left 30,x%
    width 30,26
    height 30,26
    color 30,30,30,30
    2d_target_is 30
    2d_pen_color 180,180,180
    2d_fill_color 180,180,180
    2d_line 10,1,16,1
    2d_line 8,2,18,2
    2d_line 7,3,19,3
    2d_line 7,4,11,4
    2d_line 14,4,19,4
    2d_line 6,5,10,5
    2d_rectangle 6,5,9,9
    2d_rectangle 16,5,20,10
    2d_line 15,10,19,10
    2d_line 14,11,19,11
    2d_line 13,12,18,12
    2d_line 12,13,17,13
    2d_line 12,14,16,14
    2d_rectangle 11,15,14,19
    2d_line 14,15,14,17
    2d_rectangle 11,21,14,24
    
    cursor_point 30
    hint 30,"Aide"
    on_click 30,afficheAide
end_sub
' ------------------------------------------------------------------------------
sub creerIconeApropos(x%,y%)
    picture 35
    top 35,y%
    left 35,x%
    width 35,26
    height 35,26
    color 35,30,30,30
    2d_target_is 35
    2d_pen_color 180,180,180
    2d_fill_color 180,180,180
    2d_line 11,2,14,2
    2d_rectangle 10,3,15,6
    2d_line 11,6,14,6
    2d_point 8,12
    2d_line 9,10,9,13
    2d_line 10,9,10,12
    2d_rectangle 11,9,14,22
    2d_line 11,22,17,22
    2d_point 16,21
    2d_line 12,23,16,23
    2d_line 13,24,15,24
    
    cursor_point 35
    hint 35,"Informations"
    on_click 35,afficherApropos
end_sub
' ------------------------------------------------------------------------------
sub creerIconeQuitter(x%,y%)
    picture 40
    top 40,y%
    left 40,x%
    width 40,26
    height 40,26
    color 40,30,30,30
    2d_target_is 40
    2d_pen_color 180,180,180
    2d_line 2,1,19,1
    2d_line 2,2,19,2
    2d_line 17,3,17,5
    2d_line 18,3,18,5
    2d_line 2,1,2,25
    2d_line 3,1,3,25
    2d_line 2,23,19,23
    2d_line 2,24,19,24
    2d_line 17,21,17,23
    2d_line 18,21,18,24
    ' flche
    2d_line 11,12,24,12
    2d_line 11,13,24,13
    2d_line 18,8,20,8
    2d_line 18,9,21,9
    2d_line 19,10,22,10
    2d_line 20,11,23,11
    2d_line 20,14,23,14
    2d_line 19,15,22,15
    2d_line 18,16,21,16
    2d_line 18,17,20,17

    cursor_point 40
    hint 40,"Quitter le programme"
    on_click 40,quitter
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreApropos(x%,y%)
    dim_local txt$
    command_target_is 0
    create_hide

    panel 220
    left 220,x%
    top 220,y%
    width 220,360
    height 220,260

    create_show
    command_target_is 220

    alpha 222
    top 222,30
    font_name 222,"Arial"
    font_size 222,13
    color 222,240,240,240
    txt$ = "PANORAMIC ~ Rgie Lumire 8 canaux"
    left 222,(width(220) - text_width(txt$,222)) / 2
    caption 222,txt$
    
    alpha 223
    top 223,55
    font_name 223,"Arial"
    font_size 223,10
    font_italic 223
    color 223,240,240,240
    txt$ = "Version 1.00 du 25 mai 2022"
    left 223,(width(220) - text_width(txt$,223)) / 2
    caption 223,txt$
    
    alpha 224      
    top 224,100
    font_name 224,"Arial"
    font_size 224,11
    color 224,240,240,240
    txt$ = "Ce programme a t crit par Marc"
    left 224,(width(220) - text_width(txt$,224)) / 2
    caption 224,txt$
    
    alpha 225      
    top 225,120
    font_name 225,"Arial"
    font_size 225,11
    color 225,240,240,240
    txt$ = "en langage informatique PANORAMIC 0.9.29i9"
    left 225,(width(220) - text_width(txt$,225)) / 2
    caption 225,txt$

    alpha 226      
    top 226,168
    left 226,20
    font_name 226,"Arial"
    font_size 226,10
    color 226,240,240,240
    txt$ = "Forum PANORAMIC : https://panoramic.1fr1.net/"
    left 226,(width(220) - text_width(txt$,226)) / 2
    caption 226,txt$
    cursor_point 226
    hint 226,"Click gauche pour copier l'adresse du forum"
    on_click 226,copierAdresseInternet
    
    button 228
    width 228,75
    height 228,25
    top 228,210
    left 228,137
    caption 228,"Fermer"
    
    on_click 228,fermerApropos
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreReglages()
    command_target_is 0
    create_hide
    panel 240
    top 240,36
    left 240,190
    width 240,432
    height 240,295
    create_show
    command_target_is 240
    
    button 241
    top 241,245
    left 241,294
    width 241,75
    height 241,25
    caption 241,"Fermer"
    on_click 241,fermerReglages
    
    creerModuleFichiers(20,20) 
    creerModuleMemorisation(20,175)
    creerModuleSerial(250,20)
end_sub
' ------------------------------------------------------------------------------
sub creerModuleFichiers(x%,y%)
    command_target_is 240

    container 245
    height 245,145
    width 245,211
    top 245,y%
    left 245,x%
    caption 245," Fichiers " 
    
    command_target_is 245

    button 246
    top 246,36
    left 246,25
    width 246,160
    height 246,25
    caption 246,"Charger un modle"
    on_click 246,chargerModele
    
    button 250
    top 250,89
    left 250,25
    width 250,160
    height 250,25
    caption 250,"Enregistrer le modle"
    on_click 250,enregistrerModele
end_sub
' ------------------------------------------------------------------------------
sub creerModuleMemorisation(x%,y%)
    command_target_is 240

    container 255
    height 255,100
    width 255,211
    top 255,y%
    left 255,x%
    caption 255," Mmorisation " 
    
    command_target_is 255

    alpha 256
    top 256,28
    left 256,25
    caption 256,"Rglage Transition :"
    
    picture 257
    top 257,25
    left 257,150
    width 257,35
    height 257,20
    2d_target_is 257
    print_target_is 257
    print_locate 7,3
    print "NON"
    cursor_point 257
    on_click 257,choixMemorisationTransition
    
    
    alpha 258
    top 258,62
    left 258,25
    caption 258,"Rglage Master :"
    
    picture 259
    top 259,59
    left 259,150
    width 259,35
    height 259,20
    2d_target_is 259
    print_target_is 259
    print_locate 7,3
    print "NON"
    cursor_point 259
    on_click 259,choixMemorisationMaster
    
    command_target_is 255
end_sub    
' ------------------------------------------------------------------------------
sub creerModuleSerial(x%,y%)
    dim_local n%
    command_target_is 240

    container 260
    height 260,200
    width 260,162
    top 260,y%
    left 260,x%
    caption 260," Port COM srie " 
    
    command_target_is 260

    ' legendes
    alpha 261
    top 261,25
    left 261,44
    caption 261,"Port :"
    
    alpha 262
    top 262,60
    left 262,17
    caption 262,"Baud rate :"
    
    alpha 263
    top 263,95
    left 263,21
    caption 263,"Data bits :"

    alpha 264
    top 264,130
    left 264,36
    caption 264,"Parity :"
    
    alpha 265
    top 265,165
    left 265,22
    caption 265,"Stop bits :"

    ' n port COM
    combo 266
    top 266,22
    left 266,75
    width 266,70
    height 266,25
    for n% = 1 to 255
        item_add 266,"COM" + str$(n%)
    next n%
    on_change 266,choixPortCom
    
    ' vitesse en bauds
    combo 267
    top 267,57
    left 267,75
    width 267,70
    height 267,25
    item_add 267,"110"
    item_add 267,"300"
    item_add 267,"600"
    item_add 267,"1200"
    item_add 267,"2400"
    item_add 267,"4800"
    item_add 267,"9600"
    item_add 267,"14400"
    item_add 267,"19200"
    item_add 267,"38400"
    item_add 267,"57600"
    item_add 267,"115200"
    on_change 267,choixBaudrate
    
    ' donnes : nombre bits
    combo 268
    top 268,92
    left 268,75
    width 268,70
    item_add 268,"5"
    item_add 268,"6"
    item_add 268,"7"
    item_add 268,"8"
    on_change 268,choixNbBits
    
    ' parit
    combo 269  
    top 269,127
    left 269,75
    width 269,70
    item_add 269,"Aucune"
    item_add 269,"Impaire"
    item_add 269,"Paire"
    on_change 269,choixParity
    
    ' bits d'arrt
    combo 270
    top 270,162
    left 270,75
    width 270,70
    item_add 270,"1"
    item_add 270,"1.5"
    item_add 270,"2"
    on_change 270,choixBitstop
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreAide()
    form 45
    width 45,800
    height 45,500
    left 45,30
    top 45,30
    caption 45,"PANORAMIC Rgie lumire 8 canaux"
    command_target_is 45
    memo_rich 46
    color 46,240,240,230
    full_space 46
    bar_vertical 46
    notice()
    hide 45
end_sub
' ------------------------------------------------------------------------------
sub lectureFichierSauvegarde()
    dim_local i%
    if file_exists(dossier$ + "rl8save") = 0
       ' valeurs par dfaut port srie
        sPortCom$ = ""
        sBaudRate$ = "9600"
        sDataBit$ = "8"
        sParity$ = "Aucune"
        sStopBit$ ="1"

       ' valeurs par dfaut des tiquettes des boutons mmoires
        etiquettes$(1) = "Canal 1"
        etiquettes$(2) = "Canal 2"
        etiquettes$(3) = "Canal 3"
        etiquettes$(4) = "Canal 4"
        etiquettes$(5) = "Canal 5"
        etiquettes$(6) = "Canal 6"
        etiquettes$(7) = "Canal 7"
        etiquettes$(8) = "Canal 8"
        etiquettes$(9) = "Transition"
        etiquettes$(10) = "Master"
        etiquettes$(11) = "M1"
        etiquettes$(12) = "M2"
        etiquettes$(13) = "M3"
        etiquettes$(14) = "M4"
        etiquettes$(15) = "M5"

        ' valeurs par dfaut des potentiomtres
        niveauPotentiometre%(1) = 0 :' [0,100]
        niveauPotentiometre%(2) = 0 :' [0,100]
        niveauPotentiometre%(3) = 0 :' [0,100]
        niveauPotentiometre%(4) = 0 :' [0,100]
        niveauPotentiometre%(5) = 0 :' [0,100]
        niveauPotentiometre%(6) = 0 :' [0,100]
        niveauPotentiometre%(7) = 0 :' [0,100]
        niveauPotentiometre%(8) = 0 :' [0,100]
        niveauPotentiometre%(9) = 0 :' [0,100]
        niveauPotentiometre%(10) = 100 :' [0,100]

        ' valeurs par dfaut du choix de la mmorisation
        memorisationMaster% = 0 
        memorisationTransition% = 0
    else
    ' lecture de l'enregistrement automatique de tous les paramtres  
        file_open_read 233,dossier$ + "rl8save"
        ' port srie
        sPortCom$ = file_readln$(233)
        sBaudRate$ = file_readln$(233)
        sDataBit$ = file_readln$(233)
        sParity$ = file_readln$(233)
        sStopBit$ = file_readln$(233)
        ' tiquettes
        for i% = 1 to 15
            etiquettes$(i%) = file_readln$(233)
        next i%
        ' position des curseurs des potentiomtres
        for i% = 1 to 10
            niveauPotentiometre%(i%) = val(file_readln$(233))
        next i%
        ' choix de la mmorisation
        memorisationMaster% = val(file_readln$(233)) 
        memorisationTransition% = val(file_readln$(233))
        ' contenu des mmoires
        for i% = 1 to 5
            for j% = 1 to 10
                memoire%(i%,j%) = val(file_readln$(233))
            next j%
        next i%
        file_close 233
    end_if

    ' afficher paramtres port COM
    text 266,sPortCom$
    text 267,sBaudRate$
    text 268,sDataBit$
    text 269,sParity$
    text 270,sStopBit$

    if sPortCom$ <> "" 
        portCom% = val(mid$(sPortCom$,4,len(sPortCom$)))
    end_if    

    afficherEtiquettes()
    positionnerCurseurPotentiometre()
    afficherChoixMemorisation()
end_sub
' ------------------------------------------------------------------------------
sub afficherChoixMemorisation()
    if memorisationMaster% = 1
        color 259,255,255,255
        print_target_is 259
        print_locate 7,3
        print "OUI"
    else
        color 259,255,255,255
        print_target_is 259
        print_locate 7,3
        print "NON"
    end_if  

    if memorisationTransition% = 1
        color 257,255,255,255
        print_target_is 257
        print_locate 7,3
        print "OUI"
    else
        color 257,255,255,255
        print_target_is 257
        print_locate 7,3
        print "NON"
    end_if
end_sub
' ------------------------------------------------------------------------------
sub afficherEtiquettes()
    dim_local n%
    etiquette% = 54
    for n% = 1 to 15
        ' centrer le texte de l'tiquette
        left etiquette%,(54 - text_width(etiquettes$(n%),etiquette%)) / 2
        ' afficher le texte de l'tiquette
        caption etiquette%,etiquettes$(n%)
        etiquette% = etiquette% + 10
    next n%
end_sub
' ------------------------------------------------------------------------------
sub positionnerCurseurPotentiometre()
    dim_local n%, curseur%
    curseur% = 52
    for n% = 1 to 10
        valeur = niveauPotentiometre%(n%)
        ' afficher la valeur de rglage du potentiomtre
        if valeur < 1
            font_color curseur%+5,255,0,0
            txt$ = "OFF"
        else
            font_color curseur%+5,0,255,0
            if n% = 9 :' exception pour le curseur 9 "Transition"
                txt$ = str$(valeur/10) + "s" 
            else
                txt$ = str$(valeur) + "%"
            end_if
        end_if

        left curseur%+5,(54 - text_width(txt$,curseur%+5)) / 2
        caption curseur%+5,txt$
        ' Positionner le curseur du potentiomtre
        valeur = valeur / 0.745
        valeur = int(155 - valeur)
        sprite_y_position curseur%,valeur 
        curseur% = curseur% + 10
    next n%
end_sub
' ------------------------------------------------------------------------------
choixPortCom:
    serial_close 234
    on% = 0
    color 204,255,0,0 :' couleur du voyant (rouge)

    if item_index(266) = 0
       text 266,sPortCom$
       return
    end_if
    
    sPortCom$ = item_index$(266)
    portCom% = val(mid$(sPortCom$,4,len(sPortCom$)))    

    if serial_port_exists(portCom%) = 0
        info$ = "Le port " + sPortCom$ + " n'est pas disponible !" + chr$(13) + chr$(13)
        info$ = info$ + "Vrifiez les connexions lectriques ainsi que le numro de port COM attribu."
        if message_error_ok(info$) < 2
            return
        end_if 
    end_if
return
' ------------------------------------------------------------------------------
choixBaudrate:
    if item_index(267) = 0
       text 267,sBaudRate$
       return
    end_if
    sBaudRate$ = item_index$(267)
return
' ------------------------------------------------------------------------------
choixNbBits:
    if item_index(268) = 0
       text 268,sDataBit$
       return
    end_if
    sDataBit$ = item_index$(268)
return
' ------------------------------------------------------------------------------
choixParity:
    if item_index(269) = 0
       text 269,sParity$
       return
    end_if
    sParity$ = item_index$(269)
return
' ------------------------------------------------------------------------------
choixBitstop:
    if item_index(270) = 0
       text 270,sStopBit$
       return
    end_if
    sStopBit$ = item_index$(270)
return
' ------------------------------------------------------------------------------
sub envoyerTrameSerie()
    trame$ = chr$(128)
    trame$ = trame$ + chr$(int(niveauPotentiometre%(1) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(2) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(3) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(4) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(5) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(6) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(7) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(int(niveauPotentiometre%(8) * niveauPotentiometre%(10) / 100))
    trame$ = trame$ + chr$(255)
    if on% = 1
        serial_write 234,trame$
    end_if
end_sub
' ------------------------------------------------------------------------------
choixMemorisationMaster:
    if memorisationMaster% = 0
        memorisationMaster% = 1
        color 259,255,255,255
        print_target_is 259
        print_locate 7,3
        print "OUI"
    else
       memorisationMaster% = 0
        color 259,255,255,255
        print_target_is 259
        print_locate 7,3
        print "NON"
    end_if  
return
' ------------------------------------------------------------------------------
choixMemorisationTransition:
    if memorisationTransition% = 0
        memorisationTransition% = 1
        color 257,255,255,255
        print_target_is 257
        print_locate 7,3
        print "OUI"
    else
        memorisationTransition% = 0
        color 257,255,255,255
        print_target_is 257
        print_locate 7,3
        print "NON"
    end_if
return
' ------------------------------------------------------------------------------
enregistrerModele:
    enregistrerFichier()
return
' ------------------------------------------------------------------------------
sub enregistrerFichier()
    dim_local nomFichier$, b$, longueurNomProjet%, pos%, n%, annonce$

    filter 231,"Fichier Rgie Lumire (*.rl1)|*.rl1"
    nomFichier$ = file_name$(231)

    if nomFichier$ = "_" or nomFichier$ = ""
        exit_sub
    end_if
        
    b$=lower$(nomFichier$)
    
    if file_extract_extension$(b$) <> ".rl1"
        if file_extract_extension$(b$) <> ""
            longueurNomProjet% = len(nomFichier$)
            pos% = instr_right(nomFichier$,".")
            n% = longueurNomProjet% - pos%
            nomFichier$ = left$(nomFichier$,n%)
        end_if
        nomFichier$ = nomFichier$ + ".rl1"
    end_if

    if file_exists(nomFichier$) = 1
        b$ = file_extract_name$(nomFichier$)
        annonce$ = "Enregistrement :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le fichier " + chr$(34) + b$ + chr$(34) + " existe dj !"
        annonce$ = annonce$ + chr$(13) + chr$(13)+ "Le remplacer ?"
        if message_confirmation_yes_no(annonce$) <> 1
            exit_sub
        end_if    
    end_if    

    ' enregistrement sur disque
    file_open_write 232,nomFichier$
        ' port srie
        file_writeln 232,sPortCom$
        file_writeln 232,sBaudRate$
        file_writeln 232,sDataBit$
        file_writeln 232,sParity$
        file_writeln 232,sStopBit$
        ' tiquettes
        for i% = 1 to 15
            file_writeln 232,etiquettes$(i%)
        next i%
        ' position des curseurs des potentiomtres
        for i% = 1 to 10
            file_writeln 232,str$(niveauPotentiometre%(i%))
        next i%
        ' choix de la mmorisation
        file_writeln 232,str$(memorisationMaster%) 
        file_writeln 232,str$(memorisationTransition%)
        ' contenu des mmoires
        for i% = 1 to 5
            for j% = 1 to 10
                file_writeln 232,str$(memoire%(i%,j%))
            next j%
        next i%
    file_close 232
    hide 240 
    message "Enregistrement effectu avec succs !"
end_sub
' ------------------------------------------------------------------------------
chargerModele:
    ouvrirFichier()
return
' ------------------------------------------------------------------------------
sub ouvrirFichier()
    dim_local nomFichier$, reponseUtilisateur%
    filter 230,"Fichier Rgie Lumire (*.rl1)|*.rl1"
    nomFichier$ = file_name$(230)

    if nomFichier$ = "_"
         exit_sub
    end_if
         
    if file_exists(nomFichier$) = 0
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(nomFichier$) + "''  est introuvable !")
        exit_sub
    end_if
    
    if lower$(file_extract_extension$(nomFichier$)) <> ".rl1"
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(nomFichier$) + "''  n'est pas compatible avec la Rgie Lumire !")
        exit_sub
    end_if

    ' lecture fichier sur le disque  
    file_open_read 233,nomFichier$
       ' port srie
        sPortCom$ = file_readln$(233)
        sBaudRate$ = file_readln$(233)
        sDataBit$ = file_readln$(233)
        sParity$ = file_readln$(233)
        sStopBit$ = file_readln$(233)
        ' tiquettes
        for i% = 1 to 15
            etiquettes$(i%) = file_readln$(233)
        next i%
        ' position des curseurs des potentiomtres
        for i% = 1 to 10
            niveauPotentiometre%(i%) = val(file_readln$(233))
        next i%
        ' choix de la mmorisation
        memorisationMaster% = val(file_readln$(233)) 
        memorisationTransition% = val(file_readln$(233))
        ' contenu des mmoires
        for i% = 1 to 5
            for j% = 1 to 10
                memoire%(i%,j%) = val(file_readln$(233))
            next j%
        next i%
    file_close 233

    ' afficher paramtres port COM
    text 266,sPortCom$
    text 267,sBaudRate$
    text 268,sDataBit$
    text 269,sParity$
    text 270,sStopBit$

    if sPortCom$ <> "" 
        portCom% = val(mid$(sPortCom$,4,len(sPortCom$)))
    end_if    

    afficherEtiquettes()
    positionnerCurseurPotentiometre()
    afficherChoixMemorisation()
    hide 240
end_sub
' ------------------------------------------------------------------------------
fermerApropos:
    hide 220
return
' ------------------------------------------------------------------------------
copierAdresseInternet:
    clipboard_string_copy "https://panoramic.1fr1.net/"
return
' ------------------------------------------------------------------------------
appuiIconeCadenas:
    annulerEditionEtiquette()

    if cadenas% = 0
        cadenas% = 1
        show 15
        hide 16
        inactive 210 :' panel des boutons mmoires
        off_mouse_down 52 :' curseur 1
        off_mouse_down 62 :' curseur 2
        off_mouse_down 72 :' curseur 3
        off_mouse_down 82 :' curseur 4
        off_mouse_down 92 :' curseur 5
        off_mouse_down 102 :' curseur 6
        off_mouse_down 112 :' curseur 7
        off_mouse_down 122 :' curseur 8
        off_mouse_down 132 :' curseur 9
        off_mouse_down 142 :' curseur 10
        off_mouse_down 202 :' bouton ON/OFF
        off_click 20 :' icone Bandeau
        off_click 25 :' icone Reglages  
        off_click 35 :' icone A propos
        off_click 40 :' icone Quitter
    else
        cadenas% = 0
        show 16
        hide 15
        active 210 :' panel boutons memoires
        on_mouse_down 52,deplacerCurseur1
        on_mouse_down 62,deplacerCurseur2
        on_mouse_down 72,deplacerCurseur3
        on_mouse_down 82,deplacerCurseur4
        on_mouse_down 92,deplacerCurseur5
        on_mouse_down 102,deplacerCurseur6
        on_mouse_down 112,deplacerCurseur7
        on_mouse_down 122,deplacerCurseur8
        on_mouse_down 132,deplacerCurseur9
        on_mouse_down 142,deplacerCurseur10
        on_mouse_down 202,appuiBoutonOnOff
        on_click 20,appuiIconeBandeau
        on_click 25,AfficherReglages  
        on_click 35,afficherApropos
        on_click 40,quitter
    end_if    
return
' ------------------------------------------------------------------------------
appuiIconeBandeau:
    annulerEditionEtiquette()
    top0% = top(0)
    left0% = left(0)
    if bandeau% = 0
        bandeau% = 1
        border_normal 0
        width 0,width(0) - width_client(0) + 807
        height 0,height(0) - height_client(0) + 367
        top 0,top0% - 31
        left 0,left0% - 8
    else
        bandeau% = 0
        border_hide 0
        width 0,807
        height 0,367
        top 0,top0% + 31
        left 0,left0% + 8
    end_if
return
' ------------------------------------------------------------------------------
AfficherReglages:
    annulerEditionEtiquette()
    hide 220 :' fenetre A Propos
    if show(240) = 0
        show 240
    else
        hide 240
    end_if    
return
' ------------------------------------------------------------------------------
fermerReglages:
    hide 240
return
' ------------------------------------------------------------------------------
afficheAide:
    annulerEditionEtiquette()
    show 45
    normal 45
    to_foreground 45
return
' ------------------------------------------------------------------------------
appuiBoutonOnOff:
    off_mouse_down 202  
    annulerEditionEtiquette()

    ' on ignore le clic-droit souris
    if mouse_right_down(202)=1
        on_mouse_down 202,appuiBoutonOnOff  
        return
    end_if
    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(202)
    null% = mouse_left_down(202)
    ' le bouton est enfonc
    while mouse_left_up(202) = 0 :' Tant que le bouton gauche souris reste appuy            
       show 203
       pause 20
    end_while
    ' le bouton est relach
    if on% = 1
        on% = 0
        color 204,255,0,0 :' couleur du voyant (rouge)
        serial_close 234
    else
        on% = 1
        color 204,0,255,0 :' couleur du voyant (vert)
        ouvrirLiaisonSerie()
    end_if    
    hide 203
    on_mouse_down 202,appuiBoutonOnOff  
return
' ------------------------------------------------------------------------------
sub ouvrirLiaisonSerie()
    if sPortCom$ = ""
        info$ = "Veuillez configurer le port srie !"
        if message_warning_ok(info$) > 0
        on% = 0
        color 204,255,0,0 :' couleur du voyant (rouge)
        end_if
        exit_sub
    end_if

    if serial_port_exists(portCom%) = 0
        info$ = "Le port " + sPortCom$ + " n'est pas disponible !" + chr$(13) + chr$(13)
        info$ = info$ + "Vrifiez les connexions lectriques ainsi que le numro de port COM attribu."
        if message_error_ok(info$) < 2
            on% = 0
            color 204,255,0,0 :' couleur du voyant (rouge)
            exit_sub
        end_if 
    end_if
    
    if sParity$ = "Aucune" then parity% = 0
    if sParity$ = "Impaire" then parity% = 1
    if sParity$ = "Paire" then parity% = 2

    serial_port 234,portCom%
    serial_baudrate 234,val(sBaudRate$)
    serial_databits 234,val(sDataBit$)
    serial_parity 234,parity%
    serial_stopbits 234,val(sStopBit$)
    serial_open 234

    envoyerTrameSerie()
end_sub
' ------------------------------------------------------------------------------
sub creerAfficheurs(x%,y%)
    command_target_is 0
    color 1,0,0,0 :' Planche  dessins

    creerAfficheur(100,x%,y%)
    x% = x% + 57
    creerAfficheur(105,x%,y%)
    x% = x% + 57
    creerAfficheur(110,x%,y%)
    x% = x% + 57
    creerAfficheur(115,x%,y%)
    x% = x% + 57
    creerAfficheur(120,x%,y%)
    x% = x% + 57
    creerAfficheur(125,x%,y%)
    x% = x% + 57
    creerAfficheur(130,x%,y%)
    x% = x% + 57
    creerAfficheur(135,x%,y%)
    x% = x% + 80
    creerAfficheur(140,x%,y%)
    x% = x% + 80
    creerAfficheur(145,x%,y%)
end_sub
' ------------------------------------------------------------------------------
sub creerAfficheur(n%,x%,y%)
    picture n%
    width n%,54
    height n%,20
    left n%,x%
    top n%,y%
    color n%,10,10,10
    
    alpha n% + 1
    left n% + 1,x% + 8
    top n% + 1,y% + 2
    color n% + 1,10,10,10
    font_name n% + 1,"Courier"
    font_color n% + 1,0,180,0
    font_size n% + 1,12
end_sub
' ------------------------------------------------------------------------------
deplacerCurseur1:
    off_mouse_down 52
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(52)=1
        on_mouse_down 52,deplacerCurseur1    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(52)
    null% = mouse_left_down(52)

    while mouse_left_up(52) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(52)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 52,20
        end_if
        if ySouris% > 155
            sprite_y_position 52,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 52,ySouris%
        end_if
        valeur = sprite_y_position(52)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(1)
            niveauPotentiometre%(1) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 57,255,0,0
            txt$ = "OFF"
        else
            font_color 57,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 57,(54 - text_width(txt$,57)) / 2
        caption 57,txt$
        pause 30
    end_while
    on_mouse_down 52,deplacerCurseur1    
return
' ------------------------------------------------------------------------------
deplacerCurseur2:
    off_mouse_down 62
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(62)=1
        on_mouse_down 62,deplacerCurseur2    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(62)
    null% = mouse_left_down(62)

    while mouse_left_up(62) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(62)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 62,20
        end_if
        if ySouris% > 155
            sprite_y_position 62,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 62,ySouris%
        end_if
        valeur = sprite_y_position(62)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(2)
            niveauPotentiometre%(2) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 67,255,0,0
            txt$ = "OFF"
        else
            font_color 67,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 67,(54 - text_width(txt$,67)) / 2
        caption 67,txt$
        pause 30
    end_while
    on_mouse_down 62,deplacerCurseur2    
return
' ------------------------------------------------------------------------------
deplacerCurseur3:
    off_mouse_down 72
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(72)=1
        on_mouse_down 72,deplacerCurseur3    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(72)
    null% = mouse_left_down(72)

    while mouse_left_up(72) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(72)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 72,20
        end_if
        if ySouris% > 155
            sprite_y_position 72,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 72,ySouris%
        end_if
        valeur = sprite_y_position(72)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(3)
            niveauPotentiometre%(3) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 77,255,0,0
            txt$ = "OFF"
        else
            font_color 77,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 77,(54 - text_width(txt$,77)) / 2
        caption 77,txt$
        pause 30
    end_while
    on_mouse_down 72,deplacerCurseur3    
return
' ------------------------------------------------------------------------------
deplacerCurseur4:
    off_mouse_down 82
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(82)=1
        on_mouse_down 82,deplacerCurseur4    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(82)
    null% = mouse_left_down(82)

    while mouse_left_up(82) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(82)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 82,20
        end_if
        if ySouris% > 155
            sprite_y_position 82,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 82,ySouris%
        end_if
        valeur = sprite_y_position(82)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(4)
            niveauPotentiometre%(4) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 87,255,0,0
            txt$ = "OFF"
        else
            font_color 87,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 87,(54 - text_width(txt$,87)) / 2
        caption 87,txt$
        pause 30
    end_while
    on_mouse_down 82,deplacerCurseur4    
return
' ------------------------------------------------------------------------------
deplacerCurseur5:
    off_mouse_down 92
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(92)=1
        on_mouse_down 92,deplacerCurseur5    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(92)
    null% = mouse_left_down(92)

    while mouse_left_up(92) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(92)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 92,20
        end_if
        if ySouris% > 155
            sprite_y_position 92,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 92,ySouris%
        end_if
        valeur = sprite_y_position(92)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(5)
            niveauPotentiometre%(5) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 97,255,0,0
            txt$ = "OFF"
        else
            font_color 97,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 97,(54 - text_width(txt$,97)) / 2
        caption 97,txt$
        pause 30
    end_while
    on_mouse_down 92,deplacerCurseur5    
return
' ------------------------------------------------------------------------------
deplacerCurseur6:
    off_mouse_down 102
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(102)=1
        on_mouse_down 102,deplacerCurseur6    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(102)
    null% = mouse_left_down(102)

    while mouse_left_up(102) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(102)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 102,20
        end_if
        if ySouris% > 155
            sprite_y_position 102,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 102,ySouris%
        end_if
        valeur = sprite_y_position(102)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(6)
            niveauPotentiometre%(6) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 107,255,0,0
            txt$ = "OFF"
        else
            font_color 107,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 107,(54 - text_width(txt$,107)) / 2
        caption 107,txt$
        pause 30
    end_while
    on_mouse_down 102,deplacerCurseur6    
return
' ------------------------------------------------------------------------------
deplacerCurseur7:
    off_mouse_down 112
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(112) = 1
        on_mouse_down 112,deplacerCurseur7    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(112)
    null% = mouse_left_down(112)

    while mouse_left_up(112) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(112)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 112,20
        end_if
        if ySouris% > 155
            sprite_y_position 112,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 112,ySouris%
        end_if
        valeur = sprite_y_position(112)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(7)
            niveauPotentiometre%(7) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 117,255,0,0
            txt$ = "OFF"
        else
            font_color 117,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 117,(54 - text_width(txt$,117)) / 2
        caption 117,txt$
        pause 30
    end_while
    on_mouse_down 112,deplacerCurseur7    
return
' ------------------------------------------------------------------------------
deplacerCurseur8:
    off_mouse_down 122
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(122)=1
        on_mouse_down 122,deplacerCurseur8    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(122)
    null% = mouse_left_down(122)

    while mouse_left_up(122) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(122)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 122,20
        end_if
        if ySouris% > 155
            sprite_y_position 122,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 122,ySouris%
        end_if
        valeur = sprite_y_position(122)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(8)
            niveauPotentiometre%(8) = valeur
            envoyerTrameSerie()
        end_if
        if valeur < 1
            font_color 127,255,0,0
            txt$ = "OFF"
        else
            font_color 127,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 127,(54 - text_width(txt$,127)) / 2
        caption 127,txt$
        pause 30
    end_while
    on_mouse_down 122,deplacerCurseur8    
return
' ------------------------------------------------------------------------------
deplacerCurseur9:
    off_mouse_down 132
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(132)=1
        on_mouse_down 132,deplacerCurseur9    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(132)
    null% = mouse_left_down(132)

    while mouse_left_up(132) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(132)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 132,20
        end_if
        if ySouris% > 155
            sprite_y_position 132,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 132,ySouris%
        end_if
        valeur = sprite_y_position(132)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)
        if valeur <> niveauPotentiometre%(9)
            niveauPotentiometre%(9) = valeur
        end_if
        valeur = valeur / 10
        if valeur < 0.1
            font_color 137,255,0,0
            txt$ = "OFF"
        else
            font_color 137,0,255,0
            txt$ = str$(valeur) + "s"
        end_if
        left 137,(54 - text_width(txt$,137)) / 2
        caption 137,txt$
        pause 30
    end_while
    on_mouse_down 132,deplacerCurseur9    
return
' ------------------------------------------------------------------------------
deplacerCurseur10:
    off_mouse_down 142
    annulerEditionEtiquette()

    ' inhibition bouton droit souris 
    if mouse_right_down(142)=1
        on_mouse_down 142,deplacerCurseur10    
        return
    end_if

    ' raffraichissement de l'tat des boutons de la souris
    null% = mouse_left_up(142)
    null% = mouse_left_down(142)

    while mouse_left_up(142) = 0 :' Tant que le bouton gauche souris est appuy            
        ySouris% = mouse_y_position(142)-19
        if ySouris% < 20 :' limite haute
            sprite_y_position 142,20
        end_if
        if ySouris% > 155
            sprite_y_position 142,155 :' limite basse
        end_if
        if ySouris% > 20 and ySouris% < 155
            sprite_y_position 142,ySouris%
        end_if
        valeur = sprite_y_position(142)
        valeur = 155 - valeur
        valeur = int(valeur * 0.745)

        if valeur <> niveauPotentiometre%(10)
            niveauPotentiometre%(10) = valeur
            envoyerTrameSerie()
        end_if
        
        if valeur < 1
            font_color 147,255,0,0
            txt$ = "OFF"
        else
            font_color 147,0,255,0
            txt$ = str$(valeur) + "%"
        end_if
        left 147,(54 - text_width(txt$,147)) / 2
        caption 147,txt$
        pause 30
    end_while
    on_mouse_down 142,deplacerCurseur10    
return
' ------------------------------------------------------------------------------
appuiMemoire1:
    bloquerEvenements()
    annulerEditionEtiquette()

    ' inhiber l'action du bouton droit souris
    if mouse_right_down(151) = 1
        on_mouse_down 151,appuiMemoire1
        return
    end_if

    ' raffraichir l'tat des boutons de la souris
    null% = mouse_left_up(151)
    null% = mouse_left_down(151)

    show 152 :' afficher le picture bouton travail 
    hide 151 :' afficher le picture bouton repos
    2d_target_is 152
              
    action% = 0
    delai% = number_ticks

    while mouse_left_up(151) = 0 :' Tant que le bouton gauche souris n'est pas lach            
        if delai% + 1500 < number_ticks :' delai d'attente en ms pour valider l'appui long
            action% = 1

            ' mise en mmoire des rglages
            for i% = 1 to 10
                memoire%(1,i%) = niveauPotentiometre%(i%)
            next i%

            2d_flood 10,10,230,0,0
            pause 100 :' dlai du premier flash rouge
            2d_flood 10,10,60,60,60
            pause 100 :' delai entre les deux flashs
            2d_flood 10,10,230,0,0
            pause 100 :' dlai du 2me flash rouge
            2d_flood 10,10,60,60,60
            exit_while    
        end_if
    end_while

    if action% = 0
        transition(1) :' n du bouton mmoire en paramtre
        2d_flood 10,10,0,200,0
        pause 150 :' dlai du flash vert
        2d_flood 10,10,60,60,60
    end_if

    show 151 :' afficher le picture bouton repos
    hide 152 :' cacher le picture bouton travail
    debloquerEvenements()
return
' ------------------------------------------------------------------------------
appuiMemoire2:
    bloquerEvenements()
    annulerEditionEtiquette()

    ' inhiber l'action du bouton droit souris
    if mouse_right_down(161) = 1
        on_mouse_down 161,appuiMemoire2
        return
    end_if

    ' raffraichir l'tat des boutons de la souris
    null% = mouse_left_up(161)
    null% = mouse_left_down(161)

    show 162 :' afficher le picture bouton travail 
    hide 161 :' afficher le picture bouton repos
    2d_target_is 162
              
    action% = 0
    delai% = number_ticks
    while mouse_left_up(161) = 0 :' Tant que le bouton gauche souris n'est pas lach            
        if delai% + 1500 < number_ticks :' delai d'attente en ms pour valider l'appui long
            action% = 1

            ' mise en mmoire des rglages
            for i% = 1 to 10
                memoire%(2,i%) = niveauPotentiometre%(i%)
            next i%

            2d_flood 10,10,230,0,0
            pause 100 :' dlai du premier flash rouge
            2d_flood 10,10,60,60,60
            pause 100 :' delai entre les deux flashs
            2d_flood 10,10,230,0,0
            pause 100 :' dlai du 2me flash rouge
            2d_flood 10,10,60,60,60
            exit_while    
        end_if
    end_while
    if action% = 0
        transition(2) :' n du bouton mmoire en paramtre
        2d_flood 10,10,0,200,0
        pause 150 :' dlai du flash vert
        2d_flood 10,10,60,60,60
    end_if

    show 161 :' afficher le picture bouton repos
    hide 162 :' cacher le picture bouton travail
    debloquerEvenements()
return
' ------------------------------------------------------------------------------
appuiMemoire3:
    bloquerEvenements()
    annulerEditionEtiquette()

    ' inhiber l'action du bouton droit souris
    if mouse_right_down(171) = 1
        on_mouse_down 171,appuiMemoire3
        return
    end_if

    ' raffraichir l'tat des boutons de la souris
    null% = mouse_left_up(171)
    null% = mouse_left_down(171)

    show 172 :' afficher le picture bouton travail 
    hide 171 :' afficher le picture bouton repos
    2d_target_is 172
              
    action% = 0
    delai% = number_ticks
    while mouse_left_up(171) = 0 :' Tant que le bouton gauche souris n'est pas lach            
        if delai% + 1500 < number_ticks :' delai d'attente en ms pour valider l'appui long
            action% = 1

            ' mise en mmoire des rglages
            for i% = 1 to 10
                memoire%(3,i%) = niveauPotentiometre%(i%)
            next i%

            2d_flood 10,10,230,0,0
            pause 100 :' dlai du premier flash rouge
            2d_flood 10,10,60,60,60
            pause 100 :' delai entre les deux flashs
            2d_flood 10,10,230,0,0
            pause 100 :' dlai du 2me flash rouge
            2d_flood 10,10,60,60,60
            exit_while    
        end_if
    end_while
    if action% = 0
        transition(3) :' n du bouton mmoire en paramtre
        2d_flood 10,10,0,200,0
        pause 150 :' dlai du flash vert
        2d_flood 10,10,60,60,60
    end_if

    show 171 :' afficher le picture bouton repos
    hide 172 :' cacher le picture bouton travail
    debloquerEvenements()
return
' ------------------------------------------------------------------------------
appuiMemoire4:
    bloquerEvenements()
    annulerEditionEtiquette()

    ' inhiber l'action du bouton droit souris
    if mouse_right_down(181) = 1
        on_mouse_down 181,appuiMemoire4
        return
    end_if

    ' raffraichir l'tat des boutons de la souris
    null% = mouse_left_up(181)
    null% = mouse_left_down(181)

    show 182 :' afficher le picture bouton travail 
    hide 181 :' afficher le picture bouton repos
    2d_target_is 182
              
    action% = 0
    delai% = number_ticks
    while mouse_left_up(181) = 0 :' Tant que le bouton gauche souris n'est pas lach            
        if delai% + 1500 < number_ticks :' delai d'attente en ms pour valider l'appui long
            action% = 1

            ' mise en mmoire des rglages
            for i% = 1 to 10
                memoire%(4,i%) = niveauPotentiometre%(i%)
            next i%

            2d_flood 10,10,230,0,0
            pause 100 :' dlai du premier flash rouge
            2d_flood 10,10,60,60,60
            pause 50 :' delai entre les deux flashs
            2d_flood 10,10,230,0,0
            pause 100 :' dlai du 2me flash rouge
            2d_flood 10,10,60,60,60
            exit_while    
        end_if
    end_while
    if action% = 0
        transition(4) :' n du bouton mmoire en paramtre
        2d_flood 10,10,0,200,0
        pause 150 :' dlai du flash vert
        2d_flood 10,10,60,60,60
    end_if

    show 181 :' afficher le picture bouton repos
    hide 182 :' cacher le picture bouton travail
    debloquerEvenements()
return
' ------------------------------------------------------------------------------
appuiMemoire5:
    bloquerEvenements()
    annulerEditionEtiquette()

    ' inhiber l'action du bouton droit souris
    if mouse_right_down(191) = 1
        on_mouse_down 191,appuiMemoire5
        return
    end_if

    ' raffraichir l'tat des boutons de la souris
    null% = mouse_left_up(191)
    null% = mouse_left_down(191)

    show 192 :' afficher le picture bouton travail 
    hide 191 :' afficher le picture bouton repos
    2d_target_is 192
              
    action% = 0
    delai% = number_ticks
    while mouse_left_up(191) = 0 :' Tant que le bouton gauche souris n'est pas lach            
        if delai% + 1500 < number_ticks :' delai d'attente en ms pour valider l'appui long
            action% = 1

            ' mise en mmoire des rglages
            for i% = 1 to 10
                memoire%(5,i%) = niveauPotentiometre%(i%)
            next i%

            2d_flood 10,10,230,0,0
            pause 100 :' dlai du premier flash rouge
            2d_flood 10,10,60,60,60
            pause 100 :' delai entre les deux flashs
            2d_flood 10,10,230,0,0
            pause 100 :' dlai du 2me flash rouge
            2d_flood 10,10,60,60,60
            exit_while    
        end_if
    end_while
    if action% = 0
        transition(5) :' n du bouton mmoire en paramtre
        2d_flood 10,10,0,200,0
        pause 100 :' dlai du flash vert
        2d_flood 10,10,60,60,60
    end_if

    show 191 :' afficher le picture bouton repos
    hide 192 :' cacher le picture bouton travail
    debloquerEvenements()
return
' ------------------------------------------------------------------------------
sub transition(m%)
    dim_local pas(10), posCurseur(10), delai%, n%, niveau%, temps%,  

    if memorisationTransition% = 1
        niveauPotentiometre%(9) = memoire%(m%,9) :' potentiomtre "Transition"
    end_if

    if niveauPotentiometre%(9) > 1
        temps% = number_ticks
        ' couleur du bouton memoire
        2d_flood 10,10,200,200,0

        for n% = 1 to 8
             posCurseur(n%) = niveauPotentiometre%(n%)
             pas(n%) = (memoire%(m%,n%) - niveauPotentiometre%(n%)) / niveauPotentiometre%(9)
        next n%

        if memorisationMaster% = 1
             posCurseur(10) = niveauPotentiometre%(10)
             pas(10) = (memoire%(m%,10) - niveauPotentiometre%(10)) / niveauPotentiometre%(9)
        end_if

        for delai% = 1 to niveauPotentiometre%(9)-1
            for n% = 1 to 8
                posCurseur(n%) = posCurseur(n%) + pas(n%)
                niveauPotentiometre%(n%) = int(posCurseur(n%))   
            next n%

            if memorisationMaster% = 1
                posCurseur(10) = posCurseur(10) + pas(10)
                niveauPotentiometre%(10) = int(posCurseur(10))   
            end_if

            positionnerCurseurPotentiometre()
            envoyerTrameSerie()
            ' rgulation boucle  100 ms
            while number_ticks < temps% + 100 
            end_while
            temps% = number_ticks
        next delai%
    end_if
    
    ' couleur du bouton mmoire
    2d_flood 10,10,60,60,60
    pause 50
    ' lecture mmoire 
    for n% = 1 to 8
        niveauPotentiometre%(n%) = memoire%(m%,n%)
    next n%
    
    if memorisationMaster% = 1
        niveauPotentiometre%(10) = memoire%(m%,10)
    end_if
    
    positionnerCurseurPotentiometre()
    envoyerTrameSerie()
end_sub
' ------------------------------------------------------------------------------
sub bloquerEvenements()
    inactive 210 :' panel des boutons mmoires
    inactive 10 :' panel des icnes
    off_mouse_down 52 :' curseur 1
    off_mouse_down 62 :' curseur 2
    off_mouse_down 72 :' curseur 3
    off_mouse_down 82 :' curseur 4
    off_mouse_down 92 :' curseur 5
    off_mouse_down 102 :' curseur 6
    off_mouse_down 112 :' curseur 7
    off_mouse_down 122 :' curseur 8
    off_mouse_down 132 :' curseur 9
    off_mouse_down 142 :' curseur 10
    off_mouse_down 202 :' bouton ON/OFF
    for etiquette% = 53 to 143 step 10 
        off_click etiquette% 
    next etiquette%
    for etiquette% = 54 to 144 step 10 
        off_click etiquette% 
    next etiquette%
end_sub
' ------------------------------------------------------------------------------
sub debloquerEvenements()
    active 10 :' panel des icnes
    active 210 :' panel boutons memoires
    on_mouse_down 52,deplacerCurseur1
    on_mouse_down 62,deplacerCurseur2
    on_mouse_down 72,deplacerCurseur3
    on_mouse_down 82,deplacerCurseur4
    on_mouse_down 92,deplacerCurseur5
    on_mouse_down 102,deplacerCurseur6
    on_mouse_down 112,deplacerCurseur7
    on_mouse_down 122,deplacerCurseur8
    on_mouse_down 132,deplacerCurseur9
    on_mouse_down 142,deplacerCurseur10
    on_mouse_down 202,appuiBoutonOnOff
    for etiquette% = 53 to 143 step 10 
        on_click etiquette%,saisieEtiquette 
    next etiquette%
    for etiquette% = 54 to 144 step 10 
        on_click etiquette%,saisieEtiquette 
    next etiquette%
end_sub
' ------------------------------------------------------------------------------
saisieEtiquette:
    off_click number_click
    for etiquette% = 55 to 195 step 10 
        hide etiquette%
    next etiquette%
    etiquette% = number_click
    if odd(etiquette%) = 1
        etiquette% = etiquette% + 1
        editeur% = etiquette% + 1
    else
        editeur% = etiquette% + 1
    end_if 
    controleSaisieEtiquette()
    on_click number_click,saisieEtiquette 
return
' ------------------------------------------------------------------------------
sub controleSaisieEtiquette()
    clear editeur%
    show editeur%
    set_focus editeur%
    text editeur%, caption$(etiquette%)
    caret_position editeur%,len(text$(editeur%))
    on_change editeur%,contoleSaisie
end_sub
' ------------------------------------------------------------------------------
contoleSaisie:
    off_change editeur%
    if scancode = 13
        if instr(text$(editeur%),chr$(13)) < 1
           return
        end_if
        ' supprimer les caractres CR et LF de la chaine texte$ 
        texte$ = text$(editeur%)
        legende$ = ""
        for null% = 1 to len(texte$)
            car$ = mid$(texte$,null%,1)
            if car$ <> chr$(10) and car$ <> chr$(13)
                legende$ = legende$ + car$
            end_if
        next null%
        etiquettes$(int((etiquette% / 10) - 4)) = legende$
         ' centrer et afficher le texte saisi
        left etiquette%,(54 - text_width(legende$,etiquette%)) / 2
        caption etiquette%,legende$
        hide editeur%
    end_if
    on_change editeur%,contoleSaisie
return
' ------------------------------------------------------------------------------
sub annulerEditionEtiquette()
    for etiquette% = 55 to 195 step 10 
        hide etiquette%
    next etiquette%
end_sub
' ------------------------------------------------------------------------------
afficherApropos:
    annulerEditionEtiquette()
    hide 240 :' fenetre Reglages
    if show(220) = 0
        show 220
    else
        hide 220
    end_if    
return
' ------------------------------------------------------------------------------
quitter:
    close_inactive
    annulerEditionEtiquette()
    hide 240 :' fenetre Reglages
    hide 220 :' fenetre A Propos
    hide 45 :' fentre Aide
    if message_information_yes_no("Voulez-vous vraiment quitter ?") <> 1
        return
    end_if

    ' fermeture liaison srie
    on% = 0
    color 204,255,0,0 :' couleur du voyant (rouge)
    serial_close 234
    
    ' enregistrement automatique de tous les paramtres  
    file_open_write 232,dossier$ + "rl8save"
        ' port srie
        file_writeln 232,sPortCom$
        file_writeln 232,sBaudRate$
        file_writeln 232,sDataBit$
        file_writeln 232,sParity$
        file_writeln 232,sStopBit$
        ' tiquettes
        for i% = 1 to 15
            file_writeln 232,etiquettes$(i%)
        next i%
        ' position des curseurs des potentiomtres
        for i% = 1 to 10
            file_writeln 232,str$(niveauPotentiometre%(i%))
        next i%
        ' choix de la mmorisation
        file_writeln 232,str$(memorisationMaster%) 
        file_writeln 232,str$(memorisationTransition%)
        ' contenu des mmoires
        for i% = 1 to 5
            for j% = 1 to 10
                file_writeln 232,str$(memoire%(i%,j%))
            next j%
        next i%
    file_close 232
    close_active
    terminate
return
' ------------------------------------------------------------------------------
sub notice()
    dim_local tx$
    tx$ = tx$ + "{\rtf1\ansi\ansicpg1252\deff0\deflang1036\deflangfe1036{\fonttbl{\f0\fswiss\fprq2\fcharset0 Calibri;}}"
    tx$ = tx$ + "{\colortbl ;\red20\green70\blue129;\red0\green0\blue0;\red255\green255\blue255;\red0\green0\blue128;}"
    tx$ = tx$ + "\viewkind4\uc1\pard\sl276\slmult1\qc\cf1\highlight2\f0\fs36" 
    tx$ = tx$ + "\par \cf3\highlight4\fs40   PANORAMIC R\'e9gie lumi\'e8re 8 canaux "  
    tx$ = tx$ + "\par \pard\sl276\slmult1\cf1\highlight0\fs22" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \fs36\tab\i Sommaire\i0" 
    tx$ = tx$ + "\par \fs22" 
    tx$ = tx$ + "\par \b\fs24\tab 1. Pr\'e9sentation"
    tx$ = tx$ + "\par \pard\fi720\sl276\slmult1\fs22" 
    tx$ = tx$ + "\par \fs24 2. L'interrupteur ON/OFF"
    tx$ = tx$ + "\par \pard\sl276\slmult1\b0\fs22" 
    tx$ = tx$ + "\par \b\fs24\tab 3. Les potentiom\'e8tres"
    tx$ = tx$ + "\par \b0\fs22\tab\tab 3.1. Le potentiom\'e8tre Master"
    tx$ = tx$ + "\par \tab\tab 3.2. Le potentiom\'e8tre Transition"
    tx$ = tx$ + "\par \tab\tab 3.3. Les potentiom\'e8tres Canaux 1 \'e0 8"
    tx$ = tx$ + "\par \tab\tab 3.4. Les \'e9tiquettes"
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \b\fs24\tab 4. Les ic\'f4nes"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22\tab 4.1. L'ic\'f4ne Cadenas"
    tx$ = tx$ + "\par \pard\sl276\slmult1\tab\tab 4.2. L'ic\'f4ne Bandeau fen\'eatre"
    tx$ = tx$ + "\par \tab\tab 4.3. L'ic\'f4ne R\'e9glages"
    tx$ = tx$ + "\par \tab\tab\tab 4.3.1. Les fichiers"
    tx$ = tx$ + "\par \tab\tab\tab\tab Charger un mod\'e8le"
    tx$ = tx$ + "\par \tab\tab\tab\tab Enregistrer un mod\'e8le"
    tx$ = tx$ + "\par \tab\tab\tab 4.3.2. La m\'e9morisation"
    tx$ = tx$ + "\par \tab\tab\tab\tab R\'e9glage Transition"
    tx$ = tx$ + "\par \tab\tab\tab\tab R\'e9glage Master"
    tx$ = tx$ + "\par \tab\tab\tab 4.3.3. Le port s\'e9rie"
    tx$ = tx$ + "\par \tab\tab 4.4. L'ic\'f4ne Aide"
    tx$ = tx$ + "\par \tab\tab 4.5. L'ic\'f4ne A propos"
    tx$ = tx$ + "\par \tab\tab 4.6. L'ic\'f4ne Sortir"
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \b\fs24\tab 5. Les m\'e9moires"
    tx$ = tx$ + "\par \b0\fs22\tab\tab 5.1. La m\'e9morisation d'une sc\'e8ne"
    tx$ = tx$ + "\par \tab\tab 5.2. Le rappel de m\'e9morisation d'une sc\'e8ne"
    tx$ = tx$ + "\par \tab\tab 5.3. Supprimer une m\'e9morisation"
    tx$ = tx$ + "\par \tab\tab 5.4. Les \'e9tiquettes"
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \b\fs24\tab 6. Annexe technique"
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\sl276\slmult1\qc * * * * *"
    tx$ = tx$ + "\par \pard\sl276\slmult1\b0\fs22" 
    tx$ = tx$ + "\par \b\fs24\tab 1. Pr\'e9sentation"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22 Ecrite en langage PANORAMIC, la \b R\'e9gie lumi\'e8re 8 canaux\b0  est une interface graphique permettant la modulation de l'\'e9clairage d'une sc\'e8ne via une carte \'e9lectronique. Reli\'e9e au port USB de l'ordinateur, une carte Arduino connect\'e9e \'e0 quelques LEDs permet de r\'e9aliser une premi\'e8re exp\'e9rience."
    tx$ = tx$ + "\par \pard\sl276\slmult1"  
    tx$ = tx$ + "\par \pard\fi720\sl276\slmult1\b\fs24 2. L'interrupteur ON/OFF"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22 Il active ou d\'e9sactive la liaison s\'e9rie du port USB."
    tx$ = tx$ + "\par Son voyant indique l'\'e9tat de la connexion :"
    tx$ = tx$ + "\par \pard\fi720\sl276\slmult1 - Vert, la liaison s\'e9rie est active ;"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1 - Rouge, liaison s\'e9rie est inactive. La R\'e9gie lumi\'e8re peut \'eatre test\'e9e dans ce mode (mode d\'e9monstration)."  
    tx$ = tx$ + "\par \pard\sl276\slmult1\b\fs24" 
    tx$ = tx$ + "\par \pard\fi720\sl276\slmult1 3. Les potentiom\'e8tres"
    tx$ = tx$ + "\par \pard\sl276\slmult1\b0\fs22\tab\tab 3.1. Le potentiom\'e8tre Master"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Son bouton est rouge. Il r\'e8gle la puissance g\'e9n\'e9rale disponible sur l'ensemble des canaux."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 3.2. Le potentiom\'e8tre Transition"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Son bouton est gris. Il d\'e9termine la dur\'e9e de transition lors de l'appel d'une m\'e9moire. La transition s'effectuera en douceur pendant un temps r\'e9glable entre 0 et 10 secondes."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 3.3. Les potentiom\'e8tres Canaux 1 \'e0 8"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Leurs boutons sont noirs. Ils permettent le r\'e9glage manuel des canaux 1 \'e0 8. La plage de variation s'\'e9tend de 0 et 100% de la puissance disponible renseign\'e9e par le potentiom\'e8tre Master."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 3.4. Les \'e9tiquettes"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Chaque potentiom\'e8tre poss\'e8de \'e0 sa base une \'e9tiquette dont le texte peut \'eatre personnalis\'e9. Cliquez dessus pour passer en mode \'e9dition. Tapez sur la touche Entr\'e9e du clavier pour valider votre saisie. Vos nouveaux libell\'e9s resteront en m\'e9moire m\'eame si vous quittez le programme."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \b\fs24\tab 4. Les ic\'f4nes"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22\tab 4.1. L'ic\'f4ne cadenas"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 C'est une s\'e9curit\'e9 qui permet le verrouillage de toutes les commandes de la R\'e9gie lumi\'e8re."
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1" 
    tx$ = tx$ + "\par \pard\sl276\slmult1\tab\tab 4.2. L'ic\'f4ne Bandeau fen\'eatre"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Sa fonction est d'afficher (ou de cacher) le bandeau de la fen\'eatre de la R\'e9gie Lumi\'e8re pour pouvoir la d\'e9placer sur l'\'e9cran."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 4.3. L'ic\'f4ne R\'e9glages"
    tx$ = tx$ + "\par \tab\tab\tab 4.3.1. Les fichiers"
    tx$ = tx$ + "\par \pard\li2160\sl276\slmult1 - Le bouton \'ab Charger un mod\'e8le \'bb lit un fichier avec une extension \b .rl1\b0  enregistr\'e9 sur le disque."
    tx$ = tx$ + "\par - Le bouton \'ab Enregistrer le mod\'e8le \'bb sauvegarde toute la configuration de la R\'e9gie lumi\'e8re sous le nom que vous souhaitez. L'extension \b .rl1\b0  est automatiquement ajout\'e9e au nom du fichier."
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 4.3.2. La m\'e9morisation"
    tx$ = tx$ + "\par \pard\li2160\sl276\slmult1 Vous pouvez ignorer ou prendre en compte les r\'e9glages de \b Transition\b0  et \b Master\b0  lors d'une m\'e9morisation. Les options disponibles sont :"
    tx$ = tx$ + "\par - \b R\'e9glage de transition : OUI.\b0  La dur\'e9e de transition est prise en compte dans les m\'e9moires et sera appliqu\'e9e lors du rappel de la m\'e9moire."
    tx$ = tx$ + "\par - \b R\'e9glage de transition : NON.\b0  Le r\'e9glage de transition est en mode manuel. Avant d'appuyer sur une m\'e9moire, s\'e9lectionnez manuellement la dur\'e9e de transition souhait\'e9e."
    tx$ = tx$ + "\par - \b R\'e9glage master : OUI.\b0  La m\'e9morisation prend en compte le r\'e9glage de niveau g\'e9n\'e9ral (Master)."
    tx$ = tx$ + "\par - \b R\'e9glage master : NON.\b0  Le niveau de r\'e9glage n'est pas m\'e9moris\'e9." 
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab\tab 4.3.3. Le port s\'e9rie"
    tx$ = tx$ + "\par \pard\li2160\sl276\slmult1 Ce module vous permet de d\'e9finir les caract\'e9ristiques de la liaison s\'e9rie en fonction de votre carte \'e9lectronique. Par d\'e9faut, les r\'e9glages sont :"
    tx$ = tx$ + "\par - Baud rate : 9600"
    tx$ = tx$ + "\par - Data bits : 8"
    tx$ = tx$ + "\par - Parity : Aucune"
    tx$ = tx$ + "\par - Stop bits : 1"
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \tab\tab 4.4. L'ic\'f4ne Aide"
    tx$ = tx$ + "\par \pard\fi720\li720\sl276\slmult1 Affiche l'aide que vous lisez actuellement ;-)"
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 4.5. L'ic\'f4ne A propos"
    tx$ = tx$ + "\par \pard\fi720\li720\sl276\slmult1 Informations sur le logiciel."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 4.6. L'ic\'f4ne Sortir"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Ferme la R\'e9gie Lumi\'e8re. Tous les r\'e9glages sont m\'e9moris\'e9s et seront charg\'e9s lors du prochain lancement."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \b\fs24\tab 5. Les m\'e9moires"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22 La R\'e9gie lumi\'e8re poss\'e8de 5 m\'e9moires. Les positions des huit curseurs de potentiom\'e8tres correspondant aux canaux de 1 \'e0 8 sont m\'e9moris\'e9es. Dans la fen\'eatre \'ab R\'e9glages \'bb, si vous avez s\'e9lectionn\'e9 les options de m\'e9morisation sur OUI, la dur\'e9e de transition et le r\'e9glage Master seront \'e9galement mis en m\'e9moire."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \pard\sl276\slmult1\tab\tab 5.1. La m\'e9morisation d'une sc\'e8ne"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 La mise en m\'e9moire s'effectue en maintenant appuy\'e9 le bouton-m\'e9moire choisi pendant 2 secondes. Le bouton \'e9mettra deux flashs rouges pour vous indiquer la r\'e9ussite de l'op\'e9ration."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 5.2. Le rappel de m\'e9morisation d'une sc\'e8ne"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Un appui bref sur un des boutons-m\'e9moire permet de rappeler la configuration enregistr\'e9e. Si la dur\'e9e de transition est m\'e9moris\'e9e, le bouton-m\'e9moire restera de couleur jaune pendant toute la dur\'e9e de la transition. Les commandes sont neutralis\'e9es durant ce laps de temps. A la fin de la transition, un flash vert est \'e9mis."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \tab\tab 5.3. Supprimer une m\'e9morisation"
    tx$ = tx$ + "\par \tab\tab L'enregistrement d'une nouvelle sc\'e8ne supprimera l'ancienne."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par \tab\tab 5.4. Les \'e9tiquettes"
    tx$ = tx$ + "\par \pard\li1440\sl276\slmult1 Chaque bouton-m\'e9moire poss\'e8de \'e0 sa base une \'e9tiquette dont le texte peut \'eatre personnalis\'e9. Cliquez dessus pour passer en mode \'e9dition. Tapez sur la touche Entr\'e9e du clavier pour valider votre saisie. Vos nouveaux libell\'e9s resteront en m\'e9moire m\'eame si vous quittez le programme."
    tx$ = tx$ + "\par \pard\sl276\slmult1" 
    tx$ = tx$ + "\par \b\fs24\tab 6. Annexe technique"
    tx$ = tx$ + "\par \pard\li720\sl276\slmult1\b0\fs22 Les trames \'e9mises vers le port USB sont compos\'e9es de 10 octets."
    tx$ = tx$ + "\par Les valeurs en d\'e9cimal de chaque octet sont :"
    tx$ = tx$ + "\par \tab - Octet 1  = 128. Octet de d\'e9but de trame."
    tx$ = tx$ + "\par \tab - Octet 2  = [0,100]. Niveau du canal 1 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 3  = [0,100]. Niveau du canal 2 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 4  = [0,100]. Niveau du canal 3 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 5  = [0,100]. Niveau du canal 4 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 6  = [0,100]. Niveau du canal 5 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 7  = [0,100]. Niveau du canal 6 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 8  = [0,100]. Niveau du canal 7 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 9  = [0,100]. Niveau du canal 8 compris entre 0 et 100 inclus."
    tx$ = tx$ + "\par \tab - Octet 10 = 255. Octet de fin de trame."
    tx$ = tx$ + "\par" 
    tx$ = tx$ + "\par }"
    text 46,tx$
end_sub