' RVB vers TSL (RGB to HSL)
' Marc - Mai 2022
' Ecrit en langage Panoramic

dim rouge%,vert%,bleu%
dim teinte,saturation,luminosite

caption 0,"RVB vers TSL (RGB to HSL)"

' ******* SAISIR ICI LES VALEURS RVB  CONVERTIR *******
rouge% = 82
vert% = 152
bleu% = 87

rvb2tsl(rouge%,vert%,bleu%)
print " R,V,B = " + str$(rouge%) + "," + str$(vert%) + "," + str$(bleu%)
print
print " Teinte = " + str$(teinte) + ""
print " Saturation = " + str$(saturation) + "%"
print " Luminosit = " + str$(luminosite) + "%"

end
' ------------------------------------------------------------------------------
sub rvb2tsl(r1,v1,b1)
    dim_local mini, maxi, ecart

    ' conversion rvb dans l'intervalle [0,1]
    r1 = r1 / 255
    v1 = v1 / 255
    b1 = b1 / 255

   ' recherche de la plus grande valeur parmi les composantes r,v,b
    maxi = max(r1,max(v1,b1))

    ' recherche de la plus petite valeur parmi les composantes r,v,b  
    mini = min(r1,min(v1,b1))

    ' calcul luminosit
    luminosite = (maxi + mini) / 2

    ' calcul de l'cart entre la valeur mini et maxi
    ecart = maxi - mini

    ' calcul de la teinte et de la saturation
    if ecart = 0
        teinte = 0
        saturation = 0
    else      
 ' calcul de la saturation
 if luminosite < 0.5 then saturation = ecart / (maxi + mini)
 if luminosite >= 0.5 then saturation = ecart / (2 - maxi - mini )

        ' calcul de la teinte
 if r1 = maxi then teinte = ( v1 - b1 ) / ecart
 if v1 = maxi then teinte = 2 + ((b1 - r1) / ecart)
 if b1 = maxi then teinte = 4 + ((r1 - v1) / ecart)
    end_if

    ' conversion de la teinte en degrs [0,360]
    teinte = int(teinte * 60)
    teinte = wrap_value(teinte)

    ' conversion saturation en pourcentage [0,100%]
    saturation = int(saturation * 100)

    ' conversion luminance en pourcentage [0,100%]
    luminosite = int(luminosite * 100)
end_sub