
rem ============================================================================
rem Graphisme avec les fonctions logiques binaires : BIN_AND ; BIN_OR ; BIN_XOR
rem                           par Papydall
rem ============================================================================
dim a,x,y,x0,y0,ym,i
label choix, quitter
width 0,1000 : height 0,700
picture 10 : width 10,600 : height 10,600 : 2d_target_is 10
x0 = width_client(10)*.5 : y0 = height_client(10)-10 : ym = y0/2
color 10,200,100,50 : 2d_fill_color 50,100,200 : 2d_circle x0,y0/2+5,ym
container_option 20 : top 20,20 : left 20,650 : height 20,520 : width 20,300
font_bold 20 : caption 20,"Faites votre choix"

option  30 : caption 30,"bin_and(x,y-x)"
option  40 : caption 40,"bin_or(x,y-x)"
option  50 : caption 50,"bin_xor(x,y-x)"
option  60 : caption 60,"bin_and(x,y)"
option  70 : caption 70,"bin_and(x,y+x)"
option  80 : caption 80,"bin_and(y/pi,y+x/sqr(2))"
option  90 : caption 90,"bin_and(x,sqr(x*x+y*y))"
option 100 : caption 100,"bin_and(bin_and(x,sqr(x*x+y*y)),y)"
option 110 : caption 110,"bin_and(x*pi,y*pi)"
option 120 : caption 120,"bin_and(bin_and(x*x,x*x),sqr(y*x+y*x))"
option 130 : caption 130,"bin_and(bin_and(bin_and(x,x*y*pi),y),x)"
option 140 : caption 140,"bin_and(x*x/y+pi,y*y/x+pi)"
option 150 : caption 150,"bin_and(pi*x-y,pi*y)"
option 160 : caption 160,"bin_and(exp(1)*x,exp(1)*y)"
option 170 : caption 170,"bin_or(exp(1)*x,exp(1)*y)"
option 180 : caption 180,"bin_and(exp(pi)*x,exp(1)*y)"

alpha 998  : top 998,height(10)+20 : left 998,50 : font_bold 998
font_color 998,0,0,255 : font_size 998,12
caption 998,"Papydall vous propose du graphisme avec les fonctions binaires"
button 999 : top 999, height(20)+50 : left 999,width(10)+50
caption 999,"Quitter" : on_click 999,quitter

for i = 30 to 180 step 10
    parent i,20 : top i,i*3-50 : left i,10 : width i,250 : font_bold i
    on_click i,choix
next i
end
rem ============================================================================
Choix:    
    Tracer()
return
rem ============================================================================
Quitter:
    terminate
return
rem ============================================================================
SUB Tracer()
    inactive 20
    color 10,200,100,50 : 2d_fill_color 50,100,200 : 2d_circle x0,y0/2+5,ym
    caption 0,"Graphisme avec les fonctions logiques binaires ... Trac en cours ... <ESC> pour arrter"
    for y = 1 to ym
        for x = 1 to y
            select number_click
                case 30  : a = bin_and(x,y-x)  
                case 40  : a = bin_or(x,y-x)  
                case 50  : a = bin_xor(x,y-x)
                case 60  : a = bin_and(x,y)
                case 70  : a = bin_and(x,y+x)
                case 80  : a = bin_and(y,y-x)
                case 90  : a = bin_and(y/pi,y+x/sqr(2))
                case 100 : a = bin_and(x,sqr(x*x+y*y))
                case 110 : a = bin_and(bin_and(x,sqr(x*x+y*y)),y)
                case 120 : a = bin_and(x*pi,y*pi)
                case 130 : a = bin_and(bin_and(x*x,x*x),sqr(y*x+y*x))
                case 140 : a = bin_and(bin_and(bin_and(x,x*y*pi),y),x)
                case 150 : a = bin_and(x*x/y+pi,y*y/x+pi)
                case 160 : a = bin_and(pi*x-y,pi*y)
                case 170 : a = bin_and(exp(1)*x,exp(1)*y)
                case 180 : a = bin_and(exp(1)*x,exp(1)*y)
              
            end_select            
            if a <> 0
               couleur(a)
               2d_point x0+x,y+5    : 2d_point x0-x,y+5
               2d_point x0+x,y0-y+5 : 2d_point x0-x,y0-y+5          
               display
            end_if
            if scancode = 27 then caption 0,"Programme arrt par l'utilisateur ! " : end
        next x
    next y
    caption 0,"TERMINE"
    active 20
END_SUB
rem ============================================================================
SUB Couleur(a)
    if a > 10 then 2d_pen_color 255,0,0
    if a > 20 then 2d_pen_color 0,255,0
    if a > 30 then 2d_pen_color 0,0,255
    if a > 40 then 2d_pen_color 255,255,0
    if a > 50 then 2d_pen_color 0,255,255
    if a > 60 then 2d_pen_color 127,0,0
    if a > 70 then 2d_pen_color 0,127,0
    if a > 80 then 2d_pen_color 0,0,127
    if a > 100 then 2d_pen_color rnd(255),rnd(255),rnd(255)
END_SUB
rem ============================================================================