' Editeur pour langage informatique PANORAMIC
dim versionEditeur$, nomEditeur$, repertoireEditeur$, delai%
dim ptr%, bufferProjet$, Syn_Edit$(25,3), N_Tab%, N_Syn%, Tab_Actif%, taillePolice%, nomPolice$
dim i%, j%, a$, t2$, t3$, Index%
dim r%, v%, b%, Mot_recherche_rapide$, Index1%
dim cibleClipBoard%, clipboard$
dim annonce$, reponseUtilisateur%, lightDark%

label redimFenetre0,Quitter
label Creer_Executable,creerApplication
label Couper_Texte,Copier_Texte,Coller_Texte,Supprimer_Texte,Raccourcis
label nouveauProjet,ouvrirProjet,enregistrerProjet,Fermer_Source,executerProjet
label Change_Tab_Actif,Modif,Retour_Focus
label redimFenetreRechercher, AfficheFenetreRechercher,fermerFenetreRechercher
label remplacerUneFois,remplacerTout
label P_Index,recherche_Suivant,Recherche_Precedent
label afficheAide, affichageFicheMotCle, redimFenetreAide
label afficherOutilCouleurs,choixCouleur,reglageCouleur,Copier_couleur, redimPaletteCouleurs
label rechercheRapideAvantF3,rechercheRapideArriereF4
label toucheDown,toucheUp,redimFenetreCodeTouches, afficherCodeTouches,
label afficherTableAscii, redimFenetreCodeAscii, clairSombre
label afficherFenetreAPropos, fermerFenetreAPropos, redimFenetreAPropos
label afficherFenetrePreferences, fermerFenetrePreferences
label choixNomPolice, choixTaillePolice

VerifierPresenceMakeExe()    

nomEditeur$ = "EliP 6"
versionEditeur$ = "version 6.06 du 15/11/2022"
repertoireEditeur$ = dir_current$ + "\"
application_title nomEditeur$

nomPolice$ = "Courier new"     :' nom de la police de caratres par dfaut.
taillePolice% = 12             :' taille de la police par dfaut.

interfaceUtilisateur()

chargerFichierPreferences()

end

' ------------------------------------------------------------------------------
sub VerifierPresenceMakeExe()
    if file_exists(repertoireEditeur$ + "Make_Exe.exe") = 0
        annonce$ = "Impossible d'excuter l'diteur EliP : " + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le fichier Make_Exe.exe est manquant !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Ce fichier doit tre situ dans le mme dossier que l'diteur."
        if message_error_ok(annonce$) < 2
            terminate
        end_if
    end_if
end_sub
' ------------------------------------------------------------------------------
sub chargerFichierPreferences()
    if file_exists(repertoireEditeur$ + "EliP6.cfg") = 1
        off_change 142
        off_change 143

        file_open_read 37,repertoireEditeur$ + "EliP6.cfg"
            nomPolice$ = file_readln$(37)
            taillePolice% = val(file_readln$(37))
        file_close 37

        text 142,nomPolice$
        text 143,str$(taillePolice%)

        on_change 142,ChoixNomPolice
        on_change 143,choixTaillePolice
    end_if
end_sub
' ------------------------------------------------------------------------------
sub interfaceUtilisateur()
    creerFenetrePricipale()
    creerBarreIcones()
    creerZoneEditeur()
    creerBarreEtat()
    creerMenuPop()
    creerFenetreRecherche()
    creerFenetrePaletteCouleurs()
    creerFenetreCodesTouches()
    creerFenetreCodeAscii()
    creerFenetreAide()
    creerFenetreAPropos()
    creerFenetrePreferences()
    
    open_dialog 40
    save_dialog 41

    FermerSource()
end_sub
' ------------------------------------------------------------------------------
sub creerFenetrePricipale()
    caption 0, nomEditeur$
    width 0,1200
    height 0,750
    left 0,(screen_x - width(0)) / 2
    top 0,(screen_y - height(0)) / 2
    font_name 0,"Arial"
    font_size 0,9
    color 0,240,240,240
    on_resize 0,redimFenetre0
    on_close 0,Quitter
end_sub
' ------------------------------------------------------------------------------
sub creerBarreIcones()
    creerIconeNouveauProjet(8,8)
    creerIconeOuvrirProjet(48,8)
    creerIconeEnregistrerProjet(88,8)
    creerIconeFermer(128,8)
    creerIconeCouper(168,8)
    creerIconeCopier(208,8)
    creerIconeColler(248,8)
    creerIconeRechercher(288,8)
    creerIconeExecuter(328,8)
    creerIconeExecutable(368,8)    
    creerIconeApplication(408,8)
    creerIconeCouleurs(448,8)
    creerIconeCodeTouches(488,8)
    creerIconeCodeAscii(528,8)
    creerIconeAide(568,8)
    creerIconeClairSombre(608,8)
    creerIconePreferences(648,8)
    creerIconeAPropos(688,8)
end_sub
' ------------------------------------------------------------------------------
sub creerIconeNouveauProjet(x%,y%)
    picture 1
    height 1,28
    width 1,28
    color 1,240,240,240
    top 1,y%
    left 1,x%
    cursor_point 1
    hint 1,"Nouveau Projet"
    on_click 1,nouveauProjet

    2d_target_is 1
    2d_pen_color 0,0,0
    2d_line 7,5,7,23
    2d_line 7,22,21,22
    2d_line 7,5,16,5
    2d_line 15,5,21,11
    2d_line 20,10,20,23
    2d_flood 9,7,255,255,255
    2d_line 15,5,15,11
    2d_line 15,10,21,10
end_sub
' ------------------------------------------------------------------------------
sub creerIconeOuvrirProjet(x%,y%)
    picture 2
    height 2,28
    width 2,28
    color 2,240,240,240
    top 2,y%
    left 2,x%
    cursor_point 2
    hint 2,"Charger un Projet"
    on_click 2,ouvrirProjet

    2d_target_is 2
    2d_pen_color 0,0,0
    2d_line 16,4,20,4
    2d_point 15,5
    2d_point 20,5
    2d_point 21,6
    2d_line 20,7,23,7
    2d_line 22,5,22,8
    2d_line 5,9,11,9
    2d_line 10,11,21,11
    2d_line 11,16,25,16
    2d_line 5,22,19,22
    2d_line 5,9,5,23
    2d_line 10,9,10,12
    2d_line 20,11,20,17
    2d_line 5,22,12,15
    2d_line 18,22,25,15
    2d_flood 7,11,255,255,255
    2d_flood 12,18,250,250,0
end_sub
' ------------------------------------------------------------------------------
sub creerIconeEnregistrerProjet(x%,y%)
    picture 3
    height 3,28
    width 3,28
    color 3,240,240,240
    top 3,y%
    left 3,x%
    cursor_point 3
    hint 3,"Enregistrer le Projet"
    on_click 3,enregistrerProjet

    2d_target_is 3
    2d_pen_color 0,0,0
    2d_line 7,5,20,5
    2d_line 19,6,21,6
    2d_line 20,7,22,7
    2d_line 7,22,21,22
    2d_line 6,6,6,22
    2d_line 21,7,21,22
    2d_flood 7,7,0,255,0
    2d_rectangle 8,14,20,21
    2d_line 10,16,18,16
    2d_line 10,18,18,18
    2d_rectangle 9,5,18,10
    2d_line 9,6,15,6
    2d_line 9,7,15,7
    2d_line 9,8,15,8
end_sub
' ------------------------------------------------------------------------------
sub creerIconeFermer(x%,y%)
    picture 4
    height 4,28
    width 4,28
    color 4,240,240,240
    top 4,y%
    left 4,x%
    cursor_point 4
    hint 4,"Fermer Projet"
    on_click 4,Fermer_Source

    2d_target_is 4
    2d_pen_color 0,0,0
    2d_line 8,5,14,11
    2d_line 14,10,20,4
    2d_line 19,5,23,9
    2d_line 22,8,16,14
    2d_line 17,14,23,20
    2d_line 22,19,18,23
    2d_line 19,22,13,16
    2d_line 13,17,7,23
    2d_line 8,22,4,18
    2d_line 5,19,11,13
    2d_line 10,13,4,7
    2d_line 5,8,9,4
    2d_flood 8,8,255,0,0
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCouper(x%,y%)
    picture 5
    height 5,28
    width 5,28
    color 5,240,240,240
    top 5,y%
    left 5,x%
    cursor_point 5
    hint 5,"Couper"
    on_click 5,Couper_texte

    2d_target_is 5
    2d_pen_color 90,90,90
    2d_line 21,4,11,14
    2d_line 22,4,11,15
    2d_line 23,5,12,16
    2d_line 23,6,13,16
    2d_pen_color 0,0,0
    2d_line 23,4,10,17
    2d_pen_color 0,0,255
    2d_line 7,11,11,11
    2d_line 6,12,12,12
    2d_line 5,13,8,13
    2d_line 4,14,7,14
    2d_line 3,15,6,15
    2d_line 3,16,5,16
    2d_line 3,17,5,17
    2d_line 3,18,9,18
    2d_line 4,19,8,19
    2d_line 7,17,10,17
    2d_line 8,16,11,16
    2d_line 9,15,12,15
    2d_line 10,14,12,14
    2d_line 10,13,12,13
    2d_line 12,16,16,16
    2d_line 11,17,17,17
    2d_line 10,18,13,18
    2d_line 9,19,12,19
    2d_line 8,20,11,20
    2d_line 8,21,10,21
    2d_line 8,22,10,22
    2d_line 8,23,14,23
    2d_line 9,24,13,24
    2d_line 12,22,15,22
    2d_line 13,21,16,21
    2d_line 14,20,17,20
    2d_line 15,19,17,19
    2d_line 14,18,17,18
    2d_pen_color 255,255,255
    2d_point 15,12
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCopier(x%,y%)
    picture 6
    height 6,28
    width 6,28
    color 6,240,240,240
    top 6,y%
    left 6,x%
    cursor_point 6
    hint 6,"Copier"
    on_click 6,Copier_Texte

    2d_target_is 6
    2d_pen_color 0,0,0
    2d_line 4,5,13,5
    2d_line 12,5,16,9
    2d_line 16,9,21,9
    2d_line 20,9,24,13
    2d_line 23,12,23,24
    2d_line 23,23,11,23
    2d_line 12,23,12,19
    2d_line 12,19,3,19
    2d_line 4,19,4,4
    2d_flood 7,7,255,255,255
    2d_line 11,5,11,10
    2d_line 12,9,12,24
    2d_line 19,9,19,14
    2d_line 6,9,10,9
    2d_line 11,9,21,9
    2d_line 6,11,13,11
    2d_line 6,13,13,13
    2d_line 14,13,18,13
    2d_line 19,13,24,13
    2d_line 6,15,13,15
    2d_line 14,15,22,15
    2d_line 6,17,13,17
    2d_line 14,17,22,17
    2d_line 14,19,22,19
    2d_line 14,21,22,21
end_sub
' ------------------------------------------------------------------------------
sub creerIconeColler(x%,y%)
    picture 7
    height 7,28
    width 7,28
    Color 7,240,240,240
    top 7,y%
    left 7,x%
    cursor_point 7
    hint 7,"Coller"
    on_click 7,Coller_Texte

    2d_target_is 7
    2d_pen_color 0,0,0
    2d_line 11,3,15,3
    2d_point 10,4
    2d_point 15,4
    2d_line 4,5,22,5
    2d_point 8,6
    2d_point 17,6
    2d_line 8,7,18,7
    2d_line 4,5,4,22
    2d_line 4,21,13,21
    2d_line 21,5,21,15
    2d_line 20,13,24,17
    2d_line 23,16,23,24
    2d_line 23,23,11,23
    2d_line 12,23,12,11
    2d_line 12,12,20,12
    2d_flood 13,13,255,255,255
    2d_line 19,12,19,18
    2d_line 19,17,24,17
    2d_line 14,15,18,15
    2d_line 14,17,18,17
    2d_line 14,19,22,19
    2d_line 14,21,22,21
    2d_flood 5,6,200,150,80
    2d_flood 20,12,200,150,80
    2d_flood 9,6,120,120,120
    2d_flood 11,4,120,120,120
end_sub
' ------------------------------------------------------------------------------
sub creerIconeRechercher(x%,y%)
    picture 8
    height 8,28
    width 8,28
    color 8,240,240,240
    top 8,y%
    left 8,x%
    cursor_point 8
    hint 8,"Rechercher / Remplacer"
    on_click 8,AfficheFenetreRechercher

    2d_target_is 8
    2d_pen_color 0,0,255
    ' flche haute
    2d_line 9,2,15,2
    2d_line 7,3,17,3
    2d_line 6,4,10,4
    2d_line 14,4,18,4
    2d_point 21,4
    2d_line 5,5,8,5
    2d_line 16,5,19,5
    2d_line 20,5,22,5
    2d_line 4,6,7,6
    2d_line 17,6,22,6
    2d_line 4,7,6,7
    2d_line 18,7,22,7
    2d_line 3,8,6,8
    2d_line 16,8,22,8
    2d_line 3,9,5,9
    2d_line 15,9,22,9
    ' flche basse
    2d_line 2,12,9,12
    2d_line 19,12,21,12
    2d_line 2,13,8,13
    2d_line 18,13,21,13
    2d_line 2,14,6,14
    2d_line 18,14,20,14
    2d_line 2,15,7,15
    2d_line 17,15,20,15
    2d_line 2,16,4,16
    2d_line 5,16,8,16
    2d_line 16,16,19,16
    2d_point 2,17
    2d_line 6,17,10,17
    2d_line 14,17,18,17
    2d_line 7,18,17,18
    2d_line 9,19,15,19
    ' poigne
    2d_pen_color 0,255,0
    2d_point 19,16
    2d_line 18,17,21,17
    2d_line 17,18,22,18
    2d_line 18,19,23,19
    2d_line 19,20,24,20
    2d_line 20,21,25,21
    2d_line 21,22,26,22
    2d_line 22,23,26,23
    2d_line 23,24,26,24
    2d_pen_color 0,0,0
    2d_line 19,15,27,23
    2d_line 16,18,24,26
    2d_line 23,25,26,25
    2d_line 26,22,26,25
    ' zone centrale
    2d_pen_color 255,255,255
    2d_line 10,4,14,4
    2d_line 8,5,16,5
    2d_line 7,6,17,6
    2d_line 6,7,18,7
    2d_line 6,8,16,8
    2d_line 5,9,15,9
    2d_line 4,10,20,10
    2d_line 4,11,20,11
    2d_line 9,12,19,12
    2d_line 8,13,18,13
    2d_line 6,14,18,14
    2d_line 7,15,17,15
    2d_line 8,16,16,16
    2d_line 10,17,14,17
    ' reflet dans la loupe
    2d_pen_color 105,105,105
    2d_line 10,5,13,5
    2d_line 9,6,12,6
    2d_line 8,7,10,7
    2d_line 12,7,14,7
    2d_line 7,8,9,8
    2d_line 11,8,13,8
    2d_point 7,9
    2d_point 10,9
    2d_point 6,10
end_sub
' ------------------------------------------------------------------------------
sub creerIconeExecuter(x%,y%)
    picture 9
    height 9,28
    width 9,28
    color 9,240,240,240
    top 9,y%
    left 9,x%
    cursor_point 9
    hint 9,"Excuter le Projet"
    on_click 9,executerProjet

    2d_target_is 9
    2d_pen_color 255,0,0
    2d_line 14,5,21,5
    2d_line 14,6,20,6
    2d_line 13,7,19,7
    2d_line 12,8,18,8
    2d_line 11,9,17,9
    2d_line 11,10,16,10
    2d_line 10,11,15,11
    2d_line 10,12,14,12
    2d_line 9,13,18,13
    2d_line 13,14,17,14
    2d_line 12,15,16,15
    2d_line 12,16,15,16
    2d_line 11,17,14,17
    2d_line 10,18,13,18
    2d_line 10,19,12,19
    2d_line 9,20,11,20
    2d_line 8,21,10,21
    2d_point 8,22
    2d_point 7,23
    2d_point 6,24
    ' contour de l'clair
    2d_pen_color 90,0,0
    2d_line 14,4,23,4
    2d_line 13,5,13,7
    2d_point 12,7
    2d_line 11,8,11,10
    2d_point 10,10
    2d_line 9,11,9,13
    2d_point 8,13
    2d_line 7,14,13,14
    2d_line 11,15,11,17
    2d_point 10,17
    2d_line 9,18,9,20
    2d_point 8,20
    2d_line 7,21,7,23
    2d_point 6,23
    2d_line 5,24,5,26
    2d_line 19,12,5,26
    2d_line 14,12,20,12
    2d_line 22,4,13,13
end_sub
' ------------------------------------------------------------------------------
sub creerIconeExecutable(x%,y%)
    picture 10
    height 10,28
    width 10,28
    color 10,240,240,240
    top 10,y%
    left 10,x%
    cursor_point 10
    hint 10,"Crer un excutable"
    on_click 10,Creer_Executable

    2d_target_is 10
    ' roue dente
    2d_pen_color 80,80,80
    2d_line 12,1,16,1
    2d_line 12,2,16,2
    2d_point 5,3
    2d_line 11,3,17,3
    2d_point 22,3
    2d_line 4,4,7,4
    2d_line 9,4,19,4
    2d_line 21,4,24,4
    2d_line 3,5,25,5
    2d_line 4,6,24,6
    2d_line 5,7,23,7
    2d_line 5,8,23,8
    2d_line 4,9,24,9
    2d_line 4,10,24,10
    2d_line 3,11,25,11
    2d_line 1,12,27,12
    2d_line 1,13,27,13
    2d_line 1,14,27,14
    2d_line 1,15,27,15
    2d_line 3,16,25,16
    2d_line 4,17,6,17
    2d_line 22,17,24,17
    2d_line 4,18,6,18
    2d_line 22,18,24,18
    2d_line 5,19,7,19
    2d_line 21,19,23,19
    2d_line 5,20,8,20
    2d_line 20,20,23,20
    2d_line 4,21,9,21
    2d_line 19,21,24,21
    2d_line 3,22,25,22
    2d_line 4,23,7,23
    2d_line 9,23,19,23
    2d_line 21,23,24,23
    2d_point 5,24
    2d_line 11,24,17,24
    2d_point 22,24
    2d_line 12,25,16,25
    2d_line 12,26,16,26
    ' Couleur fond roue dente
    2d_pen_color 160,255,140
    2d_line 11,5,17,5
    2d_line 9,6,19,6
    2d_line 8,7,20,7
    2d_line 7,8,21,8
    2d_line 6,9,22,9
    2d_line 6,10,22,10
    2d_line 5,11,23,11
    2d_line 5,12,23,12
    2d_line 5,13,23,13
    2d_line 5,14,23,14
    2d_line 5,15,23,15
    2d_line 5,16,23,16
    2d_line 6,17,22,17
    2d_line 6,18,22,18
    2d_line 7,19,21,19
    2d_line 8,20,20,20
    2d_line 9,21,19,21
    2d_line 11,22,17,22
    ' couleur lettre e
    2d_pen_color 0,0,0
    2d_line 12,8,18,8
    2d_line 12,9,18,9
    2d_line 12,13,16,13
    2d_line 12,14,16,14
    2d_line 12,18,18,18
    2d_line 12,19,18,19
    2d_line 10,8,10,20
    2d_line 11,8,11,20
end_sub
' ------------------------------------------------------------------------------
sub creerIconeApplication(x%,y%)
    picture 11
    height 11,28
    width 11,28
    color 11,240,240,240
    top 11,y%
    left 11,x%
    cursor_point 11
    hint 11,"Crer une application"
    on_click 11,creerApplication

    2d_target_is 11
    ' roue dente
    2d_pen_color 80,80,80
    2d_line 12,1,16,1
    2d_line 12,2,16,2
    2d_point 5,3
    2d_line 11,3,17,3
    2d_point 22,3
    2d_line 4,4,7,4
    2d_line 9,4,19,4
    2d_line 21,4,24,4
    2d_line 3,5,25,5
    2d_line 4,6,24,6
    2d_line 5,7,23,7
    2d_line 5,8,23,8
    2d_line 4,9,24,9
    2d_line 4,10,24,10
    2d_line 3,11,25,11
    2d_line 1,12,27,12
    2d_line 1,13,27,13
    2d_line 1,14,27,14
    2d_line 1,15,27,15
    2d_line 3,16,25,16
    2d_line 4,17,6,17
    2d_line 22,17,24,17
    2d_line 4,18,6,18
    2d_line 22,18,24,18
    2d_line 5,19,7,19
    2d_line 21,19,23,19
    2d_line 5,20,8,20
    2d_line 20,20,23,20
    2d_line 4,21,9,21
    2d_line 19,21,24,21
    2d_line 3,22,25,22
    2d_line 4,23,7,23
    2d_line 9,23,19,23
    2d_line 21,23,24,23
    2d_point 5,24
    2d_line 11,24,17,24
    2d_point 22,24
    2d_line 12,25,16,25
    2d_line 12,26,16,26
    ' Couleur fond roue dente
    2d_pen_color 160,255,140
    2d_line 11,5,17,5
    2d_line 9,6,19,6
    2d_line 8,7,20,7
    2d_line 7,8,21,8
    2d_line 6,9,22,9
    2d_line 6,10,22,10
    2d_line 5,11,23,11
    2d_line 5,12,23,12
    2d_line 5,13,23,13
    2d_line 5,14,23,14
    2d_line 5,15,23,15
    2d_line 5,16,23,16
    2d_line 6,17,22,17
    2d_line 6,18,22,18
    2d_line 7,19,21,19
    2d_line 8,20,20,20
    2d_line 9,21,19,21
    2d_line 11,22,17,22
    ' couleur lettre a
    2d_pen_color 0,0,0
    2d_line 13,7,15,7
    2d_line 13,8,15,8
    2d_line 12,9,16,9
    2d_line 12,10,16,10
    2d_line 11,11,13,11
    2d_line 15,11,17,11
    2d_line 11,12,13,12
    2d_line 15,12,17,12
    2d_line 10,13,12,13
    2d_line 16,13,18,13
    2d_line 10,14,12,14
    2d_line 16,14,18,14
    2d_line 9,15,19,15
    2d_line 9,16,11,16
    2d_line 17,16,19,16
    2d_line 8,17,10,17
    2d_line 18,17,20,17
    2d_line 8,18,10,18
    2d_line 18,18,20,18
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCouleurs(x%,y%)
    picture 12
    height 12,28
    width 12,28
    color 12,240,240,240
    top 12,y%
    left 12,x%
    cursor_point 12
    hint 12,"Palette de couleurs"
    on_click 12,afficherOutilCouleurs

    2d_target_is 12
    2d_pen_color 191,0,0
    2d_line 2,3,2,25 
    2d_pen_color 255,4,0
    2d_line 3,3,3,25 
    2d_pen_color 255,40,0
    2d_line 4,3,4,25 
    2d_pen_color 255,86,0
    2d_line 5,3,5,25
    2d_pen_color 255,128,0
    2d_line 6,3,6,25
    2d_pen_color 254,171,0
    2d_line 7,3,7,25
    2d_pen_color 255,215,0
    2d_line 8,3,8,25
    2d_pen_color 250,254,0
    2d_line 9,3,9,25
    2d_pen_color 211,255,0
    2d_line 10,3,10,25
    2d_pen_color 165,254,0
    2d_line 11,3,11,25
    2d_pen_color 123,255,1
    2d_line 12,3,12,25
    2d_pen_color 81,255,0
    2d_line 13,3,13,25
    2d_pen_color 17,255,57
    2d_line 14,3,14,25
    2d_pen_color 0,255,124
    2d_line 15,3,15,25
    2d_pen_color 0,254,163
    2d_line 16,3,16,25
    2d_pen_color 0,255,207
    2d_line 17,3,17,25
    2d_pen_color 0,254,249
    2d_line 18,3,18,25
    2d_pen_color 0,219,255
    2d_line 19,3,19,25
    2d_pen_color 0,173,254
    2d_line 20,3,20,25
    2d_pen_color 0,132,255
    2d_line 21,3,21,25
    2d_pen_color 0,87,255
    2d_line 22,3,22,25
    2d_pen_color 0,47,255
    2d_line 23,3,23,25 
    2d_pen_color 0,1,255
    2d_line 24,3,24,25 
    2d_pen_color 0,0,127
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCodeTouches(x%,y%)
    picture 13
    height 13,28
    width 13,28
    color 13,240,240,240
    top 13,y%
    left 13,x%
    cursor_point 13
    hint 13,"Le code des touches"
    on_click 13,afficherCodeTouches

    2d_target_is 13
    2d_pen_color 0,0,0
    2d_fill_color 255,255,255
    2d_rectangle 4,4,24,24
    2d_line 3,5,3,23
    2d_line 5,24,24,24
    2d_line 24,5,24,25
    2d_line 25,6,25,24
    2d_line 9,8,20,8
    2d_line 9,9,20,9
    2d_line 13,10,13,20
    2d_line 14,10,14,20
    2d_line 15,10,15,20
    2d_pen_color 255,255,255
    2d_line 4,6,4,22
    2d_line 23,6,23,22
end_sub
' ------------------------------------------------------------------------------
sub creerIconeCodeAscii(x%,y%)
    picture 14
    height 14,28
    width 14,28
    color 14,240,240,240
    top 14,y%
    left 14,x%
    cursor_point 14
    hint 14,"La table ASCII"
    on_click 14,afficherTableAscii

    2d_target_is 14
    2d_pen_color 0,0,0
    2d_line 4,5,7,5
    2d_line 3,6,3,12
    2d_line 7,6,7,12
    2d_line 4,8,7,8
    2d_line 10,5,13,5
    2d_line 9,6,9,8
    2d_point 13,6
    2d_line 10,8,13,8
    2d_line 13,9,13,11
    2d_line 10,11,13,11
    2d_point 9,10
    2d_line 16,5,19,5
    2d_point 19,6
    2d_line 15,6,15,11
    2d_line 16,11,19,11
    2d_point 19,10
    2d_line 21,5,21,12
    2d_line 24,5,24,12
    2d_line 4,16,7,16
    2d_point 7,17
    2d_line 3,17,3,22
    2d_line 4,22,7,22
    2d_point 7,21
    2d_line 10,16,13,16
    2d_line 9,17,9,22
    2d_line 13,17,13,22
    2d_line 10,22,13,22
    2d_line 15,16,15,23
    2d_line 15,16,19,16
    2d_line 15,22,19,22
    2d_line 19,17,19,22
    2d_line 21,16,25,16
    2d_line 21,16,21,23
    2d_line 21,22,25,22
    2d_line 21,19,24,19
end_sub
' ------------------------------------------------------------------------------
sub creerIconeAide(x%,y%)
    picture 15
    height 15,28
    width 15,28
    color 15,240,240,240
    top 15,y%
    left 15,x%
    hint 15,"Aide"
    cursor_point 15
    on_click 15,afficheAide

    2d_target_is 15
    ' contour livre
    2d_pen_color 0,0,0
    2d_line 5,4,10,4
    2d_line 18,4,23,4
    2d_line 3,5,5,5
    2d_line 10,5,13,5
    2d_line 15,5,18,5
    2d_line 23,5,25,5
    2d_line 3,22,25,22
    2d_line 3,5,3,23
    2d_line 13,6,13,23
    2d_line 14,6,14,23
    2d_line 24,5,24,23 
    ' Couleur pages du livre
    2d_flood 5,6,255,255,0
    2d_flood 15,6,255,255,0
    ' critures page gauche
    2d_line 7,7,11,7
    2d_line 5,8,7,8
    2d_point 11,8   
    2d_line 7,10,11,10
    2d_line 5,11,7,11
    2d_point 11,11   
    2d_line 7,13,11,13
    2d_line 5,14,7,14
    2d_point 11,14   
    2d_line 7,16,11,16
    2d_line 5,17,7,17
    2d_point 11,17   
    2d_line 7,19,11,19
    2d_line 5,20,7,20
    2d_point 11,20   
    ' critures page droite
    2d_line 17,7,21,7
    2d_line 21,8,23,8
    2d_point 16,8   
    2d_line 17,10,21,10
    2d_line 21,11,23,11
    2d_point 16,11   
    2d_line 17,13,21,13
    2d_line 21,14,23,14
    2d_point 16,14   
    2d_line 17,16,21,16
    2d_line 21,17,23,17
    2d_point 16,17   
    2d_line 17,19,21,19
    2d_line 21,20,23,20
    2d_point 16,20
end_sub
' ------------------------------------------------------------------------------
sub creerIconeClairSombre(x%,y%)
    picture 16
    height 16,28
    width 16,28
    color 16,240,240,240
    top 16,y%
    left 16,x%
    cursor_point 16
    hint 16,"Clair / Sombre"
    on_click 16,clairSombre
    
    2d_target_is 16
    2d_pen_color 0,0,0
    2d_circle 14,14,11
    2d_pen_color 127,127,127
    2d_line 6,20,21,5
    2d_flood 17,17,0,0,0
end_sub
' ------------------------------------------------------------------------------
sub creerIconePreferences(x%,y%)
    picture 18
    height 18,28
    width 18,28
    color 18,240,240,240
    top 18,y%
    left 18,x%
    cursor_point 18
    hint 18,"Prfrences"
    on_click 18,afficherFenetrePreferences

    2d_target_is 18
    2d_pen_color 0,70,0
    ' dessin 1er curseur
    2d_line 4,6,17,6
    2d_line 17,4,20,4
    2d_line 16,5,16,8
    2d_line 17,8,20,8
    2d_line 20,5,20,8
    2d_line 20,6,24,6
    ' dessin 2me curseur
    2d_line 4,14,8,14
    2d_line 8,12,11,12
    2d_line 8,16,11,16
    2d_line 7,13,7,16
    2d_line 11,13,11,16
    2d_line 11,14,24,14
    ' dessin 3me curseur
    2d_line 4,22,13,22
    2d_line 12,21,12,24
    2d_line 13,20,16,20
    2d_line 13,24,16,24
    2d_line 16,21,16,24
    2d_line 16,22,24,22
end_sub
' ------------------------------------------------------------------------------
sub creerIconeAPropos(x%,y%)
    picture 17
    height 17,28
    width 17,28
    color 17,240,240,240
    top 17,y%
    left 17,x%
    cursor_point 17
    Hint 17,"A-Propos"
    on_click 17,afficherFenetreAPropos

    2d_target_is 17
    2d_pen_color 0,0,255
    2d_line 10,3,17,3
    2d_line 9,4,19,4
    2d_line 8,5,20,5
    2d_line 7,6,21,6
    2d_line 6,7,11,7
    2d_line 15,7,22,7
    2d_line 6,8,10,8
    2d_line 16,8,22,8
    2d_line 6,9,9,9
    2d_line 17,9,22,9
    2d_line 17,10,22,10
    2d_line 17,11,22,11
    2d_line 16,12,21,12
    2d_line 15,13,20,13
    2d_line 14,14,19,14
    2d_line 13,15,18,15
    2d_line 12,16,17,16
    2d_line 12,17,16,17
    2d_line 12,18,16,18
    2d_line 12,21,16,21
    2d_line 12,22,16,22
    2d_line 12,23,16,23
    2d_line 12,24,16,24
end_sub
' ------------------------------------------------------------------------------
sub creerZoneEditeur()
    dim_local x%,y%
    container_tab 200
    top 200,44
    width 200,width_client(0)
    height 200,height_client(0)-65
    
    panel 131
    width 131,718
    height 131,height(200)
    width 131,width(200) 
    top 131,46
    font_name 131,"Arial"
    font_size 131,180
    font_bold 131
    font_color 131,235,235,235
    2d_fill_color 240,240,240
    caption 131,nomEditeur$
end_sub
' ------------------------------------------------------------------------------
sub creerBarreEtat()
    command_target_is 0
    alpha 21
    font_size 21,9
    top 21,height_client(0)-18
    left 21,3
    color 21,240,240,240
    caption 21,"Pas de projet charg."

    picture 352
    width 352,12
    height 352,12
    top 352,height_client(0)-12
    left 352,width_client(0)-12
    color 352,240,240,240
    2d_target_is 352
    2d_pen_color 0,0,0
    2d_rectangle 6,0,8,2 
    2d_rectangle 3,3,5,5 
    2d_rectangle 6,3,8,5 
    2d_rectangle 0,6,2,8 
    2d_rectangle 3,6,5,8 
    2d_rectangle 6,6,8,8 
end_sub
' ------------------------------------------------------------------------------
sub creerMenuPop()
    main_menu_pop 25
        sub_menu 26 : parent 26,25
        caption 26,"Couper"+chr$(9)+"Ctrl+ X" : on_click 26,Couper_Texte
        sub_menu 27 : parent 27,25
        caption 27,"Copier"+chr$(9)+"Ctrl+ C" : on_click 27,Copier_Texte
        sub_menu 28 : parent 28,25
        caption 28,"Coller"+chr$(9)+"Ctrl+ V" : on_click 28,Coller_Texte
        sub_menu 29 : parent 29,25
        caption 29,"Supprimer"+chr$(9)+"Suppr" : on_click 29,Supprimer_Texte
        sub_menu 30 : parent 30,25
        caption 30,"-"
        sub_menu 31 : parent 31,25
        caption 31,"Aide"+chr$(9)+"F1" : on_click 31,afficheAide 
        sub_menu 32 : parent 32,25
        caption 32,"-" 
        sub_menu 33 : parent 33,25
        caption 33,"Mot Suivant"+chr$(9)+"F3" : on_click 33,rechercheRapideAvantF3 
        sub_menu 34 : parent 34,25
        caption 34,"Mot Prcdent"+chr$(9)+"F4" : on_click 34,rechercheRapideArriereF4
    hide 26
    hide 27
    hide 28
    hide 29
    hide 33
    hide 34
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreRecherche()
    form 45
    border_small 45
    width 45,width(45) - width_client(45) + 364
    height 45,height(45) - height_client(45) + 137
    top 45,(screen_y - height(45)) / 2
    left 45,(screen_x - width(45)) / 2
    hide 45
    command_target_is 45
    on_resize 45,redimFenetreRechercher
    caption 45,nomEditeur$ + " : Rechercher / Remplacer"

    ' Rechercher 
    alpha 46
    font_size 46,9
    top 46,13
    left 46,7
    caption 46,"Rechercher :"

    ' Remplacer par
    alpha 47
    font_size 47,9
    top 47,43
    left 47,7
    caption 47,"Remplacer par :"

    ' zone saisie Rechercher
    edit 48
    width 48,165
    height 48,22
    top 48,11
    left 48,95

    ' zone saisie Remplacer par
    edit 49
    width 49,165
    height 49,22
    top 49,41
    left 49,95

    ' case  cocher Mot entier
    check 50
    width 50,150
    height 50,25
    top 50,72
    left 50,40
    caption 50,"Mot entier uniquement"

    ' case  cocher Respecter la casse
    check 51
    width 51,150
    height 51,25
    top 51,100
    left 51,40
    caption 51,"Respecter la casse"

    ' bouton Suivant
    button 52
    width 52,85
    height 52,25
    top 52,9
    left 52,270  
    caption 52,"Suivant"  

    ' bouton Prcdent
    button 53
    width 53,85
    height 53,25
    top 53,39
    left 53,270
    caption 53,"Prcdent"

    ' bouton Remplacer
    button 54
    width 54,85
    height 54,25
    top 54,69
    left 54,270
    caption 54,"Remplacer"

    ' bouton Remplacer tout
    button 55
    width 55,85
    height 55,25
    top 55,99
    left 55,270
    caption 55,"Remplacer tout"

    on_click 52,recherche_Suivant
    on_click 53,Recherche_Precedent
    on_click 54,remplacerUneFois
    on_click 55,remplacerTout

    on_close 45,fermerFenetreRechercher
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerFenetrePaletteCouleurs()
    command_target_is 0
    form 60
    border_small 60
    width 60,width(60) - width_client(60) + 265
    height 60,height(60) - height_client(60) + 216
    top 60,(screen_y - height(60))/2
    left 60,(screen_x - width(60))/2
    hide 60
    command_target_is 60
    color 60,30,30,30
    font_size 60,10
    font_color 60,255,255,255
    on_resize 60,redimPaletteCouleurs
    caption 60,nomEditeur$ + " : Couleurs"
    creerBarreChromatique(4,4)
    creerBarreMosaiqueCouleurs(4,29)
    creerBarreNiveauxGris(4,54)
    creerZoneRenduCouleur(4,82)
    creerCurseursRVB(4,146)
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerBarreChromatique(x%,y%)
    dim_local i%,c%
    picture 61
    width 61,256
    height 61,25
    top 61,y%
    left 61,x%
    2d_target_is 61
    c%=0
    for i%=0 to 41
        2d_pen_color 255,c%,0 
        2d_line i%,0,i%,25
        c%=c%+6
    next i%
    c%=255
    for i%=42 to 84
        2d_pen_color c%,255,0 
        2d_line i%,0,i%,25
        c%=c%-6
    next i%
    c%=0
    for i%=85 to 127
        2d_pen_color 0,255,c% 
        2d_line i%,0,i%,25
        c%=c%+6
    next i%
    c%=255
    for i%=128 to 170
        2d_pen_color 0,c%,255 
        2d_line i%,0,i%,25
        c%=c%-6
    next i%
    c%=0
    for i%=171 to 213
        2d_pen_color c%,0,255 
        2d_line i%,0,i%,25
        c%=c%+6
    next i%
    c%=255
    for i%=214 to 256
        2d_pen_color 255,0,c% 
        2d_line i%,0,i%,25
        c%=c%-6
    next i%
    cursor_cross 61
    on_click 61,choixCouleur
end_sub
' ------------------------------------------------------------------------------
sub creerBarreMosaiqueCouleurs(x%,y%)
    dim_local i%
    picture 62
    width 62,256
    height 62,25
    top 62,y%
    left 62,x%
    2d_target_is 62
    2d_pen_color 255,255,255
    for i%=0 to 31
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 255,0,0
    for i%=32 to 63
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 0,255,0
    for i%=64 to 95
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 0,0,255
    for i%=96 to 127
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 0,255,255
    for i%=128 to 159
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 255,0,255
    for i%=160 to 191
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 255,255,0
    for i%=192 to 223
    2d_line i%,0,i%,25
    next i%
    2d_pen_color 0,0,0
    for i%=224 to 255
    2d_line i%,0,i%,25
    next i%
    cursor_cross 62
    on_click 62,choixCouleur
end_sub
' ------------------------------------------------------------------------------
sub creerBarreNiveauxGris(x%,y%)    
    dim_local i%,c%
    picture 63
    width 63,256
    height 63,25
    top 63,y%
    left 63,x%
    2d_target_is 63
    c%=0
    for i%=0 to 255
        2d_pen_color i%,i%,i% 
        2d_line i%,0,i%,25
        c%=c%+4
    next i%
    cursor_cross 63
    on_click 63,choixCouleur
end_sub
' ------------------------------------------------------------------------------
sub creerZoneRenduCouleur(x%,y%)
    picture 64
    width 64,180
    height 64,60
    top 64,y%
    left 64,x%
    color 64,0,0,0
    alpha 65
    color 65,30,30,30
    font_color 65,255,255,255
    top 65,y%+1 
    left 65,x% + 200
    alpha 66
    color 66,30,30,30
    font_color 66,255,255,255
    top 66,y% + 20
    left 66,x% + 199
    alpha 67
    color 67,30,30,30
    font_color 67,255,255,255
    top 67,y% + 39
    left 67,x% + 200
    caption 65,"R  0"
    caption 66,"V  0"
    caption 67,"B  0"
    cursor_point 64
    hint 64,"Zone tmoin de rendu couleur." + chr$(13) + chr$(13) + "Clic gauche pour copier les valeurs R.V.B. dans le presse-papier."
    on_click 64,Copier_Couleur
end_sub
' ------------------------------------------------------------------------------
sub creerCurseursRVB(x%,y%)
    alpha 68
    color 68,30,30,30
    font_color 68,255,255,255
    top 68,y%
    left 68,x%+6
    caption 68,"R"

    scroll_bar 69
    width 69,233
    height 69,18
    top 69,y%
    left 69,x%+24
    min 69,0
    max 69,255

    alpha 70
    color 70,30,30,30
    font_color 70,255,255,255
    top 70,y%+24
    left 70,x%+6
    caption 70,"V"

    scroll_bar 71
    width 71,233
    height 71,18
    top 71,y%+24
    left 71,x%+24
    min 71,0
    max 71,255

    alpha 72
    color 72,30,30,30
    font_color 72,255,255,255
    top 72,y%+47
    left 72,x%+7
    caption 72,"B"

    scroll_bar 73
    width 73,233
    height 73,18
    top 73,y%+47
    left 73,x%+24
    min 73,0 : max 73,255

    prereglerCouleurDemonstration(180,120,50)

    on_change 69,reglageCouleur
    on_change 71,reglageCouleur
    on_change 73,reglageCouleur
end_sub
' ------------------------------------------------------------------------------
sub prereglerCouleurDemonstration(r1%,v1%,b1%)
    ' prrglage d'une couleur de dmonstration
    position 69,r1%
    position 71,v1%
    position 73,b1%
    color 64,r1%,v1%,b1%
    caption 65,"R  " + str$(r1%)
    caption 66,"V  " + str$(v1%)
    caption 67,"B  " + str$(b1%)
    r% = r1%
    v% = v1%
    b% = b1%
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreCodesTouches()
    form 80
    border_small 80
    width 80,width(80) - width_client(80) + 290
    height 80,height(80) - height_client(80) + 160
    color 80,50,50,150
    top 80,(screen_y - height(80))/2
    left 80,(screen_x - width(80))/2
    hide 80
    font_size 80,12
    font_color 80,255,255,255
    on_resize 80,redimFenetreCodeTouches
    caption 80,nomEditeur$ + " : Le code des touches"

    command_target_is 80

    alpha 81
    top 81,10
    left 81,10
    font_color 81,255,255,80
    caption 81,"Tapez sur une touche !"

    alpha 82
    top 82,40
    left 82,40
    caption 82,"KEY_DOWN_CODE ............"

    alpha 83
    top 83,60
    left 83,40
    caption 83,"KEY_DOWN_SPECIAL ........"

    alpha 84
    top 84,80
    left 84,40
    caption 84,"KEY_UP_CODE .................."

    alpha 85
    top 85,100
    left 85,40
    caption 85,"KEY_UP_SPECIAL .............."

    alpha 86
    top 86,120
    left 86,40
    caption 86,"SCANCODE ......................"

    alpha 87
    top 87,40
    left 87,222

    alpha 88
    top 88,60
    left 88,222

    alpha 89
    top 89,80
    left 89,222

    alpha 90
    top 90,100
    left 90,222

    alpha 91
    top 91,120
    left 91,222

    caption 87," :      "
    caption 88," :      "
    caption 89," :      "
    caption 90," :      "
    caption 91," :      "
    on_key_down 80,toucheDown
    on_key_up 80,toucheUp
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreCodeAscii()
    dim_local dec$, bin$, hexa$, car$, c%, d%
    form 95
    border_small 95
    width 95,width(95) - width_client(95) + 304
    height 95,height(95) - height_client(95) + 630
    top 95,(screen_y - height(95))/2
    left 95,left(0) + width(0) - 350
    hide 95
    on_resize 95,redimFenetreCodeAscii
    caption 95,nomEditeur$ + " : La table ASCII"
    command_target_is 95
    
    list 96
    width 96,width_client(95)
    height 96,height_client(95)
    font_name 96,"Courier New"
    font_size 96,12

    panel 97
    width 97,282
    height 97,30
    left 97,2
    top 97,2 
    color 97,0,30,130
    
    alpha 98
    parent 98,97
    top 98,6
    left 98,36
    color 98,0,30,130
    font_color 98,255,255,255
    font_name 98,"Courier New"
    font_size 98,12
    hint 98,"Binaire"
    caption 98,"BIN"
    
    alpha 99
    parent 99,97
    top 99,6
    left 99,121
    color 99,0,30,130
    font_color 99,255,255,255
    font_name 99,"Courier New"
    font_size 99,12
    hint 99,"Dcimal"
    caption 99,"DEC"
    
    alpha 100
    parent 100,97
    top 100,6
    left 100,176
    color 100,0,30,130
    font_color 100,255,255,255
    font_name 100,"Courier New"
    font_size 100,12
    hint 100,"Hexadcimal"
    caption 100,"HEX"
    
    alpha 101
    parent 101,97
    top 101,6
    left 101,231
    color 101,0,30,130
    font_color 101,255,255,255
    font_name 101,"Courier New"
    font_size 101,12
    hint 101,"Caractre ASCII"
    caption 101,"CAR"

    item_add 96,""
    item_add 96,""
    item_add 96," 00000000     0   00   NUL"
    item_add 96," 00000001     1   01   SOH"
    item_add 96," 00000010     2   02   STX"
    item_add 96," 00000011     3   03   ETX"
    item_add 96," 00000100     4   04   EOT"
    item_add 96," 00000101     5   05   ENQ"
    item_add 96," 00000110     6   06   ACK"
    item_add 96," 00000111     7   07   BEL"
    item_add 96," 00001000     8   08    BS"
    item_add 96," 00001001     9   09    HT"
    item_add 96," 00001010    10   0A    LF"
    item_add 96," 00001011    11   0B    VT"
    item_add 96," 00001100    12   0C    FF"
    item_add 96," 00001101    13   0D    CR"
    item_add 96," 00001110    14   0E    SO"
    item_add 96," 00001111    15   0F    SI"
    item_add 96," 00010000    16   10   DLE"
    item_add 96," 00010001    17   11   DC1"
    item_add 96," 00010010    18   12   DC2"
    item_add 96," 00010011    19   13   DC3"
    item_add 96," 00010100    20   14   DC4"
    item_add 96," 00010101    21   15   NAK"
    item_add 96," 00010110    22   16   SYN"
    item_add 96," 00010111    23   17   ETB"
    item_add 96," 00011000    24   18   CAN"
    item_add 96," 00011001    25   19    EM"
    item_add 96," 00011010    26   1A   SUB"
    item_add 96," 00011011    27   1B   ESC"
    item_add 96," 00011100    28   1C    FS"
    item_add 96," 00011101    29   1D    GS"
    item_add 96," 00111110    30   1E    RS"
    item_add 96," 00111111    31   1F    US"
    item_add 96," 00100000    32   20  SPACE"
    
    for d% = 33 to 255
        c% = d%
        bin$ =""
        while c% > 0
            if frac(c% / 2) = 0
                bin$ = "0" + bin$
            else
                bin$ = "1" + bin$
            end_if
            c% = int(c% / 2)
        end_while
           
        while len(bin$) < 8
            bin$ = "0" + bin$ 
        end_while             
        
        dec$ = str$(d%)
        while len(dec$) < 3
            dec$ = " " + dec$ 
        end_while             
        
        hexa$ = hex$(d%)
        while len(hexa$) < 2
            hexa$ = " " + hexa$ 
        end_while             
        
        car$ = " " + chr$(d%) 
        item_add 96," " + bin$ + "   " + dec$ + "   " + hexa$ + "   " + car$ 
    next d%
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreAide()
    form 110
    width 110,width(110) - width_client(110) + 1200
    height 110,height(110) - height_client(110) + 650
    left 110,(screen_x - width(110)) / 2
    top 110,(screen_y - height(110)) / 2
    hide 110
    font_size 110,10
    caption 110,nomEditeur$ + " : Manuel des mots-cls Panoramic"
    on_resize 110,redimFenetreAide
    command_target_is 110

    list 111
    top 111,1 
    width 111,240
    height 111,height_client(110) - 2
    left 111,width_client(110) - width(111) - 1

    hviewer 112
    top 112,1
    left 112,1
    width 112,width_client(110) - width(111) - 2
    height 112,height_client(110) - 1
    
    ' extraire de MAKE_EXE et charger la liste des mots-cles dans le LIST 111
    clipboard$ = clipboard_string_paste$
    execute_wait repertoireEditeur$+"make_exe.exe|-l"
    clipboard_paste 111
    clipboard_string_copy clipboard$
    item_select 111,1
    on_click 111,affichageFicheMotCle
end_sub
' ------------------------------------------------------------------------------
sub creerFenetrePreferences()
    form 140
    border_hide 140
    width 140,258
    height 140,150 
    hide 140
    color 140,200,200,200
    font_name 140,"Arial"
    font_size 140,10
    command_target_is 140

    alpha 141
    top 141,20
    left 141,33
    font_size 141,11
    font_italic 141
    caption 141,"Police et taille de caractres:"

    combo 142
    height 142,21
    width 142,148
    top 142,55
    left 142,20
    font_color 142,0,0,0
    font_names_load 142
    text 142,nomPolice$
    on_change 142,choixNomPolice

    combo 143
    height 143,21
    width 143,50
    top 143,55
    left 143,188
    font_color 143,0,0,0
    item_add 143,"8"
    item_add 143,"9"
    item_add 143,"10"
    item_add 143,"11"
    item_add 143,"12"
    item_add 143,"13"
    item_add 143,"14"
    item_add 143,"15"
    item_add 143,"16"
    item_add 143,"17"
    item_add 143,"18"
    item_add 143,"19"
    item_add 143,"20"
    item_add 143,"21"
    item_add 143,"22"
    text 143,str$(taillePolice%)
    on_change 143,choixTaillePolice

    button 144
    top 144,104
    left 144,92
    caption 144,"Ok"
    on_click 144,fermerFenetrePreferences
 
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub creerFenetreAPropos()
    dim_local n%
    form 120
    border_small 120
    width 120,width(120) - width_client(120) + 640
    height 120,height(120) - height_client(120) + 360 
    left 120,(screen_x - width(120))/2
    top 120,(screen_y - height(120))/2
    hide 120
    caption 120,nomEditeur$ + " : A-propos"
    on_resize 120,redimFenetreAPropos
    on_close 120,fermerFenetreAPropos


    command_target_is 120
    picture 121
    width 121,640
    height 121,360
    color 121,250,250,250
    2d_target_is 121
    
    ' Dcor dgrad vert    
    2d_pen_width 2
    2d_fill_off
    for n% = 210 to 0 step -1
        2d_pen_color n%/2,147+n%/2,0+n%/2
        2d_ellipse -43-n%,20-n%,1530+n%,700+n%
    next n%

    ' Titre EliP en lettres blanches
    2d_pen_width 1
    2D_PEN_COLOR 250,250,250
    2D_FILL_COLOR 250,250,250
    ' lettre E
    2D_RECTANGLE 41,40,55,86
    2D_RECTANGLE 55,40,79,50
    2D_RECTANGLE 55,56,77,66
    2D_RECTANGLE 55,76,79,86
    ' Lettre L
    2d_rectangle 90,40,104,86
    ' Lettre i
    2d_rectangle 115,56,129,86
    2d_circle 122,46,8
    ' Lettre P
    2d_rectangle 140,40,154,86
    2d_rectangle 154,40,171,49
    2d_rectangle 154,61,171,70
    2d_rectangle 167,48,179,62
    2d_line 179,50,179,60
    2d_rectangle 171,42,174,48
    2d_rectangle 174,46,178,48
    2d_point 171,41
    2d_point 174,43
    2d_line 174,44,176,44
    2d_line 174,45,177,45
    2d_line 165,49,167,49
    2d_point 166,50
    2d_point 166,59
    2d_line 165,60,167,60
    2d_rectangle 171,62,174,68
    2d_rectangle 174,62,178,64
    2d_point 171,68
    2d_point 174,66
    2d_line 174,65,176,65
    2d_line 174,64,177,64
    
    ' Logo Panoramic
    picture 122
    height 122,90
    width 122,90
    top 122,65
    left 122,500
    color 122,255,255,255
    hint 122,"https://panoramic.1fr1.net/" 
    2d_target_is 122

    ' dessin des cercles rouges
    2d_fill_color 255,255,255
    2d_pen_width 4
    2d_pen_color 255,0,0
    2d_circle 45,45,39
    2d_circle 45,45,29

    ' dessin du "P" en bleu
    2d_pen_width 1
    2d_pen_color 51,52,153
    2d_fill_color 51,52,153
    2d_rectangle 32,32,55,34
    2d_rectangle 37,34,43,59
    2d_rectangle 42,47,55,49
    2d_rectangle 53,36,60,45
    2d_line 35,34,37,34
    2d_point 36,35
    2d_line 35,58,37,58
    2d_point 36,57
    2d_point 43,57
    2d_line 42,58,45,58
    2d_rectangle 32,59,50,61
    2d_line 55,33,57,33
    2d_line 50,34,58,34
    2d_line 51,35,59,35
    2d_line 52,36,52,38
    2d_line 60,38,60,43
    2d_line 52,43,52,45
    2d_line 51,45,59,45
    2d_line 50,46,58,46
    2d_line 55,47,57,47
    
    ' lgende
    alpha 123
    font_name 123,"Arial"
    font_size 123,26
    color 123,250,250,250
    font_color 123,0,0,0
    top 123,176
    left 123,266
    caption 123,nomEditeur$
    
    ' lgende
    alpha 124
    font_name 124,"Arial"
    font_size 124,14
    color 124,250,250,250
    font_color 124,0,0,0
    top 124,190
    left 124,361
    caption 124,versionEditeur$
    
    ' lgende
    alpha 125
    font_name 125,"Arial"
    font_size 125,14
    color 125,250,250,250
    font_color 125,0,0,0
    top 125,220
    left 125,176
    caption 125,"Ecrit par Marc en langage informatique Panoramic"
    
    ' avertissement, dcharge de responsabilit
    alpha 126
    font_name 126,"Arial"
    font_size 126,10
    color 126,250,250,250
    font_color 126,0,0,0
    
    top 126,290
    left 126,47
    annonce$ = "Cet diteur a t dvelopp sous Panoramic 0.9.29i9 et fonctionne avec le make_exe 0.9.29i9" + chr$(13)
    annonce$ = annonce$ + "du 17/12/2019. Ce logiciel et son code-source sont fournis gratuitement sans aucune garantie." + chr$(13)
    annonce$ = annonce$ + "Lauteur ne saurait tre tenu responsable des dommages rsultant de son utilisation." + chr$(13)
    caption 126,annonce$
end_sub
' ------------------------------------------------------------------------------
' Fin de la cration de l'interface utilsateur
' ------------------------------------------------------------------------------




' ==============================================================================
'                       Gestion des vnements
' ==============================================================================
'
' Nouveau projet
' ------------------------------------------------------------------------------
nouveauProjet:
    command_target_is 0

    for i% = 1 to 26
        if i% = 26
            reponseUtilisateur% = message_warning_ok("Seulement 25 onglets peuvent tre ouverts simultanment !")
            exit_for
        end_if    
        N_Tab% = i% + 200
        N_Syn% = i% + 250
        if object_exists(N_Tab%) = 0
            tab N_Tab%
            parent N_Tab%,200
            Syn_Edit$(i%,3) = ""
            a$ = "Nouveau_" + str$(i%) + ".bas"
            caption N_Tab%,a$ + Syn_Edit$(i%,3)
            Syn_Edit$(i%,2) = a$
            Syn_Edit$(i%,1) = dir_current$ + "\"
            command_target_is N_Tab%
            synedit N_Syn%
            full_space N_Syn%
            themeClairSombre(N_Syn%)
            mark_on N_Tab%
            set_focus N_Syn%
            on_change N_Syn%,Modif
            on_click N_Syn%,P_Index
            on_key_down N_Syn%,Raccourcis
            Tab_Actif% = i%
            on_show N_Tab%,Change_Tab_Actif
            caption 21,Syn_Edit$(i%,1) + Syn_Edit$(i%,2) + Syn_Edit$(i%,3)
            cibleClipBoard% = N_Syn%
            Index%=CARET_POSITION(N_Syn%)
            Index1% = Index%
            Source_present()
            exit_for
        end_if
    next i%
    
    command_target_is 0
return



' ==============================================================================
' Ouvrir un projet
' ------------------------------------------------------------------------------
ouvrirProjet:
    command_target_is 0

    if object_exists(40) = 0
        open_dialog 40
    end_if    

    filter 40,"Basic Files (*.bas)|*.bas|Backup Files (*.bak)|*.bak|All Panoramic Files (*.bas *.bak)|*.bas;*.bak"
    a$=FILE_NAME$(40)
    delete 40

    if a$="_"
         return
    end_if
         
    if file_exists(a$) = 0
        reponseUtilisateur% = message_warning_ok("Le fichier : ''" + file_extract_name$(a$) + "''  est introuvable !")
        set_focus 0
        return
    end_if

    for i% = 1 to 26
        if i% = 26
            reponseUtilisateur% = message_warning_ok("Seulement 25 onglets peuvent tre ouverts simultanment !")
            exit_for
        end_if    

        N_Tab% = i% + 200
        N_Syn% = i% + 250

        if object_exists(N_Tab%)=0
            tab N_Tab%
            parent N_Tab%,200
            Syn_Edit$(i%,1) = file_extract_path$(a$)
            Syn_Edit$(i%,2) = file_extract_name$(a$)
            Syn_Edit$(i%,3) = ""
            command_target_is N_Tab%
            synedit N_Syn%
            full_space N_Syn%
            themeClairSombre(N_Syn%)
            mark_on N_Tab%
            set_focus N_Syn%
            file_load N_Syn%,a$
            on_change N_Syn%,Modif
            on_click N_Syn%,P_Index
            on_key_down N_Syn%,Raccourcis
            Tab_Actif% = i%
            on_show N_Tab%,Change_Tab_Actif
            caption N_Tab%,Syn_Edit$(i%,2)
            caption 21,Syn_Edit$(i%,1)+Syn_Edit$(i%,2)
            cibleClipBoard% = N_Syn%
            Index% = CARET_POSITION(N_Syn%)
            Index1% = Index%
            Source_present()
            exit_for
        end_if
    next i%
    
    command_target_is 0
return



' ==============================================================================
' Enregistrer le projet
' ------------------------------------------------------------------------------
enregistrerProjet:
    subEnregistrementprojet()
return
' ------------------------------------------------------------------------------
sub subEnregistrementprojet()
    dim_local nomDuProjet$, b$, longueurNomProjet%, pos%, n%, annonce$

    b$ = lower$(Syn_Edit$(Tab_Actif%,2))

    if file_extract_extension$(b$) = ".bak"
        Syn_Edit$(Tab_Actif%,2) = left$(Syn_Edit$(Tab_Actif%,2),len(Syn_Edit$(Tab_Actif%,2))-4) + ".bas"
    end_if

    filter 41,"Basic Files|*.bas"
    dir_dialog 41,Syn_Edit$(Tab_Actif%,1)
    file_dialog 41,Syn_Edit$(Tab_Actif%,2)
    nomDuProjet$ = file_name$(41)

    if nomDuProjet$ = "_" or nomDuProjet$ = ""
        exit_sub
    end_if
        
    b$=upper$(nomDuProjet$)
    
    if file_extract_extension$(b$) <> ".BAS"
        if file_extract_extension$(b$) <> ""
            longueurNomProjet% = len(nomDuProjet$)
            pos% = instr_right(nomDuProjet$,".")
            n% = longueurNomProjet% - pos%
            nomDuProjet$ = left$(nomDuProjet$,n%)
        end_if
        nomDuProjet$ = nomDuProjet$ + ".bas"
    end_if

    if file_exists(nomDuProjet$) = 1
        b$ = file_extract_name$(nomDuProjet$)
        annonce$ = "Enregistrement :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le fichier " + chr$(34) + b$ + chr$(34) + " existe dj !"
        annonce$ = annonce$ + chr$(13) + chr$(13)+ "Le remplacer ?"
        if message_confirmation_yes_no(annonce$) <> 1
            exit_sub
        end_if    
    end_if    
    
    file_save Tab_Actif% + 250,nomDuProjet$
    Syn_Edit$(Tab_Actif%,1) = file_extract_path$(nomDuProjet$)
    Syn_Edit$(Tab_Actif%,2) = file_extract_name$(nomDuProjet$)
    Syn_Edit$(Tab_Actif%,3) = ""
    caption (Tab_Actif% + 200),Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)
    caption 21,Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)
    
end_sub




' ==============================================================================
' Fermer le projet
' ------------------------------------------------------------------------------
Fermer_Source:
    FermerSource()
return
' ------------------------------------------------------------------------------
sub FermerSource()
    Nettoyage_Temp_Exe()

    if Syn_Edit$(Tab_Actif%,3) = "*"
        annonce$ = "Fermer le projet :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le code-source a t modifi !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Voulez-vous l'enregistrer avant de le fermer ?"
        reponseUtilisateur% = message_warning_yes_no(annonce$)

        if reponseUtilisateur% = 1 
            subEnregistrementprojet()
        else
            if reponseUtilisateur% = 0
                exit_sub
            end_if    
        end_if        

    end_if    

    Syn_Edit$(Tab_Actif%,1) = ""
    Syn_Edit$(Tab_Actif%,2) = ""
    Syn_Edit$(Tab_Actif%,3) = ""

    if Tab_Actif% > 0
        delete Tab_Actif% + 200
    end_if
    
    for i% = 1 to 25
        if object_exists(i% + 200) = 1
            exit_sub
        end_if    
    next i%
        
    ' icones
    inactive 3
    inactive 4
    inactive 5
    inactive 6
    inactive 7
    inactive 8
    inactive 9
    inactive 10
    inactive 11
    inactive 16

    ' objet PANEL du filigrane
    show 131

    ' menu contextuel  
    hide 26
    hide 27
    hide 28
    hide 29
    hide 33
    hide 34

    N_Syn% = 0
    set_focus 0
    caption 21,"Pas de projet charg."
end_sub




' ==============================================================================
' Couper / copier / coller / Supprimer
' ------------------------------------------------------------------------------
Couper_Texte:
    clipboard_string_copy select_read$(cibleClipBoard%)
    select_delete N_Syn%
return
' ------------------------------------------------------------------------------
Copier_Texte:
    clipboard_string_copy select_read$(cibleClipBoard%) 
return
' ------------------------------------------------------------------------------
Coller_Texte:
    select_delete cibleClipBoard%
    text_insert cibleClipBoard%,caret_position(cibleClipBoard%),clipboard_string_paste$
return
' ------------------------------------------------------------------------------
Supprimer_Texte:
    text_delete N_Syn%,caret_position(N_Syn%),len(select_read$(N_Syn%)) 
return



' ==============================================================================
' Rechercher / Remplacer
' ------------------------------------------------------------------------------
AfficheFenetreRechercher:
    off_click 8
    show 45
    to_foreground 45
    set_focus 48
    on_click 8,AfficheFenetreRechercher
return
' ------------------------------------------------------------------------------
recherche_Suivant:
    inactive 45
    inactive 0
    caption 45,nomEditeur$ + " : Rechercher / Remplacer        PATIENTEZ... !"
    rechercheSuivant_1()
    active 0
    active 45
    caption 45,nomEditeur$ + " : Rechercher / Remplacer"
return
' ------------------------------------------------------------------------------
sub rechercheSuivant_1()
    dim_local ListeCar$, carPrecedent$, carSuivant$

    if text$(48) = ""
        exit_sub
    end_if

    ' option "Respecter la casse"
    if checked(51) = 0
        bufferProjet$ = lower$(text$(N_Syn%))
        t2$ = lower$(text$(48))
    else
        bufferProjet$ = text$(N_Syn%)
        t2$ = text$(48)
    end_if

    if len(select_read$(N_Syn%)) > 0
        index% = caret_position(N_Syn%) + len(select_read$(N_Syn%))
    end_if
    ptr% = instr_pos(bufferProjet$,t2$,index% + 1)

    ' option "Mot entier uniquement"
    if checked(50) = 1 and ptr% > 0
        ' Constitution de la liste des caractres qui composent un mot quelconque
        ListeCar$ = "abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789$%"  

        repeat
            ' Identification du caractre prcdent le mot recherch
            if ptr% > 1
                carPrecedent$ = mid$(bufferProjet$,ptr%-1,1)
            else
                carPrecedent$ = chr$(32) : ' lorsque le mot commence ds le dbut de bufferProjet$ 
            end_if
        
           ' Vrifier si le caractre prcdent est absent de la liste ListeCar$
            if instr(ListeCar$,carPrecedent$) < 1
                ' Identification du caractre suivant le mot recherch
                carSuivant$ = mid$(bufferProjet$,ptr%+len(t2$),1)
                ' cas du mot entier situ en fin de fichier 
                if ptr% + len(t2$) - 1 = len(bufferProjet$)
                    carSuivant$ = chr$(32)
                end_if
                ' Vrifier si le caractre suivant est absent de la liste ListeCar$
                if instr(ListeCar$,carSuivant$) < 1
                    exit_repeat
                end_if
            end_if
            index% = index% + len(t2$) 
            ptr% = instr_pos(bufferProjet$,t2$,index% + 1)
        until ptr% < 1 
    end_if

    if ptr% = 0
        annonce$ = "Recherche ''Suivant'' :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'expression ''" + text$(48) + "'' n'a pas t trouve." + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Voulez-vous recommencer depuis le dbut ?"
        if message_confirmation_yes_no(annonce$) = 1
            index% = 0
            ptr% = instr_pos(bufferProjet$,t2$,index% + 1)
            if ptr% = 0
                annonce$ = "Recherche dans tout le projet :" + chr$(13) + chr$(13)
                annonce$ = annonce$ + "L'expression ''" + text$(48) + "'' n'a pas t trouve."
                reponseUtilisateur% = message_information_ok(annonce$)
                exit_sub
            end_if
            select_text N_Syn%,ptr%,len(t2$)
            index% = caret_position(N_Syn%) + len(t2$)
            exit_sub
        else
            exit_sub
        end_if
     end_if

    select_text N_Syn%,ptr%,len(t2$)
    index% = caret_position(N_Syn%) + len(t2$)
end_sub
' ------------------------------------------------------------------------------
recherche_Precedent:
    inactive 45
    inactive 0
    caption 45,nomEditeur$ + " : Rechercher / Remplacer        PATIENTEZ... !"
    recherchePrecedent()
    active 0
    active 45
    caption 45,nomEditeur$ + " : Rechercher / Remplacer"
return
' ------------------------------------------------------------------------------
sub recherchePrecedent()
    dim_local ListeCar$, carPrecedent$, carSuivant$

    if text$(48) = ""
        exit_sub
    end_if
    if len(select_read$(N_Syn%)) > 0
        index% = caret_position(N_Syn%)
    end_if

    if checked(51) = 0
        bufferProjet$ = left$(lower$(text$(N_Syn%)),index%)
        t2$ = lower$(text$(48))
    else
        bufferProjet$ = left$(text$(N_Syn%),index%)
        t2$ = text$(48)
    end_if

    ptr% = instr_right(bufferProjet$,t2$)

    ' option "Mot entier uniquement"
    if checked(50) = 1 and ptr% > 0
        ' liste des caractres qui composent un mot entier quelconque
        ListeCar$ = "abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789$%"  

        repeat
            ' Identification du caractre prcdent le mot recherch
            if len(bufferProjet$) - ptr% - len(t2$) +1 < 1
                carPrecedent$ = chr$(32) :' absence de caractre prcdent (dbut de chane))
            else
                carPrecedent$ = mid$(bufferProjet$,len(bufferprojet$) - ptr% - len(t2$) +1,1)
            end_if    

           ' Vrifier si le caractre prcdent est absent de la liste pour tre considr "mot entier"
            if instr(ListeCar$,carPrecedent$) < 1
                ' Identification du caractre suivant le mot recherch
                if ptr% = 1 :' lorsque le mot est situ en toute fin de chane
                    carSuivant$ = chr$(32) :' mot entier situ en fin de chane 
                else
                    carSuivant$ = mid$(bufferProjet$,len(bufferprojet$) - ptr% + 2,1)
                end_if
                ' Vrifier si le caractre suivant est absent de la liste
                if instr(ListeCar$,carSuivant$) < 1
                    exit_repeat
                end_if
            end_if

            index% = len(bufferprojet$) - ptr% - len(t2$) 
            bufferProjet$ = left$(bufferProjet$,index%)
            ptr% = instr_right(bufferProjet$,t2$)
        until ptr% < 1 
    end_if

    if ptr% = 0
        annonce$ = "Recherche ''Prcdent'' :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'expression ''" + text$(48) + "'' n'a pas t trouve."
        reponseUtilisateur% = message_information_ok(annonce$)
        set_focus 45
        exit_sub    
    end_if
    
    select_text N_Syn%,len(bufferProjet$) - ptr% - len(t2$) + 2,len(t2$)
end_sub
' ------------------------------------------------------------------------------
remplacerUneFois:
    if select_read$(N_Syn%) = ""
        rechercheSuivant_1()
        return
    end_if
     
    t3$ = text$(49)
    select_delete N_Syn%
    text_insert N_Syn%,caret_position(N_Syn%),t3$
    index% = caret_position(N_Syn%)
    rechercheSuivant_1()
return
' ------------------------------------------------------------------------------
remplacerTout:
    inactive 45
    inactive 0
    caption 45,nomEditeur$ + " : Rechercher / Remplacer        PATIENTEZ... !"
    remplacerTout_1()
    active 0
    active 45
    caption 45,nomEditeur$ + " : Rechercher / Remplacer"
return
' ------------------------------------------------------------------------------
sub remplacerTout_1()
    dim_local ListeCar$, carPrecedent$, carSuivant$
    if text$(48) = ""
        exit_sub
    end_if
    if select_read$(N_Syn%) = ""
        if checked(51) = 0
            bufferProjet$ = lower$(text$(N_Syn%))
            t2$ = lower$(text$(48))
        else
            bufferProjet$ = text$(N_Syn%)
            t2$ = text$(48)
        end_if
        
        ptr% = instr_pos(bufferProjet$,t2$,index% + 1)
        
        if ptr% = 0
            annonce$ = "Remplacer tout :"  + chr$(13) + chr$(13)
            annonce$ = annonce$ + "L'expression ''" + text$(48) + "'' n'a pas t trouve."
            reponseUtilisateur% = message_information_ok(annonce$)
            set_focus 45
            exit_sub    
        end_if
        
        select_text N_Syn%,ptr%,len(t2$)
    end_if
     
    while 0 = 0
        t3$ = text$(49)
        select_delete N_Syn%
        text_insert N_Syn%,caret_position(N_Syn%),t3$
        index% = caret_position(N_Syn%)

        ' rechargement bufferProjet$ aprs remplacement
        if checked(51) = 0
            bufferProjet$ = lower$(text$(N_Syn%))
            t2$ = lower$(text$(48))
        else
            bufferProjet$ = text$(N_Syn%)
            t2$ = text$(48)
        end_if
        
        ptr% = instr_pos(bufferProjet$,t2$,index% + 1)

        ' option "Mot entier uniquement"
        if checked(50) = 1 and ptr% > 0
            ' Constitution de la liste des caractres qui composent un mot quelconque
            ListeCar$ = "abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789$%"  

            repeat
                ' Identification du caractre prcdent le mot recherch
                if ptr% > 1
                    carPrecedent$ = mid$(bufferProjet$,ptr%-1,1)
                else
                    carPrecedent$ = chr$(32) : ' lorsque le mot commence ds le dbut de bufferProjet$ 
                end_if
        
               ' Vrifier si le caractre prcdent est absent de la liste ListeCar$
                if instr(ListeCar$,carPrecedent$) < 1
                    ' Identification du caractre suivant le mot recherch
                    carSuivant$ = mid$(bufferProjet$,ptr%+len(t2$),1)
                    ' cas du mot entier situ en fin de fichier 
                    if ptr% + len(t2$) - 1 = len(bufferProjet$)
                        carSuivant$ = chr$(32)
                    end_if
                    ' Vrifier si le caractre suivant est absent de la liste ListeCar$
                    if instr(ListeCar$,carSuivant$) < 1
                        exit_repeat
                    end_if
                end_if
                index% = index% + len(t2$) 
                ptr% = instr_pos(bufferProjet$,t2$,index% + 1)
            until ptr% < 1 
        end_if

        ' si occurence non trouve
        if ptr% = 0
            reponseUtilisateur% = message_information_ok("Remplacements termins !")
            set_focus 45
            exit_while    
        end_if
        
        ' recherche occurence suivante
        index% = caret_position(N_Syn%)
        select_text N_Syn%,ptr%,len(t2$)
    end_while
end_sub
' ------------------------------------------------------------------------------
fermerFenetreRechercher:
    text 48,""
    text 49,""
    mark_off 50
    mark_off 51
    hide 45
return
' ------------------------------------------------------------------------------
redimFenetreRechercher:
    off_resize 45
    width 45,width(45) - width_client(45) + 364
    height 45,height(45) - height_client(45) + 137
    on_resize 45,redimFenetreRechercher
return


' ==============================================================================
' Excuter le projet 
' ------------------------------------------------------------------------------
executerProjet:
    executerProjet_1()
return
' ------------------------------------------------------------------------------
sub executerProjet_1()
    dim_local a$, b$, i%
    a$ = lower$(Syn_Edit$(Tab_Actif%,2))

    if right$(a$,4)<>".bas"
        annonce$ = "Ce projet est une sauvegarde .bak !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Enregistrez votre projet en .bas avant de pouvoir l'utiliser."
        reponseUtilisateur% = message_warning_ok(annonce$)
        exit_sub
    end_if    

    inactive 0
    hide 45  :' fenetre Remplacer
    hide 110 :' fenetre Aide
    dir_change Syn_Edit$(Tab_Actif%,1) 
    Nettoyage_Temp_Exe()

    for i% = 1 to 5
        b$ = Syn_Edit$(Tab_Actif%,1) + "Panoramic_Temp_" + str$(i%) + ".exe"
        if file_exists(b$) = 0
            exit_for
        end_if
        if i% = 5
            annonce$ = "Vous avez atteint la limite de 5 projets en cours d'excution simultanment." + chr$(13) + chr$(13)
            annonce$ = annonce$ + "Supprimez-en quelques uns pour pouvoir continuer !"
            reponseUtilisateur% = message_warning_ok(annonce$)
            active 0
            exit_sub    
        end_if
    next i%

    a$ = Syn_Edit$(Tab_Actif%,1) + "Panoramic_Temp_" + str$(i%) + ".bas"
    file_save Tab_Actif% + 250,a$
    wait 200
    execute_wait repertoireEditeur$ + "Make_Exe.exe| -e " + chr$(34) + a$ + chr$(34)
    execute b$
    pause 200
    if file_exists(a$) = 1 then file_delete a$
    if file_exists(b$) = 1 then file_delete b$
    active 0 
end_sub



' ==============================================================================
' Crer un Excutable
' ------------------------------------------------------------------------------
Creer_Executable:
    subCreerExecutable()
return
' ------------------------------------------------------------------------------
sub subCreerExecutable()
    dim_local a$
    
    if text$(N_Syn%)=""
        exit_sub
    end_if    

    a$ = lower$(Syn_Edit$(Tab_Actif%,2))

    if right$(a$,4)<>".bas"
        annonce$ = "Ce projet est une sauvegarde .bak !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Enregistrez votre projet en .bas avant de pouvoir l'utiliser."
        reponseUtilisateur% = message_warning_ok(annonce$)
        exit_sub
    end_if    

    hide 45  :' fenetre Rechercher
    hide 110 :' fenetre Aide

    if Syn_Edit$(Tab_Actif%,3) = "*"
        if message_information_ok("Sauvegardez votre projet avant de crer un excutable !") < 2
            exit_sub
        end_if    
    end_if

    a$ = LEFT$(Syn_Edit$(Tab_Actif%,2),len(Syn_Edit$(Tab_Actif%,2)) - 3) + "exe"

    if file_exists(a$) = 1
        annonce$ = "Le Fichier existe :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + Syn_Edit$(Tab_Actif%,1) + a$ + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le remplacer ?"
        if message_warning_yes_no(annonce$) <> 1 then exit_sub
    end_if

    a$ = Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2)
    execute_wait repertoireEditeur$ + "Make_Exe.exe| -e " + chr$(34) + a$ + chr$(34)
    annonce$ = "Excutable cr avec succs !" + chr$(13) + chr$(13)
    annonce$ = annonce$ + Syn_Edit$(Tab_Actif%,1) + left$(Syn_Edit$(Tab_Actif%,2),len(Syn_Edit$(Tab_Actif%,2))-3) + "exe"
    reponseUtilisateur% = message_information_ok(annonce$)
end_sub





' ==============================================================================
' Crer une Application
' ------------------------------------------------------------------------------
creerApplication:
    subCreerApplication()
return
' ------------------------------------------------------------------------------
sub subCreerApplication()
    dim_local a$
    
    if text$(N_Syn%)=""
        exit_sub
    end_if    

    a$ = lower$(Syn_Edit$(Tab_Actif%,2))

    if right$(a$,4)<>".bas"
        annonce$ = "Ce projet est une sauvegarde .bak !" + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Enregistrez votre projet en .bas avant de pouvoir l'utiliser."
        reponseUtilisateur% = message_warning_ok(annonce$)
        exit_sub
    end_if    

    hide 45  :' fenetre Rechercher
    hide 110 :' fenetre Aide

    if Syn_Edit$(Tab_Actif%,3) = "*"
        if message_information_ok("Sauvegardez votre projet avant de crer un excutable !") < 2
            exit_sub
        end_if    
    end_if

    a$ = LEFT$(Syn_Edit$(Tab_Actif%,2),len(Syn_Edit$(Tab_Actif%,2)) - 3) + "exe"

    if file_exists(a$) = 1
        annonce$ = "Le Fichier existe :" + chr$(13) + chr$(13)
        annonce$ = annonce$ + Syn_Edit$(Tab_Actif%,1) + a$ + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Le remplacer ?"
        if message_warning_yes_no(annonce$) <> 1 then exit_sub
    end_if

    a$ = Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2)
    execute_wait repertoireEditeur$ + "Make_Exe.exe| -a " + chr$(34) + a$ + chr$(34)
    annonce$ = "Application cre avec succs !" + chr$(13) + chr$(13)
    annonce$ = annonce$ + Syn_Edit$(Tab_Actif%,1) + left$(Syn_Edit$(Tab_Actif%,2),len(Syn_Edit$(Tab_Actif%,2)) - 3) + "exe"
    reponseUtilisateur% = message_information_ok(annonce$)
end_sub




' ==============================================================================
' Palette de couleurs
' ------------------------------------------------------------------------------
afficherOutilCouleurs:
    show 60
    to_foreground 60
return
' ------------------------------------------------------------------------------
choixCouleur:
    off_change 69
    off_change 71
    off_change 73
    r% = color_pixel_red(number_click,mouse_x_position(number_click),mouse_y_position(number_click))
    v% = color_pixel_green(number_click,mouse_x_position(number_click),mouse_y_position(number_click))
    b% = color_pixel_blue(number_click,mouse_x_position(number_click),mouse_y_position(number_click))
    color 64,r%,v%,b%
    caption 65,"R  " + str$(r%)
    caption 66,"V  " + str$(v%)
    caption 67,"B  " + str$(b%)
    position 69,r%
    position 71,v%
    position 73,b%
    on_change 69,reglageCouleur
    on_change 71,reglageCouleur
    on_change 73,reglageCouleur
return
' ------------------------------------------------------------------------------
reglageCouleur:
    off_change 69
    off_change 71
    off_change 73
    if number_change = 69 then r%=POSITION(69)
    if number_change = 71 then v%=POSITION(71)
    if number_change = 73 then b%=POSITION(73)
    color 64,r%,v%,b%
    caption 65,"R  " + str$(r%)
    caption 66,"V  " + str$(v%)
    caption 67,"B  " + str$(b%)
    position 69,r%
    position 71,v%
    position 73,b%
    on_change 69,reglageCouleur
    on_change 71,reglageCouleur
    on_change 73,reglageCouleur
return
' ------------------------------------------------------------------------------
Copier_couleur:
    clipboard_string_copy str$(r%)+","+str$(v%)+","+str$(b%)
return
' ------------------------------------------------------------------------------
redimPaletteCouleurs:
    off_resize 60
    width 60,width(60) - width_client(60) + 265
    height 60,height(60) - height_client(60) + 216
    on_resize 60,redimPaletteCouleurs
return
' ------------------------------------------------------------------------------



' ==============================================================================
' Le code des touches
' ------------------------------------------------------------------------------
afficherCodeTouches:
    show 80
    to_foreground 80
return
' ------------------------------------------------------------------------------
toucheDown:
    caption 87," : "+str$(key_down_code)
    
    if key_down_special > 0
        caption 88," : "+str$(key_down_special)
    end_if
    
    caption 89," :      "
    caption 90," :      "
    caption 91," : "+str$(scancode)
return
' ------------------------------------------------------------------------------
toucheUp:
    caption 87," :      "
    caption 88," :      "
    caption 89," : "+str$(key_up_code)
    
    if key_up_special > 0
        caption 90," : "+str$(key_up_special)
    end_if
    
    caption 91," :      "
return
' ------------------------------------------------------------------------------
redimFenetreCodeTouches:
    off_resize 80
    width 80,width(80) - width_client(80) + 290
    height 80,height(80) - height_client(80) + 160
    on_resize 80,redimFenetreCodeTouches
return




' ==============================================================================
' La table ASCII
' ------------------------------------------------------------------------------
afficherTableAscii:
    show 95
    to_foreground 95
return
' ------------------------------------------------------------------------------
redimFenetreCodeAscii:
    off_resize 95
    width 95,width(95) - width_client(95) + 304
    height 96,height_client(95)
    on_resize 95,redimFenetreCodeAscii
return
' ------------------------------------------------------------------------------




' ==============================================================================
' L'aide
' ------------------------------------------------------------------------------
afficheAide:
    off_click 15
    rechercherMotCleCurseur()
    pause 20
    clipboard$ = clipboard_string_paste$
    pause 20
    execute_wait repertoireEditeur$ + "make_exe.exe|-k 1 " + item_index$(111)
    pause 20
    clipboard_paste 112
    pause 20
    show 110
    normal 110
    to_foreground 110
    clipboard_string_copy clipboard$
    pause 20
    on_click 15,afficheAide
return
' ------------------------------------------------------------------------------
sub rechercherMotCleCurseur()
    dim_local motCurseur$, index%, a$, pointeur%, source$, i%, j%

    if n_Syn% = 0
        exit_sub
    end_if
    
    source$ = text$(n_Syn%)

    index% = caret_position(n_Syn%)
    if index% = 0
        index% = 1
    end_if    

    ' recherche de la premire lettre du mot sous le curseur
    pointeur% = 1
    while pointeur% > 0
        a$ = mid$(Source$,index%,1)
        a$ = upper$(a$)
        pointeur% = instr("$#_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789)",a$)
        index% = index% - 1
        IF index% = 0
            index% = -1
            exit_while
        end_if    
    end_while
    
    ' recherche dernire lettre du mot sous le curseur et constitution du motCurseur$
    index% = index% + 2
    pointeur% = 1
    while pointeur% > 0
        a$ = mid$(Source$,index%,1)
        a$ = upper$(a$)
        pointeur% = instr("$#_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789(",a$)
        if pointeur% > 0
            motCurseur$ = motCurseur$ + a$
            if motCurseur$ = "("
                motCurseur$ = ""
                a$ = ""
            end_if
            if a$ = "("
                exit_while
            end_if    
        end_if    
        index%=index%+1
    end_while

    ' recherche si le motCurseur$ existe dans la liste des mots-cls
    for j% = 1 to count(111)
        i% = instr(item_read$(111,j%),motCurseur$)
        if i% = 1 then exit_for
    next j%
    
    ' prslection du mot-cl dans la liste
    if j% <= count(111)
        item_select 111,count(111)
        item_select 111,j%
    end_if
end_sub
' ------------------------------------------------------------------------------
affichageFicheMotCle:
    off_click 111
    show 110
    to_foreground 110
    pause 20
    clipboard$ = clipboard_string_paste$
    pause 20
    repeat
      execute_wait repertoireEditeur$+"make_exe.exe|-k 1 " + item_index$(111)
      pause 20
    until instr(clipboard_string_paste$,"PANORAMIC : "+item_index$(111)+"<")<>0    
    pause 20
    clipboard_paste 112
    pause 20
    clipboard_string_copy clipboard$
    pause 20
    on_click 111,affichageFicheMotCle
return
' ------------------------------------------------------------------------------       
redimFenetreAide:
    off_resize 110
    height 111,height_client(110) - 2
    left 111,width_client(110) - width(111) - 1
    width 112,width_client(110) - width(111) - 2
    height 112,height_client(110)
    on_resize 110,redimFenetreAide
return



' ==============================================================================
' Affichage Clair / Sombre
' ------------------------------------------------------------------------------
clairSombre:
    if lightDark% = 1
        lightDark% = 0
    else
        lightDark% = 1
    end_if

    for i% = 251 to 275
        if object_exists(i%) = 1        
            themeClairSombre(i%)
        end_if    
    next i%        
return
' ------------------------------------------------------------------------------
sub themeClairSombre(numeroSynedit)
    if lightDark% = 1                 :' MODE SOMBRE 
       synedit_target_is_object
       color numeroSynedit,10,10,10          :' Couleur de fond diteur
       font_name numeroSynedit,nomPolice$    :' Nom de la police de l'diteur
       font_size numeroSynedit,taillePolice% :' Taille de la police de l'diteur
       font_color numeroSynedit,255,255,255  :' Couleur de la police de l'diteur 
       
       synedit_target_is_gutter
       color numeroSynedit,10,10,10          :' Couleur de fond de la gouttire
       font_name numeroSynedit,nomPolice$    :' Nom dela police de la gouttire
       font_size numeroSynedit,taillePolice% :' Taille de la police de la gouttire
       font_color numeroSynedit,128,128,0    :' Couleur de la police de la gouttire

       synedit_target_is_keyword
       font_color numeroSynedit,0,255,0      :' Couleur des mots-cls
'       font_italic numeroSynedit            :' Ecriture en italique des mots-cls 
'       font_bold numeroSynedit              :' Ecriture en gras des mots-cls
       
       synedit_target_is_comment
       font_color numeroSynedit,255,0,0      :' Couleur des commentaires
       font_italic numeroSynedit             :' Ecriture en italique des commentaires
'       font_bold numeroSynedit              :' Ecriture en gras des commentaires 

       synedit_target_is_string
       font_color numeroSynedit,180,180,180  :' Couleur des chanes de caractres
'       font_italic numeroSynedit            :' Ecriture en italique des chanes de caractres
'       font_bold numeroSynedit              :' Ecriture en gras des chanes de caractres
   else                               :' MODE CLAIR
       synedit_target_is_object
       color numeroSynedit,255,255,255       :' Couleur de fond diteur
       font_name numeroSynedit,nomPolice$    :' Nom de la police de l'diteur
       font_size numeroSynedit,taillePolice% :' Taille de la police de l'diteur
       font_color numeroSynedit,0,0,0        :' Couleur de la police de l'diteur 
       
       synedit_target_is_gutter
       color numeroSynedit,255,255,255       :' Couleur de fond de la gouttire
       font_name numeroSynedit,nomPolice$    :' Nom dela police de la gouttire
       font_size numeroSynedit,taillePolice% :' Taille de la police de la gouttire
       font_color numeroSynedit,128,128,0    :' Couleur de la police de la gouttire

       synedit_target_is_keyword
       font_color numeroSynedit,0,0,255      :' Couleur des mots-cls
'       font_italic numeroSynedit            :' Ecriture en italique des mots-cls 
'       font_bold numeroSynedit              :' Ecriture en gras des mots-cls
       
       synedit_target_is_comment
       font_color numeroSynedit,255,0,0      :' Couleur des commentaires
       font_italic numeroSynedit             :' Ecriture en italique des commentaires
'       font_bold numeroSynedit              :' Ecriture en gras des commentaires 

       synedit_target_is_string
       font_color numeroSynedit,80,80,80  :' Couleur des chanes de caractres
'       font_italic numeroSynedit            :' Ecriture en italique des chanes de caractres
'       font_bold numeroSynedit              :' Ecriture en gras des chanes de caractres
   end_if         
end_sub





' ==============================================================================
' Les raccourcis clavier
' ------------------------------------------------------------------------------
raccourcis:
    if key_down_code = 112 and KEY_DOWN_SPECIAL = 0 then trigger_click 15        :' F1 aide
    if key_down_code = 114 and KEY_DOWN_SPECIAL = 0 then trigger_click 33        :' F3 recherche rapide avant
    if key_down_code = 115 and KEY_DOWN_SPECIAL = 0 then trigger_click 34        :' F4 recherche rapide arriere
    if key_down_code = 120 and KEY_DOWN_SPECIAL = 0 then trigger_click 9         :' F9 executer
    if key_down_code = 70 and KEY_DOWN_SPECIAL = 3 then trigger_click 8          :' Ctrl+f Rechercher / remplacer
    if key_down_code = 82 and KEY_DOWN_SPECIAL = 3 then trigger_click 8          :' Ctrl+r Rechercher / remplacer
    if key_down_code = 83 and KEY_DOWN_SPECIAL = 3 then enregistrementRapide()   :' Ctrl+s        
    if key_down_code = 107 and key_down_special = 3 then augmenterTaillePolice() :' Augmenter la taille de la police
    if key_down_code = 109 and key_down_special = 3 then diminuerTaillePolice()  :' Diminuer taille de la police
return




' ==============================================================================
' RECHERCHE RAPIDE F3 / F4
' ------------------------------------------------------------------------------
rechercheRapideAvantF3:
    Mot_Curseur_Recherche()

    if Mot_recherche_rapide$ = ""
        return
    end_if

    bufferProjet$ = lower$(text$(N_Syn%))
    Mot_recherche_rapide$ = lower$(Mot_recherche_rapide$)
    ptr% = instr_pos(bufferProjet$,Mot_recherche_rapide$,Index% + 1)

    if ptr% = 0
        annonce$ = "F3 : Recherche Rapide en avant." + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'expression ''" + Mot_recherche_rapide$ + "'' n'a pas t trouve." + chr$(13) + chr$(13)
        annonce$ = annonce$ + "Voulez-vous recommencer depuis le dbut ?"
        if message_confirmation_yes_no(annonce$) = 1
            index% = 0
            ptr% = instr_pos(bufferProjet$,Mot_recherche_rapide$,Index%+1)
            select_text N_Syn%,ptr%,len(Mot_recherche_rapide$)
            index% = index% + 1
            return
        else
            return
        end_if        
    end_if

    select_text N_Syn%,ptr%,len(Mot_recherche_rapide$)
    Index% = ptr%
return
' ------------------------------------------------------------------------------
rechercheRapideArriereF4:
    Mot_Curseur_Recherche()

    if Mot_recherche_rapide$ = ""
        return
    end_if

    bufferProjet$ = left$(lower$(text$(N_Syn%)),Index%)
    Mot_recherche_rapide$=lower$(Mot_recherche_rapide$)
    ptr% = instr_right(bufferProjet$,Mot_recherche_rapide$)

    if ptr% = 0
        annonce$ = "F4 : Recherche Rapide en arrire." + chr$(13) + chr$(13)
        annonce$ = annonce$ + "L'expression ''" + Mot_recherche_rapide$ + "'' n'a pas t trouve."
        reponseUtilisateur% = message_information_ok(annonce$)
        return    
    end_if

    select_text N_Syn%,len(bufferProjet$) - ptr% - len(Mot_recherche_rapide$) + 2,len(Mot_recherche_rapide$)
    Index% = Index% - ptr%
return
' ------------------------------------------------------------------------------
sub Mot_Curseur_Recherche()
    dim_local pos%,a$,r%,source$

    if object_exists(Tab_Actif%+200)=0
        exit_sub
    end_if

    pos% = caret_position(N_Syn%)

    if select_read$(N_Syn%) <> ""
        Mot_recherche_rapide$ = select_read$(N_Syn%)
   
        if pos% = 0
            exit_sub
        end_if
   
        ' mettre le caret  la fin de  l'expression recherche et index% +1
        if instr_pos(text$(N_Syn%),Mot_recherche_rapide$,pos%) = 1
            caret_position N_syn%,caret_position(N_syn%)+len(Mot_recherche_rapide$)
            index% = caret_position(N_syn%) + 1
        else
            index% = caret_position(N_syn%) + 1
        end_if
        
        exit_sub
    end_if         

    pos% = Index1%
    Source$ = TEXT$(N_Syn%)
    a$ = ""
    Mot_recherche_rapide$ = ""
    r% = 1
    
    if pos% = 0
        pos% = 1
    end_if    
        
    while r% > 0
        a$ = mid$(Source$,pos%,1)
        a$ = upper$(a$)
        r% = instr("$%_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",a$)
        pos% = pos%-1
        if pos% = 0
            pos% = -1
            exit_while
        end_if    
    end_while
    pos% = pos% + 2
    r% = 1
    while r% > 0
        a$ = mid$(Source$,pos%,1)
        a$ = upper$(a$)
        r% = instr("$%_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",a$)
        if r% > 0
            Mot_recherche_rapide$ = Mot_recherche_rapide$ + a$
            if len(Mot_recherche_rapide$) = 1 and Mot_recherche_rapide$ = "("
                Mot_recherche_rapide$ = ""
                a$ = ""
            end_if
            if a$ = "("
                exit_while
            end_if    
        end_if    
        pos% = pos% + 1
    end_while
end_sub



' ==============================================================================
' Affichage fentre A-PROPOS
' ------------------------------------------------------------------------------
afficherFenetreAPropos:
    show 120
    to_foreground 120
    inactive 0
return
' ------------------------------------------------------------------------------
fermerFenetreAPropos:
    active 0
    hide 120
return
' ------------------------------------------------------------------------------
redimFenetreAPropos:
    off_resize 120
    width 120,width(120) - width_client(120) + 640
    height 120,height(120) - height_client(120) + 360
    on_resize 120,redimFenetreAPropos 
return



' ==============================================================================
' Affichage fentre PREFERENCES
' ------------------------------------------------------------------------------
afficherFenetrePreferences:
    inactive 0
    show 140
    set_focus 144
    to_foreground 140
    left 140,((width(0)-width(140))/2)+left(0) 
    top 140,((height(0)-height(140))/2)+top(0)
return
' ------------------------------------------------------------------------------
choixNomPolice:
    nomPolice$ = text$(142)
    set_focus 144        
    for i% = 251 to 275
        if object_exists(i%) = 1        
            themeClairSombre(i%)
        end_if    
    next i%
return
' ------------------------------------------------------------------------------
choixTaillePolice:
    taillePolice% = val(text$(143)) 
    set_focus 144        
    for i% = 251 to 275
        if object_exists(i%) = 1        
            themeClairSombre(i%)
        end_if    
    next i%
return
' ------------------------------------------------------------------------------
fermerFenetrePreferences:
    hide 140
    file_open_write 38,repertoireEditeur$ + "EliP6.cfg"
        file_writeln 38,nomPolice$
        file_writeln 38,str$(taillePolice%)
    file_close 38
    active 0
return




' ==============================================================================
' Enregistrement rapide (Ctrl + s)
' ------------------------------------------------------------------------------
sub enregistrementRapide()
    dim_local a$

    if lower$(file_extract_extension$(Syn_Edit$(Tab_Actif%,2))) <> ".bas"
        subEnregistrementprojet()
        exit_sub
    end_if

    if len(Syn_Edit$(Tab_Actif%,2)) > 7 and lower$(left$(Syn_Edit$(Tab_Actif%,2),8)) = "nouveau_"
        subEnregistrementprojet()    
        exit_sub
    end_if
      
      
    inactive 0
    a$ = Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2)
    file_save Tab_Actif% + 250,a$
    Syn_Edit$(Tab_Actif%,3) = ""
    caption (Tab_Actif% + 200),Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)
    caption 21,Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)

    active 0
end_sub




' ==============================================================================
' Sauvegarde automatique toutes les 5 minutes d'activit
' ------------------------------------------------------------------------------
Modif:
    off_change number_change
    Syn_Edit$(number_change - 250,3) = "*"
    caption (number_change - 50),Syn_Edit$(number_change - 250,2) + Syn_Edit$(number_change - 250,3)
    caption 21,Syn_Edit$(number_change - 250,1) + Syn_Edit$(number_change - 250,2) + Syn_Edit$(number_change - 250,3)
    Sauvegarde_Auto()
    on_change number_change,Modif
return
' ------------------------------------------------------------------------------
sub Sauvegarde_Auto()
    dim_local tmp%, a$
    tmp% = number_ticks / 1000 - delai%
    if tmp% > 300
        if lower$(file_extract_extension$(Syn_Edit$(Tab_Actif%,2))) <> ".bas"
            exit_sub
        end_if
        inactive 0
        a$ = Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2)
        a$ = left$(a$,len(a$) - 3) + "bak"
        file_save Tab_Actif% + 250, a$
        active 0
        delai% = number_ticks / 1000
    end_if    
end_sub




' ==============================================================================
' Changer la taille de la police dans l'diteur 
' ------------------------------------------------------------------------------
sub augmenterTaillePolice()
    dim_local n%
    taillePolice% = taillePolice% + 1

    if taillePolice% > 30
        taillePolice% = 30
    end_if

    for n% = 251 to 275 :' numro d'objet des synedit
        if object_exists(n%) = 1
            synedit_target_is_object
            font_size n%,taillePolice% :' Taille de la police de l'diteur
            synedit_target_is_gutter
            font_size n%,taillePolice% :' Taille de la police de la gouttire
        end_if
    next n%
end_sub
' ------------------------------------------------------------------------------
sub diminuerTaillePolice()
    dim_local n%
    taillePolice% = taillePolice% - 1

    if taillePolice% < 6
        taillePolice% = 6
    end_if

    for n% = 251 to 275 :' numro d'objet des synedit
        if object_exists(n%) = 1
            synedit_target_is_object
            font_size n%,taillePolice% :' Taille de la police de l'diteur
            synedit_target_is_gutter
            font_size n%,taillePolice% :' Taille de la police de la gouttire
        end_if
    next n%
end_sub




' ==============================================================================
' Divers
' ------------------------------------------------------------------------------
Retour_Focus:
    set_focus N_Syn%
return
' ------------------------------------------------------------------------------
P_Index:
    Index% = caret_position(N_Syn%)
    Index1% = Index%

    if number_click = N_Syn%
        cibleClipBoard% = N_Syn%
        return
    end_if

    N_Syn% = number_click
    Tab_Actif% = N_Syn% - 250
    N_Tab% = N_Syn% - 50
    cibleClipBoard% = N_Syn%

    dir_change Syn_Edit$(Tab_Actif%,1) 
    caption 21,Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)
return
' ------------------------------------------------------------------------------
Change_Tab_Actif:
    Tab_Actif% = number_show - 200
    N_Syn% = Tab_Actif% + 250
    N_Tab% = Tab_Actif% + 200
    cibleClipBoard% = N_Syn%
    set_focus N_Syn%
    dir_change Syn_Edit$(Tab_Actif%,1) 
    caption 21,Syn_Edit$(Tab_Actif%,1) + Syn_Edit$(Tab_Actif%,2) + Syn_Edit$(Tab_Actif%,3)
return
' ------------------------------------------------------------------------------
sub Source_present()
    ' icones
    active 3
    active 4
    active 5
    active 6
    active 7
    active 8
    active 9
    active 10
    active 11
    active 16
    
    ' objet PANEL du filigrane
    hide 131

    ' menu contextuel
    show 26
    show 27
    show 28
    show 29
    show 33
    show 34
end_sub
' ------------------------------------------------------------------------------
redimFenetre0:
    off_resize 0
    redimensionner_1()
    on_resize 0,redimFenetre0
return
' ------------------------------------------------------------------------------
sub redimensionner_1()
    dim_local x%,y%

    top 21,height_client(0) - 18

    top 352,height_client(0) - 12
    left 352,width_client(0) - 12

    width 200,width_client(0)
    height 200,height_client(0) - 65

    height 131,height(200)
    width 131,width(200) 
end_sub
' ------------------------------------------------------------------------------
sub Nettoyage_Temp_Exe()
    dim_local Temp%, b$
    for Temp% = 1 to 5
        b$ = Syn_Edit$(Tab_Actif%,1) + "Panoramic_Temp_" + str$(Temp%) + ".exe"
        if file_exists(b$) = 1 then file_delete b$
    next Temp%
end_sub
' ------------------------------------------------------------------------------
Quitter:
    close_inactive

    if message_information_yes_no("Voulez-vous vraiment quitter ?") <> 1
        return
    end_if

    for i% = 25 to 1 step -1
        if object_exists(i% + 200) = 1
            for j% = 1 to 5
                a$ = Syn_Edit$(i%,1) + "Panoramic_Temp_" + str$(j%) + ".exe"
                if file_exists(a$) = 1 then file_delete a$
            next j%
        end_if
    next i%

    for i% = 25 to 1 step -1
        if Syn_Edit$(i%,3) = "*"
            mark_on i% + 200
            annonce$ = "Le projet  " + Syn_Edit$(i%,2) + "  a t modifi !" + chr$(13) + chr$(13) + "Voulez-vous l'enregistrer ?"
            reponseUtilisateur% = message_confirmation_yes_no(annonce$)
            if reponseUtilisateur% = 1
                subEnregistrementprojet()
            else
                if reponseUtilisateur% = 0
                    return
                end_if    
            end_if        
        end_if
    next i%

    close_active
    terminate
return